package abcm.cloning;



/**
 * Classes implementing this interface should be able to return a
 * deep clone of themselves: that is, not only a clone of the 
 * object itself but with duplication of all the objects in its
 * instance variables.
 * 
 *  @author John T. Murphy <br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public interface ABCMDeepCloneable {

  /**
   * Gets a deep clone of this object
   * @param cloneStore the clone store, which may already contain
   * a clone of this object.
   * @return the clone
   */
  public ABCMDeepCloneable getDeepClone(ABCMCloneStore cloneStore);
  
}
