package abcm.cloning;

import java.util.Vector;


/**
 * A Vector that can return a deep clone of itself- a clone
 * that contains duplicates of all the objects in its collection.
 *  
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public class ABCMDeepCloneableVector extends Vector<ABCMDeepCloneable> implements ABCMDeepCloneable{

  /** Serial ID  */
  private static final long serialVersionUID = -5785785252089109205L;

  /** (non-Javadoc)
   * @see abcm.cloning.ABCMDeepCloneable#getDeepClone(abcm.cloning.ABCMCloneStore)
   */
  public ABCMDeepCloneable getDeepClone(ABCMCloneStore cloneStore){
    ABCMDeepCloneableVector newVector = new ABCMDeepCloneableVector();
    cloneStore.put(this, newVector);
    for(ABCMDeepCloneable toCopy: this) newVector.add(cloneStore.getClone(toCopy));    
    return newVector;
  }
  
}
