package abcm.db;

import abcm.db.components.defaults.tables.ABCMDefaultAnalysesTable;
import abcm.db.components.defaults.tables.ABCMDefaultAnalysisCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultAnalysisDataSeriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultCodeModelCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultCodeModelOptionDomainsTable;
import abcm.db.components.defaults.tables.ABCMDefaultCodeModelOptionValuesTable;
import abcm.db.components.defaults.tables.ABCMDefaultCodeModelsAndOptionValuesTable;
import abcm.db.components.defaults.tables.ABCMDefaultCodeModelsTable;
import abcm.db.components.defaults.tables.ABCMDefaultCommandCategoriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultDataModelCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultDataModelsTable;
import abcm.db.components.defaults.tables.ABCMDefaultHistoriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultHistoryCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultHistoryNarrativesTable;
import abcm.db.components.defaults.tables.ABCMDefaultJournalEntriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultNarrativeArgumentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultNarrativeCommandsTable;
import abcm.db.components.defaults.tables.ABCMDefaultNarrativeCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultNarrativeInstructionsTable;
import abcm.db.components.defaults.tables.ABCMDefaultNarrativesTable;
import abcm.db.components.defaults.tables.ABCMDefaultParameterAppliesToCodeModelTable;
import abcm.db.components.defaults.tables.ABCMDefaultParameterCategoriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultParameterCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultParameterSetCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultParameterSetsAndValuesTable;
import abcm.db.components.defaults.tables.ABCMDefaultParameterSetsTable;
import abcm.db.components.defaults.tables.ABCMDefaultParametersTable;
import abcm.db.components.defaults.tables.ABCMDefaultProbeCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultProbeSetCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultProbeSetProbesTable;
import abcm.db.components.defaults.tables.ABCMDefaultProbeSetsTable;
import abcm.db.components.defaults.tables.ABCMDefaultProbesTable;
import abcm.db.components.defaults.tables.ABCMDefaultProjectResearchersTable;
import abcm.db.components.defaults.tables.ABCMDefaultReferenceCategoriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultReferenceCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultReferenceWorkTypesTable;
import abcm.db.components.defaults.tables.ABCMDefaultReferencesAndAuthorsTable;
import abcm.db.components.defaults.tables.ABCMDefaultReferencesAndCategoriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultReferencesTable;
import abcm.db.components.defaults.tables.ABCMDefaultResearcherSessionsTable;
import abcm.db.components.defaults.tables.ABCMDefaultResearchersTable;
import abcm.db.components.defaults.tables.ABCMDefaultRunModesTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationConfigurationCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationConfigurationsTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationDataSeriesTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationDataTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationRunsTable;
import abcm.db.components.defaults.tables.ABCMDefaultSimulationsTable;
import abcm.db.components.defaults.tables.ABCMDefaultSummariesTable;
import abcm.db.components.defaults.tables.ABCMDefaultSummaryAnalysesTable;
import abcm.db.components.defaults.tables.ABCMDefaultSummaryCommentsTable;
import abcm.db.components.defaults.tables.ABCMDefaultTermsTable;
import abcm.db.components.defaults.tables.ABCMDefaultTruthValuesTable;
import abcm.db.components.defaults.views.ABCMDefaultAnalysesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultAnalysesAndRunsView;
import abcm.db.components.defaults.views.ABCMDefaultAnalysisDataSeriesView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_AnalysesView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_CodeModelsView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_DataModelsView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_HistoriesView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_NarrativesView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_ParameterSetsView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_ProbeSetsView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_ProbesView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_SimulationConfigurationsView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_SimulationsView;
import abcm.db.components.defaults.views.ABCMDefaultCanBeEdited_SummariesView;
import abcm.db.components.defaults.views.ABCMDefaultCodeModeOptionsListedView;
import abcm.db.components.defaults.views.ABCMDefaultCodeModelsAndAllOptionsView;
import abcm.db.components.defaults.views.ABCMDefaultCodeModelsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultCodeModelsDomainsAndValuesAllView;
import abcm.db.components.defaults.views.ABCMDefaultCodeModelsForWriteupView;
import abcm.db.components.defaults.views.ABCMDefaultCodeModelsInSimulationsView;
import abcm.db.components.defaults.views.ABCMDefaultCommandCategoriesInOrderView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_AnalysesView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_CodeModelsView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_DataModelsView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_HistoriesView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_NarrativesView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_ParameterSetsView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_ProbeSetsView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_ProbesView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_SimulationConfigurationsView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_SimulationsView;
import abcm.db.components.defaults.views.ABCMDefaultCommentsCount_SummariesView;
import abcm.db.components.defaults.views.ABCMDefaultConfigurationsInDataModelsView;
import abcm.db.components.defaults.views.ABCMDefaultDataModelsInSimulationsView;
import abcm.db.components.defaults.views.ABCMDefaultDataModelsWithNamesOfElementsSTEP1View;
import abcm.db.components.defaults.views.ABCMDefaultDataModelsWithNamesOfElementsView;
import abcm.db.components.defaults.views.ABCMDefaultHistoriesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultHistoriesInDataModelsView;
import abcm.db.components.defaults.views.ABCMDefaultHistoriesNarrativesAndInstructionsView;
import abcm.db.components.defaults.views.ABCMDefaultHistoriesNarrativesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultJournalEntriesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultNarrativeArgumentsView;
import abcm.db.components.defaults.views.ABCMDefaultNarrativeCommandsByCategoryView;
import abcm.db.components.defaults.views.ABCMDefaultNarrativeCommandsView;
import abcm.db.components.defaults.views.ABCMDefaultNarrativesAndInstructionsView;
import abcm.db.components.defaults.views.ABCMDefaultNarrativesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultNarrativesInHistoriesView;
import abcm.db.components.defaults.views.ABCMDefaultParameterSetsAndAllParametersView;
import abcm.db.components.defaults.views.ABCMDefaultParameterSetsAndResearchersStep1View;
import abcm.db.components.defaults.views.ABCMDefaultParameterSetsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultParameterSetsAndTruthValuesView;
import abcm.db.components.defaults.views.ABCMDefaultParameterSetsAndValuesView;
import abcm.db.components.defaults.views.ABCMDefaultParameterSetsInSimulationRunsView;
import abcm.db.components.defaults.views.ABCMDefaultParametersAndCategoriesView;
import abcm.db.components.defaults.views.ABCMDefaultProbeSetProbesView;
import abcm.db.components.defaults.views.ABCMDefaultProbeSetsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultProbeSetsInSimulationRunsView;
import abcm.db.components.defaults.views.ABCMDefaultProbesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultProbesInProbeSetsView;
import abcm.db.components.defaults.views.ABCMDefaultProjectResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultReferenceAuthorsView;
import abcm.db.components.defaults.views.ABCMDefaultReferencesAndCommentsView;
import abcm.db.components.defaults.views.ABCMDefaultReferencesTypesAndAddedByView;
import abcm.db.components.defaults.views.ABCMDefaultResearchersAndSessionsView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationAnalysesAndDataView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationAnalysesDatesView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationAnalysesSeriesView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationConfigurationsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationConfigurationsAndTruthValuesView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationRunsAndResearchersSTEP0View;
import abcm.db.components.defaults.views.ABCMDefaultSimulationRunsAndResearchersSTEP1View;
import abcm.db.components.defaults.views.ABCMDefaultSimulationRunsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationsAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationsInSimulationRunsView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationsWithTruthValuesView;
import abcm.db.components.defaults.views.ABCMDefaultSummariesAndResearchersView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryAnalysesAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryCodeModelsAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryCodeModelsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryConfigurationsAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryConfigurationsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryDataModelsAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryDataModelsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryHistoriesAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryHistoriesView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryNarrativesAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryNarrativesView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryParameterSetsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryProbeSetsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryRunsAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummaryRunsView;
import abcm.db.components.defaults.views.ABCMDefaultSummarySimulationsAndDetailsView;
import abcm.db.components.defaults.views.ABCMDefaultSummarySimulationsView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisCommentsTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMCodeModelCommentsTable;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsAndOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMCommandCategoriesTable;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMDataModelCommentsTable;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMHistoryCommentsTable;
import abcm.db.components.tables.ABCMHistoryNarrativesTable;
import abcm.db.components.tables.ABCMJournalEntriesTable;
import abcm.db.components.tables.ABCMNarrativeArgumentsTable;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;
import abcm.db.components.tables.ABCMNarrativeCommentsTable;
import abcm.db.components.tables.ABCMNarrativeInstructionsTable;
import abcm.db.components.tables.ABCMNarrativesTable;
import abcm.db.components.tables.ABCMParameterAppliesToCodeModelTable;
import abcm.db.components.tables.ABCMParameterCategoriesTable;
import abcm.db.components.tables.ABCMParameterCommentsTable;
import abcm.db.components.tables.ABCMParameterSetCommentsTable;
import abcm.db.components.tables.ABCMParameterSetsAndValuesTable;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMParametersTable;
import abcm.db.components.tables.ABCMProbeCommentsTable;
import abcm.db.components.tables.ABCMProbeSetCommentsTable;
import abcm.db.components.tables.ABCMProbeSetProbesTable;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMProbesTable;
import abcm.db.components.tables.ABCMProjectResearchersTable;
import abcm.db.components.tables.ABCMReferenceCategoriesTable;
import abcm.db.components.tables.ABCMReferenceCommentsTable;
import abcm.db.components.tables.ABCMReferenceWorkTypesTable;
import abcm.db.components.tables.ABCMReferencesAndAuthorsTable;
import abcm.db.components.tables.ABCMReferencesAndCategoriesTable;
import abcm.db.components.tables.ABCMReferencesTable;
import abcm.db.components.tables.ABCMResearcherSessionsTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMRunModesTable;
import abcm.db.components.tables.ABCMSimulationCommentsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationCommentsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;
import abcm.db.components.tables.ABCMSummaryCommentsTable;
import abcm.db.components.tables.ABCMTermsTable;
import abcm.db.components.tables.ABCMTruthValuesTable;
import abcm.db.components.views.*;
import abcm.db.syntaxengines.AbstractSQLSyntaxEngine;

/**
 * 
 *  
 *  Abstruse: The general procedure for overloading a database gateway
 *  is to place in the constructor of the subclass statements that create new
 *  instances of the required table and view classes and use the 'set' statement
 *  to place these in the internal collection. That is, the constructor for the
 *  AbstractABCMGateway class contains statements like:
 *  
 *  <code>
 *  setTable1(new DefaultTable1());
 *  setTable2(new DefaultTable2(table1));
 *  </code>
 *  
 *  Notice that the instance of Table2 is related to the instance of Table1, which
 *  is represented by the instance variable table1. To replace the original
 *  Table1 class with a new one requires placing in the constructor of the child
 *  class a statement like:
 *  
 *  <code>
 *  setTable1(new SubclassOfTable1());
 *  </code>
 *  
 *  Likewise, View instances can be set similarly:
 *  
 *  <code>
 *  setView1(new DefaultView1(this));
 *  setView2(new DefaultView2(this));
 *  </code>
 *  
 *  And in the subclass:
 *  
 *  <code>
 *  setView1(new SubclassOfView1(this));
 *  </code>
 *  
 *  However, there is an important difference between Tables and Views. In general,
 *  Tables and Views can be thought of as nothing more than lists of fields and field
 *  names. If retrieval is all that is needed, then any of the above code will work
 *  as expected- that is, the new field names designated in the SubclassOfTable1 and
 *  SubclassOfView1 will be used during all database retrieval actions. However, if the
 *  intent is to create a new database, the difference between Tables and Views must
 *  be considered carefully.
 *  
 *  Tables included hard-coded links to other Tables on which they depend. In the first example
 *  above, table2 will include String values that indicate the foreign-key link to the table1
 *  object that was passed to it. These links will <em>not<em> change when the new instance
 *  of the SubclassOfTable1 is created and the setTable1 method is invoked. Thus, table2 will
 *  still refer to the fields as they were defined in the original Table1 instance.
 *  
 *  Again, this will not matter unless the intent is to create a new database; if a new database
 *  is created and a dependent table tries to link a foreign-key field using a name that does
 *  not exist, an SQL error will result and the database will not be created.
 *  
 *  The workaround for this is simple: re-create all tables that have foreign key links to
 *  the table being subclassed. Thus:
 *  
 *  <code>
 *  setTable1(new SubclassOfTable1());
 *  setTable2(new DefaultTable2(table1));
 *  </code>
 *  
 *  Any new Table class that requires table1 as an argument would be re-created; note that it can
 *  simply be a new instance of the Default class- no subclass is required.
 *  
 *  Conversely, Views do not contain these kinds of links. A view object is normally only a 
 *  list of the field names in a related view in the database to which the gateway gives
 *  access. However, when creating a database, the View object makes use of a pointer to
 *  the database gateway object (this class or a subclass of it) and gets its references to
 *  the tables or views from which it draws its information 'on the fly'. In the above example, when
 *  view2 is created it will make use of the current view1 object in the gateway, which will
 *  be the latest one set with the setView1() method.
 *  
 *  JavaDoc is not provided for the collection of instance variables representing the individual tables,
 *  or their getters and setters. Note that the table setters preserve population order for database
 *  creation.
 *   
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */

public abstract class AbstractABCMDBGateway extends AbstractDBGateway{

  /** Type ID for objects of type 'Reference' in the ABCM Database */
  public static final int REFERENCE           =  1;
  /** Type ID for objects of type 'Simulation' in the ABCM Database */
  public static final int SIMULATION          =  3;
  /** Type ID for objects of type 'Data Model' in the ABCM Database */
  public static final int DATA_MODEL          =  4;
  /** Type ID for objects of type 'Configuration' in the ABCM Database */
  public static final int CONFIGURATION       =  5;
  /** Type ID for objects of type 'History' in the ABCM Database */
  public static final int HISTORY             =  6;
  /** Type ID for objects of type 'Narrative' in the ABCM Database */
  public static final int NARRATIVE           =  7;
  /** Type ID for objects of type 'Code Model' in the ABCM Database */
  public static final int CODE_MODEL          =  8;
  /** Type ID for objects of type 'Parameter Set' in the ABCM Database */
  public static final int PARAM_SET           =  9;
  /** Type ID for objects of type 'Parameter' in the ABCM Database */
  public static final int PARAMETER           = 10;
  /** Type ID for objects of type 'Probe Set' in the ABCM Database */
  public static final int PROBE_SET           = 11;
  /** Type ID for objects of type 'Probe' in the ABCM Database */
  public static final int PROBE               = 12;
  /** Type ID for objects of type 'Simulation Run' in the ABCM Database */
  public static final int SIMULATION_RUN      = 13;
  /** Type ID for objects of type 'Analysis' in the ABCM Database */
  public static final int ANALYSIS            = 15;
  /** Type ID for objects of type 'Summary' in the ABCM Database */
  public static final int SUMMARY             = 16;
  
  /* Instances of default tables */
  protected ABCMResearchersTable                                researchersTable;
  protected ABCMProjectResearchersTable                         projectResearchersTable;
  protected ABCMResearcherSessionsTable                         researcherSessionsTable;
  protected ABCMJournalEntriesTable                             journalEntriesTable;
  protected ABCMRunModesTable                                   runModesTable;
  protected ABCMTruthValuesTable                                truthValuesTable;
  protected ABCMCommentsTable                                   commentsTable;
  protected ABCMCodeModelOptionDomainsTable                     codeModelOptionDomainsTable;
  protected ABCMCodeModelOptionValuesTable                      codeModelOptionValuesTable;
  protected ABCMCodeModelsTable                                 codeModelsTable;
  protected ABCMCodeModelsAndOptionValuesTable                  codeModelsAndOptionValuesTable;
  protected ABCMCommandCategoriesTable                          commandCategoriesTable;
  protected ABCMNarrativeCommandsTable                          narrativeCommandsTable;
  protected ABCMNarrativeArgumentsTable                         narrativeArgumentsTable;
  protected ABCMNarrativesTable                                 narrativesTable;
  protected ABCMNarrativeInstructionsTable                      narrativeInstructionsTable;
  protected ABCMHistoriesTable                                  historiesTable;
  protected ABCMHistoryNarrativesTable                          historyNarrativesTable;
  protected ABCMSimulationConfigurationsTable                   simulationConfigurationsTable;
  protected ABCMDataModelsTable                                 dataModelsTable;
  protected ABCMSimulationsTable                                simulationsTable;
  protected ABCMParameterCategoriesTable                        parameterCategoriesTable;
  protected ABCMParametersTable                                 parametersTable;
  protected ABCMParameterAppliesToCodeModelTable                parameterAppliesToCodeModelTable;
  protected ABCMParameterSetsTable                              parameterSetsTable;
  protected ABCMParameterSetsAndValuesTable                     parameterSetsAndValuesTable;
  protected ABCMProbesTable                                     probesTable;
  protected ABCMProbeSetsTable                                  probeSetsTable;
  protected ABCMProbeSetProbesTable                             probeSetProbesTable;
  protected ABCMSimulationRunsTable                             simulationRunsTable;
  protected ABCMSimulationDataSeriesTable                       simulationDataSeriesTable;
  protected ABCMSimulationDataTable                             simulationDataTable;
  protected ABCMAnalysesTable                                   analysesTable;
  protected ABCMAnalysisDataSeriesTable                         analysisDataSeriesTable;
  protected ABCMSummariesTable                                  summariesTable;
  protected ABCMSummaryAnalysesTable                            summaryAnalysesTable;
  protected ABCMReferenceCategoriesTable                        referenceCategoriesTable;
  protected ABCMReferenceWorkTypesTable                         referenceWorkTypesTable;
  protected ABCMReferencesTable                                 referencesTable;
  protected ABCMReferencesAndCategoriesTable                    referencesAndCategoriesTable;
  protected ABCMReferencesAndAuthorsTable                       referencesAndAuthorsTable;
  protected ABCMReferenceCommentsTable                          referenceCommentsTable;
  protected ABCMCodeModelCommentsTable                          codeModelCommentsTable;
  protected ABCMNarrativeCommentsTable                          narrativeCommentsTable;
  protected ABCMHistoryCommentsTable                            historyCommentsTable;
  protected ABCMSimulationConfigurationCommentsTable            simulationConfigurationCommentsTable;
  protected ABCMDataModelCommentsTable                          dataModelCommentsTable;
  protected ABCMSimulationCommentsTable                         simulationCommentsTable;
  protected ABCMParameterCommentsTable                          parameterCommentsTable;
  protected ABCMParameterSetCommentsTable                       parameterSetCommentsTable;
  protected ABCMProbeCommentsTable                              probeCommentsTable;
  protected ABCMProbeSetCommentsTable                           probeSetCommentsTable;
  protected ABCMAnalysisCommentsTable                           analysisCommentsTable;
  protected ABCMSummaryCommentsTable                            summaryCommentsTable;
  protected ABCMTermsTable                                      termsTable;

  /* Instances of the default views */
  protected ABCMAnalysesAndResearchersView                         analysesAndResearchersView;
  protected ABCMAnalysesAndRunsView                                analysesAndRunsView;
  protected ABCMAnalysesInSummariesView                            analysesInSummariesView;
  protected ABCMAnalysisDataSeriesView                             analysisDataSeriesView;
  protected ABCMCodeModelOptionDomainsAndValuesView                codeModelOptionDomainsAndValuesView;
  protected ABCMCodeModelsAndAllOptionsView                        codeModelsAndAllOptionsView;
  protected ABCMCodeModelsDomainsAndValuesAllView                  codeModelsDomainsAndValuesAllView;
  protected ABCMCodeModelsDomainsAndOptionsView                    codeModelsDomainsAndOptionsView;
  protected ABCMCodeModelsForWriteupView                           codeModelsForWriteupView;
  protected ABCMCodeModelsInSimulationsView                        codeModelsInSimulationsView;
  protected ABCMCodeModeOptionsListedView                          codeModeOptionsListedView;
  protected ABCMCommandCategoriesInOrderView                       commandCategoriesInOrderView;
  protected ABCMCommentsAndResearchersView                         commentsAndResearchersView;
  protected ABCMCommentsCount_AnalysesView                         commentsCount_AnalysesView;
  protected ABCMCanBeEdited_AnalysesView                           canBeEdited_AnalysesView;
  protected ABCMCommentsCount_CodeModelsView                       commentsCount_CodeModelsView;
  protected ABCMCanBeEdited_CodeModelsView                         canBeEdited_CodeModelsView;
  protected ABCMCodeModelsAndResearchersView                       codeModelsAndResearchersView;
  protected ABCMCommentsCount_DataModelsView                       commentsCount_DataModelsView;
  protected ABCMCommentsCount_HistoriesView                        commentsCount_HistoriesView;
  protected ABCMCommentsCount_NarrativesView                       commentsCount_NarrativesView;
  protected ABCMCommentsCount_ParameterSetsView                    commentsCount_ParameterSetsView;

  protected ABCMCommentsCount_ProbesView                           commentsCount_ProbesView;
  protected ABCMCommentsCount_ProbeSetsView                        commentsCount_ProbeSetsView;
  protected ABCMCommentsCount_SimulationConfigurationsView         commentsCount_SimulationConfigurationsView;
  protected ABCMCommentsCount_SimulationsView                      commentsCount_SimulationsView;
  protected ABCMCommentsCount_SummariesView                        commentsCount_SummariesView;
  protected ABCMCanBeEdited_SummariesView                          canBeEdited_SummariesView;
  protected ABCMConfigurationsInDataModelsView                     configurationsInDataModelsView;
  protected ABCMCanBeEdited_SimulationConfigurationsView           canBeEdited_SimulationConfigurationsView;
  protected ABCMSimulationConfigurationsAndTruthValuesView         simulationConfigurationsAndTruthValuesView;
  protected ABCMDataModelsInSimulationsView                        dataModelsInSimulationsView;
  protected ABCMCanBeEdited_DataModelsView                         canBeEdited_DataModelsView;
  protected ABCMHistoriesInDataModelsView                          historiesInDataModelsView;
  protected ABCMCanBeEdited_HistoriesView                          canBeEdited_HistoriesView;
  protected ABCMHistoriesAndResearchersView                        historiesAndResearchersView;
  protected ABCMHistoriesNarrativesAndInstructionsView             historiesNarrativesAndInstructionsView;
  protected ABCMHistoriesNarrativesAndResearchersView              historiesNarrativesAndResearchersView;
  protected ABCMHistoryNarrativeDetailsView                        historyNarrativeDetailsView;
  protected ABCMProjectResearchersView                             projectResearchersView;
  protected ABCMJournalEntriesAndResearchersView                   journalEntriesAndResearchersView;
  protected ABCMNarrativeCommandsView                              narrativeCommandsView;
  protected ABCMNarrativeCommandsAndArgumentsView                  narrativeCommandsAndArgumentsView;
  protected ABCMNarrativeCommandsByCategoryView                    narrativeCommandsByCategoryView;
  protected ABCMNarrativesAndInstructionsView                      narrativesAndInstructionsView;
  protected ABCMNarrativesInHistoriesView                          narrativesInHistoriesView;
  protected ABCMCanBeEdited_NarrativesView                         canBeEdited_NarrativesView;
  protected ABCMNarrativesAndResearchersView                       narrativesAndResearchersView;
  protected ABCMParameterAppliesToCodeModelDomainsView             parameterAppliesToCodeModelDomainsView;
  protected ABCMParametersAndCategoriesView                        parametersAndCategoriesView;
  protected ABCMParameterSetsAndAllParametersView                  parameterSetsAndAllParametersView;
  protected ABCMParameterSetsAndValuesView                         parameterSetsAndValuesView;
  protected ABCMParameterSetsAndTruthValuesView                    parameterSetsAndTruthValuesView;
  protected ABCMParameterSetsInSimulationRunsView                  parameterSetsInSimulationRunsView;
  protected ABCMCanBeEdited_ParameterSetsView                      canBeEdited_ParameterSetsView;
  protected ABCMParameterSetsAndResearchersStep1View               parameterSetsAndResearchersStep1View;
  protected ABCMParameterSetsAndResearchersView                    parameterSetsAndResearchersView;
  protected ABCMParameterSetValuesAndParametersView                parameterSetValuesAndParametersView;
  protected ABCMProbesAndProbeSetsView                             probesAndProbeSetsView;
  protected ABCMProbeSetProbesView                                 probeSetProbesView;
  protected ABCMProbeSetsInSimulationRunsView                      probeSetsInSimulationRunsView;
  protected ABCMCanBeEdited_ProbeSetsView                          canBeEdited_ProbeSetsView;
  protected ABCMProbeSetsAndResearchersView                        probeSetsAndResearchersView;
  protected ABCMProbesInProbeSetsView                              probesInProbeSetsView;
  protected ABCMCanBeEdited_ProbesView                             canBeEdited_ProbesView;
  protected ABCMProbesAndResearchersView                           probesAndResearchersView;
  protected ABCMqdfFORfrmCodeModelOptionValuesView                 qdfFORfrmCodeModelOptionValuesView;
  protected ABCMReferenceAuthorsView                               referenceAuthorsView;
  protected ABCMReferenceCommentsAndResearchersView                referenceCommentsAndResearchersView;
  protected ABCMReferencesAndCommentsView                          referencesAndCommentsView;
  protected ABCMReferencesTypesAndAddedByView                      referencesTypesAndAddedByView;
  protected ABCMResearcherLoginsView                               researcherLoginsView;
  protected ABCMResearchersAndSessionsView                         researchersAndSessionsView;
  protected ABCMSimulationAnalysesDatesView                        simulationAnalysesDatesView;
  protected ABCMSimulationAnalysesAndDataView                      simulationAnalysesAndDataView;
  protected ABCMSimulationAnalysesSeriesView                       simulationAnalysesSeriesView;
  protected ABCMDataModelsWithNamesOfElementsSTEP1View             dataModelsWithNamesOfElementsSTEP1View;
  protected ABCMDataModelsWithNamesOfElementsView                  dataModelsWithNamesOfElementsView;
  protected ABCMSimulationConfigurationsAndResearchersView         simulationConfigurationsAndResearchersView;
  protected ABCMSimulationDetailsOLDView                           simulationDetailsOLDView;
  protected ABCMSimulationsAndResearchersView                      simulationsAndResearchersView;
  protected ABCMSimulationsInSimulationRunsView                    simulationsInSimulationRunsView;
  protected ABCMCanBeEdited_SimulationsView                        canBeEdited_SimulationsView;
  protected ABCMSimulationsWithTruthValuesView                     simulationsWithTruthValuesView;
  protected ABCMSimulationDetailsView                              simulationDetailsView;
  protected ABCMSimulationRunsAndResearchersSTEP0View              simulationRunsAndResearchersSTEP0View;
  protected ABCMSimulationRunsAndResearchersSTEP1View              simulationRunsAndResearchersSTEP1View;
  protected ABCMSimulationRunsAndResearchersView                   simulationRunsAndResearchersView;
  protected ABCMSummariesAndResearchersView                        summariesAndResearchersView;
  protected ABCMSummaryAnalysesAndDetailsView                      summaryAnalysesAndDetailsView;
  protected ABCMSummaryCodeModelsView                              summaryCodeModelsView;
  protected ABCMSummaryCodeModelsAndDetailsView                    summaryCodeModelsAndDetailsView;
  protected ABCMSummaryConfigurationsView                          summaryConfigurationsView;
  protected ABCMSummaryConfigurationsAndDetailsView                summaryConfigurationsAndDetailsView;
  protected ABCMSummaryDataModelsView                              summaryDataModelsView;
  protected ABCMSummaryDataModelsAndDetailsView                    summaryDataModelsAndDetailsView;
  protected ABCMSummaryHistoriesView                               summaryHistoriesView;
  protected ABCMSummaryHistoriesAndDetailsView                     summaryHistoriesAndDetailsView;
  protected ABCMSummaryNarrativesView                              summaryNarrativesView;
  protected ABCMSummaryNarrativesAndDetailsView                    summaryNarrativesAndDetailsView;
  protected ABCMSummaryParameterSetsView                           summaryParameterSetsView;
  protected ABCMSummaryParameterSetsAndDetailsView                 summaryParameterSetsAndDetailsView;
  protected ABCMSummaryProbeSetsView                               summaryProbeSetsView;
  protected ABCMSummaryRunsView                                    summaryRunsView;
  protected ABCMSummaryRunsAndDetailsView                          summaryRunsAndDetailsView;
  protected ABCMSummarySimulationsView                             summarySimulationsView;
  protected ABCMSummarySimulationsAndDetailsView                   summarySimulationsAndDetailsView;

  protected ABCMNarrativeArgumentsView                             narrativeArgumentsView;
  
/* Constructor */  
  
  /**
   * Constructor
   */
  public AbstractABCMDBGateway(AbstractSQLSyntaxEngine syntaxEngine){
    super(syntaxEngine);
    
    
    /* Tables */
    // Create instances of all the tables
    setResearchersTable(                                new ABCMDefaultResearchersTable()                                                    );
    setProjectResearchersTable(                         new ABCMDefaultProjectResearchersTable(researchersTable)                             );
    setResearcherSessionsTable(                         new ABCMDefaultResearcherSessionsTable(researchersTable)                             );
    setJournalEntriesTable(                             new ABCMDefaultJournalEntriesTable(researchersTable)                                 );
    setRunModesTable(                                   new ABCMDefaultRunModesTable()                                                       );
    setTruthValuesTable(                                new ABCMDefaultTruthValuesTable()                                                    );
    setCommentsTable(                                   new ABCMDefaultCommentsTable(researchersTable)                                       );
    setCodeModelOptionDomainsTable(                     new ABCMDefaultCodeModelOptionDomainsTable()                                         );
    setCodeModelOptionValuesTable(                      new ABCMDefaultCodeModelOptionValuesTable(codeModelOptionDomainsTable)               );
    setCodeModelsTable(                                 new ABCMDefaultCodeModelsTable(researchersTable)                                     );
    setCodeModelsAndOptionValuesTable(                  new ABCMDefaultCodeModelsAndOptionValuesTable(codeModelsTable, 
                                                             codeModelOptionValuesTable)                                                     );
    setCommandCategoriesTable(                          new ABCMDefaultCommandCategoriesTable()                                              );
    setNarrativeCommandsTable(                          new ABCMDefaultNarrativeCommandsTable(commandCategoriesTable)                        );
    setNarrativeArgumentsTable(                         new ABCMDefaultNarrativeArgumentsTable(narrativeCommandsTable)                       );
    setNarrativesTable(                                 new ABCMDefaultNarrativesTable(researchersTable)                                     );
    setNarrativeInstructionsTable(                      new ABCMDefaultNarrativeInstructionsTable(narrativesTable, narrativeCommandsTable)   );
    setHistoriesTable(                                  new ABCMDefaultHistoriesTable(researchersTable, truthValuesTable)                    );
    setHistoryNarrativesTable(                          new ABCMDefaultHistoryNarrativesTable(historiesTable, narrativesTable)               );
    setSimulationConfigurationsTable(                   new ABCMDefaultSimulationConfigurationsTable(researchersTable)                       );
    setDataModelsTable(                                 new ABCMDefaultDataModelsTable(historiesTable, simulationConfigurationsTable, 
                                                             researchersTable)                                                               );
    setSimulationsTable(                                new ABCMDefaultSimulationsTable(codeModelsTable, dataModelsTable, researchersTable)  );
    setParameterCategoriesTable(                        new ABCMDefaultParameterCategoriesTable()                                            );
    setParametersTable(                                 new ABCMDefaultParametersTable(parameterCategoriesTable)                             );
    setParameterAppliesToCodeModelTable(                new ABCMDefaultParameterAppliesToCodeModelTable(parametersTable, 
                                                             codeModelOptionValuesTable)                                                     );
    setParameterSetsTable(                              new ABCMDefaultParameterSetsTable(researchersTable)                                  );
    setParameterSetsAndValuesTable(                     new ABCMDefaultParameterSetsAndValuesTable(parametersTable, truthValuesTable)        );
    setProbesTable(                                     new ABCMDefaultProbesTable(researchersTable)                                         );
    setProbeSetsTable(                                  new ABCMDefaultProbeSetsTable(researchersTable)                                      );
    setProbeSetProbesTable(                             new ABCMDefaultProbeSetProbesTable(probeSetsTable, probesTable)                      );
    setSimulationRunsTable(                             new ABCMDefaultSimulationRunsTable(simulationsTable, parameterSetsTable, 
                                                             probeSetsTable, runModesTable, researchersTable)                                );
    setSimulationDataSeriesTable(                       new ABCMDefaultSimulationDataSeriesTable(simulationRunsTable)                        );
    setSimulationDataTable(                             new ABCMDefaultSimulationDataTable(simulationDataSeriesTable)                        );
    setAnalysesTable(                                   new ABCMDefaultAnalysesTable(researchersTable)                                       );
    setAnalysisDataSeriesTable(                         new ABCMDefaultAnalysisDataSeriesTable(analysesTable, simulationDataSeriesTable)     );
    setSummariesTable(                                  new ABCMDefaultSummariesTable(researchersTable)                                      );
    setSummaryAnalysesTable(                            new ABCMDefaultSummaryAnalysesTable(summariesTable, analysesTable)                   );
    setReferenceCategoriesTable(                        new ABCMDefaultReferenceCategoriesTable()                                            );
    setReferenceWorkTypesTable(                         new ABCMDefaultReferenceWorkTypesTable()                                             );
    setReferencesTable(                                 new ABCMDefaultReferencesTable(referenceWorkTypesTable, researchersTable)            );
    setReferencesAndCategoriesTable(                    new ABCMDefaultReferencesAndCategoriesTable(referencesTable, 
                                                             referenceCategoriesTable)                                                       );
    setReferencesAndAuthorsTable(                       new ABCMDefaultReferencesAndAuthorsTable(referencesTable, researchersTable)          );
    setReferenceCommentsTable(                          new ABCMDefaultReferenceCommentsTable(referencesTable, commentsTable)                );
    setCodeModelCommentsTable(                          new ABCMDefaultCodeModelCommentsTable(codeModelsTable, commentsTable)                );
    setNarrativeCommentsTable(                          new ABCMDefaultNarrativeCommentsTable(narrativesTable, commentsTable)                );
    setHistoryCommentsTable(                            new ABCMDefaultHistoryCommentsTable(historiesTable, commentsTable)                   );
    setSimulationConfigurationCommentsTable(            new ABCMDefaultSimulationConfigurationCommentsTable(simulationConfigurationsTable, 
                                                             commentsTable)                                                                  );
    setDataModelCommentsTable(                          new ABCMDefaultDataModelCommentsTable(dataModelsTable, commentsTable)                );
    setSimulationCommentsTable(                         new ABCMDefaultSimulationCommentsTable(simulationsTable, commentsTable)              );
    setParameterCommentsTable(                          new ABCMDefaultParameterCommentsTable(parametersTable, commentsTable)                );
    setParameterSetCommentsTable(                       new ABCMDefaultParameterSetCommentsTable(parameterSetsTable, commentsTable)          );
    setProbeCommentsTable(                              new ABCMDefaultProbeCommentsTable(probesTable, commentsTable)                        );
    setProbeSetCommentsTable(                           new ABCMDefaultProbeSetCommentsTable(probeSetsTable, commentsTable)                  );
    setAnalysisCommentsTable(                           new ABCMDefaultAnalysisCommentsTable(analysesTable, commentsTable)                   );
    setSummaryCommentsTable(                            new ABCMDefaultSummaryCommentsTable(summariesTable, commentsTable)                   );
    setTermsTable(                                      new ABCMDefaultTermsTable()                                                          );


    
    /* Views */
    // Create instances of all views
    
// WorkTypeManager                                         = No views required
    
// ResearcherManager                                       = No views required
    
// GlossaryManager                                         = No views required
    
// ProjectResearcherManager                                = No views required
    setProjectResearchersView                             (new ABCMDefaultProjectResearchersView(this));
    
// ResearcherLoginsManager
    setResearchersAndSessionsView                         (new ABCMDefaultResearchersAndSessionsView(this));
    
// ParameterCategoriesManager                              = No view required
    
// CodeModelOptionDomainManager
    setCodeModelsForWriteupView                           (new ABCMDefaultCodeModelsForWriteupView(this));
    
// ParameterManager
    setParametersAndCategoriesView                        (new ABCMDefaultParametersAndCategoriesView(this));
    
// AnalysisManager
    setAnalysesAndResearchersView                         (new ABCMDefaultAnalysesAndResearchersView(this));
    setAnalysisDataSeriesView                             (new ABCMDefaultAnalysisDataSeriesView(this));
    setSimulationAnalysesDatesView                        (new ABCMDefaultSimulationAnalysesDatesView(this));
    setSimulationAnalysesSeriesView                       (new ABCMDefaultSimulationAnalysesSeriesView(this));
    
    setSimulationAnalysesAndDataView                      (new ABCMDefaultSimulationAnalysesAndDataView(this));
    setCommentsCount_AnalysesView                         (new ABCMDefaultCommentsCount_AnalysesView(this));
    setCanBeEdited_AnalysesView                           (new ABCMDefaultCanBeEdited_AnalysesView(this));
    
// CodeModelManager
    setCodeModelsAndAllOptionsView                        (new ABCMDefaultCodeModelsAndAllOptionsView(this));
    setCodeModelsDomainsAndValuesAllView                  (new ABCMDefaultCodeModelsDomainsAndValuesAllView(this));
    setCodeModelsInSimulationsView                        (new ABCMDefaultCodeModelsInSimulationsView(this));    
    setCommentsCount_CodeModelsView                       (new ABCMDefaultCommentsCount_CodeModelsView(this));
    
    setCanBeEdited_CodeModelsView                         (new ABCMDefaultCanBeEdited_CodeModelsView(this));
    setCodeModelsAndResearchersView                       (new ABCMDefaultCodeModelsAndResearchersView(this));
    
// DataModelManager
    setCommentsCount_DataModelsView                       (new ABCMDefaultCommentsCount_DataModelsView(this));
    setDataModelsInSimulationsView                        (new ABCMDefaultDataModelsInSimulationsView(this));
    setCanBeEdited_DataModelsView                         (new ABCMDefaultCanBeEdited_DataModelsView(this));
    setSimulationConfigurationsAndTruthValuesView         (new ABCMDefaultSimulationConfigurationsAndTruthValuesView(this));
    setDataModelsWithNamesOfElementsSTEP1View             (new ABCMDefaultDataModelsWithNamesOfElementsSTEP1View(this));
    setDataModelsWithNamesOfElementsView                  (new ABCMDefaultDataModelsWithNamesOfElementsView(this));
    
// HistoryManager
    setHistoriesInDataModelsView                          (new ABCMDefaultHistoriesInDataModelsView(this));
    setCommentsCount_HistoriesView                        (new ABCMDefaultCommentsCount_HistoriesView(this));
    setCanBeEdited_HistoriesView                          (new ABCMDefaultCanBeEdited_HistoriesView(this));    
    setHistoriesAndResearchersView                        (new ABCMDefaultHistoriesAndResearchersView(this));
    
// ParameterSetManager
    setParameterSetsAndAllParametersView                  (new ABCMDefaultParameterSetsAndAllParametersView(this));
    setParameterSetsAndValuesView                         (new ABCMDefaultParameterSetsAndValuesView(this));
    setParameterSetsInSimulationRunsView                  (new ABCMDefaultParameterSetsInSimulationRunsView(this));
    setCommentsCount_ParameterSetsView                    (new ABCMDefaultCommentsCount_ParameterSetsView(this));    
    setCanBeEdited_ParameterSetsView                      (new ABCMDefaultCanBeEdited_ParameterSetsView(this));
    setParameterSetsAndTruthValuesView                    (new ABCMDefaultParameterSetsAndTruthValuesView(this));
    setParameterSetsAndResearchersStep1View               (new ABCMDefaultParameterSetsAndResearchersStep1View(this));
    setParameterSetsAndResearchersView                    (new ABCMDefaultParameterSetsAndResearchersView(this));
    
// ProbeManager
    setProbesInProbeSetsView                              (new ABCMDefaultProbesInProbeSetsView(this));
    setCommentsCount_ProbesView                           (new ABCMDefaultCommentsCount_ProbesView(this));
    setCanBeEdited_ProbesView                             (new ABCMDefaultCanBeEdited_ProbesView(this));
    setProbesAndResearchersView                           (new ABCMDefaultProbesAndResearchersView(this));
    
// ProbeSetManager
    setProbeSetProbesView                                 (new ABCMDefaultProbeSetProbesView(this));
    setProbeSetsInSimulationRunsView                      (new ABCMDefaultProbeSetsInSimulationRunsView(this));
    setCommentsCount_ProbeSetsView                        (new ABCMDefaultCommentsCount_ProbeSetsView(this));
    setCanBeEdited_ProbeSetsView                          (new ABCMDefaultCanBeEdited_ProbeSetsView(this));
    setProbeSetsAndResearchersView                        (new ABCMDefaultProbeSetsAndResearchersView(this));
    
// SimulationManager
    setSimulationsInSimulationRunsView                    (new ABCMDefaultSimulationsInSimulationRunsView(this));
    setCommentsCount_SimulationsView                      (new ABCMDefaultCommentsCount_SimulationsView(this));    
    setCanBeEdited_SimulationsView                        (new ABCMDefaultCanBeEdited_SimulationsView(this));
    setSimulationsWithTruthValuesView                     (new ABCMDefaultSimulationsWithTruthValuesView(this));    
    setSimulationDetailsView                              (new ABCMDefaultSimulationDetailsView(this));
    setSimulationsAndResearchersView                      (new ABCMDefaultSimulationsAndResearchersView(this));
    
// CodeModelOptionsValuesManager
    setCodeModeOptionsListedView                          (new ABCMDefaultCodeModeOptionsListedView(this));
    
// CommandArgumentManager
    setNarrativeArgumentsView                             (new ABCMDefaultNarrativeArgumentsView(this));
    
// CommandsManager
    setCommandCategoriesInOrderView                       (new ABCMDefaultCommandCategoriesInOrderView(this));
    setNarrativeCommandsByCategoryView                    (new ABCMDefaultNarrativeCommandsByCategoryView(this));    
    setNarrativeCommandsView                              (new ABCMDefaultNarrativeCommandsView(this));
    
// HistoryNarrativeManager
    setHistoriesNarrativesAndResearchersView              (new ABCMDefaultHistoriesNarrativesAndResearchersView(this));
    
// JournalEntryManager    
    setJournalEntriesAndResearchersView                   (new ABCMDefaultJournalEntriesAndResearchersView(this));
    
// NarrativeManager
    setHistoriesNarrativesAndInstructionsView             (new ABCMDefaultHistoriesNarrativesAndInstructionsView(this));
    setNarrativesAndInstructionsView                      (new ABCMDefaultNarrativesAndInstructionsView(this));
    setCommentsCount_NarrativesView                       (new ABCMDefaultCommentsCount_NarrativesView(this));
    setNarrativesInHistoriesView                          (new ABCMDefaultNarrativesInHistoriesView(this));
    setCanBeEdited_NarrativesView                         (new ABCMDefaultCanBeEdited_NarrativesView(this));
    setNarrativesAndResearchersView                       (new ABCMDefaultNarrativesAndResearchersView(this));
    
// ReferenceManager
    setReferenceAuthorsView                               (new ABCMDefaultReferenceAuthorsView(this));
    setReferencesTypesAndAddedByView                      (new ABCMDefaultReferencesTypesAndAddedByView(this));
    
// SimulationDataManager                                  = No views required
    
// SimulationDataSeriesManager                            = No views required
    
// SimulationRunManager
    setSimulationRunsAndResearchersSTEP0View              (new ABCMDefaultSimulationRunsAndResearchersSTEP0View(this));
    setSimulationRunsAndResearchersSTEP1View              (new ABCMDefaultSimulationRunsAndResearchersSTEP1View(this));
    setSimulationRunsAndResearchersView                   (new ABCMDefaultSimulationRunsAndResearchersView(this));
    
// CommentManager
    setReferencesAndCommentsView                          (new ABCMDefaultReferencesAndCommentsView(this));
    // Also uses ReferenceAuthorsView
    setCommentsAndResearchersView                         (new ABCMDefaultCommentsAndResearchersView(this));
    
// AbstractSummaryManager
    setSummaryAnalysesAndDetailsView                      (new ABCMDefaultSummaryAnalysesAndDetailsView(this));
    setAnalysesAndRunsView                                (new ABCMDefaultAnalysesAndRunsView(this));
    setSummariesAndResearchersView                        (new ABCMDefaultSummariesAndResearchersView(this));
    setSummaryRunsView                                    (new ABCMDefaultSummaryRunsView(this));
    setSummaryRunsAndDetailsView                          (new ABCMDefaultSummaryRunsAndDetailsView(this));
    setSummarySimulationsView                             (new ABCMDefaultSummarySimulationsView(this));
    setSummarySimulationsAndDetailsView                   (new ABCMDefaultSummarySimulationsAndDetailsView(this));
    setSummaryDataModelsView                              (new ABCMDefaultSummaryDataModelsView(this));
    setSummaryDataModelsAndDetailsView                    (new ABCMDefaultSummaryDataModelsAndDetailsView(this));
    setSummaryCodeModelsView                              (new ABCMDefaultSummaryCodeModelsView(this));
    setSummaryCodeModelsAndDetailsView                    (new ABCMDefaultSummaryCodeModelsAndDetailsView(this));
    // Also uses DataModelsWithNamesOfElementsView
    // Also uses DataModelsWithNamesOfElementsStep1View
    setSummaryHistoriesView                               (new ABCMDefaultSummaryHistoriesView(this));
    setSummaryHistoriesAndDetailsView                     (new ABCMDefaultSummaryHistoriesAndDetailsView(this));    
    setSummaryNarrativesView                              (new ABCMDefaultSummaryNarrativesView(this));
    setSummaryNarrativesAndDetailsView                    (new ABCMDefaultSummaryNarrativesAndDetailsView(this));
    setSummaryConfigurationsView                          (new ABCMDefaultSummaryConfigurationsView(this));
    setConfigurationsInDataModelsView                     (new ABCMDefaultConfigurationsInDataModelsView(this));
    setCommentsCount_SimulationConfigurationsView         (new ABCMDefaultCommentsCount_SimulationConfigurationsView(this));
    setCanBeEdited_SimulationConfigurationsView           (new ABCMDefaultCanBeEdited_SimulationConfigurationsView(this));
    setSimulationConfigurationsAndResearchersView         (new ABCMDefaultSimulationConfigurationsAndResearchersView(this));
    setSummaryConfigurationsAndDetailsView                (new ABCMDefaultSummaryConfigurationsAndDetailsView(this));       
    setSummaryParameterSetsView                           (new ABCMDefaultSummaryParameterSetsView(this));
    setSummaryProbeSetsView                               (new ABCMDefaultSummaryProbeSetsView(this));
    setCommentsCount_SummariesView                        (new ABCMDefaultCommentsCount_SummariesView(this));
    setCanBeEdited_SummariesView                          (new ABCMDefaultCanBeEdited_SummariesView(this));

  }  
  
  
  
  /* Setters for tables */
  // These are used when the default table is to be replaced with
  // a customized one further down in the subclass hierarchy
  public void setResearchersTable(ABCMResearchersTable table){
    substituteTable(researchersTable, table);
    researchersTable= table;
  }

  public void setProjectResearchersTable(ABCMProjectResearchersTable table){
    substituteTable(projectResearchersTable, table);
    projectResearchersTable= table;
  }

  public void setResearcherSessionsTable(ABCMResearcherSessionsTable table){
    substituteTable(researcherSessionsTable, table);
    researcherSessionsTable= table;
  }

  public void setJournalEntriesTable(ABCMJournalEntriesTable table){
    substituteTable(journalEntriesTable, table);
    journalEntriesTable= table;
  }

  public void setRunModesTable(ABCMRunModesTable table){
    substituteTable(runModesTable, table);
    runModesTable= table;
  }

  public void setTruthValuesTable(ABCMTruthValuesTable table){
    substituteTable(truthValuesTable, table);
    truthValuesTable= table;
  }

  public void setCommentsTable(ABCMCommentsTable table){
    substituteTable(commentsTable, table);
    commentsTable= table;
  }

  public void setCodeModelOptionDomainsTable(ABCMCodeModelOptionDomainsTable table){
    substituteTable(codeModelOptionDomainsTable, table);
    codeModelOptionDomainsTable= table;
  }

  public void setCodeModelOptionValuesTable(ABCMCodeModelOptionValuesTable table){
    substituteTable(codeModelOptionValuesTable, table);
    codeModelOptionValuesTable= table;
  }

  public void setCodeModelsTable(ABCMCodeModelsTable table){
    substituteTable(codeModelsTable, table);
    codeModelsTable= table;
  }

  public void setCodeModelsAndOptionValuesTable(ABCMCodeModelsAndOptionValuesTable table){
    substituteTable(codeModelsAndOptionValuesTable, table);
    codeModelsAndOptionValuesTable= table;
  }

  public void setCommandCategoriesTable(ABCMCommandCategoriesTable table){
    substituteTable(commandCategoriesTable, table);
    commandCategoriesTable= table;
  }

  public void setNarrativeCommandsTable(ABCMNarrativeCommandsTable table){
    substituteTable(narrativeCommandsTable, table);
    narrativeCommandsTable= table;
  }

  public void setNarrativeArgumentsTable(ABCMNarrativeArgumentsTable table){
    substituteTable(narrativeArgumentsTable, table);
    narrativeArgumentsTable= table;
  }

  public void setNarrativesTable(ABCMNarrativesTable table){
    substituteTable(narrativesTable, table);
    narrativesTable= table;
  }

  public void setNarrativeInstructionsTable(ABCMNarrativeInstructionsTable table){
    substituteTable(narrativeInstructionsTable, table);
    narrativeInstructionsTable= table;
  }

  public void setHistoriesTable(ABCMHistoriesTable table){
    substituteTable(historiesTable, table);
    historiesTable= table;
  }

  public void setHistoryNarrativesTable(ABCMHistoryNarrativesTable table){
    substituteTable(historyNarrativesTable, table);
    historyNarrativesTable= table;
  }

  public void setSimulationConfigurationsTable(ABCMSimulationConfigurationsTable table){
    substituteTable(simulationConfigurationsTable, table);
    simulationConfigurationsTable= table;
  }

  public void setDataModelsTable(ABCMDataModelsTable table){
    substituteTable(dataModelsTable, table);
    dataModelsTable= table;
  }

  public void setSimulationsTable(ABCMSimulationsTable table){
    substituteTable(simulationsTable, table);
    simulationsTable= table;
  }

  public void setParameterCategoriesTable(ABCMParameterCategoriesTable table){
    substituteTable(parameterCategoriesTable, table);
    parameterCategoriesTable= table;
  }

  public void setParametersTable(ABCMParametersTable table){
    substituteTable(parametersTable, table);
    parametersTable= table;
  }

  public void setParameterAppliesToCodeModelTable(ABCMParameterAppliesToCodeModelTable table){
    substituteTable(parameterAppliesToCodeModelTable, table);
    parameterAppliesToCodeModelTable= table;
  }

  public void setParameterSetsTable(ABCMParameterSetsTable table){
    substituteTable(parameterSetsTable, table);
    parameterSetsTable= table;
  }

  public void setParameterSetsAndValuesTable(ABCMParameterSetsAndValuesTable table){
    substituteTable(parameterSetsAndValuesTable, table);
    parameterSetsAndValuesTable= table;
  }

  public void setProbesTable(ABCMProbesTable table){
    substituteTable(probesTable, table);
    probesTable= table;
  }

  public void setProbeSetsTable(ABCMProbeSetsTable table){
    substituteTable(probeSetsTable, table);
    probeSetsTable= table;
  }

  public void setProbeSetProbesTable(ABCMProbeSetProbesTable table){
    substituteTable(probeSetProbesTable, table);
    probeSetProbesTable= table;
  }

  public void setSimulationRunsTable(ABCMSimulationRunsTable table){
    substituteTable(simulationRunsTable, table);
    simulationRunsTable= table;
  }

  public void setSimulationDataSeriesTable(ABCMSimulationDataSeriesTable table){
    substituteTable(simulationDataSeriesTable, table);
    simulationDataSeriesTable= table;
  }

  public void setSimulationDataTable(ABCMSimulationDataTable table){
    substituteTable(simulationDataTable, table);
    simulationDataTable= table;
  }

  public void setAnalysesTable(ABCMAnalysesTable table){
    substituteTable(analysesTable, table);
    analysesTable= table;
  }

  public void setAnalysisDataSeriesTable(ABCMAnalysisDataSeriesTable table){
    substituteTable(analysisDataSeriesTable, table);
    analysisDataSeriesTable= table;
  }

  public void setSummariesTable(ABCMSummariesTable table){
    substituteTable(summariesTable, table);
    summariesTable= table;
  }

  public void setSummaryAnalysesTable(ABCMSummaryAnalysesTable table){
    substituteTable(summaryAnalysesTable, table);
    summaryAnalysesTable= table;
  }

  public void setReferenceCategoriesTable(ABCMReferenceCategoriesTable table){
    substituteTable(referenceCategoriesTable, table);
    referenceCategoriesTable= table;
  }

  public void setReferenceWorkTypesTable(ABCMReferenceWorkTypesTable table){
    substituteTable(referenceWorkTypesTable, table);
    referenceWorkTypesTable= table;
  }

  public void setReferencesTable(ABCMReferencesTable table){
    substituteTable(referencesTable, table);
    referencesTable= table;
  }

  public void setReferencesAndCategoriesTable(ABCMReferencesAndCategoriesTable table){
    substituteTable(referencesAndCategoriesTable, table);
    referencesAndCategoriesTable= table;
  }

  public void setReferencesAndAuthorsTable(ABCMReferencesAndAuthorsTable table){
    substituteTable(referencesAndAuthorsTable, table);
    referencesAndAuthorsTable= table;
  }

  public void setReferenceCommentsTable(ABCMReferenceCommentsTable table){
    substituteTable(referenceCommentsTable, table);
    referenceCommentsTable= table;
  }

  public void setCodeModelCommentsTable(ABCMCodeModelCommentsTable table){
    substituteTable(codeModelCommentsTable, table);
    codeModelCommentsTable= table;
  }

  public void setNarrativeCommentsTable(ABCMNarrativeCommentsTable table){
    substituteTable(narrativeCommentsTable, table);
    narrativeCommentsTable= table;
  }

  public void setHistoryCommentsTable(ABCMHistoryCommentsTable table){
    substituteTable(historyCommentsTable, table);
    historyCommentsTable= table;
  }

  public void setSimulationConfigurationCommentsTable(ABCMSimulationConfigurationCommentsTable table){
    substituteTable(simulationConfigurationCommentsTable, table);
    simulationConfigurationCommentsTable= table;
  }

  public void setDataModelCommentsTable(ABCMDataModelCommentsTable table){
    substituteTable(dataModelCommentsTable, table);
    dataModelCommentsTable= table;
  }

  public void setSimulationCommentsTable(ABCMSimulationCommentsTable table){
    substituteTable(simulationCommentsTable, table);
    simulationCommentsTable= table;
  }

  public void setParameterCommentsTable(ABCMParameterCommentsTable table){
    substituteTable(parameterCommentsTable, table);
    parameterCommentsTable= table;
  }

  public void setParameterSetCommentsTable(ABCMParameterSetCommentsTable table){
    substituteTable(parameterSetCommentsTable, table);
    parameterSetCommentsTable= table;
  }

  public void setProbeCommentsTable(ABCMProbeCommentsTable table){
    substituteTable(probeCommentsTable, table);
    probeCommentsTable= table;
  }

  public void setProbeSetCommentsTable(ABCMProbeSetCommentsTable table){
    substituteTable(probeSetCommentsTable, table);
    probeSetCommentsTable= table;
  }

  public void setAnalysisCommentsTable(ABCMAnalysisCommentsTable table){
    substituteTable(analysisCommentsTable, table);
    analysisCommentsTable= table;
  }

  public void setSummaryCommentsTable(ABCMSummaryCommentsTable table){
    substituteTable(summaryCommentsTable, table);
    summaryCommentsTable= table;
  }

  public void setTermsTable(ABCMTermsTable table){
    substituteTable(termsTable, table);
    termsTable= table;
  }


  
  /* Setters for Views */
  public void setAnalysesAndResearchersView(ABCMAnalysesAndResearchersView view){
    substituteView(analysesAndResearchersView, view);
    analysesAndResearchersView = view;
  }

  public void setAnalysesAndRunsView(ABCMAnalysesAndRunsView view){
    substituteView(analysesAndRunsView, view);
    analysesAndRunsView = view;
  }

  public void setAnalysesInSummariesView(ABCMAnalysesInSummariesView view){
    substituteView(analysesInSummariesView, view);
    analysesInSummariesView = view;
  }

  public void setAnalysisDataSeriesView(ABCMAnalysisDataSeriesView view){
    substituteView(analysisDataSeriesView, view);
    analysisDataSeriesView = view;
  }

  public void setCodeModelOptionDomainsAndValuesView(ABCMCodeModelOptionDomainsAndValuesView view){
    substituteView(codeModelOptionDomainsAndValuesView, view);
    codeModelOptionDomainsAndValuesView = view;
  }

  public void setCodeModelsAndAllOptionsView(ABCMCodeModelsAndAllOptionsView view){
    substituteView(codeModelsAndAllOptionsView, view);
    codeModelsAndAllOptionsView = view;
  }

  public void setCodeModelsDomainsAndValuesAllView(ABCMCodeModelsDomainsAndValuesAllView view){
    substituteView(codeModelsDomainsAndValuesAllView, view);
    codeModelsDomainsAndValuesAllView = view;
  }

  public void setCodeModelsDomainsAndOptionsView(ABCMCodeModelsDomainsAndOptionsView view){
    substituteView(codeModelsDomainsAndOptionsView, view);
    codeModelsDomainsAndOptionsView = view;
  }

  public void setCodeModelsForWriteupView(ABCMCodeModelsForWriteupView view){
    substituteView(codeModelsForWriteupView, view);
    codeModelsForWriteupView = view;
  }

  public void setCodeModelsInSimulationsView(ABCMCodeModelsInSimulationsView view){
    substituteView(codeModelsInSimulationsView, view);
    codeModelsInSimulationsView = view;
  }

  public void setCodeModeOptionsListedView(ABCMCodeModeOptionsListedView view){
    substituteView(codeModeOptionsListedView, view);
    codeModeOptionsListedView = view;
  }

  public void setCommandCategoriesInOrderView(ABCMCommandCategoriesInOrderView view){
    substituteView(commandCategoriesInOrderView, view);
    commandCategoriesInOrderView = view;
  }

  public void setCommentsAndResearchersView(ABCMCommentsAndResearchersView view){
    substituteView(commentsAndResearchersView, view);
    commentsAndResearchersView = view;
  }

  public void setCommentsCount_AnalysesView(ABCMCommentsCount_AnalysesView view){
    substituteView(commentsCount_AnalysesView, view);
    commentsCount_AnalysesView = view;
  }

  public void setCanBeEdited_AnalysesView(ABCMCanBeEdited_AnalysesView view){
    substituteView(canBeEdited_AnalysesView, view);
    canBeEdited_AnalysesView = view;
  }

  public void setCommentsCount_CodeModelsView(ABCMCommentsCount_CodeModelsView view){
    substituteView(commentsCount_CodeModelsView, view);
    commentsCount_CodeModelsView = view;
  }

  public void setCanBeEdited_CodeModelsView(ABCMCanBeEdited_CodeModelsView view){
    substituteView(canBeEdited_CodeModelsView, view);
    canBeEdited_CodeModelsView = view;
  }

  public void setCodeModelsAndResearchersView(ABCMCodeModelsAndResearchersView view){
    substituteView(codeModelsAndResearchersView, view);
    codeModelsAndResearchersView = view;
  }

  public void setCommentsCount_DataModelsView(ABCMCommentsCount_DataModelsView view){
    substituteView(commentsCount_DataModelsView, view);
    commentsCount_DataModelsView = view;
  }

  public void setCommentsCount_HistoriesView(ABCMCommentsCount_HistoriesView view){
    substituteView(commentsCount_HistoriesView, view);
    commentsCount_HistoriesView = view;
  }

  public void setCommentsCount_NarrativesView(ABCMCommentsCount_NarrativesView view){
    substituteView(commentsCount_NarrativesView, view);
    commentsCount_NarrativesView = view;
  }

  public void setCommentsCount_ParameterSetsView(ABCMCommentsCount_ParameterSetsView view){
    substituteView(commentsCount_ParameterSetsView, view);
    commentsCount_ParameterSetsView = view;
  }

  public void setCommentsCount_ProbesView(ABCMCommentsCount_ProbesView view){
    substituteView(commentsCount_ProbesView, view);
    commentsCount_ProbesView = view;
  }

  public void setCommentsCount_ProbeSetsView(ABCMCommentsCount_ProbeSetsView view){
    substituteView(commentsCount_ProbeSetsView, view);
    commentsCount_ProbeSetsView = view;
  }

  public void setCommentsCount_SimulationConfigurationsView(ABCMCommentsCount_SimulationConfigurationsView view){
    substituteView(commentsCount_SimulationConfigurationsView, view);
    commentsCount_SimulationConfigurationsView = view;
  }

  public void setCommentsCount_SimulationsView(ABCMCommentsCount_SimulationsView view){
    substituteView(commentsCount_SimulationsView, view);
    commentsCount_SimulationsView = view;
  }

  public void setCommentsCount_SummariesView(ABCMCommentsCount_SummariesView view){
    substituteView(commentsCount_SummariesView, view);
    commentsCount_SummariesView = view;
  }

  public void setCanBeEdited_SummariesView(ABCMCanBeEdited_SummariesView view){
    substituteView(canBeEdited_SummariesView, view);
    canBeEdited_SummariesView = view;
  }

  public void setConfigurationsInDataModelsView(ABCMConfigurationsInDataModelsView view){
    substituteView(configurationsInDataModelsView, view);
    configurationsInDataModelsView = view;
  }

  public void setCanBeEdited_SimulationConfigurationsView(ABCMCanBeEdited_SimulationConfigurationsView view){
    substituteView(canBeEdited_SimulationConfigurationsView, view);
    canBeEdited_SimulationConfigurationsView = view;
  }

  public void setDataModelsInSimulationsView(ABCMDataModelsInSimulationsView view){
    substituteView(dataModelsInSimulationsView, view);
    dataModelsInSimulationsView = view;
  }

  public void setCanBeEdited_DataModelsView(ABCMCanBeEdited_DataModelsView view){
    substituteView(canBeEdited_DataModelsView, view);
    canBeEdited_DataModelsView = view;
  }

  public void setHistoriesInDataModelsView(ABCMHistoriesInDataModelsView view){
    substituteView(historiesInDataModelsView, view);
    historiesInDataModelsView = view;
  }

  public void setCanBeEdited_HistoriesView(ABCMCanBeEdited_HistoriesView view){
    substituteView(canBeEdited_HistoriesView, view);
    canBeEdited_HistoriesView = view;
  }

  public void setHistoriesAndResearchersView(ABCMHistoriesAndResearchersView view){
    substituteView(historiesAndResearchersView, view);
    historiesAndResearchersView = view;
  }

  public void setHistoriesNarrativesAndInstructionsView(ABCMHistoriesNarrativesAndInstructionsView view){
    substituteView(historiesNarrativesAndInstructionsView, view);
    historiesNarrativesAndInstructionsView = view;
  }

  public void setHistoriesNarrativesAndResearchersView(ABCMHistoriesNarrativesAndResearchersView view){
    substituteView(historiesNarrativesAndResearchersView, view);
    historiesNarrativesAndResearchersView = view;
  }

  public void setHistoryNarrativeDetailsView(ABCMHistoryNarrativeDetailsView view){
    substituteView(historyNarrativeDetailsView, view);
    historyNarrativeDetailsView = view;
  }

  public void setProjectResearchersView(ABCMProjectResearchersView view){
    substituteView(projectResearchersView, view);
    projectResearchersView = view;
  }

  public void setJournalEntriesAndResearchersView(ABCMJournalEntriesAndResearchersView view){
    substituteView(journalEntriesAndResearchersView, view);
    journalEntriesAndResearchersView = view;
  }

  public void setNarrativeCommandsView(ABCMNarrativeCommandsView view){
    substituteView(narrativeCommandsView, view);
    narrativeCommandsView = view;
  }

  public void setNarrativeCommandsAndArgumentsView(ABCMNarrativeCommandsAndArgumentsView view){
    substituteView(narrativeCommandsAndArgumentsView, view);
    narrativeCommandsAndArgumentsView = view;
  }

  public void setNarrativeCommandsByCategoryView(ABCMNarrativeCommandsByCategoryView view){
    substituteView(narrativeCommandsByCategoryView, view);
    narrativeCommandsByCategoryView = view;
  }

  public void setNarrativesAndInstructionsView(ABCMNarrativesAndInstructionsView view){
    substituteView(narrativesAndInstructionsView, view);
    narrativesAndInstructionsView = view;
  }

  public void setNarrativesInHistoriesView(ABCMNarrativesInHistoriesView view){
    substituteView(narrativesInHistoriesView, view);
    narrativesInHistoriesView = view;
  }

  public void setCanBeEdited_NarrativesView(ABCMCanBeEdited_NarrativesView view){
    substituteView(canBeEdited_NarrativesView, view);
    canBeEdited_NarrativesView = view;
  }

  public void setNarrativesAndResearchersView(ABCMNarrativesAndResearchersView view){
    substituteView(narrativesAndResearchersView, view);
    narrativesAndResearchersView = view;
  }

  public void setParameterAppliesToCodeModelDomainsView(ABCMParameterAppliesToCodeModelDomainsView view){
    substituteView(parameterAppliesToCodeModelDomainsView, view);
    parameterAppliesToCodeModelDomainsView = view;
  }

  public void setParametersAndCategoriesView(ABCMParametersAndCategoriesView view){
    substituteView(parametersAndCategoriesView, view);
    parametersAndCategoriesView = view;
  }

  public void setParameterSetsAndAllParametersView(ABCMParameterSetsAndAllParametersView view){
    substituteView(parameterSetsAndAllParametersView, view);
    parameterSetsAndAllParametersView = view;
  }

  public void setParameterSetsAndValuesView(ABCMParameterSetsAndValuesView view){
    substituteView(parameterSetsAndValuesView, view);
    parameterSetsAndValuesView = view;
  }

  public void setParameterSetsAndTruthValuesView(ABCMParameterSetsAndTruthValuesView view){
    substituteView(parameterSetsAndTruthValuesView, view);
    parameterSetsAndTruthValuesView = view;
  }

  public void setParameterSetsInSimulationRunsView(ABCMParameterSetsInSimulationRunsView view){
    substituteView(parameterSetsInSimulationRunsView, view);
    parameterSetsInSimulationRunsView = view;
  }

  public void setCanBeEdited_ParameterSetsView(ABCMCanBeEdited_ParameterSetsView view){
    substituteView(canBeEdited_ParameterSetsView, view);
    canBeEdited_ParameterSetsView = view;
  }

  public void setParameterSetsAndResearchersStep1View(ABCMParameterSetsAndResearchersStep1View view){
    substituteView(parameterSetsAndResearchersStep1View, view);
    parameterSetsAndResearchersStep1View = view;
  }

  public void setParameterSetsAndResearchersView(ABCMParameterSetsAndResearchersView view){
    substituteView(parameterSetsAndResearchersView, view);
    parameterSetsAndResearchersView = view;
  }

  public void setParameterSetValuesAndParametersView(ABCMParameterSetValuesAndParametersView view){
    substituteView(parameterSetValuesAndParametersView, view);
    parameterSetValuesAndParametersView = view;
  }
  
  public void setProbesAndProbeSetsView(ABCMProbesAndProbeSetsView view){
    substituteView(probesAndProbeSetsView, view);
    probesAndProbeSetsView = view;
  }

  public void setProbeSetProbesView(ABCMProbeSetProbesView view){
    substituteView(probeSetProbesView, view);
    probeSetProbesView = view;
  }

  public void setProbeSetsInSimulationRunsView(ABCMProbeSetsInSimulationRunsView view){
    substituteView(probeSetsInSimulationRunsView, view);
    probeSetsInSimulationRunsView = view;
  }

  public void setCanBeEdited_ProbeSetsView(ABCMCanBeEdited_ProbeSetsView view){
    substituteView(canBeEdited_ProbeSetsView, view);
    canBeEdited_ProbeSetsView = view;
  }

  public void setProbeSetsAndResearchersView(ABCMProbeSetsAndResearchersView view){
    substituteView(probeSetsAndResearchersView, view);
    probeSetsAndResearchersView = view;
  }

  public void setProbesInProbeSetsView(ABCMProbesInProbeSetsView view){
    substituteView(probesInProbeSetsView, view);
    probesInProbeSetsView = view;
  }

  public void setCanBeEdited_ProbesView(ABCMCanBeEdited_ProbesView view){
    substituteView(canBeEdited_ProbesView, view);
    canBeEdited_ProbesView = view;
  }  

  public void setProbesAndResearchersView(ABCMProbesAndResearchersView view){
    substituteView(probesAndResearchersView, view);
    probesAndResearchersView = view;
  }

  public void setqdfFORfrmCodeModelOptionValuesView(ABCMqdfFORfrmCodeModelOptionValuesView view){
    substituteView(qdfFORfrmCodeModelOptionValuesView, view);
    qdfFORfrmCodeModelOptionValuesView = view;
  }

  public void setReferenceAuthorsView(ABCMReferenceAuthorsView view){
    substituteView(referenceAuthorsView, view);
    referenceAuthorsView = view;
  }

  public void setReferenceCommentsAndResearchersView(ABCMReferenceCommentsAndResearchersView view){
    substituteView(referenceCommentsAndResearchersView, view);
    referenceCommentsAndResearchersView = view;
  }

  public void setReferencesAndCommentsView(ABCMReferencesAndCommentsView view){
    substituteView(referencesAndCommentsView, view);
    referencesAndCommentsView = view;
  }

  public void setReferencesTypesAndAddedByView(ABCMReferencesTypesAndAddedByView view){
    substituteView(referencesTypesAndAddedByView, view);
    referencesTypesAndAddedByView = view;
  }

  public void setResearcherLoginsView(ABCMResearcherLoginsView view){
    substituteView(researcherLoginsView, view);
    researcherLoginsView = view;
  }

  public void setResearchersAndSessionsView(ABCMResearchersAndSessionsView view){
    substituteView(researchersAndSessionsView, view);
    researchersAndSessionsView = view;
  }

  public void setSimulationAnalysesDatesView(ABCMSimulationAnalysesDatesView view){
    substituteView(simulationAnalysesDatesView, view);
    simulationAnalysesDatesView = view;
  }

  public void setSimulationAnalysesAndDataView(ABCMSimulationAnalysesAndDataView view){
    substituteView(simulationAnalysesAndDataView, view);
    simulationAnalysesAndDataView = view;
  }

  public void setSimulationAnalysesSeriesView(ABCMSimulationAnalysesSeriesView view){
    substituteView(simulationAnalysesSeriesView, view);
    simulationAnalysesSeriesView = view;
  }

  public void setDataModelsWithNamesOfElementsSTEP1View(ABCMDataModelsWithNamesOfElementsSTEP1View view){
    substituteView(dataModelsWithNamesOfElementsSTEP1View, view);
    dataModelsWithNamesOfElementsSTEP1View = view;
  }

  public void setDataModelsWithNamesOfElementsView(ABCMDataModelsWithNamesOfElementsView view){
    substituteView(dataModelsWithNamesOfElementsView, view);
    dataModelsWithNamesOfElementsView = view;
  }

  public void setSimulationConfigurationsAndResearchersView(ABCMSimulationConfigurationsAndResearchersView view){
    substituteView(simulationConfigurationsAndResearchersView, view);
    simulationConfigurationsAndResearchersView = view;
  }

  public void setSimulationDetailsOLDView(ABCMSimulationDetailsOLDView view){
    substituteView(simulationDetailsOLDView, view);
    simulationDetailsOLDView = view;
  }

  public void setSimulationsAndResearchersView(ABCMSimulationsAndResearchersView view){
    substituteView(simulationsAndResearchersView, view);
    simulationsAndResearchersView = view;
  }

  public void setSimulationsInSimulationRunsView(ABCMSimulationsInSimulationRunsView view){
    substituteView(simulationsInSimulationRunsView, view);
    simulationsInSimulationRunsView = view;
  }

  public void setCanBeEdited_SimulationsView(ABCMCanBeEdited_SimulationsView view){
    substituteView(canBeEdited_SimulationsView, view);
    canBeEdited_SimulationsView = view;
  }

  public void setSimulationsWithTruthValuesView(ABCMSimulationsWithTruthValuesView view){
    substituteView(simulationsWithTruthValuesView, view);
    simulationsWithTruthValuesView = view;
  }

  public void setSimulationDetailsView(ABCMSimulationDetailsView view){
    substituteView(simulationDetailsView, view);
    simulationDetailsView = view;
  }

  public void setSimulationRunsAndResearchersSTEP0View(ABCMSimulationRunsAndResearchersSTEP0View view){
    substituteView(simulationRunsAndResearchersSTEP0View, view);
    simulationRunsAndResearchersSTEP0View = view;
  }
  
  public void setSimulationRunsAndResearchersSTEP1View(ABCMSimulationRunsAndResearchersSTEP1View view){
    substituteView(simulationRunsAndResearchersSTEP1View, view);
    simulationRunsAndResearchersSTEP1View = view;
  }

  public void setSimulationRunsAndResearchersView(ABCMSimulationRunsAndResearchersView view){
    substituteView(simulationRunsAndResearchersView, view);
    simulationRunsAndResearchersView = view;
  }

  public void setSummariesAndResearchersView(ABCMSummariesAndResearchersView view){
    substituteView(summariesAndResearchersView, view);
    summariesAndResearchersView = view;
  }

  public void setSummaryAnalysesAndDetailsView(ABCMSummaryAnalysesAndDetailsView view){
    substituteView(summaryAnalysesAndDetailsView, view);
    summaryAnalysesAndDetailsView = view;
  }

  public void setSummaryCodeModelsView(ABCMSummaryCodeModelsView view){
    substituteView(summaryCodeModelsView, view);
    summaryCodeModelsView = view;
  }

  public void setSummaryCodeModelsAndDetailsView(ABCMSummaryCodeModelsAndDetailsView view){
    substituteView(summaryCodeModelsAndDetailsView, view);
    summaryCodeModelsAndDetailsView = view;
  }

  public void setSummaryConfigurationsView(ABCMSummaryConfigurationsView view){
    substituteView(summaryConfigurationsView, view);
    summaryConfigurationsView = view;
  }

  public void setSimulationConfigurationsAndTruthValuesView(ABCMSimulationConfigurationsAndTruthValuesView view){
    substituteView(simulationConfigurationsAndTruthValuesView, view);
    simulationConfigurationsAndTruthValuesView = view;
  }
  
  public void setSummaryConfigurationsAndDetailsView(ABCMSummaryConfigurationsAndDetailsView view){
    substituteView(summaryConfigurationsAndDetailsView, view);
    summaryConfigurationsAndDetailsView = view;
  }

  public void setSummaryDataModelsView(ABCMSummaryDataModelsView view){
    substituteView(summaryDataModelsView, view);
    summaryDataModelsView = view;
  }

  public void setSummaryDataModelsAndDetailsView(ABCMSummaryDataModelsAndDetailsView view){
    substituteView(summaryDataModelsAndDetailsView, view);
    summaryDataModelsAndDetailsView = view;
  }

  public void setSummaryHistoriesView(ABCMSummaryHistoriesView view){
    substituteView(summaryHistoriesView, view);
    summaryHistoriesView = view;
  }

  public void setSummaryHistoriesAndDetailsView(ABCMSummaryHistoriesAndDetailsView view){
    substituteView(summaryHistoriesAndDetailsView, view);
    summaryHistoriesAndDetailsView = view;
  }

  public void setSummaryNarrativesView(ABCMSummaryNarrativesView view){
    substituteView(summaryNarrativesView, view);
    summaryNarrativesView = view;
  }

  public void setSummaryNarrativesAndDetailsView(ABCMSummaryNarrativesAndDetailsView view){
    substituteView(summaryNarrativesAndDetailsView, view);
    summaryNarrativesAndDetailsView = view;
  }

  public void setSummaryParameterSetsView(ABCMSummaryParameterSetsView view){
    substituteView(summaryParameterSetsView, view);
    summaryParameterSetsView = view;
  }

  public void setSummaryParameterSetsAndDetailsView(ABCMSummaryParameterSetsAndDetailsView view){
    substituteView(summaryParameterSetsAndDetailsView, view);
    summaryParameterSetsAndDetailsView = view;
  }

  public void setSummaryProbeSetsView(ABCMSummaryProbeSetsView view){
    substituteView(summaryProbeSetsView, view);
    summaryProbeSetsView = view;
  }

  public void setSummaryRunsView(ABCMSummaryRunsView view){
    substituteView(summaryRunsView, view);
    summaryRunsView = view;
  }

  public void setSummaryRunsAndDetailsView(ABCMSummaryRunsAndDetailsView view){
    substituteView(summaryRunsAndDetailsView, view);
    summaryRunsAndDetailsView = view;
  }

  public void setSummarySimulationsView(ABCMSummarySimulationsView view){
    substituteView(summarySimulationsView, view);
    summarySimulationsView = view;
  }

  public void setSummarySimulationsAndDetailsView(ABCMSummarySimulationsAndDetailsView view){
    substituteView(summarySimulationsAndDetailsView, view);
    summarySimulationsAndDetailsView = view;
  }

  public void setNarrativeArgumentsView(ABCMNarrativeArgumentsView view){
    substituteView(narrativeArgumentsView, view);
    narrativeArgumentsView = view;
  }

  
  /* Getters for tables */
  public ABCMResearchersTable getResearchersTable(){                                                               return researchersTable;                                }
  public ABCMProjectResearchersTable getProjectResearchersTable(){                                                 return projectResearchersTable;                         }
  public ABCMResearcherSessionsTable getResearcherSessionsTable(){                                                 return researcherSessionsTable;                         }
  public ABCMJournalEntriesTable getJournalEntriesTable(){                                                         return journalEntriesTable;                             }
  public ABCMRunModesTable getRunModesTable(){                                                                     return runModesTable;                                   }
  public ABCMTruthValuesTable getTruthValuesTable(){                                                               return truthValuesTable;                                }
  public ABCMCommentsTable getCommentsTable(){                                                                     return commentsTable;                                   }
  public ABCMCodeModelOptionDomainsTable getCodeModelOptionDomainsTable(){                                         return codeModelOptionDomainsTable;                     }
  public ABCMCodeModelOptionValuesTable getCodeModelOptionValuesTable(){                                           return codeModelOptionValuesTable;                      }
  public ABCMCodeModelsTable getCodeModelsTable(){                                                                 return codeModelsTable;                                 }
  public ABCMCodeModelsAndOptionValuesTable getCodeModelsAndOptionValuesTable(){                                   return codeModelsAndOptionValuesTable;                  }
  public ABCMCommandCategoriesTable getCommandCategoriesTable(){                                                   return commandCategoriesTable;                          }
  public ABCMNarrativeCommandsTable getNarrativeCommandsTable(){                                                   return narrativeCommandsTable;                          }
  public ABCMNarrativeArgumentsTable getNarrativeArgumentsTable(){                                                 return narrativeArgumentsTable;                         }
  public ABCMNarrativesTable getNarrativesTable(){                                                                 return narrativesTable;                                 }
  public ABCMNarrativeInstructionsTable getNarrativeInstructionsTable(){                                           return narrativeInstructionsTable;                      }
  public ABCMHistoriesTable getHistoriesTable(){                                                                   return historiesTable;                                  }
  public ABCMHistoryNarrativesTable getHistoryNarrativesTable(){                                                   return historyNarrativesTable;                          }
  public ABCMSimulationConfigurationsTable getSimulationConfigurationsTable(){                                     return simulationConfigurationsTable;                   }
  public ABCMDataModelsTable getDataModelsTable(){                                                                 return dataModelsTable;                                 }
  public ABCMSimulationsTable getSimulationsTable(){                                                               return simulationsTable;                                }
  public ABCMParameterCategoriesTable getParameterCategoriesTable(){                                               return parameterCategoriesTable;                        }
  public ABCMParametersTable getParametersTable(){                                                                 return parametersTable;                                 }
  public ABCMParameterAppliesToCodeModelTable getParameterAppliesToCodeModelTable(){                               return parameterAppliesToCodeModelTable;                }
  public ABCMParameterSetsTable getParameterSetsTable(){                                                           return parameterSetsTable;                              }
  public ABCMParameterSetsAndValuesTable getParameterSetsAndValuesTable(){                                         return parameterSetsAndValuesTable;                     }
  public ABCMProbesTable getProbesTable(){                                                                         return probesTable;                                     }
  public ABCMProbeSetsTable getProbeSetsTable(){                                                                   return probeSetsTable;                                  }
  public ABCMProbeSetProbesTable getProbeSetProbesTable(){                                                         return probeSetProbesTable;                             }
  public ABCMSimulationRunsTable getSimulationRunsTable(){                                                         return simulationRunsTable;                             }
  public ABCMSimulationDataSeriesTable getSimulationDataSeriesTable(){                                             return simulationDataSeriesTable;                       }
  public ABCMSimulationDataTable getSimulationDataTable(){                                                         return simulationDataTable;                             }
  public ABCMAnalysesTable getAnalysesTable(){                                                                     return analysesTable;                                   }
  public ABCMAnalysisDataSeriesTable getAnalysisDataSeriesTable(){                                                 return analysisDataSeriesTable;                         }
  public ABCMSummariesTable getSummariesTable(){                                                                   return summariesTable;                                  }
  public ABCMSummaryAnalysesTable getSummaryAnalysesTable(){                                                       return summaryAnalysesTable;                            }
  public ABCMReferenceCategoriesTable getReferenceCategoriesTable(){                                               return referenceCategoriesTable;                        }
  public ABCMReferenceWorkTypesTable getReferenceWorkTypesTable(){                                                 return referenceWorkTypesTable;                         }
  public ABCMReferencesTable getReferencesTable(){                                                                 return referencesTable;                                 }
  public ABCMReferencesAndCategoriesTable getReferencesAndCategoriesTable(){                                       return referencesAndCategoriesTable;                    }
  public ABCMReferencesAndAuthorsTable getReferencesAndAuthorsTable(){                                             return referencesAndAuthorsTable;                       }
  public ABCMReferenceCommentsTable getReferenceCommentsTable(){                                                   return referenceCommentsTable;                          }
  public ABCMCodeModelCommentsTable getCodeModelCommentsTable(){                                                   return codeModelCommentsTable;                          }
  public ABCMNarrativeCommentsTable getNarrativeCommentsTable(){                                                   return narrativeCommentsTable;                          }
  public ABCMHistoryCommentsTable getHistoryCommentsTable(){                                                       return historyCommentsTable;                            }
  public ABCMSimulationConfigurationCommentsTable getSimulationConfigurationCommentsTable(){                       return simulationConfigurationCommentsTable;            }
  public ABCMDataModelCommentsTable getDataModelCommentsTable(){                                                   return dataModelCommentsTable;                          }
  public ABCMSimulationCommentsTable getSimulationCommentsTable(){                                                 return simulationCommentsTable;                         }
  public ABCMParameterCommentsTable getParameterCommentsTable(){                                                   return parameterCommentsTable;                          }
  public ABCMParameterSetCommentsTable getParameterSetCommentsTable(){                                             return parameterSetCommentsTable;                       }
  public ABCMProbeCommentsTable getProbeCommentsTable(){                                                           return probeCommentsTable;                              }
  public ABCMProbeSetCommentsTable getProbeSetCommentsTable(){                                                     return probeSetCommentsTable;                           }
  public ABCMAnalysisCommentsTable getAnalysisCommentsTable(){                                                     return analysisCommentsTable;                           }
  public ABCMSummaryCommentsTable getSummaryCommentsTable(){                                                       return summaryCommentsTable;                            }
  public ABCMTermsTable getTermsTable(){                                                                           return termsTable;                                      }
  
    
  /* Getters for Views */
  public ABCMAnalysesAndResearchersView                         getAnalysesAndResearchersView(){                         return analysesAndResearchersView;                        }
  public ABCMAnalysesAndRunsView                                getAnalysesAndRunsView(){                                return analysesAndRunsView;                               }
  public ABCMAnalysesInSummariesView                            getAnalysesInSummariesView(){                            return analysesInSummariesView;                           }
  public ABCMAnalysisDataSeriesView                             getAnalysisDataSeriesView(){                             return analysisDataSeriesView;                            }
  public ABCMCodeModelOptionDomainsAndValuesView                getCodeModelOptionDomainsAndValuesView(){                return codeModelOptionDomainsAndValuesView;               }
  public ABCMCodeModelsAndAllOptionsView                        getCodeModelsAndAllOptionsView(){                        return codeModelsAndAllOptionsView;                       }
  public ABCMCodeModelsDomainsAndValuesAllView                  getCodeModelsDomainsAndValuesAllView(){                  return codeModelsDomainsAndValuesAllView;                 }
  public ABCMCodeModelsDomainsAndOptionsView                    getCodeModelsDomainsAndOptionsView(){                    return codeModelsDomainsAndOptionsView;                   }
  public ABCMCodeModelsForWriteupView                           getCodeModelsForWriteupView(){                           return codeModelsForWriteupView;                          }
  public ABCMCodeModelsInSimulationsView                        getCodeModelsInSimulationsView(){                        return codeModelsInSimulationsView;                       }
  public ABCMCodeModeOptionsListedView                          getCodeModeOptionsListedView(){                          return codeModeOptionsListedView;                         }
  public ABCMCommandCategoriesInOrderView                       getCommandCategoriesInOrderView(){                       return commandCategoriesInOrderView;                      }
  public ABCMCommentsAndResearchersView                         getCommentsAndResearchersView(){                         return commentsAndResearchersView;                        }
  public ABCMCommentsCount_AnalysesView                         getCommentsCount_AnalysesView(){                         return commentsCount_AnalysesView;                        }
  public ABCMCanBeEdited_AnalysesView                           getCanBeEdited_AnalysesView(){                           return canBeEdited_AnalysesView;                          }
  public ABCMCommentsCount_CodeModelsView                       getCommentsCount_CodeModelsView(){                       return commentsCount_CodeModelsView;                      }
  public ABCMCanBeEdited_CodeModelsView                         getCanBeEdited_CodeModelsView(){                         return canBeEdited_CodeModelsView;                        }
  public ABCMCodeModelsAndResearchersView                       getCodeModelsAndResearchersView(){                       return codeModelsAndResearchersView;                      }
  public ABCMCommentsCount_DataModelsView                       getCommentsCount_DataModelsView(){                       return commentsCount_DataModelsView;                      }
  public ABCMCommentsCount_HistoriesView                        getCommentsCount_HistoriesView(){                        return commentsCount_HistoriesView;                       }
  public ABCMCommentsCount_NarrativesView                       getCommentsCount_NarrativesView(){                       return commentsCount_NarrativesView;                      }
  public ABCMCommentsCount_ParameterSetsView                    getCommentsCount_ParameterSetsView(){                    return commentsCount_ParameterSetsView;                   }
  public ABCMCommentsCount_ProbesView                           getCommentsCount_ProbesView(){                           return commentsCount_ProbesView;                          }
  public ABCMCommentsCount_ProbeSetsView                        getCommentsCount_ProbeSetsView(){                        return commentsCount_ProbeSetsView;                       }
  public ABCMCommentsCount_SimulationConfigurationsView         getCommentsCount_SimulationConfigurationsView(){         return commentsCount_SimulationConfigurationsView;        }
  public ABCMCommentsCount_SimulationsView                      getCommentsCount_SimulationsView(){                      return commentsCount_SimulationsView;                     }
  public ABCMCommentsCount_SummariesView                        getCommentsCount_SummariesView(){                        return commentsCount_SummariesView;                       }
  public ABCMCanBeEdited_SummariesView                          getCanBeEdited_SummariesView(){                          return canBeEdited_SummariesView;                         }
  public ABCMConfigurationsInDataModelsView                     getConfigurationsInDataModelsView(){                     return configurationsInDataModelsView;                    }
  public ABCMCanBeEdited_SimulationConfigurationsView           getCanBeEdited_SimulationConfigurationsView(){           return canBeEdited_SimulationConfigurationsView;          }
  public ABCMDataModelsInSimulationsView                        getDataModelsInSimulationsView(){                        return dataModelsInSimulationsView;                       }
  public ABCMCanBeEdited_DataModelsView                         getCanBeEdited_DataModelsView(){                         return canBeEdited_DataModelsView;                        }
  public ABCMHistoriesInDataModelsView                          getHistoriesInDataModelsView(){                          return historiesInDataModelsView;                         }
  public ABCMCanBeEdited_HistoriesView                          getCanBeEdited_HistoriesView(){                          return canBeEdited_HistoriesView;                         }
  public ABCMHistoriesAndResearchersView                        getHistoriesAndResearchersView(){                        return historiesAndResearchersView;                       }
  public ABCMHistoriesNarrativesAndInstructionsView             getHistoriesNarrativesAndInstructionsView(){             return historiesNarrativesAndInstructionsView;            }
  public ABCMHistoriesNarrativesAndResearchersView              getHistoriesNarrativesAndResearchersView(){              return historiesNarrativesAndResearchersView;             }
  public ABCMHistoryNarrativeDetailsView                        getHistoryNarrativeDetailsView(){                        return historyNarrativeDetailsView;                       }
  public ABCMProjectResearchersView                             getProjectResearchersView(){                             return projectResearchersView;                            }
  public ABCMJournalEntriesAndResearchersView                   getJournalEntriesAndResearchersView(){                   return journalEntriesAndResearchersView;                  }
  public ABCMNarrativeCommandsView                              getNarrativeCommandsView(){                              return narrativeCommandsView;                             }
  public ABCMNarrativeCommandsAndArgumentsView                  getNarrativeCommandsAndArgumentsView(){                  return narrativeCommandsAndArgumentsView;                 }
  public ABCMNarrativeCommandsByCategoryView                    getNarrativeCommandsByCategoryView(){                    return narrativeCommandsByCategoryView;                   }
  public ABCMNarrativesAndInstructionsView                      getNarrativesAndInstructionsView(){                      return narrativesAndInstructionsView;                     }
  public ABCMNarrativesInHistoriesView                          getNarrativesInHistoriesView(){                          return narrativesInHistoriesView;                         }
  public ABCMCanBeEdited_NarrativesView                         getCanBeEdited_NarrativesView(){                         return canBeEdited_NarrativesView;                        }
  public ABCMNarrativesAndResearchersView                       getNarrativesAndResearchersView(){                       return narrativesAndResearchersView;                      }
  public ABCMParameterAppliesToCodeModelDomainsView             getParameterAppliesToCodeModelDomainsView(){             return parameterAppliesToCodeModelDomainsView;            }
  public ABCMParametersAndCategoriesView                        getParametersAndCategoriesView(){                        return parametersAndCategoriesView;                       }
  public ABCMParameterSetsAndAllParametersView                  getParameterSetsAndAllParametersView(){                  return parameterSetsAndAllParametersView;                 }
  public ABCMParameterSetsAndValuesView                         getParameterSetsAndValuesView(){                         return parameterSetsAndValuesView;                        }
  public ABCMParameterSetsAndTruthValuesView                    getParameterSetsAndTruthValuesView(){                    return parameterSetsAndTruthValuesView;                   }
  public ABCMParameterSetsInSimulationRunsView                  getParameterSetsInSimulationRunsView(){                  return parameterSetsInSimulationRunsView;                 }
  public ABCMCanBeEdited_ParameterSetsView                      getCanBeEdited_ParameterSetsView(){                      return canBeEdited_ParameterSetsView;                     }
  public ABCMParameterSetsAndResearchersStep1View               getParameterSetsAndResearchersStep1View(){               return parameterSetsAndResearchersStep1View;              }
  public ABCMParameterSetsAndResearchersView                    getParameterSetsAndResearchersView(){                    return parameterSetsAndResearchersView;                   }
  public ABCMParameterSetValuesAndParametersView                getParameterSetValuesAndParametersView(){                return parameterSetValuesAndParametersView;               }
  public ABCMProbesAndProbeSetsView                             getProbesAndProbeSetsView(){                             return probesAndProbeSetsView;                            }
  public ABCMProbeSetProbesView                                 getProbeSetProbesView(){                                 return probeSetProbesView;                                }
  public ABCMProbeSetsInSimulationRunsView                      getProbeSetsInSimulationRunsView(){                      return probeSetsInSimulationRunsView;                     }
  public ABCMCanBeEdited_ProbeSetsView                          getCanBeEdited_ProbeSetsView(){                          return canBeEdited_ProbeSetsView;                         }
  public ABCMProbeSetsAndResearchersView                        getProbeSetsAndResearchersView(){                        return probeSetsAndResearchersView;                       }
  public ABCMProbesInProbeSetsView                              getProbesInProbeSetsView(){                              return probesInProbeSetsView;                             }
  public ABCMCanBeEdited_ProbesView                             getCanBeEdited_ProbesView(){                             return canBeEdited_ProbesView;                            }
  public ABCMProbesAndResearchersView                           getProbesAndResearchersView(){                           return probesAndResearchersView;                          }
  public ABCMqdfFORfrmCodeModelOptionValuesView                 getqdfFORfrmCodeModelOptionValuesView(){                 return qdfFORfrmCodeModelOptionValuesView;                }
  public ABCMReferenceAuthorsView                               getReferenceAuthorsView(){                               return referenceAuthorsView;                              }
  public ABCMReferenceCommentsAndResearchersView                getReferenceCommentsAndResearchersView(){                return referenceCommentsAndResearchersView;               }
  public ABCMReferencesAndCommentsView                          getReferencesAndCommentsView(){                          return referencesAndCommentsView;                         }
  public ABCMReferencesTypesAndAddedByView                      getReferencesTypesAndAddedByView(){                      return referencesTypesAndAddedByView;                     }
  public ABCMResearcherLoginsView                               getResearcherLoginsView(){                               return researcherLoginsView;                              }
  public ABCMResearchersAndSessionsView                         getResearchersAndSessionsView(){                         return researchersAndSessionsView;                        }
  public ABCMSimulationAnalysesDatesView                        getSimulationAnalysesDatesView(){                        return simulationAnalysesDatesView;                       }
  public ABCMSimulationAnalysesAndDataView                      getSimulationAnalysesAndDataView(){                      return simulationAnalysesAndDataView;                     }
  public ABCMSimulationAnalysesSeriesView                       getSimulationAnalysesSeriesView(){                       return simulationAnalysesSeriesView;                      }
  public ABCMDataModelsWithNamesOfElementsSTEP1View             getDataModelsWithNamesOfElementsSTEP1View(){             return dataModelsWithNamesOfElementsSTEP1View;            }
  public ABCMDataModelsWithNamesOfElementsView                  getDataModelsWithNamesOfElementsView(){                  return dataModelsWithNamesOfElementsView;                 }
  public ABCMSimulationConfigurationsAndResearchersView         getSimulationConfigurationsAndResearchersView(){         return simulationConfigurationsAndResearchersView;        }
  public ABCMSimulationDetailsOLDView                           getSimulationDetailsOLDView(){                           return simulationDetailsOLDView;                          }
  public ABCMSimulationsAndResearchersView                      getSimulationsAndResearchersView(){                      return simulationsAndResearchersView;                     }
  public ABCMSimulationsInSimulationRunsView                    getSimulationsInSimulationRunsView(){                    return simulationsInSimulationRunsView;                   }
  public ABCMCanBeEdited_SimulationsView                        getCanBeEdited_SimulationsView(){                        return canBeEdited_SimulationsView;                       }
  public ABCMSimulationsWithTruthValuesView                     getSimulationsWithTruthValuesView(){                     return simulationsWithTruthValuesView;                    }
  public ABCMSimulationDetailsView                              getSimulationDetailsView(){                              return simulationDetailsView;                             }
  public ABCMSimulationRunsAndResearchersSTEP0View              getSimulationRunsAndResearchersSTEP0View(){              return simulationRunsAndResearchersSTEP0View;             }
  public ABCMSimulationRunsAndResearchersSTEP1View              getSimulationRunsAndResearchersSTEP1View(){              return simulationRunsAndResearchersSTEP1View;             }
  public ABCMSimulationRunsAndResearchersView                   getSimulationRunsAndResearchersView(){                   return simulationRunsAndResearchersView;                  }
  public ABCMSummariesAndResearchersView                        getSummariesAndResearchersView(){                        return summariesAndResearchersView;                       }
  public ABCMSummaryAnalysesAndDetailsView                      getSummaryAnalysesAndDetailsView(){                      return summaryAnalysesAndDetailsView;                     }
  public ABCMSummaryCodeModelsView                              getSummaryCodeModelsView(){                              return summaryCodeModelsView;                             }
  public ABCMSummaryCodeModelsAndDetailsView                    getSummaryCodeModelsAndDetailsView(){                    return summaryCodeModelsAndDetailsView;                   }
  public ABCMSummaryConfigurationsView                          getSummaryConfigurationsView(){                          return summaryConfigurationsView;                         }
  public ABCMSimulationConfigurationsAndTruthValuesView         getSimulationConfigurationsAndTruthValuesView(){         return simulationConfigurationsAndTruthValuesView;        }
  public ABCMSummaryConfigurationsAndDetailsView                getSummaryConfigurationsAndDetailsView(){                return summaryConfigurationsAndDetailsView;               }
  public ABCMSummaryDataModelsView                              getSummaryDataModelsView(){                              return summaryDataModelsView;                             }
  public ABCMSummaryDataModelsAndDetailsView                    getSummaryDataModelsAndDetailsView(){                    return summaryDataModelsAndDetailsView;                   }
  public ABCMSummaryHistoriesView                               getSummaryHistoriesView(){                               return summaryHistoriesView;                              }
  public ABCMSummaryHistoriesAndDetailsView                     getSummaryHistoriesAndDetailsView(){                     return summaryHistoriesAndDetailsView;                    }
  public ABCMSummaryNarrativesView                              getSummaryNarrativesView(){                              return summaryNarrativesView;                             }
  public ABCMSummaryNarrativesAndDetailsView                    getSummaryNarrativesAndDetailsView(){                    return summaryNarrativesAndDetailsView;                   }
  public ABCMSummaryParameterSetsView                           getSummaryParameterSetsView(){                           return summaryParameterSetsView;                          }
  public ABCMSummaryParameterSetsAndDetailsView                 getSummaryParameterSetsAndDetailsView(){                 return summaryParameterSetsAndDetailsView;                }
  public ABCMSummaryProbeSetsView                               getSummaryProbeSetsView(){                               return summaryProbeSetsView;                              }
  public ABCMSummaryRunsView                                    getSummaryRunsView(){                                    return summaryRunsView;                                   }
  public ABCMSummaryRunsAndDetailsView                          getSummaryRunsAndDetailsView(){                          return summaryRunsAndDetailsView;                         }
  public ABCMSummarySimulationsView                             getSummarySimulationsView(){                             return summarySimulationsView;                            }
  public ABCMSummarySimulationsAndDetailsView                   getSummarySimulationsAndDetailsView(){                   return summarySimulationsAndDetailsView;                  }
  public ABCMNarrativeArgumentsView                             getNarrativeArgumentsView(){                             return narrativeArgumentsView;                            }

  /**
   * @see abcm.db.AbstractDBGateway#getDataInitializer()
   */
  public AbstractDBDataInitializer getDataInitializer(){    return new ABCMdbDataInitializer(this);   }
  
}
