package abcm.db;

import java.sql.Connection;

/**
 * Abstract definition of a data initializer.
 * 
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public abstract class AbstractDBDataInitializer {
  
  /**
   * Creates the database.
   * @param con database connection to be used
   * @throws Exception
   */
  public abstract void initialize(Connection con) throws Exception;
  
}
