package abcm.db.components;

/**
 * Tables that extend this class can be used in managers that are descendants of the
 * AbstractObjectCommentsTable class
 * 
 * @author John T. Murphy
 *
 */
public abstract class ABCMObjectCommentTable extends ABCMdbTable {
  
  /**
   * Constructor
   * @param tableName name of this table
   */
  public ABCMObjectCommentTable(String tableName) {
    super(tableName);
  }

  /**
   * Implementing classes must provide a means to generate a datum that relates
   * an object to a comment
   * @param objectPK PK of the object
   * @param commentPK PK of the comment
   * @return the datum to be saved
   */
  public abstract ABCMdbDatum getDatum(long objectPK, long commentPK);
  
}
