package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultAnalysesTable extends ABCMAnalysesTable {

  protected ABCMdbField PK, TITLE, DESC, FK_RESEARCHER, DATE_CREATED;

  public ABCMDefaultAnalysesTable(ABCMResearchersTable researchersTable){
    super("tblAnalyses");
    PK            = createAndAddField("intAnalysisID",      INT,                 true);
    TITLE         = createAndAddField("vcharAnalysisTitle", false, VCHAR100          );
    DESC          = createAndAddField("txtDescription",     false, TEXT              );
    FK_RESEARCHER = createAndAddField("intResearcherID",    false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName()         );
    DATE_CREATED  = createAndAddField("dteDateCreated",     false, DATETIME          );

    addIndex(new ABCMdbIndex("NoDupAnalysisTitles", new String[]{ getField_Title().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Title(){        return TITLE;          }
  public ABCMdbField getField_Description(){  return DESC;           }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
 
}
 
