 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisCommentsTable;
import abcm.db.components.tables.ABCMCommentsTable;
 
public class ABCMDefaultAnalysisCommentsTable extends ABCMAnalysisCommentsTable {

  protected ABCMdbField PK, FK_ANALYSIS, FK_COMMENT;

  public ABCMDefaultAnalysisCommentsTable(ABCMAnalysesTable analysesTable,
      ABCMCommentsTable commentsTable){
    super("tblAnalysisComments");
    PK          = createAndAddField("intAnalysisCommentID", INT,        true);
    FK_ANALYSIS = createAndAddField("intAnalysisID",        false, INT,
        analysesTable.getName(), analysesTable.getField_PK().getName());
    FK_COMMENT  = createAndAddField("intCommentID",         false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupAnalysisComments", 
        new String[]{ getField_AnalysisFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){         return PK;           }
  public ABCMdbField getField_AnalysisFK(){ return FK_ANALYSIS;  }
  public ABCMdbField getField_CommentFK(){  return FK_COMMENT;   }
 
}
 
