 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
 
public class ABCMDefaultAnalysisDataSeriesTable extends ABCMAnalysisDataSeriesTable {

  protected ABCMdbField PK, FK_ANALYSIS, FK_DATASERIES;

  public ABCMDefaultAnalysisDataSeriesTable(ABCMAnalysesTable analysesTable,
      ABCMSimulationDataSeriesTable simulationDataSeriesTable){
    super("tblAnalysisDataSeries");
    PK            = createAndAddField("intAnalysisDataSeriesID", INT,        true);
    FK_ANALYSIS   = createAndAddField("intAnalysisID",           false, INT,
        analysesTable.getName(), analysesTable.getField_PK().getName());
    FK_DATASERIES = createAndAddField("intDataSeriesID",         false, INT,
        simulationDataSeriesTable.getName(), simulationDataSeriesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDataSeriesInAnalysisTwice", new String[]{ getField_AnalysisFK().getName(), getField_DataSeriesFK().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_AnalysisFK(){   return FK_ANALYSIS;    }
  public ABCMdbField getField_DataSeriesFK(){ return FK_DATASERIES;  }
 
}
 
