 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelCommentsTable;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMCommentsTable;
 
public class ABCMDefaultCodeModelCommentsTable extends ABCMCodeModelCommentsTable {

  protected ABCMdbField PK, FK_CODE_MODEL, FK_COMMENT;

  public ABCMDefaultCodeModelCommentsTable(ABCMCodeModelsTable codeModelsTable,
      ABCMCommentsTable commentsTable){
    super("tblCodeModelComments");
    PK            = createAndAddField("intCodeModelCommentID", INT,        true);
    FK_CODE_MODEL = createAndAddField("intCodeModelID",        false, INT,
        codeModelsTable.getName(), codeModelsTable.getField_PK().getName());
    FK_COMMENT    = createAndAddField("intCommentID",          false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupCMComments", 
        new String[]{ getField_CodeModelFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;             }
  public ABCMdbField getField_CodeModelFK(){ return FK_CODE_MODEL;  }
  public ABCMdbField getField_CommentFK(){   return FK_COMMENT;     }
 
}
 
