 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
 
public class ABCMDefaultCodeModelOptionDomainsTable extends ABCMCodeModelOptionDomainsTable {

  protected ABCMdbField PK, DOMAIN_NAME, DESC, ID_STRING;

  public ABCMDefaultCodeModelOptionDomainsTable(){
    super("tblCodeModelOptionDomains");
    PK          = createAndAddField("intCodeModelOptionDomainID", INT,                true);
    DOMAIN_NAME = createAndAddField("vcharDomainName",            false, VCHAR50      );
    DESC        = createAndAddField("txtDescription",             false, TEXT         );
    ID_STRING   = createAndAddField("vcharInCodeDomainIDString",  false, VCHAR30      );

    addIndex(new ABCMdbIndex("NoDupCMDomainNames", new String[]{ getField_DomainName().getName() }));
    addIndex(new ABCMdbIndex("NoDupIDStrings", new String[]{ getField_InCodeID().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;           }
  public ABCMdbField getField_DomainName(){  return DOMAIN_NAME;  }
  public ABCMdbField getField_Description(){ return DESC;         }
  public ABCMdbField getField_InCodeID(){    return ID_STRING;    }

}
 
