 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;
 
public class ABCMDefaultCodeModelOptionValuesTable extends ABCMCodeModelOptionValuesTable {

  protected ABCMdbField PRIMARY_KEY, FK_CODE_MODEL_DOMAIN, OPTIONVALUE, NAME, CODE, DESC;

  public ABCMDefaultCodeModelOptionValuesTable(ABCMCodeModelOptionDomainsTable codeModelOptionDomainsTable){
    super("tblCodeModelOptionValues");
    PRIMARY_KEY          = createAndAddField("intCodeModelOptionValueID",  false, INT              );
    FK_CODE_MODEL_DOMAIN = createAndAddField("intCodeModelOptionDomainID", false, INT,
        codeModelOptionDomainsTable.getName(), codeModelOptionDomainsTable.getField_PK().getName());
    OPTIONVALUE          = createAndAddField("intOptionValue",             false, INT              );
    NAME                 = createAndAddField("vcharOptionValueName",       false, VCHAR50      );
    CODE                 = createAndAddField("txtCode",                    false, TEXT             );
    DESC                 = createAndAddField("txtDescription",             false, TEXT             );

    setMultiFieldPKFieldList(getField_CodeModelOptionDomainFK().getName(), getField_OptionValue().getName());
    addIndex(new ABCMdbIndex("NoDupCMOptionValueName", new String[]{ getField_Name().getName() }));
    addIndex(new ABCMdbIndex("NoDupCMOptionValueIDs", new String[]{ getField_PRIMARY_KEY().getName() }));

  }

  public ABCMdbField getField_PRIMARY_KEY(){             return PRIMARY_KEY;           }
  public ABCMdbField getField_CodeModelOptionDomainFK(){ return FK_CODE_MODEL_DOMAIN;  }
  public ABCMdbField getField_OptionValue(){             return OPTIONVALUE;           }
  public ABCMdbField getField_Name(){                    return NAME;                  }
  public ABCMdbField getField_Code(){                    return CODE;                  }
  public ABCMdbField getField_Description(){             return DESC;                  }

}
 
