 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsAndOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsTable;
 
public class ABCMDefaultCodeModelsAndOptionValuesTable extends ABCMCodeModelsAndOptionValuesTable {

  protected ABCMdbField PK, FK_CODE_MODEL, FK_CODE_MODEL_OPTION_DOMAIN, OPTIONVALUE;

  public ABCMDefaultCodeModelsAndOptionValuesTable(ABCMCodeModelsTable codeModelsTable,
      ABCMCodeModelOptionValuesTable codeModelOptionValuesTable){
    super("tblCodeModelsAndOptionValues");
    PK                          = createAndAddField("intPK",                      false, INT, true);
    FK_CODE_MODEL               = createAndAddField("intCodeModelID",             false, INT,
        codeModelsTable.getName(), codeModelsTable.getField_PK().getName());
    FK_CODE_MODEL_OPTION_DOMAIN = createAndAddField("intCodeModelOptionDomainID", false, INT      );
    OPTIONVALUE                 = createAndAddField("intOptionValue",             false, INT      );

    setMultiFieldPKFieldList(getField_CodeModelFK().getName(), getField_CodeModelOptionDomainFK().getName());
    addFK( new ABCMdbForeignKey("tblCodeModelsAndOptionValuesFK", "tblCodeModelOptionValues", 
       new String[]{codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getName(), 
                    codeModelOptionValuesTable.getField_OptionValue().getName()}, 
       new String[]{getField_CodeModelOptionDomainFK().getName(), getField_OptionValueFK().getName()}));

  }

  public ABCMdbField getField_PK(){                      return PK;                           }
  public ABCMdbField getField_CodeModelFK(){             return FK_CODE_MODEL;                }
  public ABCMdbField getField_CodeModelOptionDomainFK(){ return FK_CODE_MODEL_OPTION_DOMAIN;  }
  public ABCMdbField getField_OptionValueFK(){           return OPTIONVALUE;                  }
 
}
 
