 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultCodeModelsTable extends ABCMCodeModelsTable {

  protected ABCMdbField PK, TITLE, FK_RESEARCHER, DATE_CREATED, DESC;

  public ABCMDefaultCodeModelsTable(ABCMResearchersTable researchersTable){
    super("tblCodeModels");
    PK            = createAndAddField("intCodeModelID",      INT,                true);
    TITLE         = createAndAddField("vcharCodeModelTitle", false, VCHAR40          );
    FK_RESEARCHER = createAndAddField("intResearcherID",     false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DATE_CREATED  = createAndAddField("dteDateCreated",      false, DATETIME         );
    DESC          = createAndAddField("txtDescription",      false, TEXT             );

    addIndex(new ABCMdbIndex("NoDupCodeModelTitles", new String[]{ getField_Title().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Title(){        return TITLE;          }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_Description(){  return DESC;           }
 
}
 
