 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultCommentsTable extends ABCMCommentsTable {

  protected ABCMdbField PK, FK_RESEARCHER, DATE_CREATED, COMMENT;

  public ABCMDefaultCommentsTable(ABCMResearchersTable researchersTable){
    super("tblComments");
    PK            = createAndAddField("intCommentID",    INT,             true);
    FK_RESEARCHER = createAndAddField("intResearcherID", false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DATE_CREATED  = createAndAddField("dteEntryMade",    false, DATETIME      );
    COMMENT       = createAndAddField("txtComment",      false, TEXT          );

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_Comment(){    return COMMENT;          }
  
}
 
