 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMDataModelCommentsTable;
import abcm.db.components.tables.ABCMDataModelsTable;
 
public class ABCMDefaultDataModelCommentsTable extends ABCMDataModelCommentsTable {

  protected ABCMdbField PK, FK_DATA_MODEL, FK_COMMENT;

  public ABCMDefaultDataModelCommentsTable(ABCMDataModelsTable dataModelsTable,
      ABCMCommentsTable commentsTable){
    super("tblDataModelComments");
    PK            = createAndAddField("intDataModelCommentID", INT,        true);
    FK_DATA_MODEL = createAndAddField("intDataModelID",        false, INT,
        dataModelsTable.getName(), dataModelsTable.getField_PK().getName());
    FK_COMMENT    = createAndAddField("intCommentID",          false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupDataModelComments", 
        new String[]{ getField_DataModelFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;             }
  public ABCMdbField getField_DataModelFK(){ return FK_DATA_MODEL;  }
  public ABCMdbField getField_CommentFK(){   return FK_COMMENT;     }
 
}
 
