 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
 
public class ABCMDefaultDataModelsTable extends ABCMDataModelsTable {

  protected ABCMdbField PK, NAME, DESC, FK_HISTORY, FK_CONFIGURATION, CREATED, FK_RESEARCHER;

  public ABCMDefaultDataModelsTable(ABCMHistoriesTable historiesTable,
      ABCMSimulationConfigurationsTable simulationConfigurationsTable, 
      ABCMResearchersTable researchersTable){
    super("tblDataModels");
    PK               = createAndAddField("intDataModelID",               INT,                 true);
    NAME             = createAndAddField("vcharDataModelName",           false, VCHAR100          );
    DESC             = createAndAddField("txtDescription",               false, TEXT              );
    FK_HISTORY       = createAndAddField("intHistoryID",                 false, INT,
        historiesTable.getName(), historiesTable.getField_PK().getName());
    FK_CONFIGURATION = createAndAddField("intSimulationConfigurationID", false, INT,
        simulationConfigurationsTable.getName(), simulationConfigurationsTable.getField_PK().getName());
    CREATED          = createAndAddField("dteDateCreated",               false, DATETIME          );
    FK_RESEARCHER    = createAndAddField("intResearcherID",              false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupDataModelNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){              return PK;                }
  public ABCMdbField getField_Name(){            return NAME;              }
  public ABCMdbField getField_Description(){     return DESC;              }
  public ABCMdbField getField_HistoryFK(){       return FK_HISTORY;        }
  public ABCMdbField getField_ConfigurationFK(){ return FK_CONFIGURATION;  }
  public ABCMdbField getField_DateCreated(){     return CREATED;           }
  public ABCMdbField getField_ResearcherFK(){    return FK_RESEARCHER;     }

 
}
 
