 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMTruthValuesTable;
 
public class ABCMDefaultHistoriesTable extends ABCMHistoriesTable {

  protected ABCMdbField PK, TITLE, FK_RESEARCHER, DESC, FK_TRUTH_VALUE;

  public ABCMDefaultHistoriesTable(ABCMResearchersTable researchersTable,
      ABCMTruthValuesTable truthValuesTable){
    super("tblHistories");
    PK             = createAndAddField("intHistoryID",      INT,                 true);
    TITLE          = createAndAddField("vcharHistoryTitle", false, VCHAR100      );
    FK_RESEARCHER  = createAndAddField("intResearcherID",   false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DESC           = createAndAddField("txtDescription",    false, TEXT              );
    FK_TRUTH_VALUE = createAndAddField("intTruthValue",     false, INT,
        truthValuesTable.getName(), truthValuesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupHistoryTitles", new String[]{ getField_Title().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;              }
  public ABCMdbField getField_Title(){        return TITLE;           }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;   }
  public ABCMdbField getField_Description(){  return DESC;            }
  public ABCMdbField getField_TruthValueFK(){ return FK_TRUTH_VALUE;  }
 
}
 
