 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMHistoryCommentsTable;
 
public class ABCMDefaultHistoryCommentsTable extends ABCMHistoryCommentsTable {

  protected ABCMdbField PK, FK_HISTORY, FK_COMMENT;

  public ABCMDefaultHistoryCommentsTable(ABCMHistoriesTable historiesTable,
      ABCMCommentsTable commentsTable){
    super("tblHistoryComments");
    PK         = createAndAddField("intHistoryCommentID", INT,        true);
    FK_HISTORY = createAndAddField("intHistoryID",        false, INT,
        historiesTable.getName(), historiesTable.getField_PK().getName());
    FK_COMMENT = createAndAddField("intCommentID",        false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupHistComments", 
        new String[]{ getField_HistoryFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){        return PK;          }
  public ABCMdbField getField_HistoryFK(){ return FK_HISTORY;  }
  public ABCMdbField getField_CommentFK(){ return FK_COMMENT;  }
 
}
 
