 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMHistoryNarrativesTable;
import abcm.db.components.tables.ABCMNarrativesTable;
 
public class ABCMDefaultHistoryNarrativesTable extends ABCMHistoryNarrativesTable {

  protected ABCMdbField PK, FK_HISTORY, FK_NARRATIVE, BASE_DATE, ORDER;

  public ABCMDefaultHistoryNarrativesTable(ABCMHistoriesTable historiesTable,
      ABCMNarrativesTable narrativesTable){
    super("tblHistoryNarratives");
    PK           = createAndAddField("intHistoryNarrativeID", INT,             true);
    FK_HISTORY   = createAndAddField("intHistoryID",          false, INT,
        historiesTable.getName(), historiesTable.getField_PK().getName());
    FK_NARRATIVE = createAndAddField("intNarrativeID",        false, INT,
        narrativesTable.getName(), narrativesTable.getField_PK().getName());
    BASE_DATE    = createAndAddField("dblStartBaseDate",      false, FLOAT8          );
    ORDER        = createAndAddField("intOrder",              false, INT           );

    addIndex(new ABCMdbIndex("NoDupHistNarrOrders", 
        new String[]{ getField_HistoryFK().getName(), getField_Order().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;            }
  public ABCMdbField getField_HistoryFK(){   return FK_HISTORY;    }
  public ABCMdbField getField_NarrativeFK(){ return FK_NARRATIVE;  }
  public ABCMdbField getField_BaseDate(){    return BASE_DATE;     }
  public ABCMdbField getField_Order(){       return ORDER;         }
 
}
 
