 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMJournalEntriesTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultJournalEntriesTable extends ABCMJournalEntriesTable {

  protected ABCMdbField PK, FK_RESEARCHER, DATE_CREATED, ENTRY;

  public ABCMDefaultJournalEntriesTable(ABCMResearchersTable researchersTable){
    super("tblJournalEntries");
    PK            = createAndAddField("intJournalEntryID", INT,             true);
    FK_RESEARCHER = createAndAddField("intResearcherID",   false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DATE_CREATED  = createAndAddField("dteEntryMade",      false, DATETIME      );
    ENTRY         = createAndAddField("txtEntry",          false, TEXT          );

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_Entry(){        return ENTRY;          }
  
}
 
