 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMNarrativeArgumentsTable;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;
 
public class ABCMDefaultNarrativeArgumentsTable extends ABCMNarrativeArgumentsTable {

  protected ABCMdbField PK, FK_NARRATIVE_COMMAND, ARGUMENT_NO, ARGUMENT_NAME;

  public ABCMDefaultNarrativeArgumentsTable(ABCMNarrativeCommandsTable narrativeCommandsTable){
    super("tblNarrativeArguments");
    PK                   = createAndAddField("intNarrativeCommandArgID", INT,                true);
    FK_NARRATIVE_COMMAND = createAndAddField("intNarrativeCommandID",    false, INT,
        narrativeCommandsTable.getName(), narrativeCommandsTable.getField_PK().getName());
    ARGUMENT_NO          = createAndAddField("intArgNo",                 false, INT              );
    ARGUMENT_NAME        = createAndAddField("vcharArgName",             false, VCHAR50      );

    addIndex(new ABCMdbIndex("NoDupArgNos", new String[]{ getField_NarrativeCommandFK().getName(), getField_ArgumentNumber().getName() }));
    addIndex(new ABCMdbIndex("NoDupArgNames", new String[]{ getField_NarrativeCommandFK().getName(), getField_ArgumentName().getName() }));

  }

  public ABCMdbField getField_PK(){                 return PK;                    }
  public ABCMdbField getField_NarrativeCommandFK(){ return FK_NARRATIVE_COMMAND;  }
  public ABCMdbField getField_ArgumentNumber(){     return ARGUMENT_NO;           }
  public ABCMdbField getField_ArgumentName(){       return ARGUMENT_NAME;         }
 
}
 
