 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommandCategoriesTable;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;
 
public class ABCMDefaultNarrativeCommandsTable extends ABCMNarrativeCommandsTable {

  protected ABCMdbField PK, COMMAND, NUM_ARGS, DESC, COMMAND_LINE_ONLY, PROBE, INSTRUCTIONS, FK_COMMAND_CATEGORY;

  public ABCMDefaultNarrativeCommandsTable(ABCMCommandCategoriesTable commandCategoriesTable){
    super("tblNarrativeCommands");
    PK                  = createAndAddField("intNarrativeCommandID", INT,                 true);
    COMMAND             = createAndAddField("vcharNarrativeCommand", false, VCHAR25           );
    NUM_ARGS            = createAndAddField("intNumberOfArgs",       false, INT               );
    DESC                = createAndAddField("varcharDescription",    false, VCHAR200          );
    COMMAND_LINE_ONLY   = createAndAddField("blnCommandLineOnly",    false, BIT               );
    PROBE               = createAndAddField("blnProbe",              false, BIT               );
    INSTRUCTIONS        = createAndAddField("txtInstructions",       false, TEXT              );
    FK_COMMAND_CATEGORY = createAndAddField("intCommandCategory",    false, INT,
        commandCategoriesTable.getName(), commandCategoriesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupNarrativeCommands", new String[]{ getField_Command().getName() }));

  }

  public ABCMdbField getField_PK(){                return PK;                   }
  public ABCMdbField getField_Command(){           return COMMAND;              }
  public ABCMdbField getField_NumberOfArgs(){      return NUM_ARGS;             }
  public ABCMdbField getField_Description(){       return DESC;                 }
  public ABCMdbField getField_CommandLineOnly(){   return COMMAND_LINE_ONLY;    }
  public ABCMdbField getField_Probe(){             return PROBE;                }
  public ABCMdbField getField_Instructions(){      return INSTRUCTIONS;         }
  public ABCMdbField getField_CommandCategoryFK(){ return FK_COMMAND_CATEGORY;  }
 
}
 
