 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMNarrativeCommentsTable;
import abcm.db.components.tables.ABCMNarrativesTable;
 
public class ABCMDefaultNarrativeCommentsTable extends ABCMNarrativeCommentsTable {

  protected ABCMdbField PK, FK_NARRATIVE, FK_COMMENT;

  public ABCMDefaultNarrativeCommentsTable(ABCMNarrativesTable narrativesTable,
      ABCMCommentsTable commentsTable){
    super("tblNarrativeComments");
    PK           = createAndAddField("intNarrativeCommentID", INT,        true);
    FK_NARRATIVE = createAndAddField("intNarrativeID",        false, INT,
        narrativesTable.getName(), narrativesTable.getField_PK().getName());
    FK_COMMENT   = createAndAddField("intCommentID",          false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupNarrativeComments", 
        new String[]{ getField_NarrativeFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;            }
  public ABCMdbField getField_NarrativeFK(){ return FK_NARRATIVE;  }
  public ABCMdbField getField_CommentFK(){   return FK_COMMENT;    }
 
}
 
