 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;
import abcm.db.components.tables.ABCMNarrativeInstructionsTable;
import abcm.db.components.tables.ABCMNarrativesTable;
 
public class ABCMDefaultNarrativeInstructionsTable extends ABCMNarrativeInstructionsTable {

  protected ABCMdbField PK, FK_NARRATIVE, INSTRUCTION_DATE, INSTRUCTION_ORDER, FK_NARRATIVE_COMMAND, ARG_1, ARG_2, ARG_3, ARG_4, ARG_5, ARG_6, ARG_7, ARG_8, ARG_9, ARG_10, COMMENT;

  public ABCMDefaultNarrativeInstructionsTable(ABCMNarrativesTable narrativesTable,
      ABCMNarrativeCommandsTable narrativeCommandsTable){
    super("tblNarrativeInstructions");
    PK                   = createAndAddField("intInstructionID",      INT,                true);
    FK_NARRATIVE         = createAndAddField("intNarrativeID",        false, INT,
        narrativesTable.getName(), narrativesTable.getField_PK().getName());
    INSTRUCTION_DATE     = createAndAddField("dblDate",               false, FLOAT8             );
    INSTRUCTION_ORDER    = createAndAddField("intInstructionOrder",   false, INT              );
    FK_NARRATIVE_COMMAND = createAndAddField("intNarrativeCommandID", false, INT,
        narrativeCommandsTable.getName(), narrativeCommandsTable.getField_PK().getName());
    ARG_1                = createAndAddField("Arg1",                   true, VCHAR100      );
    ARG_2                = createAndAddField("Arg2",                   true, VCHAR100      );
    ARG_3                = createAndAddField("Arg3",                   true, VCHAR100      );
    ARG_4                = createAndAddField("Arg4",                   true, VCHAR100      );
    ARG_5                = createAndAddField("Arg5",                   true, VCHAR100      );
    ARG_6                = createAndAddField("Arg6",                   true, VCHAR100      );
    ARG_7                = createAndAddField("Arg7",                   true, VCHAR100      );
    ARG_8                = createAndAddField("Arg8",                   true, VCHAR100      );
    ARG_9                = createAndAddField("Arg9",                   true, VCHAR100      );
    ARG_10               = createAndAddField("Arg10",                  true, VCHAR100      );
    COMMENT              = createAndAddField("charComment",            true, VCHAR100      );

    addIndex(new ABCMdbIndex("NoDupInstructionOrders", new String[]{ getField_NarrativeFK().getName(), getField_InstructionDate().getName(), getField_InstructionOrder().getName() }));

  }

  public ABCMdbField getField_PK(){                 return PK;                    }
  public ABCMdbField getField_NarrativeFK(){        return FK_NARRATIVE;          }
  public ABCMdbField getField_InstructionDate(){    return INSTRUCTION_DATE;      }
  public ABCMdbField getField_InstructionOrder(){   return INSTRUCTION_ORDER;     }
  public ABCMdbField getField_NarrativeCommandFK(){ return FK_NARRATIVE_COMMAND;  }
  public ABCMdbField getField_Arg1(){               return ARG_1;                 }
  public ABCMdbField getField_Arg2(){               return ARG_2;                 }
  public ABCMdbField getField_Arg3(){               return ARG_3;                 }
  public ABCMdbField getField_Arg4(){               return ARG_4;                 }
  public ABCMdbField getField_Arg5(){               return ARG_5;                 }
  public ABCMdbField getField_Arg6(){               return ARG_6;                 }
  public ABCMdbField getField_Arg7(){               return ARG_7;                 }
  public ABCMdbField getField_Arg8(){               return ARG_8;                 }
  public ABCMdbField getField_Arg9(){               return ARG_9;                 }
  public ABCMdbField getField_Arg10(){              return ARG_10;                }
  public ABCMdbField getField_Comment(){            return COMMENT;               }

}
 
