 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMNarrativesTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultNarrativesTable extends ABCMNarrativesTable {

  protected ABCMdbField PK, NAME, DESC, FK_RESEARCHER, BASE_DATE, DATE_CREATED, SEASONAL;

  public ABCMDefaultNarrativesTable(ABCMResearchersTable researchersTable){
    super("tblNarratives");
    PK            = createAndAddField("intNarrativeID",     INT,                true);
    NAME          = createAndAddField("vcharNarrativeName", false, VCHAR50      );
    DESC          = createAndAddField("txtDescription",     false, TEXT             );
    FK_RESEARCHER = createAndAddField("intResearcherID",    false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    BASE_DATE     = createAndAddField("dblBaseDate",        false, FLOAT8             );
    DATE_CREATED  = createAndAddField("dteDateCreated",     false, DATETIME         );
    SEASONAL      = createAndAddField("blnIsSeasonal",      false, BIT              );

    addIndex(new ABCMdbIndex("NoDupNarrativeNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Name(){         return NAME;           }
  public ABCMdbField getField_Description(){  return DESC;           }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_BaseDate(){     return BASE_DATE;      }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_Seasonal(){     return SEASONAL;       }
 
}
 
