 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;
import abcm.db.components.tables.ABCMParameterAppliesToCodeModelTable;
import abcm.db.components.tables.ABCMParametersTable;
 
public class ABCMDefaultParameterAppliesToCodeModelTable extends ABCMParameterAppliesToCodeModelTable {

  protected ABCMdbField PK, FK_PARAMETER, FK_CODE_MODEL_OPTION, FK_CODE_MODEL_OPTION_VALUE;

  public ABCMDefaultParameterAppliesToCodeModelTable(ABCMParametersTable parametersTable,
      ABCMCodeModelOptionValuesTable codeModelOptionValuesTable){
    super("tblParameterAppliesToCodeModel");
    PK                         = createAndAddField("intParameterAppliesToCodeModelOptionID", INT,        true);
    FK_PARAMETER               = createAndAddField("intParameterID",                         false, INT,
        parametersTable.getName(), parametersTable.getField_PK().getName());
    FK_CODE_MODEL_OPTION       = createAndAddField("intCodeModelOptionDomainID",             false, INT      );
    FK_CODE_MODEL_OPTION_VALUE = createAndAddField("intOptionValue",                         false, INT      );


    addFK( new ABCMdbForeignKey("tblParameterAppliesToCodeModelFK", "tblCodeModelOptionValues", 
        new String[]{codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getName(), 
          codeModelOptionValuesTable.getField_OptionValue().getName()}, 
        new String[]{getField_CodeModelOptionDomainFK().getName(), getField_OptionValueFK().getName()}));
    addIndex(new ABCMdbIndex("NoDupParameterAppToCM", 
        new String[]{ getField_ParameterFK().getName(), 
          getField_CodeModelOptionDomainFK().getName(), 
          getField_OptionValueFK().getName() }));

  }

  public ABCMdbField getField_PK(){                      return PK;                          }
  public ABCMdbField getField_ParameterFK(){             return FK_PARAMETER;                }
  public ABCMdbField getField_CodeModelOptionDomainFK(){ return FK_CODE_MODEL_OPTION;        }
  public ABCMdbField getField_OptionValueFK(){           return FK_CODE_MODEL_OPTION_VALUE;  }
 
}
 
