 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMParameterCommentsTable;
import abcm.db.components.tables.ABCMParametersTable;
 
public class ABCMDefaultParameterCommentsTable extends ABCMParameterCommentsTable {

  protected ABCMdbField PK, FK_PARAMETER, FK_COMMENT;

  public ABCMDefaultParameterCommentsTable(ABCMParametersTable parametersTable,
      ABCMCommentsTable commentsTable){
    super("tblParameterComments");
    PK           = createAndAddField("intParameterCommentID", INT,        true);
    FK_PARAMETER = createAndAddField("intParameterID",        false, INT,
        parametersTable.getName(), parametersTable.getField_PK().getName());
    FK_COMMENT   = createAndAddField("intCommentID",          false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupParamComments", 
        new String[]{ getField_ParameterFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;            }
  public ABCMdbField getField_ParameterFK(){ return FK_PARAMETER;  }
  public ABCMdbField getField_CommentFK(){   return FK_COMMENT;    }
 
}
 
