 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMParameterSetCommentsTable;
import abcm.db.components.tables.ABCMParameterSetsTable;
 
public class ABCMDefaultParameterSetCommentsTable extends ABCMParameterSetCommentsTable {

  protected ABCMdbField PK, FK_PARAMETER_SET, FK_COMMENT;

  public ABCMDefaultParameterSetCommentsTable(ABCMParameterSetsTable parameterSetsTable,
      ABCMCommentsTable commentsTable){
    super("tblParameterSetComments");
    PK               = createAndAddField("intParameterSetCommentID", INT,        true);
    FK_PARAMETER_SET = createAndAddField("intParameterSetID",        false, INT,
        parameterSetsTable.getName(), parameterSetsTable.getField_PK().getName());
    FK_COMMENT       = createAndAddField("intCommentID",             false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupParamSetComments", new String[]{ getField_ParameterSetFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){             return PK;                }
  public ABCMdbField getField_ParameterSetFK(){ return FK_PARAMETER_SET;  }
  public ABCMdbField getField_CommentFK(){      return FK_COMMENT;        }
 
}
 
