 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMParameterSetsAndValuesTable;
import abcm.db.components.tables.ABCMParametersTable;
import abcm.db.components.tables.ABCMTruthValuesTable;
 
public class ABCMDefaultParameterSetsAndValuesTable extends ABCMParameterSetsAndValuesTable {

  protected ABCMdbField PK, FK_PARAMETER_SET, FK_PARAMETER, VALUE, TRUTH_VALUE;

  public ABCMDefaultParameterSetsAndValuesTable(ABCMParametersTable parametersTable, ABCMTruthValuesTable truthValuesTable){
    super("tblParameterSetsAndValues");
    PK                 = createAndAddField("intParameterSetParameterID",      INT,                true);
    FK_PARAMETER_SET   = createAndAddField("intParameterSetID",               INT,                false);
    FK_PARAMETER       = createAndAddField("intParameterID",                  false,               INT,
        parametersTable.getName(), parametersTable.getField_PK().getName());
    VALUE              = createAndAddField("dblValue",                        false,               FLOAT8    );
    TRUTH_VALUE        = createAndAddField("intTruthValue",                   false,               INT,
        truthValuesTable.getName(), truthValuesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupEntriesForParamInParamSet", new String[]{ getField_ParameterSet_FK().getName(), getField_Parameter_FK().getName() }));
    

  }

  public ABCMdbField getField_PK(){               return PK;                 }
  public ABCMdbField getField_ParameterSet_FK(){  return FK_PARAMETER_SET;   }
  public ABCMdbField getField_Parameter_FK(){     return FK_PARAMETER;       }
  public ABCMdbField getField_Value(){            return VALUE;              }
  public ABCMdbField getField_TruthValue(){       return TRUTH_VALUE;        }
}
 
