 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultParameterSetsTable extends ABCMParameterSetsTable {

  protected ABCMdbField PK, NAME, DATE_CREATED, IS_AUTOMATIC, DESC, FK_RESEARCHER;

  public ABCMDefaultParameterSetsTable(ABCMResearchersTable researchersTable){
    super("tblParameterSets");
    PK            = createAndAddField("intParameterSetID",     INT,                true);
    NAME          = createAndAddField("vcharParameterSetName", false, VCHAR50      );
    DATE_CREATED  = createAndAddField("dteDateCreated",        false, DATETIME         );
    IS_AUTOMATIC  = createAndAddField("blnAutomatic",          false, BIT              );
    DESC          = createAndAddField("memDescription",        false, TEXT             );
    FK_RESEARCHER = createAndAddField("intResearcherID",       false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupParamSetNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Name(){         return NAME;           }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_IsAutomatic(){  return IS_AUTOMATIC;   }
  public ABCMdbField getField_Description(){  return DESC;           }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
 
}
 
