 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMParameterCategoriesTable;
import abcm.db.components.tables.ABCMParametersTable;
 
public class ABCMDefaultParametersTable extends ABCMParametersTable {

  protected ABCMdbField PK, NAME, DESC, DATE_CREATED, DEFAULT_VALUE, MINIMUM_VALUE, MAXIMUM_VALUE, UNITS, IS_ENGINE, FK_PARAMETER_CATEGORY, ORDER;

  public ABCMDefaultParametersTable(ABCMParameterCategoriesTable parameterCategoriesTable){
    super("tblParameters");
    PK                    = createAndAddField("intParameterID",         INT,                true);
    NAME                  = createAndAddField("vcharParameterName",     false, VCHAR50        );
    DESC                  = createAndAddField("txtDescription",         false, TEXT           );
    DATE_CREATED          = createAndAddField("dteDateAdded",           false, VCHAR50        );
    DEFAULT_VALUE         = createAndAddField("dblDefaultValue",        false, FLOAT8         );
    MINIMUM_VALUE         = createAndAddField("dblMinValue",            false, FLOAT8         );
    MAXIMUM_VALUE         = createAndAddField("dblMaxValue",            false, FLOAT8         );
    UNITS                 = createAndAddField("txtUnits",               false, VCHAR10        );
    IS_ENGINE             = createAndAddField("blnEngine",              false, BIT          );
    FK_PARAMETER_CATEGORY = createAndAddField("intParameterCategoryID", false, INT,
        parameterCategoriesTable.getName(), parameterCategoriesTable.getField_PK().getName());
    ORDER                 = createAndAddField("intOrderInCategory",     false, INT            );

    addIndex(new ABCMdbIndex("NoDupParameterNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){                  return PK;                     }
  public ABCMdbField getField_Name(){                return NAME;                   }
  public ABCMdbField getField_Description(){         return DESC;                   }
  public ABCMdbField getField_DateCreated(){         return DATE_CREATED;           }
  public ABCMdbField getField_DefaultValue(){        return DEFAULT_VALUE;          }
  public ABCMdbField getField_Minimum(){             return MINIMUM_VALUE;          }
  public ABCMdbField getField_Maximum(){             return MAXIMUM_VALUE;          }
  public ABCMdbField getField_Units(){               return UNITS;                  }
  public ABCMdbField getField_IsEngine(){            return IS_ENGINE;              }
  public ABCMdbField getField_ParameterCategoryFK(){ return FK_PARAMETER_CATEGORY;  }
  public ABCMdbField getField_Order(){               return ORDER;                  }
 
}
 
