 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMProbeCommentsTable;
import abcm.db.components.tables.ABCMProbesTable;
 
public class ABCMDefaultProbeCommentsTable extends ABCMProbeCommentsTable {

  protected ABCMdbField PK, FK_PROBE, FK_COMMENT;

  public ABCMDefaultProbeCommentsTable(ABCMProbesTable probesTable,
      ABCMCommentsTable commentsTable){
    super("tblProbeComments");
    PK         = createAndAddField("intProbeCommentID", INT,        true);
    FK_PROBE   = createAndAddField("intProbeID",        false, INT,
        probesTable.getName(), probesTable.getField_PK().getName());
    FK_COMMENT   = createAndAddField("intCommentID",          false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupProbComments", new String[]{ getField_ProbeFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){        return PK;          }
  public ABCMdbField getField_ProbeFK(){   return FK_PROBE;    }
  public ABCMdbField getField_CommentFK(){ return FK_COMMENT;  }
 
}
 
