 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMProbeSetCommentsTable;
import abcm.db.components.tables.ABCMProbeSetsTable;
 
public class ABCMDefaultProbeSetCommentsTable extends ABCMProbeSetCommentsTable {

  protected ABCMdbField PK, FK_PROBE_SET, FK_COMMENT;

  public ABCMDefaultProbeSetCommentsTable(ABCMProbeSetsTable probeSetsTable,
      ABCMCommentsTable commentsTable){
    super("tblProbeSetComments");
    PK           = createAndAddField("intProbeSetCommentID", INT,        true);
    FK_PROBE_SET = createAndAddField("intProbeSetID",        false, INT,
        probeSetsTable.getName(), probeSetsTable.getField_PK().getName());
    FK_COMMENT   = createAndAddField("intCommentID",         false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupProbeSetComments", new String[]{ getField_ProbeSetFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){         return PK;            }
  public ABCMdbField getField_ProbeSetFK(){ return FK_PROBE_SET;  }
  public ABCMdbField getField_CommentFK(){  return FK_COMMENT;    }
 
}
 
