 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMProbeSetProbesTable;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMProbesTable;
 
public class ABCMDefaultProbeSetProbesTable extends ABCMProbeSetProbesTable {

  protected ABCMdbField PK, FK_PROBE_SET, FK_PROBE;

  public ABCMDefaultProbeSetProbesTable(ABCMProbeSetsTable probeSetsTable,
      ABCMProbesTable probesTable){
    super("tblProbeSetProbes");
    PK           = createAndAddField("intProbeSetProbeID", INT, true);
    FK_PROBE_SET = createAndAddField("intProbeSetID", false, INT,
        probeSetsTable.getName(), probeSetsTable.getField_PK().getName());
    FK_PROBE     = createAndAddField("intProbeID",    false, INT,
        probesTable.getName(), probesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoProbeInProbeSetTwice", 
        new String[]{ getField_ProbeSetFK().getName(), getField_ProbeFK().getName() }));

  }

  public ABCMdbField getField_PK(){         return PK;            }
  public ABCMdbField getField_ProbeSetFK(){ return FK_PROBE_SET;  }
  public ABCMdbField getField_ProbeFK(){    return FK_PROBE;      }
 
}
 
