 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultProbeSetsTable extends ABCMProbeSetsTable {

  protected ABCMdbField PK, NAME, DATE_CREATED, FK_RESEARCHER, DESC;

  public ABCMDefaultProbeSetsTable(ABCMResearchersTable researchersTable){
    super("tblProbeSets");
    PK            = createAndAddField("intProbeSetID",     INT,                true);
    NAME          = createAndAddField("vcharProbeSetName", false, VCHAR50      );
    DATE_CREATED  = createAndAddField("dteDateCreated",    false, DATETIME         );
    FK_RESEARCHER = createAndAddField("intResearcherID",   false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DESC          = createAndAddField("txtDescription",    false, TEXT             );

    addIndex(new ABCMdbIndex("NoDupProbeSetnames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Name(){         return NAME;           }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_Description(){  return DESC;           }
 
}
 
