 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMProbesTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultProbesTable extends ABCMProbesTable {

  protected ABCMdbField PK, NAME, DESC, DATE_CREATED, FK_RESEARCHER, 
      DATA_SERIES_NAME, DATA_SERIES_DOMAIN, IS_NUMERIC, 
      IS_MONTHLY, BASE_DATE, FREQUENCY, RETRIEVE, OFFSET;

  public ABCMDefaultProbesTable(ABCMResearchersTable researchersTable){
    super("tblProbes");
    PK                 = createAndAddField("intProbeID",            INT,                 true);
    NAME               = createAndAddField("vcharProbeName",        false, VCHAR100      );
    DESC               = createAndAddField("txtDescription",        false, TEXT              );
    DATE_CREATED       = createAndAddField("dteDateCreated",        false, DATETIME          );
    FK_RESEARCHER      = createAndAddField("intResearcherID",       false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DATA_SERIES_NAME   = createAndAddField("vcharDataSeriesName",   false, VCHAR50       );
    DATA_SERIES_DOMAIN = createAndAddField("vcharDataSeriesDomain", false, VCHAR50       );
    IS_NUMERIC         = createAndAddField("blnIsNumeric",          false, BIT               );
    IS_MONTHLY         = createAndAddField("blnIsMonthly",          false, BIT               );
    BASE_DATE          = createAndAddField("dblBaseDate",           false, FLOAT8              );
    FREQUENCY          = createAndAddField("dblFrequency",          false, INT               );
    RETRIEVE           = createAndAddField("txtRetrieve",           false, TEXT              );
    OFFSET             = createAndAddField("dblOffset",             false, FLOAT8              );

    addIndex(new ABCMdbIndex("NoDupProbeNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){               return PK;                  }
  public ABCMdbField getField_Name(){             return NAME;                }
  public ABCMdbField getField_Description(){      return DESC;                }
  public ABCMdbField getField_DateCreated(){      return DATE_CREATED;        }
  public ABCMdbField getField_ResearcherFK(){     return FK_RESEARCHER;       }
  public ABCMdbField getField_DataSeriesName(){   return DATA_SERIES_NAME;    }
  public ABCMdbField getField_DataSeriesDomain(){ return DATA_SERIES_DOMAIN;  }
  public ABCMdbField getField_IsNumeric(){        return IS_NUMERIC;          }
  public ABCMdbField getField_IsMonthly(){        return IS_MONTHLY;          }
  public ABCMdbField getField_BaseDate(){         return BASE_DATE;           }
  public ABCMdbField getField_Frequency(){        return FREQUENCY;           }
  public ABCMdbField getField_Retrieve(){         return RETRIEVE;            }
  public ABCMdbField getField_Offset(){           return OFFSET;              }
 
}
 
