 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMProjectResearchersTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultProjectResearchersTable extends ABCMProjectResearchersTable {

  protected ABCMdbField PK, FK_RESEARCHER, USERNAME, PASSWORD, IS_ADMINISTRATOR;

  public ABCMDefaultProjectResearchersTable(ABCMResearchersTable researchersTable){
    super("tblProjectResearchers");
    PK               = createAndAddField("intProjectResearcherID",           INT,                true);
    FK_RESEARCHER    = createAndAddField("intResearcherID",    false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    USERNAME         = createAndAddField("vcharUserName",      false, VCHAR50      );
    PASSWORD         = createAndAddField("vcharPassword",      false, VCHAR50      );
    IS_ADMINISTRATOR = createAndAddField("blnIsAdministrator", false, BIT              );

    addIndex(new ABCMdbIndex("NoDupResearchers", new String[]{ getField_ResearcherFK().getName() }));
    addIndex(new ABCMdbIndex("NoDupUsernames", new String[]{ getField_Username().getName() }));

  }
  
  public ABCMdbField getField_PK(){              return PK;                }
  public ABCMdbField getField_ResearcherFK(){    return FK_RESEARCHER;     }
  public ABCMdbField getField_Username(){        return USERNAME;          }
  public ABCMdbField getField_Password(){        return PASSWORD;          }
  public ABCMdbField getField_IsAdministrator(){ return IS_ADMINISTRATOR;  }
  
}
 
