 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMReferenceCommentsTable;
import abcm.db.components.tables.ABCMReferencesTable;
 
public class ABCMDefaultReferenceCommentsTable extends ABCMReferenceCommentsTable {

  protected ABCMdbField PK, FK_REFERENCE, PAGES, FK_COMMENT;

  public ABCMDefaultReferenceCommentsTable(ABCMReferencesTable referencesTable,
      ABCMCommentsTable commentsTable){
    super("tblReferenceComments");
    PK           = createAndAddField("intRefCommentID", INT,                true);
    FK_REFERENCE = createAndAddField("intReferenceID",  false, INT,
        referencesTable.getName(), referencesTable.getField_PK().getName());
    PAGES        = createAndAddField("vcharPages",      false, VCHAR16      );
    FK_COMMENT   = createAndAddField("intCommentID",    false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupRefComments", new String[]{ getField_ReferenceFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;            }
  public ABCMdbField getField_ReferenceFK(){ return FK_REFERENCE;  }
  public ABCMdbField getField_Pages(){       return PAGES;         }
  public ABCMdbField getField_CommentFK(){   return FK_COMMENT;    }
 
}
 
