 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMReferencesAndAuthorsTable;
import abcm.db.components.tables.ABCMReferencesTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultReferencesAndAuthorsTable extends ABCMReferencesAndAuthorsTable {

  protected ABCMdbField PK, FK_REFERENCE, AUTHOR_ORDER, FK_RESEARCHER;

  public ABCMDefaultReferencesAndAuthorsTable(ABCMReferencesTable referencesTable,
      ABCMResearchersTable researchersTable){
    super("tblReferencesAndAuthors");
    PK            = createAndAddField("intRefAuthorID",  INT,        true);
    FK_REFERENCE  = createAndAddField("intReferenceID",  false, INT,
        referencesTable.getName(), referencesTable.getField_PK().getName());
    AUTHOR_ORDER  = createAndAddField("intAuthorOrder",  false, INT      );
    FK_RESEARCHER = createAndAddField("intResearcherID", false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoAuthorTwicePerRef", new String[]{ getField_ReferenceFK().getName(), getField_ResearcherFK().getName() }));
    addIndex(new ABCMdbIndex("NoDupAuthorOrder", new String[]{ getField_ReferenceFK().getName(), getField_AuthorOrder().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_ReferenceFK(){  return FK_REFERENCE;   }
  public ABCMdbField getField_AuthorOrder(){  return AUTHOR_ORDER;   }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
 
}
 
