 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMReferenceCategoriesTable;
import abcm.db.components.tables.ABCMReferencesAndCategoriesTable;
import abcm.db.components.tables.ABCMReferencesTable;
 
public class ABCMDefaultReferencesAndCategoriesTable extends ABCMReferencesAndCategoriesTable {

  protected ABCMdbField PK, FK_REFERENCE, FK_REF_CATEGORY;

  public ABCMDefaultReferencesAndCategoriesTable(ABCMReferencesTable referencesTable,
      ABCMReferenceCategoriesTable referenceCategoriesTable){
    super("tblReferencesAndCategories");
    PK              = createAndAddField("intRefCategoryID", INT,        true);
    FK_REFERENCE    = createAndAddField("intReferenceID",   false, INT,
        referencesTable.getName(), referencesTable.getField_PK().getName());
    FK_REF_CATEGORY = createAndAddField("intCategoryID",    false, INT,
        referenceCategoriesTable.getName(), referenceCategoriesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupRefCatEntries", 
        new String[]{ getField_ReferenceFK().getName(), getField_CategoryFK().getName() }));

  }

  public ABCMdbField getField_PK(){          return PK;               }
  public ABCMdbField getField_ReferenceFK(){ return FK_REFERENCE;     }
  public ABCMdbField getField_CategoryFK(){  return FK_REF_CATEGORY;  }
 
}
 
