 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMReferenceWorkTypesTable;
import abcm.db.components.tables.ABCMReferencesTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultReferencesTable extends ABCMReferencesTable {

  protected ABCMdbField PK, TITLE, REF_DATE, SUMMARY, ABSTRACT, FK_REFERENCE_TYPES, FK_RESEARCHER, LOCATION;

  public ABCMDefaultReferencesTable(ABCMReferenceWorkTypesTable referenceWorkTypesTable,
      ABCMResearchersTable researchersTable){
    super("tblReferences");
    PK                 = createAndAddField("intReferenceID",         INT,                 true);
    TITLE              = createAndAddField("vcharTitle",             false, VCHAR200      );
    REF_DATE           = createAndAddField("vcharDate",              false, VCHAR10       );
    SUMMARY            = createAndAddField("txtSummary",             false, TEXT              );
    ABSTRACT           = createAndAddField("txtAbstract",            false, TEXT              );
    FK_REFERENCE_TYPES = createAndAddField("intTypeOfWork",          false, INT,
        referenceWorkTypesTable.getName(), referenceWorkTypesTable.getField_PK().getName());
    FK_RESEARCHER      = createAndAddField("intAddedByResearcherID", false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    LOCATION           = createAndAddField("vcharLocation",          false, VCHAR255      );

  }

  public ABCMdbField getField_PK(){              return PK;                  }
  public ABCMdbField getField_Title(){           return TITLE;               }
  public ABCMdbField getField_ReferenceDate(){   return REF_DATE;            }
  public ABCMdbField getField_Summary(){         return SUMMARY;             }
  public ABCMdbField getField_Abstract(){        return ABSTRACT;            }
  public ABCMdbField getField_ReferenceTypeFK(){ return FK_REFERENCE_TYPES;  }
  public ABCMdbField getField_ResearcherFK(){    return FK_RESEARCHER;       }
  public ABCMdbField getField_Location(){        return LOCATION;            }

 
}
 
