 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearcherSessionsTable;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultResearcherSessionsTable extends ABCMResearcherSessionsTable {
 
  protected ABCMdbField PK, FK_RESEARCHER, LOGIN_AUTHORIZED_TIME, SESSION_BEGIN, SESSION_END;

  public ABCMDefaultResearcherSessionsTable(ABCMResearchersTable researchersTable){
    super("tblResearcherSessions");
    PK                    = createAndAddField("intLoginRecordID",     INT,             true);
    FK_RESEARCHER         = createAndAddField("intResearcherID",      false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    LOGIN_AUTHORIZED_TIME = createAndAddField("dteLoginAuthorizedAt", false, DATETIME      );
    SESSION_BEGIN         = createAndAddField("dteSessionBeginAt",    false, DATETIME      );
    SESSION_END           = createAndAddField("dteSessionEndAt",      true,  DATETIME      );

  }

  public ABCMdbField getField_PK(){                     return PK;                     }
  public ABCMdbField getField_ResearcherFK(){           return FK_RESEARCHER;          }
  public ABCMdbField getField_LoginAuthorizationTime(){ return LOGIN_AUTHORIZED_TIME;  }
  public ABCMdbField getField_SessionBeginTime(){       return SESSION_BEGIN;          }
  public ABCMdbField getField_SessionEndTime(){         return SESSION_END;            }
  
}
 
