 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class ABCMDefaultResearchersTable extends ABCMResearchersTable {
 
  protected ABCMdbField PK, NAME, LAST_FIRST, DESC;

  public ABCMDefaultResearchersTable(){
    super("tblResearchers");
    PK         = createAndAddField("intResearcherID",          INT,                true);
    NAME       = createAndAddField("vcharResearcherName",      false, VCHAR50      );
    LAST_FIRST = createAndAddField("vcharResearcherLastFirst", false, VCHAR50      );
    DESC       = createAndAddField("txtDescription",           false, TEXT             );

    addIndex(new ABCMdbIndex("NoDupResearchers", new String[]{ getField_ResearcherName().getName() }));
    addIndex(new ABCMdbIndex("NoDupNames", new String[]{ getField_LastNameFirstName().getName() }));

  }

  public ABCMdbField getField_PK(){                return PK;          }
  public ABCMdbField getField_ResearcherName(){    return NAME;        }
  public ABCMdbField getField_LastNameFirstName(){ return LAST_FIRST;  }
  public ABCMdbField getField_Description(){       return DESC;        }
  
}
 
