 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMSimulationCommentsTable;
import abcm.db.components.tables.ABCMSimulationsTable;
 
public class ABCMDefaultSimulationCommentsTable extends ABCMSimulationCommentsTable {

  protected ABCMdbField PK, FK_SIMULATION, FK_COMMENT;

  public ABCMDefaultSimulationCommentsTable(ABCMSimulationsTable simulationsTable,
      ABCMCommentsTable commentsTable){
    super("tblSimulationComments");
    PK            = createAndAddField("intSimulationCommentID", INT,        true);
    FK_SIMULATION = createAndAddField("intSimulationID",        false, INT,
        simulationsTable.getName(), simulationsTable.getField_PK().getName());
    FK_COMMENT    = createAndAddField("intCommentID",           false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupSimComments", new String[]{ getField_SimulationFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_SimulationFK(){ return FK_SIMULATION;  }
  public ABCMdbField getField_CommentFK(){    return FK_COMMENT;     }
 
}
 
