 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationCommentsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
 
public class ABCMDefaultSimulationConfigurationCommentsTable extends ABCMSimulationConfigurationCommentsTable {

  protected ABCMdbField PK, FK_SIMULATION_CONFIGURATION, FK_COMMENT;

  public ABCMDefaultSimulationConfigurationCommentsTable(ABCMSimulationConfigurationsTable simulationConfigurationsTable,
      ABCMCommentsTable commentsTable){
    super("tblSimulationConfigurationComments");
    PK                          = createAndAddField("intSimulationConfigurationCommentID", INT,        true);
    FK_SIMULATION_CONFIGURATION = createAndAddField("intSimulationConfigurationID",        false, INT,
        simulationConfigurationsTable.getName(), simulationConfigurationsTable.getField_PK().getName());
    FK_COMMENT                  = createAndAddField("intCommentID",                        false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupSimConfigComments", new String[]{ getField_SimulationConfigurationFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){                        return PK;                           }
  public ABCMdbField getField_SimulationConfigurationFK(){ return FK_SIMULATION_CONFIGURATION;  }
  public ABCMdbField getField_CommentFK(){                 return FK_COMMENT;                   }
 
}
 
