 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
 
public class ABCMDefaultSimulationConfigurationsTable extends ABCMSimulationConfigurationsTable {

  protected ABCMdbField PK, NAME, DESC, DATE_CREATED, FK_RESEARCHER;

  public ABCMDefaultSimulationConfigurationsTable(ABCMResearchersTable researchersTable){
    super("tblSimulationConfigurations");
    PK            = createAndAddField("intSimulationConfigurationID", INT,                 true);
    NAME          = createAndAddField("vcharSimConfigName",           false, VCHAR100      );
    DESC          = createAndAddField("txtDescription",               false, TEXT              );
    DATE_CREATED  = createAndAddField("dteDateCreated",               false, DATETIME          );
    FK_RESEARCHER = createAndAddField("intResearcherID",              false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupSimConfigNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Name(){         return NAME;           }
  public ABCMdbField getField_Description(){  return DESC;           }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
 
}
 
