 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
 
public class ABCMDefaultSimulationDataSeriesTable extends ABCMSimulationDataSeriesTable {

  protected ABCMdbField PK, FK_SIMULATION_RUN, NAME, DESC, IS_NUMERIC;

  public ABCMDefaultSimulationDataSeriesTable(ABCMSimulationRunsTable simulationRunsTable){
    super("tblSimulationDataSeries");
    PK                = createAndAddField("intDataSeriesID",    INT,                 true);
    FK_SIMULATION_RUN = createAndAddField("intSimulationRunID", false, INT,
        simulationRunsTable.getName(), simulationRunsTable.getField_PK().getName());
    NAME              = createAndAddField("vcharSeriesName",    false, VCHAR100      );
    DESC              = createAndAddField("vcharDescription",   false, VCHAR200      );
    IS_NUMERIC        = createAndAddField("blnIsNumeric",       false, BIT               );

    addIndex(new ABCMdbIndex("NoDupSeriesInSim", 
        new String[]{ getField_SimulationRunFK().getName(), getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){              return PK;                 }
  public ABCMdbField getField_SimulationRunFK(){ return FK_SIMULATION_RUN;  }
  public ABCMdbField getField_Name(){            return NAME;               }
  public ABCMdbField getField_Description(){     return DESC;               }
  public ABCMdbField getField_IsNumeric(){       return IS_NUMERIC;         }
 
}
 
