 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMRunModesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;
 
public class ABCMDefaultSimulationRunsTable extends ABCMSimulationRunsTable {

  protected ABCMdbField PK, DATE_CREATED, FK_SIMULATION, FK_PARAMETER_SET, 
      FK_PROBE_SET, FK_RUN_MODE, FK_RESEARCHER, NOTES, 
      RANDOM_NUMBER_SEED, RERUN_ID, IS_REPRODUCIBLE;

  public ABCMDefaultSimulationRunsTable(ABCMSimulationsTable simulationsTable,
      ABCMParameterSetsTable parameterSetsTable, ABCMProbeSetsTable probeSetsTable,
      ABCMRunModesTable runModesTable, ABCMResearchersTable researchersTable){
    super("tblSimulationRuns");
    PK                 = createAndAddField("intSimulationRunID",   INT,             true);
    DATE_CREATED       = createAndAddField("dteDateTimeBegun",     false, DATETIME      );
    FK_SIMULATION      = createAndAddField("intSimulationID",      false, INT,
        simulationsTable.getName(), simulationsTable.getField_PK().getName());
    FK_PARAMETER_SET   = createAndAddField("intParameterSetID",    false, INT,
        parameterSetsTable.getName(), parameterSetsTable.getField_PK().getName());
    FK_PROBE_SET       = createAndAddField("intProbeSetID",        false, INT,
        probeSetsTable.getName(), probeSetsTable.getField_PK().getName());
    FK_RUN_MODE        = createAndAddField("intMode",              false, INT,
        runModesTable.getName(), runModesTable.getField_PK().getName());
    FK_RESEARCHER      = createAndAddField("intResearcherID",      false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    NOTES              = createAndAddField("txtNotes",             true,  TEXT          );
    RANDOM_NUMBER_SEED = createAndAddField("intRandomNumberSeed",  false, INT           );
    RERUN_ID           = createAndAddField("intReRunOfID",         true,  INT,
        this.name, PK.getName());
    IS_REPRODUCIBLE    = createAndAddField("blnRunIsReproducible", true,  BIT           );

  }

  public ABCMdbField getField_PK(){               return PK;                  }
  public ABCMdbField getField_DateCreated(){      return DATE_CREATED;        }
  public ABCMdbField getField_SimulationFK(){     return FK_SIMULATION;       }
  public ABCMdbField getField_ParameterSetFK(){   return FK_PARAMETER_SET;    }
  public ABCMdbField getField_ProbeSetFK(){       return FK_PROBE_SET;        }
  public ABCMdbField getField_RunModeFK(){        return FK_RUN_MODE;         }
  public ABCMdbField getField_ResearcherFK(){     return FK_RESEARCHER;       }
  public ABCMdbField getField_Notes(){            return NOTES;               }
  public ABCMdbField getField_RandomNumberSeed(){ return RANDOM_NUMBER_SEED;  }
  public ABCMdbField getField_RerunID(){          return RERUN_ID;            }
  public ABCMdbField getField_IsReproducible(){   return IS_REPRODUCIBLE;     }
 
}
 
