 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationsTable;
 
public class ABCMDefaultSimulationsTable extends ABCMSimulationsTable {

  protected ABCMdbField PK, TITLE, FK_CODE_MODEL, FK_DATA_MODEL, DATE_CREATED, FK_RESEARCHER, DESC;

  public ABCMDefaultSimulationsTable(ABCMCodeModelsTable codeModelsTable,
      ABCMDataModelsTable dataModelsTable, ABCMResearchersTable researchersTable){
    super("tblSimulations");
    PK            = createAndAddField("intSimulationID",      INT,                 true);
    TITLE         = createAndAddField("vcharSimulationTitle", false, VCHAR100      );
    FK_CODE_MODEL = createAndAddField("intCodeModelID",       false, INT,
        codeModelsTable.getName(), codeModelsTable.getField_PK().getName());
    FK_DATA_MODEL = createAndAddField("intDataModelID",       false, INT,
        dataModelsTable.getName(), dataModelsTable.getField_PK().getName());
    DATE_CREATED  = createAndAddField("dteDateCreated",       false, DATETIME          );
    FK_RESEARCHER = createAndAddField("intResearcherID",      false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    DESC          = createAndAddField("txtDescription",       false, TEXT              );

    addIndex(new ABCMdbIndex("NoDupSimulationTitles", new String[]{ getField_Title().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Title(){        return TITLE;          }
  public ABCMdbField getField_CodeModelFK(){  return FK_CODE_MODEL;  }
  public ABCMdbField getField_DataModelFK(){  return FK_DATA_MODEL;  }
  public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
  public ABCMdbField getField_Description(){  return DESC;           }
 
}
 
