 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSummariesTable;
 
public class ABCMDefaultSummariesTable extends ABCMSummariesTable {

    protected ABCMdbField PK, TITLE, DESC, SUMMARY, CONCLUSION, FK_RESEARCHER, DATE_CREATED;

    public ABCMDefaultSummariesTable(ABCMResearchersTable researchersTable){
      super("tblSummaries");
      PK            = createAndAddField("intSummaryID",      INT,                 true);
      TITLE         = createAndAddField("vcharSummaryTitle", false, VCHAR100      );
      DESC          = createAndAddField("txtDescription",    false, TEXT              );
      SUMMARY       = createAndAddField("txtSummary",        false, TEXT              );
      CONCLUSION    = createAndAddField("txtConclusion",     false, TEXT              );
      FK_RESEARCHER = createAndAddField("intResearcherID",   false, INT,
          researchersTable.getName(), researchersTable.getField_PK().getName());
      DATE_CREATED  = createAndAddField("dteDateCreated",    false, DATETIME          );

      addIndex(new ABCMdbIndex("NoDupSummaryTitles", new String[]{ getField_Title().getName() }));

    }

    public ABCMdbField getField_PK(){           return PK;             }
    public ABCMdbField getField_Title(){        return TITLE;          }
    public ABCMdbField getField_Description(){  return DESC;           }
    public ABCMdbField getField_Summary(){      return SUMMARY;        }
    public ABCMdbField getField_Conclusion(){   return CONCLUSION;     }
    public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
    public ABCMdbField getField_DateCreated(){  return DATE_CREATED;   }

 
}
 
