 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;
 
public class ABCMDefaultSummaryAnalysesTable extends ABCMSummaryAnalysesTable {

    protected ABCMdbField PK, FK_SUMMARY, FK_ANALYSIS, DESC, ORDER;

    public ABCMDefaultSummaryAnalysesTable(ABCMSummariesTable summariesTable,
        ABCMAnalysesTable analysesTable){
      super("tblSummaryAnalyses");
      PK          = createAndAddField("intSummaryAnalysisID", INT,         true);
      FK_SUMMARY  = createAndAddField("intSummaryID",         false, INT,
          summariesTable.getName(), summariesTable.getField_PK().getName());
      FK_ANALYSIS = createAndAddField("intAnalysisID",        false, INT,
          analysesTable.getName(), analysesTable.getField_PK().getName());
      DESC        = createAndAddField("txtDescription",       false, TEXT      );
      ORDER       = createAndAddField("intOrder",             false, INT);

      // An analysis may only appear in a summary once- no repetition
      addIndex(new ABCMdbIndex("NoDupSummaryAnalyses", new String[]{ getField_SummaryFK().getName(), getField_AnalysisFK().getName()  }));
      
      // Analyses occur in an order, which is unique; no duplicate order numbers are allowed
      addIndex(new ABCMdbIndex("NoDupSummaryAnalysisOrders", new String[]{ getField_SummaryFK().getName(), getField_Order().getName() }));

    }

    public ABCMdbField getField_PK(){          return PK;           }
    public ABCMdbField getField_SummaryFK(){   return FK_SUMMARY;   }
    public ABCMdbField getField_AnalysisFK(){  return FK_ANALYSIS;  }
    public ABCMdbField getField_Description(){ return DESC;         }
    public ABCMdbField getField_Order(){       return ORDER;        }

 
}
 
