 
package abcm.db.components.defaults.tables;  
 
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryCommentsTable;
 
public class ABCMDefaultSummaryCommentsTable extends ABCMSummaryCommentsTable {

  protected ABCMdbField PK, FK_SUMMARY, FK_COMMENT;

  public ABCMDefaultSummaryCommentsTable(ABCMSummariesTable summariesTable,
      ABCMCommentsTable commentsTable){
    super("tblSummaryComments");
    PK         = createAndAddField("intSummaryCommentID", INT,        true);
    FK_SUMMARY = createAndAddField("intSummaryID",        false, INT,
        summariesTable.getName(), summariesTable.getField_PK().getName());
    FK_COMMENT = createAndAddField("intCommentID",        false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupSummaryComments", new String[]{ getField_SummaryFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){        return PK;          }
  public ABCMdbField getField_SummaryFK(){ return FK_SUMMARY;  }
  public ABCMdbField getField_CommentFK(){ return FK_COMMENT;  }
 
}
 
