
package abcm.db.components.defaults.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.views.ABCMProbeSetProbesView;

public class ABCMDefaultProbeSetProbesView extends ABCMProbeSetProbesView {

  protected ABCMdbField RESEARCHER_NAME, PROBESET_PK, PROBESET_NAME, PROBESET_DATECREATED, RESEARCHER_PK, PROBESET_DESC, PROBE_NAME, EXPRESSION1, EXPRESSION2, EXPRESSION3, DATASERIES_NAME, DATASERIES_DOMAIN, PROBE_ISNUMERIC, PROBE_ISMONTHLY, PROBE_BASEDATE, PROBE_FREQUENCY, PROBE_PK, PROBE_RETRIEVE;

  public ABCMDefaultProbeSetProbesView(AbstractABCMDBGateway db){
    super("ProbeSetProbes", db);
    RESEARCHER_NAME      = addField(new ABCMdbField("vcharResearcherName"));
    PROBESET_PK          = addField(new ABCMdbField("intProbeSetID"));
    PROBESET_NAME        = addField(new ABCMdbField("varcharProbeSetName"));
    PROBESET_DATECREATED = addField(new ABCMdbField("dteDateCreated"));
    RESEARCHER_PK        = addField(new ABCMdbField("intResearcherID"));
    PROBESET_DESC        = addField(new ABCMdbField("txtDescription"));
    PROBE_NAME           = addField(new ABCMdbField("varcharProbeName"));
    EXPRESSION1          = addField(new ABCMdbField("Expr1"));
    EXPRESSION2          = addField(new ABCMdbField("Expr2"));
    EXPRESSION3          = addField(new ABCMdbField("Expr3"));
    DATASERIES_NAME      = addField(new ABCMdbField("varcharDataSeriesName"));
    DATASERIES_DOMAIN    = addField(new ABCMdbField("varcharDataSeriesDomain"));
    PROBE_ISNUMERIC      = addField(new ABCMdbField("blnIsNumeric"));
    PROBE_ISMONTHLY      = addField(new ABCMdbField("blnIsMonthly"));
    PROBE_BASEDATE       = addField(new ABCMdbField("dblBaseDate"));
    PROBE_FREQUENCY      = addField(new ABCMdbField("dblFrequency"));
    PROBE_PK             = addField(new ABCMdbField("intProbeID"));
    PROBE_RETRIEVE       = addField(new ABCMdbField("txtRetrieve"));
  }

  public ABCMdbField getField_Researcher_Name(){      return RESEARCHER_NAME;      }
  public ABCMdbField getField_ProbeSet_PK(){          return PROBESET_PK;          }
  public ABCMdbField getField_ProbeSet_Name(){        return PROBESET_NAME;        }
  public ABCMdbField getField_ProbeSet_DateCreated(){ return PROBESET_DATECREATED; }
  public ABCMdbField getField_Researcher_PK(){        return RESEARCHER_PK;        }
  public ABCMdbField getField_ProbeSet_Desc(){        return PROBESET_DESC;        }
  public ABCMdbField getField_Probe_Name(){           return PROBE_NAME;           }
  public ABCMdbField getField_Probe_Description(){    return EXPRESSION1;          }
  public ABCMdbField getField_Probe_Date_Created(){   return EXPRESSION2;          }
  public ABCMdbField getField_Probe_Researcher_FK(){  return EXPRESSION3;          }
  public ABCMdbField getField_DataSeries_Name(){      return DATASERIES_NAME;      }
  public ABCMdbField getField_DataSeries_Domain(){    return DATASERIES_DOMAIN;    }
  public ABCMdbField getField_Probe_IsNumeric(){      return PROBE_ISNUMERIC;      }
  public ABCMdbField getField_Probe_IsMonthly(){      return PROBE_ISMONTHLY;      }
  public ABCMdbField getField_Probe_BaseDate(){       return PROBE_BASEDATE;       }
  public ABCMdbField getField_Probe_Frequency(){      return PROBE_FREQUENCY;      }
  public ABCMdbField getField_Probe_PK(){             return PROBE_PK;             }
  public ABCMdbField getField_Probe_Retrieve(){       return PROBE_RETRIEVE;       }

}
