
package abcm.db.components.defaults.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.views.ABCMSummaryRunsAndDetailsView;

public class ABCMDefaultSummaryRunsAndDetailsView extends ABCMSummaryRunsAndDetailsView {

  protected ABCMdbField SUMMARY_PK, SIMULATIONRUN_PK, RESEARCHER_NAME, SIMULATIONRUN_DATETIMEBEGUN, SIMULATIONRUN_NOTES, SIMULATIONRUN_RANDOMNUMBERSEED, SIMULATIONRUN_RERUN_FK, SIMULATION_TITLE, PARAMETERSET_NAME, PROBESET_NAME, TRUTHVALUE;

  public ABCMDefaultSummaryRunsAndDetailsView(AbstractABCMDBGateway db){
    super("SummaryRunsAndDetails", db);
    SUMMARY_PK                     = addField(new ABCMdbField("intSummaryID"));
    SIMULATIONRUN_PK               = addField(new ABCMdbField("intSimulationRunID"));
    RESEARCHER_NAME                = addField(new ABCMdbField("vcharResearcherName"));
    SIMULATIONRUN_DATETIMEBEGUN    = addField(new ABCMdbField("dteDateTimeBegun"));
    SIMULATIONRUN_NOTES            = addField(new ABCMdbField("txtNotes"));
    SIMULATIONRUN_RANDOMNUMBERSEED = addField(new ABCMdbField("intRandomNumberSeed"));
    SIMULATIONRUN_RERUN_FK         = addField(new ABCMdbField("intReRunOfID"));
    SIMULATION_TITLE               = addField(new ABCMdbField("vcharSimulationTitle"));
    PARAMETERSET_NAME              = addField(new ABCMdbField("varcharParameterSetName"));
    PROBESET_NAME                  = addField(new ABCMdbField("varcharProbeSetName"));
    TRUTHVALUE                     = addField(new ABCMdbField("txtTruthValue"));
  }

  public ABCMdbField getField_Summary_PK(){                    return SUMMARY_PK;                     }
  public ABCMdbField getField_SimulationRun_PK(){              return SIMULATIONRUN_PK;               }
  public ABCMdbField getField_Researcher_Name(){               return RESEARCHER_NAME;                }
  public ABCMdbField getField_SimulationRun_DateTimeBegun(){   return SIMULATIONRUN_DATETIMEBEGUN;    }
  public ABCMdbField getField_SimulationRun_Notes(){           return SIMULATIONRUN_NOTES;            }
  public ABCMdbField getField_SimulationRun_RandomNumberSeed(){return SIMULATIONRUN_RANDOMNUMBERSEED; }
  public ABCMdbField getField_SimulationRun_ReRun_FK(){        return SIMULATIONRUN_RERUN_FK;         }
  public ABCMdbField getField_Simulation_Title(){              return SIMULATION_TITLE;               }
  public ABCMdbField getField_ParameterSet_Name(){             return PARAMETERSET_NAME;              }
  public ABCMdbField getField_ProbeSet_Name(){                 return PROBESET_NAME;                  }
  public ABCMdbField getField_TruthValue(){                    return TRUTHVALUE;                     }

}
