 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMCommandCategoriesTable extends ABCMdbTable{
 
  public ABCMCommandCategoriesTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_Order();

  public ABCMdbDatum getDatum(String name, String description, String order){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_Order(), order);
    return datum;
  }
  
  public ABCMdbDatum getDatum(long PKByFiat, String name, String description, String order){
    ABCMdbDatum datum = getDatum(name, description, order);
    datum.setIncludesIdentityPK(true);
    datum.addValue(this.getField_PK(), PKByFiat);
    return datum;
  }
  
  public ABCMdbDatum getDatum(long PKByFiat, String name, String description, int order){
    return getDatum(PKByFiat, name, description, "" + order);
  }
  
  public ABCMdbDatum getDatum(String name, String description, int order){
    return getDatum(name, description, "" + order);
  }
  
  
}
 
