 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMDataModelsTable extends ABCMdbTable{
 
  public ABCMDataModelsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_HistoryFK();
  public abstract ABCMdbField getField_ConfigurationFK();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_ResearcherFK();

  public ABCMdbDatum getDatum(String name, String description, String historyFK, 
      String configurationFK, String dateCreated, String researcherFK){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_HistoryFK(), historyFK);
    datum.addValue(getField_ConfigurationFK(), configurationFK);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String name, String description, long historyFK, long configurationFK, String dateCreated, long researcherFK){
    return getDatum(name, description, "" + historyFK, "" + configurationFK, dateCreated, "" + researcherFK);
  }
  
}
 
