 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMNarrativeCommandsTable extends ABCMdbTable{
 
  public ABCMNarrativeCommandsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Command();
  public abstract ABCMdbField getField_NumberOfArgs();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_CommandLineOnly();
  public abstract ABCMdbField getField_Probe();
  public abstract ABCMdbField getField_Instructions();
  public abstract ABCMdbField getField_CommandCategoryFK();

  public ABCMdbDatum getDatum(String command, String numberOfArgs, String description, String CommandLineOnly, String Probe, String instructions, String categoryFK){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Command(), command);
    datum.addValue(getField_NumberOfArgs(), numberOfArgs);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_CommandLineOnly(), CommandLineOnly);
    datum.addValue(getField_Probe(), Probe);
    datum.addValue(getField_Instructions(), instructions);
    datum.addValue(getField_CommandCategoryFK(), categoryFK);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String command, long numberOfArgs, String description, boolean commandLineOnly, boolean probe, String instructions, long categoryFK){
    return getDatum( command, "" + numberOfArgs, description, (commandLineOnly ? "1" : "0"), (probe ? "1" : "0"), instructions, "" + categoryFK);
  }

}
 
