 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMNarrativesTable extends ABCMdbTable{
 
  public ABCMNarrativesTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_BaseDate();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_Seasonal();

  public ABCMdbDatum getDatum(String name, String description, String researcherFK, String baseDate, String dateCreated, String seasonal){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_BaseDate(), baseDate);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_Seasonal(), seasonal);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String name, String description, String researcherFK, String baseDate, String dateCreated, boolean seasonal){
    return getDatum(name, description, researcherFK, baseDate, dateCreated, (seasonal ? "1" : "0"));
  }
  
  public ABCMdbDatum getDatum(String name, String description, long researcherFK, double baseDate, String dateCreated, boolean seasonal){
    return getDatum(name, description, "" + researcherFK, "" + baseDate, dateCreated, (seasonal ? "1" : "0"));
  }
}
 
