 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMParameterSetsTable extends ABCMdbTable{
 
  public ABCMParameterSetsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_IsAutomatic();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_ResearcherFK();

  public ABCMdbDatum getDatum(String name, String dateCreated, String isAutomatic, String description, String researcherFK){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_IsAutomatic(), isAutomatic);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String name, String dateCreated, boolean isAutomatic, String description, long researcherFK){
    return getDatum(name, dateCreated, (isAutomatic ? "1" : "0"), description, "" + researcherFK);
  }
  
}
 
