 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMParametersTable extends ABCMdbTable{
 
  public ABCMParametersTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_DefaultValue();
  public abstract ABCMdbField getField_Minimum();
  public abstract ABCMdbField getField_Maximum();
  public abstract ABCMdbField getField_Units();
  public abstract ABCMdbField getField_IsEngine();
  public abstract ABCMdbField getField_ParameterCategoryFK();
  public abstract ABCMdbField getField_Order();

  public ABCMdbDatum getDatum(String name, String description, String dateCreated, 
      String defaultValue, String minimum, String maximum, String units, String isEngine, String parameterCategoryFK, String order){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_DefaultValue(), defaultValue);
    datum.addValue(getField_Minimum(), minimum);
    datum.addValue(getField_Maximum(), maximum);
    datum.addValue(getField_Units(), units);
    datum.addValue(getField_IsEngine(), isEngine);
    datum.addValue(getField_ParameterCategoryFK(), parameterCategoryFK);
    datum.addValue(getField_Order(), order);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String name, String description, String dateCreated, 
      double defaultValue, double minimum, double maximum, String units, boolean isEngine, long parameterCategoryFK, int order){
    return getDatum(name, description, dateCreated, "" + defaultValue, "" + minimum, "" + maximum, units, (isEngine ? "1" : "0"), "" + parameterCategoryFK, "" + order);
  }  
}
 
