 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
import abcm.math.SimDate;
 
public abstract class ABCMProbesTable extends ABCMdbTable{
 
  public ABCMProbesTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_DataSeriesName();
  public abstract ABCMdbField getField_DataSeriesDomain();
  public abstract ABCMdbField getField_IsNumeric();
  public abstract ABCMdbField getField_IsMonthly();
  public abstract ABCMdbField getField_BaseDate();
  public abstract ABCMdbField getField_Frequency();
  public abstract ABCMdbField getField_Retrieve();
  public abstract ABCMdbField getField_Offset();

  public ABCMdbDatum getDatum(String name, String description, String dateCreated, String researcherFK, 
      String dataSeriesName, String dataSeriesDomain, String isNumeric, String isMonthly, 
      String baseDate, String frequency, String retrieve, String offset){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_DataSeriesName(), dataSeriesName);
    datum.addValue(getField_DataSeriesDomain(), dataSeriesDomain);
    datum.addValue(getField_IsNumeric(), isNumeric);
    datum.addValue(getField_IsMonthly(), isMonthly);
    datum.addValue(getField_BaseDate(), baseDate);
    datum.addValue(getField_Frequency(), frequency);
    datum.addValue(getField_Retrieve(), retrieve);
    datum.addValue(getField_Offset(), offset);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String name, String description, String dateCreated, long researcherFK, String dataSeriesName, String dataSeriesDomain, 
      boolean isNumeric, boolean isMonthly, SimDate baseDate, int frequency, String retrieve, double offset){
    return getDatum(name, description, dateCreated, "" + researcherFK, 
        dataSeriesName, dataSeriesDomain, (isNumeric ? "1" : "0"), (isMonthly ? "1" : "0"), 
        "" + baseDate.value(), "" + frequency, "" + retrieve, "" + offset);
  }
  
}
 
