 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMReferencesAndAuthorsTable extends ABCMdbTable{
 
  public ABCMReferencesAndAuthorsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_ReferenceFK();
  public abstract ABCMdbField getField_AuthorOrder();
  public abstract ABCMdbField getField_ResearcherFK();

  public ABCMdbDatum getDatum(String referenceFK, String authorOrder, String researcherFK){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_ReferenceFK(), referenceFK);
    datum.addValue(getField_AuthorOrder(), authorOrder);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    return datum;
  }
  
  public ABCMdbDatum getDatum(long referenceFK, int authorOrder, long researcherFK){
    return getDatum("" + referenceFK, "" + authorOrder, "" + researcherFK);
  }
  
}
 
