 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMReferencesTable extends ABCMdbTable{
 
  public ABCMReferencesTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Title();
  public abstract ABCMdbField getField_ReferenceDate();
  public abstract ABCMdbField getField_Summary();
  public abstract ABCMdbField getField_Abstract();
  public abstract ABCMdbField getField_ReferenceTypeFK();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_Location();

  public ABCMdbDatum getDatum(String title, String referenceDate, String summary, 
      String abstractText, String referenceTypeFK, String researcherFK, String location){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Title(), title);
    datum.addValue(getField_ReferenceDate(), referenceDate);
    datum.addValue(getField_Summary(), summary);
    datum.addValue(getField_Abstract(), abstractText);
    datum.addValue(getField_ReferenceTypeFK(), referenceTypeFK);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_Location(), location);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String title, String referenceDate, String summary,
      String abstractText, long referenceTypeFK, long researcherFK, String location){
    return getDatum(title, referenceDate, summary, abstractText, "" + referenceTypeFK, "" + researcherFK, location);
  }
  
}
 
