 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMResearcherSessionsTable extends ABCMdbTable{
 
  public ABCMResearcherSessionsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_LoginAuthorizationTime();
  public abstract ABCMdbField getField_SessionBeginTime();
  public abstract ABCMdbField getField_SessionEndTime();

  public ABCMdbDatum getDatum(String researcherFK, String loginAuthorizationTime, 
      String sessionBeginTime, String sessionEndTime){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_LoginAuthorizationTime(), loginAuthorizationTime);
    datum.addValue(getField_SessionBeginTime(), sessionBeginTime);
    if(sessionEndTime != null) datum.addValue(getField_SessionEndTime(), sessionEndTime);
    return datum;
  }
  
}
 
