 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMRunModesTable extends ABCMdbTable{
 
  public ABCMRunModesTable(String tableName){ super(tableName); }
 
  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_RunMode();

  public ABCMdbDatum getDatum(String runMode){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_RunMode(), runMode);
    return datum;
  }
  
  public ABCMdbDatum getDatum(long runModePK, String runMode){
    ABCMdbDatum datum = getDatum(runMode);     // Invoke the other getDatum
    datum.setIncludesIdentityPK(true);         // Set the flag indicating that this datum includes a PK
    datum.addValue(getField_PK(), runModePK);  // Add the PK value as another datum value
    return datum;
  }

}
 
