 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMSimulationConfigurationsTable extends ABCMdbTable{
 
  public ABCMSimulationConfigurationsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_ResearcherFK();

  public ABCMdbDatum getDatum(String configName, String description, String dateCreated, String researcherFK){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), configName);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    return datum;    
  }
  
  public ABCMdbDatum getDatum(String configName, String description, String dateCreated, long researcherFK){
    return getDatum(configName, description, dateCreated, "" + researcherFK);
  }
  
}
 
