 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMSimulationRunsTable extends ABCMdbTable{
 
  public ABCMSimulationRunsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_SimulationFK();
  public abstract ABCMdbField getField_ParameterSetFK();
  public abstract ABCMdbField getField_ProbeSetFK();
  public abstract ABCMdbField getField_RunModeFK();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_Notes();
  public abstract ABCMdbField getField_RandomNumberSeed();
  public abstract ABCMdbField getField_RerunID();
  public abstract ABCMdbField getField_IsReproducible();

  public ABCMdbDatum getDatum(String dateCreated, String simulationFK, String parameterSetFK, String probeSetFK, String runModeFK, String researcherFK, String notes, String randomNumberSeed, String rerunID, String isReproducible){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_SimulationFK(), simulationFK);
    datum.addValue(getField_ParameterSetFK(), parameterSetFK);
    datum.addValue(getField_ProbeSetFK(), probeSetFK);
    datum.addValue(getField_RunModeFK(), runModeFK);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_Notes(), notes);
    datum.addValue(getField_RandomNumberSeed(), randomNumberSeed);
    datum.addValue(getField_RerunID(), rerunID);
    datum.addValue(getField_IsReproducible(), isReproducible);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String dateCreated, String simulationFK, String parameterSetFK, String probeSetFK, String runModeFK, String researcherFK, String notes, String randomNumberSeed){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_SimulationFK(), simulationFK);
    datum.addValue(getField_ParameterSetFK(), parameterSetFK);
    datum.addValue(getField_ProbeSetFK(), probeSetFK);
    datum.addValue(getField_RunModeFK(), runModeFK);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_Notes(), notes);
    datum.addValue(getField_RandomNumberSeed(), randomNumberSeed);
    return datum;
  }
}
 
