 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMSimulationsTable extends ABCMdbTable{
 
  public ABCMSimulationsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Title();
  public abstract ABCMdbField getField_CodeModelFK();
  public abstract ABCMdbField getField_DataModelFK();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_Description();

  public ABCMdbDatum getDatum(String title, String codeModelFK, String dataModelFK, 
      String dateCreated, String researcherFK, String description){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Title(), title);
    datum.addValue(getField_CodeModelFK(), codeModelFK);
    datum.addValue(getField_DataModelFK(), dataModelFK);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_Description(), description);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String title, long codeModelFK, long dataModelFK, String dateCreated, long researcherFK, String description){
    return getDatum(title, "" + codeModelFK, "" + dataModelFK, dateCreated, "" + researcherFK, description);
  }
  
}
 
