 
package abcm.db.components.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class ABCMTruthValuesTable extends ABCMdbTable{
 
  public ABCMTruthValuesTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_TruthValue();

  public ABCMdbDatum getDatum(String description, String truthValue){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_TruthValue(), truthValue);
    return datum;
  }
  
  public ABCMdbDatum getDatum(long newPKByFiat, String description, String truthValue){
    ABCMdbDatum datum = getDatum(description, truthValue);
    datum.addValue(getField_PK(), newPKByFiat);
    datum.setIncludesIdentityPK(true);
    return datum;
  }
  
}
 
