package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMAnalysesAndResearchersView extends ABCMdbView {
  
  public ABCMAnalysesAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }
  
  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_Analysis_Title();
  public abstract ABCMdbField getField_Analysis_Desc();
  public abstract ABCMdbField getField_Analysis_DateCreated();
  public abstract ABCMdbField getField_Researcher_LastNameFirstName();
  
  public String getSQL(){
    String               dbOwner          = DB.getOwner();
    
    ABCMAnalysesTable    analysesTable    = DB.getAnalysesTable();
        String analyses  = analysesTable.getFullName(dbOwner);
        
        String ANALYSIS_PK    = analysesTable.getField_PK().getFullFieldName(dbOwner);
        String ANALYSIS_TITLE = analysesTable.getField_Title().getFullFieldName(dbOwner);
        String ANALYSIS_DESC  = analysesTable.getField_Description().getFullFieldName(dbOwner);
        String ANALYSIS_DATE  = analysesTable.getField_DateCreated().getFullFieldName(dbOwner);
        String RESEARCHER_FK  = analysesTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);
   
        String RESEARCHER_PK = researchersTable.getField_PK().getFullFieldName(dbOwner);
        String LAST_FIRST    = researchersTable.getField_LastNameFirstName().getFullFieldName(dbOwner);
          
        
    return
      "SELECT " + 
         ANALYSIS_PK         + " AS " + getField_Analysis_PK().getName()                  + ",\n" + 
         ANALYSIS_TITLE      + " AS " + getField_Analysis_Title().getName()               + ",\n" + 
         ANALYSIS_DESC       + " AS " + getField_Analysis_Desc().getName()                + ",\n" + 
         ANALYSIS_DATE       + " AS " + getField_Analysis_DateCreated().getName()         + ",\n" + 
         LAST_FIRST          + " AS " + getField_Researcher_LastNameFirstName().getName() + "\n" + 
      "FROM   " + analyses + " INNER JOIN " + researchers + " ON " + " \n" + 
            RESEARCHER_FK + " = " + RESEARCHER_PK + " ";
      
  }

}
