
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;

public abstract class ABCMAnalysesAndRunsView extends ABCMdbView {
  
  public ABCMAnalysesAndRunsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_SimulationRun_PK();
  
  public String getSQL(){
   ABCMAnalysesTable             analysesTable                = DB.getAnalysesTable(); 
   ABCMAnalysisDataSeriesTable   analysisDataSeriesTable      = DB.getAnalysisDataSeriesTable();
   ABCMSimulationDataSeriesTable simulationDataSeriesTable    = DB.getSimulationDataSeriesTable();
   String                        dbOwner                      = DB.getOwner();
    
    return 
       "SELECT DISTINCT " +
          analysesTable.getField_PK().getFullFieldName(dbOwner)                          + " AS " + getField_Analysis_PK().getName()      + ",\n" + 
          simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_PK().getName() + "\n" + 
       "FROM   " + analysesTable.getFullName(dbOwner) + " INNER JOIN " +"\n" + 
                        analysisDataSeriesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " INNER JOIN " +"\n" + 
                        simulationDataSeriesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " = " + simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + " ";

  }

}
