
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;

public abstract class ABCMAnalysesInSummariesView extends ABCMdbView {
  
  public ABCMAnalysesInSummariesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_Analysis_Title();
  
  public String getSQL(){
    ABCMSummaryAnalysesTable summaryAnalysesTable = DB.getSummaryAnalysesTable();
    ABCMAnalysesTable        analysesTable        = DB.getAnalysesTable();
    String                   dbOwner              = DB.getOwner();
    
    return
      "SELECT " +summaryAnalysesTable.getField_SummaryFK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName()     + ",\n" + 
                    analysesTable.getField_PK().getFullFieldName(dbOwner)            + " AS " + getField_Analysis_PK().getName()    + ",\n" + 
                    analysesTable.getField_Title().getFullFieldName(dbOwner)         + " AS " + getField_Analysis_Title().getName() + "\n" + 
      "FROM   " + summaryAnalysesTable.getFullName(dbOwner) + " INNER JOIN " +"\n" + 
                    analysesTable.getFullName(dbOwner) + " ON " +"\n" + 
                    summaryAnalysesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " = " + analysesTable.getField_PK().getFullFieldName(dbOwner) + " ";
  }

}
