
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;

public abstract class ABCMAnalysisDataSeriesView extends ABCMdbView {

  
  public ABCMAnalysisDataSeriesView(String viewName,  AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_Analysis_Title();
  public abstract ABCMdbField getField_SimulationRun_PK();
  public abstract ABCMdbField getField_DataSeries_Name();
  public abstract ABCMdbField getField_AnalysisDataSeries_PK();
  public abstract ABCMdbField getField_DataSeries_PK();

  public String getSQL(){
    String                        dbOwner                      = DB.getOwner();
    
    ABCMAnalysesTable             analysesTable                = DB.getAnalysesTable();
        String analyses = analysesTable.getFullName(dbOwner);
        
        String ANALYSIS_PK    = analysesTable.getField_PK().getFullFieldName(dbOwner);
        String ANALYSIS_TITLE = analysesTable.getField_Title().getFullFieldName(dbOwner);
    
    ABCMSimulationDataSeriesTable simulationDataSeriesTable    = DB.getSimulationDataSeriesTable();
        String simulationDataSeries = simulationDataSeriesTable.getFullName(dbOwner);
    
        String SIM_DATA_SERIES_PK   = simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner);
        String SIMRUN_FK            = simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner);
        String SIM_DATA_SERIES_NAME = simulationDataSeriesTable.getField_Name().getFullFieldName(dbOwner);        
        
    ABCMAnalysisDataSeriesTable   analysisDataSeriesTable      = DB.getAnalysisDataSeriesTable();
        String analysisDataSeries = analysisDataSeriesTable.getFullName(dbOwner);
   
        String ANALYSIS_DATA_SERIES_PK = analysisDataSeriesTable.getField_PK().getFullFieldName(dbOwner);
        String ANALYSIS_FK             = analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner);
        String DATA_SERIES_FK          = analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner);

    return
    "SELECT " +
          ANALYSIS_PK               + " AS " + getField_Analysis_PK().getName()            + ", \n" +      
          ANALYSIS_TITLE            + " AS " + getField_Analysis_Title().getName()         + ", \n" +
          SIMRUN_FK                 + " AS " + getField_SimulationRun_PK().getName()       + ", \n" + 
          SIM_DATA_SERIES_NAME      + " AS " + getField_DataSeries_Name().getName()        + ", \n" + 
          ANALYSIS_DATA_SERIES_PK   + " AS " + getField_AnalysisDataSeries_PK().getName()  + ", \n" + 
          SIM_DATA_SERIES_PK        + " AS " + getField_DataSeries_PK().getName()          + "\n" + 
      "FROM  " + 
        analyses + " INNER JOIN " + analysisDataSeries + " ON " +"\n" + 
             ANALYSIS_PK + " = " + ANALYSIS_FK + " INNER JOIN " +"\n" + 
                 simulationDataSeries + " ON " +"\n" + 
                 DATA_SERIES_FK + " = " + SIM_DATA_SERIES_PK + " ";
  }
  
}
