
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;

public abstract class ABCMCanBeEdited_AnalysesView extends ABCMdbView {
  
  public ABCMCanBeEdited_AnalysesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner                                                = DB.getOwner();
    
    ABCMAnalysesTable analysesTable                               = DB.getAnalysesTable();
        String analyses = analysesTable.getFullName(dbOwner);
        
        String ANALYSIS_PK = analysesTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMCommentsCount_AnalysesView commentsCount_AnalysesView     = DB.getCommentsCount_AnalysesView();
        String commentsCount_Analyses = commentsCount_AnalysesView.getFullName(dbOwner);
       
        String COMMENT_COUNT = commentsCount_AnalysesView.getField_CountOfComments().getFullFieldName(dbOwner);
        String ANALYSIS_FK   = commentsCount_AnalysesView.getField_Analysis_PK().getFullFieldName(dbOwner);
    
  
    return
    "SELECT " + 
        ANALYSIS_PK   + " AS " + getField_Analysis_PK().getName()     + ", \n" + 
        COMMENT_COUNT + " AS " + getField_CountOfComments().getName() + "\n" + 
    "FROM   "  + commentsCount_Analyses + " INNER JOIN " + analyses + " ON " +"\n" + 
                    ANALYSIS_FK + " = " + ANALYSIS_PK + " " +
    "WHERE     (" + COMMENT_COUNT + " = 0) ";
  }

}
