
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelsTable;

public abstract class ABCMCanBeEdited_CodeModelsView extends ABCMdbView {
  
  public ABCMCanBeEdited_CodeModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CountOfSimulations();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner                                                  = DB.getOwner();
    
    ABCMCodeModelsTable codeModelsTable                             = DB.getCodeModelsTable();
        String codeModels = codeModelsTable.getFullName(dbOwner);
    
        String CODE_MODEL_PK = codeModelsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMCodeModelsInSimulationsView codeModelsInSimulationsView     = DB.getCodeModelsInSimulationsView();
        String codeModelsInSimulations = codeModelsInSimulationsView.getFullName(dbOwner);
    
        String COUNT_OF_SIMS      = codeModelsInSimulationsView.getField_CountOfSimulations().getFullFieldName(dbOwner);
        String CODE_MODEL_FK_SIMS = codeModelsInSimulationsView.getField_CodeModel_PK().getFullFieldName(dbOwner); 
        
    ABCMCommentsCount_CodeModelsView commentsCount_CodeModelsView   = DB.getCommentsCount_CodeModelsView();
        String commentsCount_CodeModels = commentsCount_CodeModelsView.getFullName(dbOwner);
    
        String CODE_MODEL_FK_COMMENTS = commentsCount_CodeModelsView.getField_CodeModel_PK().getFullFieldName(dbOwner); 
        String COUNT_OF_COMMENTS      = commentsCount_CodeModelsView.getField_CountOfComments().getFullFieldName(dbOwner);
  
    
    return
    
    "SELECT " +
        CODE_MODEL_PK     + " AS " + this.getField_CodeModel_PK().getName()       + ", \n" + 
        COUNT_OF_SIMS     + " AS " + this.getField_CountOfSimulations().getName() + ", \n" + 
        COUNT_OF_COMMENTS + " AS " + this.getField_CountOfComments().getName()    + "\n" + 
     "FROM " + 
        codeModels + " LEFT OUTER JOIN " +"\n" + 
        commentsCount_CodeModels + " ON " +"\n" + 
        CODE_MODEL_PK + " = " + CODE_MODEL_FK_COMMENTS + " LEFT OUTER JOIN " +"\n" + 
        codeModelsInSimulations + " ON " +"\n" + 
        CODE_MODEL_PK + " = " + CODE_MODEL_FK_SIMS + " \n" + 
     "WHERE (" + COUNT_OF_SIMS + " = 0) AND (" + COUNT_OF_COMMENTS + " = 0)";
  }

}
