
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMDataModelsTable;

public abstract class ABCMCanBeEdited_DataModelsView extends ABCMdbView {
  
  public ABCMCanBeEdited_DataModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_CountOfSimulations();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMDataModelsTable dataModelsTable = DB.getDataModelsTable();
        String dataModels = dataModelsTable.getFullName(dbOwner);
        
        String DATA_MODEL_PK = dataModelsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMCommentsCount_DataModelsView commentsCount_DataModelsView = DB.getCommentsCount_DataModelsView();
        String commentsCount_DataModels = commentsCount_DataModelsView.getFullName(dbOwner);
        
        String COMMENT_COUNT    = commentsCount_DataModelsView.getField_CountOfComments().getFullFieldName(dbOwner);
        String COMMENT_COUNT_FK = commentsCount_DataModelsView.getField_DataModel_PK().getFullFieldName(dbOwner);
    
    ABCMDataModelsInSimulationsView dataModelsInSimulationsView = DB.getDataModelsInSimulationsView();
        String dataModelsInSimulations = dataModelsInSimulationsView.getFullName(dbOwner);
    
        String SIM_COUNT     = dataModelsInSimulationsView.getField_CountOfSimulations().getFullFieldName(dbOwner);
        String SIM_COUNT_FK  = dataModelsInSimulationsView.getField_DataModel_PK().getFullFieldName(dbOwner);
        
    return
       "SELECT " +
           DATA_MODEL_PK   + " AS " + getField_DataModel_PK().getName()        + ", \n" + 
           SIM_COUNT       + " AS " + getField_CountOfSimulations().getName()  + ", \n" + 
           COMMENT_COUNT   + " AS " + getField_CountOfComments().getName()     + "\n" + 
       "FROM " + 
           dataModels + " LEFT OUTER JOIN " +"\n" + 
           commentsCount_DataModels + " ON " +"\n" + 
           DATA_MODEL_PK + " = " + COMMENT_COUNT_FK + " LEFT OUTER JOIN " +"\n" + 
           dataModelsInSimulations + " ON " +"\n" + 
           DATA_MODEL_PK + " = " + SIM_COUNT_FK + " " +
       "WHERE (" + SIM_COUNT + " = 0) AND " +
             "(" + COMMENT_COUNT + " = 0) ";  
    }
  
  

}
