
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMHistoriesTable;

public abstract class ABCMCanBeEdited_HistoriesView extends ABCMdbView {
  
  public ABCMCanBeEdited_HistoriesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_CountOfDataModels();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMHistoriesTable historiesTable = DB.getHistoriesTable();
        String histories = historiesTable.getFullName(dbOwner); 
        
        String HISTORY_PK          = historiesTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMHistoriesInDataModelsView historiesInDataModelsView = DB.getHistoriesInDataModelsView();
        String historiesInDataModels = historiesInDataModelsView.getFullName(dbOwner);
        
        String HISTORY_IDM_FK       = historiesInDataModelsView.getField_History_PK().getFullFieldName(dbOwner);
        String COUNT_OF_DATA_MODELS = historiesInDataModelsView.getField_CountOfDataModels().getFullFieldName(dbOwner);
        
    ABCMCommentsCount_HistoriesView commentsCount_HistoriesView = DB.getCommentsCount_HistoriesView();
        String commentsCount_Histories = commentsCount_HistoriesView.getFullName(dbOwner);
        
        String COMMENT_COUNT_HISTORY_FK = commentsCount_HistoriesView.getField_History_PK().getFullFieldName(dbOwner);
        String COMMENT_COUNT            = commentsCount_HistoriesView.getField_CountOfComments().getFullFieldName(dbOwner);
        
    return
       "SELECT " +
          HISTORY_PK           + " AS " + getField_History_PK().getName()        + ", \n" + 
          COUNT_OF_DATA_MODELS + " AS " + getField_CountOfDataModels().getName() + ", \n" + 
          COMMENT_COUNT        + " AS " + getField_CountOfComments().getName()   + "\n" + 
       "FROM   "  + historiesInDataModels + " RIGHT OUTER JOIN " +"\n" + 
           histories + " ON " +"\n" + 
                HISTORY_IDM_FK + " = " + HISTORY_PK + " LEFT OUTER JOIN " +"\n" + 
           commentsCount_Histories + " ON " +"\n" + 
                HISTORY_PK + " = " + COMMENT_COUNT_HISTORY_FK + " \n" +
        "WHERE     (" + COUNT_OF_DATA_MODELS + " = 0) AND " +
                   "(" + COMMENT_COUNT + " = 0) ";
    }
  
  
}
