
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMNarrativesTable;

public abstract class ABCMCanBeEdited_NarrativesView extends ABCMdbView {
  
  public ABCMCanBeEdited_NarrativesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Narrative_PK();
  public abstract ABCMdbField getField_CountUsed();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMNarrativesTable narrativesTable = DB.getNarrativesTable();
    ABCMNarrativesInHistoriesView narrativesInHistoriesView = DB.getNarrativesInHistoriesView();
    ABCMCommentsCount_NarrativesView commentsCount_NarrativesView = DB.getCommentsCount_NarrativesView();

    
    return
    "SELECT " +
        narrativesTable.getField_PK().getFullFieldName(dbOwner)                           + " AS " + getField_Narrative_PK().getName()    + ", \n" +  
        narrativesInHistoriesView.getField_CountOfTimesUsed().getFullFieldName(dbOwner)   + " AS " + getField_CountUsed().getName()       + ",\n" +  
        commentsCount_NarrativesView.getField_CountOfComments().getFullFieldName(dbOwner) + " AS " + getField_CountOfComments().getName() + "\n" +
    "FROM " + narrativesTable.getFullName(dbOwner) + " " +
        "LEFT OUTER JOIN " + commentsCount_NarrativesView.getName() + " ON\n" + 
           narrativesTable.getField_PK().getFullFieldName(dbOwner) + " = " + commentsCount_NarrativesView.getField_Narrative_PK().getFullFieldName(dbOwner) + "\n" +
        "LEFT OUTER JOIN " + narrativesInHistoriesView.getName() + " ON\n" + 
           narrativesTable.getField_PK().getFullFieldName(dbOwner) + " = " + narrativesInHistoriesView.getField_Narrative_PK().getFullFieldName(dbOwner) + "\n" +
    "WHERE (" + narrativesInHistoriesView.getField_CountOfTimesUsed().getFullFieldName(dbOwner) + " = 0) AND " +
          "(" + commentsCount_NarrativesView.getField_CountOfComments().getFullFieldName(dbOwner) + " = 0) ";
  }
  

}
