
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsTable;

public abstract class ABCMCanBeEdited_ParameterSetsView extends ABCMdbView {

  public ABCMCanBeEdited_ParameterSetsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_CountOfRuns();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
        String parameterSets = parameterSetsTable.getFullName(dbOwner);

        String PARAM_SET_PK = parameterSetsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMParameterSetsInSimulationRunsView parameterSetsInSimulationRunsView = DB.getParameterSetsInSimulationRunsView();
        String parameterSetsInSimulationRuns = parameterSetsInSimulationRunsView.getFullName(dbOwner);
 
        String TIMES_RUN_FK = parameterSetsInSimulationRunsView.getField_ParameterSet_PK().getFullFieldName(dbOwner);
        String TIMES_RUN    = parameterSetsInSimulationRunsView.getField_CountOfTimesRun().getFullFieldName(dbOwner);

    ABCMCommentsCount_ParameterSetsView commentsCount_ParameterSetsView = DB.getCommentsCount_ParameterSetsView();
        String commentsCount_ParameterSets = commentsCount_ParameterSetsView.getFullName(dbOwner);

        String COMMENT_COUNT_FK = commentsCount_ParameterSetsView.getField_ParameterSet_PK().getFullFieldName(dbOwner);
        String COMMENT_COUNT    = commentsCount_ParameterSetsView.getField_CountOfComments().getFullFieldName(dbOwner);
        
    return
      "SELECT " +
          PARAM_SET_PK  + " AS " + getField_ParameterSet_PK().getName() + ", \n" + 
          TIMES_RUN     + " AS " + getField_CountOfRuns().getName()     + ", \n" +
          COMMENT_COUNT + " AS " + getField_CountOfComments().getName() + "\n" + 
      "FROM  "+ 
          parameterSets + " " +
          "LEFT OUTER JOIN " + commentsCount_ParameterSets + " ON " +"\n" + 
                 PARAM_SET_PK + " = " + COMMENT_COUNT_FK + "\n" +
          "LEFT OUTER JOIN " + parameterSetsInSimulationRuns + " ON " +"\n" + 
                 PARAM_SET_PK + " = " + TIMES_RUN_FK + "\n" +
      "WHERE     (" + TIMES_RUN + " = 0) AND " +
                "(" + COMMENT_COUNT + " = 0)";
  }
  

}
