
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbeSetsTable;

public abstract class ABCMCanBeEdited_ProbeSetsView extends ABCMdbView {

  public ABCMCanBeEdited_ProbeSetsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_ProbeSet_PK();
  public abstract ABCMdbField getField_CountOfTimesRun();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMProbeSetsTable probeSetsTable = DB.getProbeSetsTable();
        String probeSets = probeSetsTable.getFullName(dbOwner);

        String PROBE_SET_PK = probeSetsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMProbeSetsInSimulationRunsView probeSetsInSimulationRunsView = DB.getProbeSetsInSimulationRunsView();
        String probeSetsInSimulationRuns = probeSetsInSimulationRunsView.getFullName(dbOwner);
    
        String TIMES_RUN_FK  = probeSetsInSimulationRunsView.getField_ProbeSet_PK().getFullFieldName(dbOwner);
        String TIMES_RUN     = probeSetsInSimulationRunsView.getField_TimesRun().getFullFieldName(dbOwner);
        
    ABCMCommentsCount_ProbeSetsView commentsCount_ProbeSetsView = DB.getCommentsCount_ProbeSetsView();
        String commentsCount_ProbeSets = commentsCount_ProbeSetsView.getFullName(dbOwner);
        
        String COMMENTS_COUNT_FK = commentsCount_ProbeSetsView.getField_ProbeSet_PK().getFullFieldName(dbOwner);
        String COMMENTS_COUNT    = commentsCount_ProbeSetsView.getField_CountOfComments().getFullFieldName(dbOwner);
    
    return
       "SELECT " +
           PROBE_SET_PK   + " AS " + getField_ProbeSet_PK().getName()     + ", \n" +
           TIMES_RUN      + " AS " + getField_CountOfTimesRun().getName() + ", \n" +  
           COMMENTS_COUNT + " AS " + getField_CountOfComments().getName() + "\n" +  
      "FROM   " + probeSets + " " +
          "LEFT OUTER JOIN " + commentsCount_ProbeSets + " ON " +"\n" + 
               PROBE_SET_PK + " = " + COMMENTS_COUNT_FK + " \n" +
           "LEFT OUTER JOIN " +probeSetsInSimulationRuns + " ON " +"\n" + 
                PROBE_SET_PK + " = " + TIMES_RUN_FK + "\n" +
      "WHERE (" + TIMES_RUN + " = 0) AND " +
            "(" + COMMENTS_COUNT + " = 0)";
  }
  
}
