
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbesTable;

public abstract class ABCMCanBeEdited_ProbesView extends ABCMdbView {
      
  public ABCMCanBeEdited_ProbesView(String viewName, AbstractABCMDBGateway db){
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Probe_PK();
  public abstract ABCMdbField getField_CountOfProbeSets();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMProbesTable probesTable = DB.getProbesTable();
        String probes = probesTable.getFullName(dbOwner);

        String PROBE_PK = probesTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMProbesInProbeSetsView probesInProbeSetsView = DB.getProbesInProbeSetsView();
        String probesInProbeSets = probesInProbeSetsView.getFullName(dbOwner);

        String PROBE_COUNT_FK   = probesInProbeSetsView.getField_Probe_PK().getFullFieldName(dbOwner);
        String PROBE_SET_COUNT  = probesInProbeSetsView.getField_CountOfProbeSets().getFullFieldName(dbOwner); 
        
    ABCMCommentsCount_ProbesView commentsCount_ProbesView = DB.getCommentsCount_ProbesView();
        String commentsCount_Probes = commentsCount_ProbesView.getFullName(dbOwner);

        String COMMENT_PROBE_FK = commentsCount_ProbesView.getField_Probe_PK().getFullFieldName(dbOwner); 
        String COMMENT_COUNT    = commentsCount_ProbesView.getField_CountOfComments().getFullFieldName(dbOwner);
        
    return 
      "SELECT " + 
          PROBE_PK      + " AS " + getField_Probe_PK().getName()             + ", " + "\n" +
          PROBE_SET_COUNT   + " AS " + getField_CountOfProbeSets().getName() + ", " + "\n" +
          COMMENT_COUNT + " AS " + getField_CountOfComments().getName()      + "\n" + 
      "FROM " + probes + " " +
          "LEFT OUTER JOIN " + commentsCount_Probes + " ON " + "\n" +
              PROBE_PK + " = " + COMMENT_PROBE_FK + " " +
          "LEFT OUTER JOIN " + probesInProbeSets + " ON " + "\n" +
              PROBE_PK + " = " + PROBE_COUNT_FK + " \n" +
      "WHERE     (" + PROBE_SET_COUNT + " = 0) " + "\n" +
            "AND (" + COMMENT_COUNT + " = 0) ";        
  }
  
}
