
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class ABCMCanBeEdited_SimulationConfigurationsView extends ABCMdbView {
  
  public ABCMCanBeEdited_SimulationConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_CountOfDataModels();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationConfigurationsTable simulationConfigurationsTable = DB.getSimulationConfigurationsTable();
        String simulationConfigurations = simulationConfigurationsTable.getFullName(dbOwner);

    ABCMConfigurationsInDataModelsView configurationsInDataModelsView = DB.getConfigurationsInDataModelsView();

    ABCMCommentsCount_SimulationConfigurationsView commentsCount_SimulationConfigurationsView = DB.getCommentsCount_SimulationConfigurationsView();
        String commentsCount_SimulationConfigurations = commentsCount_SimulationConfigurationsView.getFullName(dbOwner);
        
    return
    "SELECT " +
        simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_PK().getName() + ",\n"  +
        configurationsInDataModelsView.getField_CountOfDataModels().getFullFieldName(dbOwner) + " AS " + getField_CountOfDataModels().getName() + ",\n" + 
        commentsCount_SimulationConfigurationsView.getField_CountOfComments().getFullFieldName(dbOwner) + " AS " + getField_CountOfComments().getName() + "\n" + 
    "FROM   " + simulationConfigurations + " \n" +
        "LEFT OUTER JOIN " + commentsCount_SimulationConfigurations + " ON \n" + 
             simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + commentsCount_SimulationConfigurationsView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner) + " \n" +
        "LEFT OUTER JOIN " + configurationsInDataModelsView.getName() + " ON " +"\n" + 
             simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + configurationsInDataModelsView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner) + " \n" +
       "WHERE     (" + configurationsInDataModelsView.getField_CountOfDataModels().getFullFieldName(dbOwner) + " = 0) AND\n" +
                 "(" + commentsCount_SimulationConfigurationsView.getField_CountOfComments().getFullFieldName(dbOwner) + " = 0) ";
  }
  
}
