
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMCanBeEdited_SimulationsView extends ABCMdbView {
  
  public ABCMCanBeEdited_SimulationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_CountOfRuns();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);
        
        String SIM_PK = simulationsTable.getField_PK().getFullFieldName(dbOwner);

    ABCMSimulationsInSimulationRunsView simulationsInSimulationRunsView = DB.getSimulationsInSimulationRunsView();
        String simulationsInSimulationRuns = simulationsInSimulationRunsView.getFullName(dbOwner);

        String IN_SIM_RUNS_FK        = simulationsInSimulationRunsView.getField_SimulationRun_PK().getFullFieldName(dbOwner);
        String IN_SIM_RUNS_TIMES_RUN = simulationsInSimulationRunsView.getField_CountOfTimesRun().getFullFieldName(dbOwner);
        
    ABCMCommentsCount_SimulationsView commentsCount_SimulationsView = DB.getCommentsCount_SimulationsView();
        String commentsCount_Simulations = commentsCount_SimulationsView.getFullName(dbOwner);

        String COMMENTS_COUNT_FK = commentsCount_SimulationsView.getField_Simulation_PK().getFullFieldName(dbOwner);
        String COMMENTS_COUNT    = commentsCount_SimulationsView.getField_CountOfComments().getFullFieldName(dbOwner);
        
    return
       "SELECT " +
           SIM_PK                + " AS " + getField_Simulation_PK().getName()   + ",\n" + 
           IN_SIM_RUNS_TIMES_RUN + " AS " + getField_CountOfRuns().getName()     + ",\n" + 
           COMMENTS_COUNT        + " AS " + getField_CountOfComments().getName() + "\n" + 
      "FROM "  + commentsCount_Simulations + "\n" +
          "RIGHT OUTER JOIN " + simulations + " ON " +"\n" + 
                COMMENTS_COUNT_FK + " = " + SIM_PK + " \n" +
          "LEFT OUTER JOIN " + simulationsInSimulationRuns + " ON " +"\n" + 
                SIM_PK + " = " + IN_SIM_RUNS_FK + "\n" +
      "WHERE     (" + IN_SIM_RUNS_TIMES_RUN + " = 0) \n" +
            "AND (" + COMMENTS_COUNT + " = 0)";
  }
  
  
}
