
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSummariesTable;

public abstract class ABCMCanBeEdited_SummariesView extends ABCMdbView {

  protected ABCMSummariesTable summariesTable;
  protected ABCMCommentsCount_SummariesView commentsCount_SummariesView;
  
  
  public ABCMCanBeEdited_SummariesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    ABCMSummariesTable summariesTable                              = DB.getSummariesTable();
    ABCMCommentsCount_SummariesView commentsCount_SummariesView    = DB.getCommentsCount_SummariesView();
    String dbOwner                                                 = DB.getOwner();
  
    return
        "SELECT " +
            summariesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ",\n" + 
            commentsCount_SummariesView.getField_CountOfComments().getFullFieldName(dbOwner) + " AS " + getField_CountOfComments().getName() + "\n" + 
        "FROM "  + commentsCount_SummariesView.getFullName(dbOwner) + "\n" +
            "INNER JOIN " + summariesTable.getFullName(dbOwner) + " ON \n" + 
                commentsCount_SummariesView.getField_Summary_PK().getFullFieldName(dbOwner) + " = " + summariesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "WHERE     (" + commentsCount_SummariesView.getField_CountOfComments().getFullFieldName(dbOwner) + " = 0) ";
  }
  

}
