
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;

public abstract class ABCMCodeModeOptionsListedView extends ABCMdbView {

  public ABCMCodeModeOptionsListedView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModelOptionValue_PK();
  public abstract ABCMdbField getField_CodeModelOptionDomain_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_Value();
  public abstract ABCMdbField getField_CodeModelOptionDomain_PK();
  public abstract ABCMdbField getField_CodeModelOptionDomain_ID();

  
  public String getSQL(){
    String dbOwner                                               = DB.getOwner();
    ABCMCodeModelOptionDomainsTable codeModelOptionDomainsTable  = DB.getCodeModelOptionDomainsTable();
    ABCMCodeModelOptionValuesTable codeModelOptionValuesTable    = DB.getCodeModelOptionValuesTable();
    
    // TODO FORMATTING
    
    return
    "SELECT " +
        codeModelOptionValuesTable.getField_PRIMARY_KEY().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionValue_PK().getName() + ",\n" + 
        codeModelOptionDomainsTable.getField_DomainName().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionDomain_Name().getName()  + ",\n" + 
        codeModelOptionValuesTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionValue_Name().getName() + ",\n" + 
        codeModelOptionValuesTable.getField_OptionValue().getFullFieldName(dbOwner)+ " AS " + getField_CodeModelOptionValue_Value().getName() + ",\n" + 
        codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionDomain_PK().getName() + ",\n" + 
        codeModelOptionDomainsTable.getField_InCodeID().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionDomain_ID().getName()  + "\n" + 
   "FROM " + codeModelOptionValuesTable.getFullName(dbOwner) + " INNER JOIN " + codeModelOptionDomainsTable.getFullName(dbOwner) + " ON\n" + 
           codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " = " + codeModelOptionDomainsTable.getField_PK().getFullFieldName(dbOwner);
  }
  
}
