
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsAndOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsTable;

public abstract class ABCMCodeModelOptionDomainsAndValuesView extends ABCMdbView {

  public ABCMCodeModelOptionDomainsAndValuesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_CodeModels_PK();
  public abstract ABCMdbField getField_CodeModelOptionDomain_PK();
  public abstract ABCMdbField getField_CodeModelDomain_Name();
  public abstract ABCMdbField getField_CodeModelDomain_Desc();
  public abstract ABCMdbField getField_CodeModelOptionValue_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_PK();
  public abstract ABCMdbField getField_CodeModelOptionValue_Code();
  public abstract ABCMdbField getField_CodeModelOptionValue_Desc();

  public String getSQL(){
    
    ABCMCodeModelsAndOptionValuesTable codeModelsAndOptionValuesTable = DB.getCodeModelsAndOptionValuesTable();
    ABCMCodeModelsTable                codeModelsTable                = DB.getCodeModelsTable();
    ABCMCodeModelOptionDomainsTable    codeModelOptionDomainsTable    = DB.getCodeModelOptionDomainsTable();
    ABCMCodeModelOptionValuesTable     codeModelOptionValuesTable     = DB.getCodeModelOptionValuesTable();
    String                             dbOwner                        = DB.getOwner();
    
    
    return 
       "SELECT " + 
         codeModelsTable.getField_PK().getFullFieldName(dbOwner)                      + " AS " + getField_CodeModels_PK().getName()              + ", \n" + 
         codeModelOptionDomainsTable.getField_PK().getFullFieldName(dbOwner)          + " AS " + getField_CodeModelOptionDomain_PK().getName()   + ", \n" + 
         codeModelOptionDomainsTable.getField_DomainName().getFullFieldName(dbOwner)  + " AS " + getField_CodeModelDomain_Name().getName()       + ", \n" + 
         codeModelOptionDomainsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_CodeModelDomain_Desc().getName()       + ", \n" + 
         codeModelOptionValuesTable.getField_Name().getFullFieldName(dbOwner)         + " AS " + getField_CodeModelOptionValue_Name().getName()  + ", \n" + 
         codeModelOptionValuesTable.getField_OptionValue().getFullFieldName(dbOwner)  + " AS " + getField_CodeModelOptionValue_PK().getName()    + ", \n" + 
         codeModelOptionValuesTable.getField_Code().getFullFieldName(dbOwner)         + " AS " + getField_CodeModelOptionValue_Code().getName()  + ", \n" +
         codeModelOptionValuesTable.getField_Description().getFullFieldName(dbOwner)  + " AS " +  getField_CodeModelOptionValue_Desc().getName() + "\n" + 
       "FROM   " + codeModelsAndOptionValuesTable.getFullName(dbOwner) + " INNER JOIN " +"\n" + 
                        codeModelOptionValuesTable.getFullName(dbOwner) + " ON " +"\n" + 
                         codeModelsAndOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " = " + codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " AND  " + codeModelsAndOptionValuesTable.getField_OptionValueFK().getFullFieldName(dbOwner) + " = " + codeModelOptionValuesTable.getField_OptionValue().getFullFieldName(dbOwner) + 
               " INNER JOIN " +"\n" + 
                    codeModelsTable.getFullName(dbOwner) + " ON " +"\n" + 
                    codeModelsAndOptionValuesTable.getField_CodeModelFK().getFullFieldName(dbOwner) + " = " + codeModelsTable.getField_PK().getFullFieldName(dbOwner) + 
               " RIGHT OUTER JOIN " +"\n" + 
                    codeModelOptionDomainsTable.getFullName(dbOwner) + " ON " +"\n" + 
                    codeModelsAndOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " = " + codeModelOptionDomainsTable.getField_PK().getFullFieldName(dbOwner) + 
       " ORDER BY " + codeModelsTable.getField_PK().getFullFieldName(dbOwner) + ", " + codeModelOptionDomainsTable.getField_PK().getFullFieldName(dbOwner);
  }
  
}
