
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
import abcm.db.components.tables.ABCMCodeModelsTable;

public abstract class ABCMCodeModelsAndAllOptionsView extends ABCMdbView {

  public ABCMCodeModelsAndAllOptionsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CodeModelOptionDomain_PK();
  public abstract ABCMdbField getField_CodeModelDomain_Name();
  public abstract ABCMdbField getField_CodeModelDomain_Desc();
  public abstract ABCMdbField getField_CodeModelDomain_ID();
  public abstract ABCMdbField getField_CodeModel_Title();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_CodeModel_DateCreated();
  public abstract ABCMdbField getField_CodeModel_Desc();
  
  public String getSQL(){
    String dbOwner                                                   = DB.getOwner();
    
    ABCMCodeModelsTable codeModelsTable                              = DB.getCodeModelsTable();
    
    ABCMCodeModelOptionDomainsTable codeModelOptionDomainsTable      = DB.getCodeModelOptionDomainsTable();
    
    
    return   
      "SELECT " +
          codeModelsTable.getField_PK().getFullFieldName(dbOwner) +                      " AS " + getField_CodeModel_PK().getName() + ",\n" + 
          codeModelOptionDomainsTable.getField_PK().getFullFieldName(dbOwner) +          " AS " + getField_CodeModelOptionDomain_PK().getName() + ",\n" + 
          codeModelOptionDomainsTable.getField_DomainName().getFullFieldName(dbOwner) +  " AS " + getField_CodeModelDomain_Name().getName() + ",\n" + 
          codeModelOptionDomainsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_CodeModelDomain_Desc().getName() + ",\n" + 
          codeModelOptionDomainsTable.getField_InCodeID().getFullFieldName(dbOwner) +    " AS " + getField_CodeModelDomain_ID().getName() + ",\n" + 
          codeModelsTable.getField_Title().getFullFieldName(dbOwner) +                   " AS " + getField_CodeModel_Title().getName() + ",\n" + 
          codeModelsTable.getField_ResearcherFK().getFullFieldName(dbOwner) +            " AS " + getField_Researcher_PK().getName() + ",\n" + 
          codeModelsTable.getField_DateCreated().getFullFieldName(dbOwner) +             " AS " + getField_CodeModel_DateCreated().getName() +",\n" + 
          codeModelsTable.getField_Description().getFullFieldName(dbOwner) +             " AS " + getField_CodeModel_Desc().getName() + "\n" + 
     "FROM   "  + codeModelsTable.getFullName(dbOwner) + " CROSS JOIN " + codeModelOptionDomainsTable.getFullName(dbOwner);
  }

}
