
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMCodeModelsAndResearchersView extends ABCMdbView {
  
  public ABCMCodeModelsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CodeModel_Title();
  public abstract ABCMdbField getField_CodeModel_DateCreated();
  public abstract ABCMdbField getField_CodeModel_Desc();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CanBeEdited();

  public String getSQL(){
    String dbOwner                                                = DB.getOwner();
    
    ABCMCodeModelsTable codeModelsTable                           = DB.getCodeModelsTable();
        String codeModels = codeModelsTable.getFullName(dbOwner);
        
        String CODE_MODEL_PK    = codeModelsTable.getField_PK().getFullFieldName(dbOwner);
        String CODE_MODEL_TITLE = codeModelsTable.getField_Title().getFullFieldName(dbOwner);
        String DATE_CREATED     = codeModelsTable.getField_DateCreated().getFullFieldName(dbOwner);
        String DESC             = codeModelsTable.getField_Description().getFullFieldName(dbOwner);
        String RESEARCHER_FK    = codeModelsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        
    ABCMResearchersTable researchersTable                         = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);
    
        String RESEARCHER_PK = researchersTable.getField_PK().getFullFieldName(dbOwner);
        String NAME          = researchersTable.getField_ResearcherName().getFullFieldName(dbOwner);
        
    ABCMCanBeEdited_CodeModelsView canBeEdited_CodeModelsView     = DB.getCanBeEdited_CodeModelsView();
       String canBeEdited_CodeModels = canBeEdited_CodeModelsView.getFullName(dbOwner);
    
       String CODE_MODEL_FK = canBeEdited_CodeModelsView.getField_CodeModel_PK().getFullFieldName(dbOwner);
  
    return
       "SELECT " +
           CODE_MODEL_PK    + " AS " + getField_CodeModel_PK().getName()          + ", \n" + 
           CODE_MODEL_TITLE + " AS " + getField_CodeModel_Title().getName()       + ", \n" + 
           DATE_CREATED     + " AS " + getField_CodeModel_DateCreated().getName() + ", \n" + 
           DESC             + " AS " + getField_CodeModel_Desc().getName()        + ", \n" + 
           NAME             + " AS " + getField_Researcher_Name().getName()       + ", \n" + 
           CODE_MODEL_FK    + " AS " + getField_CanBeEdited().getName()           + "\n" + 
       "FROM  " +
            codeModels + " INNER JOIN " + researchers + " ON " +
               RESEARCHER_FK + " = " + RESEARCHER_PK + " LEFT OUTER JOIN " +"\n" + 
            canBeEdited_CodeModels + " ON " +"\n" + 
           CODE_MODEL_PK + " = " + CODE_MODEL_FK;
  }
  
}
