
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelOptionDomainsTable;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;

public abstract class ABCMCodeModelsDomainsAndOptionsView extends ABCMdbView {

  public ABCMCodeModelsDomainsAndOptionsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModelOptionDomain_ID();
  public abstract ABCMdbField getField_CodeModelOptionDomain_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_Value();

  public String getSQL(){
    ABCMCodeModelOptionDomainsTable codeModelOptionDomainsTable = DB.getCodeModelOptionDomainsTable();
    ABCMCodeModelOptionValuesTable  codeModelOptionValuesTable  = DB.getCodeModelOptionValuesTable();
    String                          dbOwner                     = DB.getOwner();
    
    return     
       "SELECT " +
          codeModelOptionDomainsTable.getField_InCodeID().getFullFieldName(dbOwner)   + " AS " + getField_CodeModelOptionDomain_ID().getName() + ",\n" + 
          codeModelOptionDomainsTable.getField_DomainName().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionDomain_Name().getName()  + ",\n" + 
          codeModelOptionValuesTable.getField_Name().getFullFieldName(dbOwner)        + " AS " + getField_CodeModelOptionValue_Name().getName()  +",\n" +
          codeModelOptionValuesTable.getField_OptionValue().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionValue_Value().getName() + "\n" +
       "FROM " + 
           codeModelOptionDomainsTable.getFullName(dbOwner) + " INNER JOIN " +"\n" + 
               codeModelOptionValuesTable.getFullName(dbOwner) + " ON " +"\n" + 
           codeModelOptionDomainsTable.getField_PK().getFullFieldName(dbOwner) + " = " + codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner);
  }
  
}
