
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;
import abcm.db.components.tables.ABCMCodeModelsAndOptionValuesTable;

public abstract class ABCMCodeModelsDomainsAndValuesAllView extends ABCMdbView {
  
  public ABCMCodeModelsDomainsAndValuesAllView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModelAndOptionValue_PK();
  public abstract ABCMdbField getField_CodeModel_Title();
  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CodeModelOptionDomain_ID();
  public abstract ABCMdbField getField_CodeModelOptionDomain_PK();
  public abstract ABCMdbField getField_CodeModelOptionValue_Value();
  public abstract ABCMdbField getField_CodeModelOptionValue_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_Code();
  public abstract ABCMdbField getField_CodeModelOptionValue_Desc();
  public abstract ABCMdbField getField_CodeModelOptionDomain_Name();
  public abstract ABCMdbField getField_CodeModelOptionDomain_Desc();

  public String getSQL(){
    String                             dbOwner                         = DB.getOwner();
    
    ABCMCodeModelsAndAllOptionsView    codeModelsAndAllOptionsView     = DB.getCodeModelsAndAllOptionsView();
    
    ABCMCodeModelOptionValuesTable     codeModelOptionValuesTable      = DB.getCodeModelOptionValuesTable();
    
    ABCMCodeModelsAndOptionValuesTable codeModelsAndOptionValuesTable  = DB.getCodeModelsAndOptionValuesTable();
    

    
    return 
      "SELECT " + 
          codeModelsAndOptionValuesTable.getField_PK().getFullFieldName(dbOwner) +                    " AS " + getField_CodeModelAndOptionValue_PK().getName() + ",\n" +
          codeModelsAndAllOptionsView.getField_CodeModel_Title().getFullFieldName(dbOwner) +          " AS " + getField_CodeModel_Title().getName() + ",\n" + 
          codeModelsAndAllOptionsView.getField_CodeModel_PK().getFullFieldName(dbOwner) +             " AS " + getField_CodeModel_PK().getName() + ",\n" + 
          codeModelsAndAllOptionsView.getField_CodeModelDomain_ID().getFullFieldName(dbOwner) +       " AS " + getField_CodeModelOptionDomain_ID().getName() + ",\n" + 
          codeModelsAndAllOptionsView.getField_CodeModelOptionDomain_PK().getFullFieldName(dbOwner) + " AS " + getField_CodeModelOptionDomain_PK().getName() + ",\n" + 
          codeModelsAndOptionValuesTable.getField_OptionValueFK().getFullFieldName(dbOwner) +         " AS " + getField_CodeModelOptionValue_Value().getName() + ",\n" + 
          codeModelOptionValuesTable.getField_Name().getFullFieldName(dbOwner) +                      " AS " + getField_CodeModelOptionValue_Name().getName() + ",\n" +              
          codeModelOptionValuesTable.getField_Code().getFullFieldName(dbOwner) +                      " AS " + getField_CodeModelOptionValue_Code().getName() + ",\n" + 
          codeModelOptionValuesTable.getField_Description().getFullFieldName(dbOwner) +               " AS " + getField_CodeModelOptionValue_Desc().getName() + ",\n" + 
          codeModelsAndAllOptionsView.getField_CodeModelDomain_Name().getFullFieldName(dbOwner) +     " AS " + getField_CodeModelOptionDomain_Name().getName() + ",\n" + 
          codeModelsAndAllOptionsView.getField_CodeModelDomain_Desc().getFullFieldName(dbOwner) +     " AS " + getField_CodeModelOptionDomain_Desc().getName() + "\n" + 
      "FROM " + codeModelOptionValuesTable.getFullName(dbOwner) + " RIGHT OUTER JOIN " +"\n" + 
                codeModelsAndOptionValuesTable.getFullName(dbOwner) + " ON " +"\n" + 
        codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " = " + codeModelsAndOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " AND\n" +
        codeModelOptionValuesTable.getField_OptionValue().getFullFieldName(dbOwner) + " = " + codeModelsAndOptionValuesTable.getField_OptionValueFK().getFullFieldName(dbOwner) + " RIGHT OUTER JOIN " +"\n" + 
        codeModelsAndAllOptionsView.getFullName(dbOwner) + " ON " +"\n" + 
        codeModelsAndOptionValuesTable.getField_CodeModelFK().getFullFieldName(dbOwner)+ " = " + codeModelsAndAllOptionsView.getField_CodeModel_PK().getFullFieldName(dbOwner) + " AND " +
        codeModelsAndOptionValuesTable.getField_CodeModelOptionDomainFK().getFullFieldName(dbOwner) + " = " + codeModelsAndAllOptionsView.getField_CodeModelOptionDomain_PK().getFullFieldName(dbOwner) + " ";
  }
  
}
