
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelOptionValuesTable;

public abstract class ABCMCodeModelsForWriteupView extends ABCMdbView {
  
  public ABCMCodeModelsForWriteupView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModelOptionValue_Name();
  public abstract ABCMdbField getField_CodeModelOptionValue_Code();
  public abstract ABCMdbField getField_CodeModelOptionValue_Desc();
  public abstract ABCMdbField getField_CodeModelOptionValue_Value();
  public abstract ABCMdbField getField_CodeModelOptionDomain_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMCodeModelOptionValuesTable codeModelOptionValuesTable = DB.getCodeModelOptionValuesTable();
        String codeModelOptionValues = codeModelOptionValuesTable.getFullName(dbOwner);
      
        String NAME      = codeModelOptionValuesTable.getField_Name().getName(); 
        String CODE      = codeModelOptionValuesTable.getField_Code().getName();
        String DESC      = codeModelOptionValuesTable.getField_Description().getName();
        String VAL       = codeModelOptionValuesTable.getField_OptionValue().getName();
        String DOMAIN_FK = codeModelOptionValuesTable.getField_CodeModelOptionDomainFK().getName();
    
    
    return
     "SELECT " + 
        NAME           + " AS " + getField_CodeModelOptionValue_Name().getName()   + ", \n" + 
        CODE           + " AS " + getField_CodeModelOptionValue_Code().getName()   + ", \n" +
        DESC           + " AS " + getField_CodeModelOptionValue_Desc().getName()   + ", \n" +
        VAL            + " AS " + getField_CodeModelOptionValue_Value().getName()  + ", \n" +
        DOMAIN_FK      + " AS " + getField_CodeModelOptionDomain_PK().getName()    + "\n" +
     "FROM " + codeModelOptionValues + "\n" +
     "ORDER BY " + NAME;
  }
  
}
