
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMCodeModelsInSimulationsView extends ABCMdbView {
  
  public ABCMCodeModelsInSimulationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CountOfSimulations();

  
  public String getSQL(){
    String dbOwner                         = DB.getOwner();

    ABCMCodeModelsTable codeModelsTable    = DB.getCodeModelsTable();
        String codeModels = codeModelsTable.getFullName(dbOwner);
        
        String CODE_MODEL_PK = codeModelsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMSimulationsTable simulationsTable  = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);
        
        String SIM_PK        = simulationsTable.getField_PK().getFullFieldName(dbOwner);
        String CODE_MODEL_FK = simulationsTable.getField_CodeModelFK().getFullFieldName(dbOwner);
    
    return
    "SELECT " +
         CODE_MODEL_PK           + " AS " + getField_CodeModel_PK().getName()       + ", \n" + 
         "COUNT(" + SIM_PK + ")" + " AS " + getField_CountOfSimulations().getName() + "\n" + 
    "FROM " +
         codeModels + " LEFT OUTER JOIN " +"\n" + 
            simulations + " ON " +  
         CODE_MODEL_PK + " = "  + CODE_MODEL_FK + "\n" +
    "GROUP BY " + CODE_MODEL_PK +
    "";
  }
}
