
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCommandCategoriesTable;

public abstract class ABCMCommandCategoriesInOrderView extends ABCMdbView {
  
  public ABCMCommandCategoriesInOrderView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CommandCategory_PK();
  public abstract ABCMdbField getField_CommandCategory_Name();
  public abstract ABCMdbField getField_CommandCategory_Desc();
  public abstract ABCMdbField getField_CommandCategory_Order();

    public String getSQL(){
      String dbOwner = DB.getOwner();

      ABCMCommandCategoriesTable commandCategoriesTable = DB.getCommandCategoriesTable();
        String commandCategories = commandCategoriesTable.getFullName(dbOwner);

        String PK    = commandCategoriesTable.getField_PK().getFullFieldName(dbOwner);
        String NAME  = commandCategoriesTable.getField_Name().getFullFieldName(dbOwner);
        String DESC  = commandCategoriesTable.getField_Description().getFullFieldName(dbOwner);
        String ORDER = commandCategoriesTable.getField_Order().getFullFieldName(dbOwner);
        
    return
       "SELECT \n" +
           PK     + " AS " + getField_CommandCategory_PK().getName()    + ",\n" +
           NAME   + " AS " + getField_CommandCategory_Name().getName()  + ",\n" +
           DESC   + " AS " + getField_CommandCategory_Desc().getName()  + ",\n" +
           ORDER  + " AS " + getField_CommandCategory_Order().getName() + "\n" +
       "FROM " + commandCategories + "\n" + 
       "ORDER BY " + ORDER;
  }
    
}
