
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMCommentsAndResearchersView extends ABCMdbView {
 
  public ABCMCommentsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Comment_PK();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Comment_DateEntryMade();
  public abstract ABCMdbField getField_Comment_Text();
  public abstract ABCMdbField getField_Researcher_Name();

  public String getSQL(){
    ABCMCommentsTable commentsTable          = DB.getCommentsTable();
    ABCMResearchersTable researchersTable    = DB.getResearchersTable();
    String dbOwner                           = DB.getOwner();
    
    return
     "SELECT " +
         commentsTable.getField_PK().getFullFieldName(dbOwner)                + " AS " + getField_Comment_PK().getName()            + ", \n" + 
         commentsTable.getField_ResearcherFK().getFullFieldName(dbOwner)      + " AS " + getField_Researcher_PK().getName()         + ", \n" +
         commentsTable.getField_DateCreated().getFullFieldName(dbOwner)       + " AS " + getField_Comment_DateEntryMade().getName() + ", \n" +
         commentsTable.getField_Comment().getFullFieldName(dbOwner)           + " AS " + getField_Comment_Text().getName()          + ", \n" +
         researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName()       + "\n" +
    "FROM " + commentsTable.getFullName(dbOwner) + "\n" +
        "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON\n" + 
          commentsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner);
  }

}
