
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisCommentsTable;

public abstract class ABCMCommentsCount_AnalysesView extends ABCMdbView {
  
  public ABCMCommentsCount_AnalysesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_CountOfComments();


  public String getSQL(){
    String dbOwner                                      = DB.getOwner();
    
    ABCMAnalysesTable analysesTable                     = DB.getAnalysesTable();
         String analyses = analysesTable.getFullName(dbOwner);
         
         String ANALYSIS_PK = analysesTable.getField_PK().getFullFieldName(dbOwner); 
    
    ABCMAnalysisCommentsTable analysisCommentsTable     = DB.getAnalysisCommentsTable();
         String analysisComments = analysisCommentsTable.getFullName(dbOwner);
    
         String COMMENT_ID  = analysisCommentsTable.getField_CommentFK().getFullFieldName(dbOwner);
         String ANALYSIS_FK = analysisCommentsTable.getField_AnalysisFK().getFullFieldName(dbOwner);
    
    return
      "SELECT " +
          ANALYSIS_PK                  + " AS " + getField_Analysis_PK().getName()     + ", \n" + 
          "COUNT(" + COMMENT_ID + ")"  + " AS " + getField_CountOfComments().getName() +  "\n" + 
      "FROM   " + 
          analysisComments + " RIGHT OUTER JOIN " + analyses + " ON " +"\n" + 
               ANALYSIS_FK + " = " + ANALYSIS_PK + "\n" +
      "GROUP BY " + ANALYSIS_PK;
  }
  
}
