
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelCommentsTable;
import abcm.db.components.tables.ABCMCodeModelsTable;

public abstract class ABCMCommentsCount_CodeModelsView extends ABCMdbView {
  
  public ABCMCommentsCount_CodeModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner                                       = DB.getOwner();
    
    ABCMCodeModelsTable codeModelsTable                  = DB.getCodeModelsTable();
        String codeModels = codeModelsTable.getFullName(dbOwner);
        
        String CODE_MODEL_PK = codeModelsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMCodeModelCommentsTable codeModelCommentsTable    = DB.getCodeModelCommentsTable();
        String codeModelComments = codeModelCommentsTable.getFullName(dbOwner);
    
        String CODE_MODEL_FK = codeModelCommentsTable.getField_CodeModelFK().getFullFieldName(dbOwner);
    
    return
      "SELECT " + CODE_MODEL_PK                  + " AS " + getField_CodeModel_PK().getName()     + ", \n" + 
                 "COUNT(" + CODE_MODEL_FK + ")" + " AS " + getField_CountOfComments(). getName() + "\n" + 
      "FROM " + codeModels + " LEFT OUTER JOIN " +"\n" + 
               codeModelComments + " ON " +"\n" + 
             CODE_MODEL_PK + " = " + CODE_MODEL_FK + " \n" +  
      " GROUP BY " + CODE_MODEL_PK;
  }
  
}
