
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMDataModelCommentsTable;
import abcm.db.components.tables.ABCMDataModelsTable;

public abstract class ABCMCommentsCount_DataModelsView extends ABCMdbView {
  
  public ABCMCommentsCount_DataModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner                                        = DB.getOwner();
    
    ABCMDataModelsTable dataModelsTable                   = DB.getDataModelsTable();
        String dataModels = dataModelsTable.getFullName(dbOwner);
    
        String DATA_MODEL_PK = dataModelsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMDataModelCommentsTable dataModelCommentsTable     = DB.getDataModelCommentsTable();
        String dataModelComments =dataModelCommentsTable.getFullName(dbOwner);
    
        String DATA_MODEL_FK = dataModelCommentsTable.getField_DataModelFK().getFullFieldName(dbOwner);
        String COMMENT_FK    = dataModelCommentsTable.getField_CommentFK().getFullFieldName(dbOwner);
    
  
    return
       "SELECT " +
          DATA_MODEL_PK               + " AS " + getField_DataModel_PK().getName()    + ", \n" + 
          "COUNT(" + COMMENT_FK + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
       "FROM   " + 
           dataModels + " LEFT OUTER JOIN " +"\n" + 
                   dataModelComments + " ON " + DATA_MODEL_PK + " = " + DATA_MODEL_FK + "\n" + 
       "GROUP BY " + DATA_MODEL_PK;

  }
  
}
