
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMHistoryCommentsTable;

public abstract class ABCMCommentsCount_HistoriesView extends ABCMdbView {
  
  public ABCMCommentsCount_HistoriesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();
  
    ABCMHistoriesTable historiesTable = DB.getHistoriesTable();
        String HISTORY_PK = historiesTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMHistoryCommentsTable historyCommentsTable   = DB.getHistoryCommentsTable();
        String historyComments = historyCommentsTable.getFullName(dbOwner);
        String HISTORY_FK = historyCommentsTable.getField_HistoryFK().getFullFieldName(dbOwner);
        
    return
      "SELECT " +
         HISTORY_PK + " AS " + this.getField_History_PK().getName() + ", \n" + 
         "COUNT(" + HISTORY_FK + ")" + " AS " + this.getField_CountOfComments().getName() + "\n" + 
       "FROM   " + historiesTable.getFullName(dbOwner) + " LEFT OUTER JOIN " +"\n" + 
            historyComments + " ON " +"\n" + 
               HISTORY_PK + " = " + HISTORY_FK + " " +
       "GROUP BY " + HISTORY_PK;
    }
 
}
