
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMNarrativeCommentsTable;
import abcm.db.components.tables.ABCMNarrativesTable;

public abstract class ABCMCommentsCount_NarrativesView extends ABCMdbView {

  public ABCMCommentsCount_NarrativesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Narrative_PK();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    ABCMNarrativesTable narrativesTable                   = DB.getNarrativesTable();
    ABCMNarrativeCommentsTable narrativeCommentsTable     = DB.getNarrativeCommentsTable();
    String dbOwner                                        = DB.getOwner();
    
    return
       "SELECT " +
           narrativesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Narrative_PK().getName() + ", \n" + 
           "COUNT(" + narrativeCommentsTable.getField_PK().getFullFieldName(dbOwner) + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
       "FROM   " + narrativeCommentsTable.getFullName(dbOwner) + " " +
          "RIGHT OUTER JOIN " + narrativesTable.getFullName(dbOwner) + " ON\n" + 
              narrativeCommentsTable.getField_NarrativeFK().getFullFieldName(dbOwner) + " = " + narrativesTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
       "GROUP BY " + narrativesTable.getField_PK().getFullFieldName(dbOwner);
  }
  

}
