
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetCommentsTable;
import abcm.db.components.tables.ABCMParameterSetsTable;

public abstract class ABCMCommentsCount_ParameterSetsView extends ABCMdbView {
  
  public ABCMCommentsCount_ParameterSetsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner                                              = DB.getOwner();
    
    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
        String parameterSets = parameterSetsTable.getFullName(dbOwner);

        String PARAM_SET_PK = parameterSetsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMParameterSetCommentsTable parameterSetCommentsTable = DB.getParameterSetCommentsTable();
        String parameterSetComments = parameterSetCommentsTable.getFullName(dbOwner);
        
        String COMMENT_FK   = parameterSetCommentsTable.getField_CommentFK().getFullFieldName(dbOwner);
        String PARAM_SET_FK = parameterSetCommentsTable.getField_ParameterSetFK().getFullFieldName(dbOwner);
    
    return
      "SELECT " +
          PARAM_SET_PK + " AS " + getField_ParameterSet_PK().getName()                + ", \n" + 
          "COUNT(" + COMMENT_FK + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
       "FROM " + 
           parameterSetComments + " \n" +
         "RIGHT OUTER JOIN " +  parameterSets + " ON " +"\n" + 
           PARAM_SET_FK + " = " + PARAM_SET_PK + "\n" +
       "GROUP BY " + PARAM_SET_PK;
  }
  
}
