
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbeSetCommentsTable;
import abcm.db.components.tables.ABCMProbeSetsTable;

public abstract class ABCMCommentsCount_ProbeSetsView extends ABCMdbView {

  public ABCMCommentsCount_ProbeSetsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ProbeSet_PK();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    String dbOwner                                    = DB.getOwner();

    ABCMProbeSetsTable probeSetsTable = DB.getProbeSetsTable();
        String probeSets = probeSetsTable.getFullName(dbOwner);

        String PROBE_SET_PK = probeSetsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMProbeSetCommentsTable probeSetCommentsTable = DB.getProbeSetCommentsTable();
        String probeSetComments = probeSetCommentsTable.getFullName(dbOwner);
        
        String COMMENT_FK   = probeSetCommentsTable.getField_CommentFK().getFullFieldName(dbOwner);
        String PROBE_SET_FK = probeSetCommentsTable.getField_ProbeSetFK().getFullFieldName(dbOwner);
        
    return
      "SELECT " +
           PROBE_SET_PK + " AS " + getField_ProbeSet_PK().getName() + ", \n" + 
          "COUNT(" + COMMENT_FK + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
     "FROM " + probeSetComments + " \n" +
        "RIGHT OUTER JOIN " + probeSets + " ON " +"\n" + 
            PROBE_SET_FK + " = " + PROBE_SET_PK + " \n" +
     "GROUP BY " + PROBE_SET_PK;
  }
  

}
