
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbeCommentsTable;
import abcm.db.components.tables.ABCMProbesTable;

public abstract class ABCMCommentsCount_ProbesView extends ABCMdbView {

  public ABCMCommentsCount_ProbesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Probe_PK();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    String dbOwner                              = DB.getOwner();

    ABCMProbesTable probesTable                 = DB.getProbesTable();
        String probes = probesTable.getFullName(dbOwner);
        String PROBE_PK = probesTable.getField_PK().getFullFieldName(dbOwner);

    ABCMProbeCommentsTable probeCommentsTable   = DB.getProbeCommentsTable();
        String probeComments = probeCommentsTable.getFullName(dbOwner);
        String COMMENT_PROBE_FK   = probeCommentsTable.getField_ProbeFK().getFullFieldName(dbOwner);
    
    return
       "SELECT " +
           PROBE_PK                          + " AS " + getField_Probe_PK().getName() + ", \n" + 
           "COUNT(" + COMMENT_PROBE_FK + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
       "FROM " + probeComments + " " +
           "RIGHT OUTER JOIN " + probes + " ON\n" + 
                COMMENT_PROBE_FK + " = " + PROBE_PK + "\n" +
       "GROUP BY " + PROBE_PK;
  }

}
