
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationConfigurationCommentsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class ABCMCommentsCount_SimulationConfigurationsView extends ABCMdbView {

  public ABCMCommentsCount_SimulationConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    ABCMSimulationConfigurationsTable simulationConfigurationsTable                 = DB.getSimulationConfigurationsTable();
    ABCMSimulationConfigurationCommentsTable simulationConfigurationCommentsTable   = DB.getSimulationConfigurationCommentsTable();
    String dbOwner                                                                  = DB.getOwner();
    
    return
      "SELECT " +
         simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_PK().getName() + ",\n" +  
         "COUNT(" + simulationConfigurationCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
      "FROM " + simulationConfigurationsTable.getFullName(dbOwner) + " \n" +
          "LEFT OUTER JOIN " + simulationConfigurationCommentsTable.getFullName(dbOwner) + " ON\n" + 
              simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + simulationConfigurationCommentsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner) + " \n" +
      "GROUP BY " + simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner);
  }
  

}
