
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationCommentsTable;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMCommentsCount_SimulationsView extends ABCMdbView {

  public ABCMCommentsCount_SimulationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner                                      = DB.getOwner();
    
    ABCMSimulationCommentsTable simulationCommentsTable = DB.getSimulationCommentsTable();
        String simulationComments = simulationCommentsTable.getFullName(dbOwner);

        String COMMENT_FK     = simulationCommentsTable.getField_CommentFK().getFullFieldName(dbOwner);
        String COMMENT_SIM_FK = simulationCommentsTable.getField_SimulationFK().getFullFieldName(dbOwner);
    
    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);
        
        String SIM_PK = simulationsTable.getField_PK().getFullFieldName(dbOwner);
  
    return
   "SELECT " +
      SIM_PK                      + " AS " + getField_Simulation_PK().getName()   + ",\n" + 
      "COUNT(" + COMMENT_FK + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
   "FROM " + simulationComments + " \n" +
      "RIGHT OUTER JOIN " + simulations + " ON " +"\n" + 
          COMMENT_SIM_FK + " = " + SIM_PK + "\n" +
   "GROUP BY " + SIM_PK;


  }
  
}
