
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryCommentsTable;

public abstract class ABCMCommentsCount_SummariesView extends ABCMdbView {

  public ABCMCommentsCount_SummariesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    ABCMSummariesTable summariesTable                = DB.getSummariesTable();
    ABCMSummaryCommentsTable summaryCommentsTable    = DB.getSummaryCommentsTable();
    String dbOwner                                   = DB.getOwner();
    
    return
     "SELECT " +
         summariesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ",\n" + 
         "COUNT(" + summaryCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
     "FROM   " + summaryCommentsTable.getFullName(dbOwner) + " \n" +
        "RIGHT OUTER JOIN " + summariesTable.getFullName(dbOwner) + " ON \n" + 
           summaryCommentsTable.getField_SummaryFK().getFullFieldName(dbOwner) + " = " + summariesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
     "GROUP BY " + summariesTable.getField_PK().getFullFieldName(dbOwner);
  }
  
}
