
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class ABCMConfigurationsInDataModelsView extends ABCMdbView {

  public ABCMConfigurationsInDataModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_CountOfDataModels();

  
  public String getSQL(){
    ABCMSimulationConfigurationsTable simulationConfigurationsTable  = DB.getSimulationConfigurationsTable();
    ABCMDataModelsTable dataModelsTable                              = DB.getDataModelsTable();
    String dbOwner                                                   = DB.getOwner();
    
    return
       "SELECT " +
          simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_PK().getName() + ",\n" + 
          "COUNT(" + dataModelsTable.getField_PK().getFullFieldName(dbOwner) + ")" + " AS " + getField_CountOfDataModels().getName() + "\n" +
       "FROM " + simulationConfigurationsTable.getFullName(dbOwner) + " \n" +
          "LEFT OUTER JOIN " +  dataModelsTable.getFullName(dbOwner) + " ON\n" + 
               simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + dataModelsTable.getField_ConfigurationFK().getFullFieldName(dbOwner) + " \n" +
       "GROUP BY " + simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " ";
  }
  
}
