
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMDataModelsInSimulationsView extends ABCMdbView {
  
  public ABCMDataModelsInSimulationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_CountOfSimulations();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMDataModelsTable dataModelsTable = DB.getDataModelsTable();
        String dataModels = dataModelsTable.getFullName(dbOwner);
        
        String DATA_MODEL_PK = dataModelsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);
        
        String SIMULATION_PK = simulationsTable.getField_PK().getFullFieldName(dbOwner);
        String DATA_MODEL_FK = simulationsTable.getField_DataModelFK().getFullFieldName(dbOwner);
    
    return
      "SELECT " +
         DATA_MODEL_PK                  + " AS " + this.getField_DataModel_PK().getName()       + ", \n" + 
         "COUNT(" + SIMULATION_PK + ")" + " AS " + this.getField_CountOfSimulations().getName() + "\n" + 
      "FROM " + 
         dataModels + " LEFT OUTER JOIN " +"\n" + 
         simulations + " ON " +"\n" + 
         DATA_MODEL_PK + " = " + DATA_MODEL_FK + " " +
       "GROUP BY " + DATA_MODEL_PK;
  }
  

}
