
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class ABCMDataModelsWithNamesOfElementsSTEP1View extends ABCMdbView {
  
  public ABCMDataModelsWithNamesOfElementsSTEP1View(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_DataModel_Name();
  public abstract ABCMdbField getField_DataModel_Desc();
  public abstract ABCMdbField getField_DataModel_DateCreated();
  public abstract ABCMdbField getField_History_Title();
  public abstract ABCMdbField getField_SimulationConfiguration_Name();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_CombinedTruthValue();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    ABCMDataModelsTable               dataModelsTable          = DB.getDataModelsTable();
        String dataModels = dataModelsTable.getFullName(dbOwner);
        
        String DATA_MODEL_PK            = dataModelsTable.getField_PK().getFullFieldName(dbOwner);
        String DATA_MODEL_NAME          = dataModelsTable.getField_Name().getFullFieldName(dbOwner);
        String DATA_MODEL_DESC          = dataModelsTable.getField_Description().getFullFieldName(dbOwner);
        String DATA_MODEL_DATE_CREATED  = dataModelsTable.getField_DateCreated().getFullFieldName(dbOwner);
        String DATA_MODEL_HISTORY_FK    = dataModelsTable.getField_HistoryFK().getFullFieldName(dbOwner);
        String DATA_MODEL_CONFIG_FK     = dataModelsTable.getField_ConfigurationFK().getFullFieldName(dbOwner);
        String DATA_MODEL_RESEARCHER_FK = dataModelsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        
    ABCMHistoriesTable                historiesTable           = DB.getHistoriesTable();
        String histories = historiesTable.getFullName(dbOwner);
        
        String HISTORY_TITLE       = historiesTable.getField_Title().getFullFieldName(dbOwner);
        String HISTORY_PK          = historiesTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMSimulationConfigurationsTable simulationConfigurationsTable = DB.getSimulationConfigurationsTable();
        String simulationConfigurations = simulationConfigurationsTable.getFullName(dbOwner);
     
        String SIM_CONFIG_NAME = simulationConfigurationsTable.getField_Name().getFullFieldName(dbOwner);
        String SIM_CONFIG_PK   = simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMResearchersTable              researchersTable         = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);
        
        String RESEARCHER_PK   = researchersTable.getField_PK().getFullFieldName(dbOwner);
        String RESEARCHER_NAME = researchersTable.getField_ResearcherName().getFullFieldName(dbOwner);
    
    
    ABCMCanBeEdited_DataModelsView    canBeEdited_DataModelsView   = DB.getCanBeEdited_DataModelsView();        
        String canBeEdited_DataModels = canBeEdited_DataModelsView.getFullName(dbOwner);
        
        String DATA_MODEL_CBE_FK      = canBeEdited_DataModelsView.getField_DataModel_PK().getFullFieldName(dbOwner);
        
    ABCMSimulationConfigurationsAndTruthValuesView simulationConfigsView = DB.getSimulationConfigurationsAndTruthValuesView();
        String simConfigs = simulationConfigsView.getFullName(dbOwner);
        
        String SIM_CONFIG_WTV_PK           = simulationConfigsView.getField_PK().getFullFieldName(dbOwner);
        
    return
       "SELECT " +      
           DATA_MODEL_PK              + " AS " + getField_DataModel_PK().getName()                 + ", \n" + 
           DATA_MODEL_NAME            + " AS " + getField_DataModel_Name().getName()               + ", \n" + 
           DATA_MODEL_DESC            + " AS " + getField_DataModel_Desc().getName()               + ", \n" +
           DATA_MODEL_DATE_CREATED    + " AS " + getField_DataModel_DateCreated().getName()        + ", \n" +
           HISTORY_TITLE              + " AS " + getField_History_Title().getName()                + ", \n" +
           SIM_CONFIG_NAME            + " AS " + getField_SimulationConfiguration_Name().getName() + ", \n" +
           RESEARCHER_NAME            + " AS " + getField_Researcher_Name().getName()              + ", \n" +
           HISTORY_PK                 + " AS " + getField_History_PK().getName()                   + ", \n" +
           SIM_CONFIG_PK              + " AS " + getField_SimulationConfiguration_PK().getName()   + ", \n" +
           DATA_MODEL_CBE_FK          + " AS " + getField_CanBeEdited().getName()                  + ", \n" +
           //"CASE WHEN [" + historiesTable.getName() + "].[" + historiesTable.getField_TruthValueFK().getName() + "] > [" + simulationConfigsView.getName() + "].["  + simulationConfigsView.getField_TruthValue().getName() + "] " +
           
//           Table.getField_TruthValueFK().getFullFieldName(dbOwner)) + " > " + DB.getSQLSyntaxEngine().getDottedName(simulationConfigsView.getField_TruthValue().getFullFieldName(dbOwner)) + " " +
//           "THEN " + historiesTable.getField_TruthValueFK().getDottedName() + " " +
//           "ELSE " + simulationConfigsView.getField_TruthValue().getDottedName() + " " +
//          "END " + " AS " + getField_CombinedTruthValue().getName()
           
           "CASE WHEN " + DB.getSQLSyntaxEngine().getDottedName(historiesTable.getField_TruthValueFK().getFullFieldName(dbOwner)) + " > " + DB.getSQLSyntaxEngine().getDottedName(simulationConfigsView.getField_TruthValue().getFullFieldName(dbOwner)) + " " +
                 "THEN " + DB.getSQLSyntaxEngine().getDottedName(historiesTable.getField_TruthValueFK().getFullFieldName(dbOwner)) + " " +
                 "ELSE " + DB.getSQLSyntaxEngine().getDottedName(simulationConfigsView.getField_TruthValue().getFullFieldName(dbOwner)) + " " +
                "END " + " AS " + getField_CombinedTruthValue().getName() +  "\n" +
           
       "FROM " +         
           dataModels + " INNER JOIN " +
           histories + " ON " + 
           DATA_MODEL_HISTORY_FK + " =  " + HISTORY_PK + " INNER JOIN " +
           simulationConfigurations + " ON " + 
           DATA_MODEL_CONFIG_FK + " = " + SIM_CONFIG_PK + " INNER JOIN " + 
           researchers + " ON " + 
           DATA_MODEL_RESEARCHER_FK + " = " + RESEARCHER_PK + " LEFT OUTER JOIN " + 
           simConfigs + " ON " +  
           SIM_CONFIG_PK + " = " +  SIM_CONFIG_WTV_PK + " LEFT OUTER JOIN " +
           canBeEdited_DataModels + " ON " + 
           DATA_MODEL_PK + " = " + DATA_MODEL_CBE_FK;
  }
  
}
