
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMTruthValuesTable;

public abstract class ABCMDataModelsWithNamesOfElementsView extends ABCMdbView {
  
  public ABCMDataModelsWithNamesOfElementsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_TruthValue();
  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_DataModel_Name();
  public abstract ABCMdbField getField_DataModel_Desc();
  public abstract ABCMdbField getField_DataModel_DateCreated();
  public abstract ABCMdbField getField_History_Title();
  public abstract ABCMdbField getField_SimulationConfiguration_Name();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_CombinedTruthValue();
  public abstract ABCMdbField getField_TruthValue_PK();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMTruthValuesTable truthValuesTable = DB.getTruthValuesTable();
        String truthValues = truthValuesTable.getFullName(dbOwner);
        
        String TRUTH_VALUE_PK = truthValuesTable.getField_PK().getName();
        String TRUTH_VALUE    = truthValuesTable.getField_TruthValue().getName();        
    
    ABCMDataModelsWithNamesOfElementsSTEP1View dataModelsWithNamesOfElementsSTEP1View = DB.getDataModelsWithNamesOfElementsSTEP1View();
        String step1View = dataModelsWithNamesOfElementsSTEP1View.getFullName(dbOwner);
        
        String DATA_MODEL_PK                   = dataModelsWithNamesOfElementsSTEP1View.getField_DataModel_PK().getFullFieldName(dbOwner);
        String DATA_MODEL_NAME                 = dataModelsWithNamesOfElementsSTEP1View.getField_DataModel_Name().getFullFieldName(dbOwner);
        String DATA_MODEL_DESC                 = dataModelsWithNamesOfElementsSTEP1View.getField_DataModel_Desc().getFullFieldName(dbOwner);
        String DATA_MODEL_DATE                 = dataModelsWithNamesOfElementsSTEP1View.getField_DataModel_DateCreated().getFullFieldName(dbOwner);
        String DATA_MODEL_CBE                  = dataModelsWithNamesOfElementsSTEP1View.getField_CanBeEdited().getFullFieldName(dbOwner);
        String DATA_MODEL_HIST_PK              = dataModelsWithNamesOfElementsSTEP1View.getField_History_PK().getFullFieldName(dbOwner);
        String DATA_MODEL_HIST_TITLE           = dataModelsWithNamesOfElementsSTEP1View.getField_History_Title().getFullFieldName(dbOwner);
        String DATA_MODEL_RESEARCHER           = dataModelsWithNamesOfElementsSTEP1View.getField_Researcher_Name().getFullFieldName(dbOwner);
        String DATA_MODEL_SIM_CONFIG_PK        = dataModelsWithNamesOfElementsSTEP1View.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner);
        String DATA_MODEL_SIM_CONFIG_NAME      = dataModelsWithNamesOfElementsSTEP1View.getField_SimulationConfiguration_Name().getFullFieldName(dbOwner);
        String DATA_MODEL_COMBINED_TRUTH_VALUE = dataModelsWithNamesOfElementsSTEP1View.getField_CombinedTruthValue().getFullFieldName(dbOwner);
            
    return
        "SELECT " +
              TRUTH_VALUE_PK                  + " AS " + getField_TruthValue_PK().getName()                + ", \n" +
              TRUTH_VALUE                     + " AS " + getField_TruthValue().getName()                   + ", \n" +
              DATA_MODEL_PK                   + " AS " + getField_DataModel_PK().getName()                 + ", \n" +
              DATA_MODEL_NAME                 + " AS " + getField_DataModel_Name().getName()               + ", \n" +
              DATA_MODEL_DESC                 + " AS " + getField_DataModel_Desc().getName()               + ", \n" +
              DATA_MODEL_DATE                 + " AS " + getField_DataModel_DateCreated().getName()        + ", \n" +
              DATA_MODEL_CBE                  + " AS " + getField_CanBeEdited().getName()                  + ", \n" +
              DATA_MODEL_HIST_PK              + " AS " + getField_History_PK().getName()                   + ", \n" +
              DATA_MODEL_HIST_TITLE           + " AS " + getField_History_Title().getName()                + ", \n" +
              DATA_MODEL_RESEARCHER           + " AS " + getField_Researcher_Name().getName()              + ", \n" +
              DATA_MODEL_SIM_CONFIG_PK        + " AS " + getField_SimulationConfiguration_PK().getName()   + ", \n" +
              DATA_MODEL_SIM_CONFIG_NAME      + " AS " + getField_SimulationConfiguration_Name().getName() + ", \n" +
              DATA_MODEL_COMBINED_TRUTH_VALUE + " AS " + getField_CombinedTruthValue().getName()           + "\n" +
         "FROM "  + 
            step1View + " INNER JOIN " +"\n" + 
            truthValues + " ON " +"\n" + 
            DATA_MODEL_COMBINED_TRUTH_VALUE + " = " + TRUTH_VALUE_PK;
    }
}
