
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMHistoriesTable;

public abstract class ABCMHistoriesInDataModelsView extends ABCMdbView {
  
  public ABCMHistoriesInDataModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_CountOfDataModels();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMHistoriesTable historiesTable = DB.getHistoriesTable();
        String histories = historiesTable.getFullName(dbOwner); 
        
        String HISTORY_PK          = historiesTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMDataModelsTable dataModelsTable = DB.getDataModelsTable();
        String dataModels = dataModelsTable.getFullName(dbOwner);
        
        String DATA_MODEL_PK = dataModelsTable.getField_PK().getFullFieldName(dbOwner);
        String HISTORY_FK    = dataModelsTable.getField_HistoryFK().getFullFieldName(dbOwner);
        
    return
       "SELECT " +
          HISTORY_PK + " AS " + getField_History_PK().getName() + ", \n" + 
          "COUNT(" + DATA_MODEL_PK + ")" + " AS " + getField_CountOfDataModels().getName()  + "\n" + 
       "FROM " + 
          histories + " LEFT OUTER JOIN " +"\n" + 
             dataModels + " ON " +"\n" + 
                HISTORY_PK + " = " + HISTORY_FK + " \n" +
      "GROUP BY " + HISTORY_PK;
    }
  
}
