
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMHistoryNarrativesTable;
import abcm.db.components.tables.ABCMNarrativesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMHistoriesNarrativesAndResearchersView extends ABCMdbView {
  
  public ABCMHistoriesNarrativesAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_Narrative_Name();
  public abstract ABCMdbField getField_Narrative_Desc();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Narrative_StartBaseDate();
  public abstract ABCMdbField getField_Narrative_BaseDate();
  public abstract ABCMdbField getField_Narrative_DateCreated();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_Narrative_Order();
  public abstract ABCMdbField getField_Narrative_PK();
  public abstract ABCMdbField getField_History_Name();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMHistoriesTable historiesTable = DB.getHistoriesTable();
        String histories = historiesTable.getFullName(dbOwner);
    
    ABCMHistoryNarrativesTable historyNarrativesTable = DB.getHistoryNarrativesTable();
        String historyNarratives = historyNarrativesTable.getFullName(dbOwner);

    ABCMNarrativesTable narrativesTable = DB.getNarrativesTable();
        String narratives = narrativesTable.getFullName(dbOwner);

    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);
    
    return

    "SELECT " +
      historyNarrativesTable.getField_HistoryFK().getFullFieldName(dbOwner)  + " AS " + getField_History_PK().getName() + ", \n" +
      narrativesTable.getField_Name().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_Name().getName() + ", \n" +
      narrativesTable.getField_Description().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_Desc().getName() + ", \n" +
      narrativesTable.getField_ResearcherFK().getFullFieldName(dbOwner)  + " AS " + getField_Researcher_PK().getName() + ", \n" +
      historyNarrativesTable.getField_BaseDate().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_StartBaseDate().getName() + ", \n" +
      narrativesTable.getField_BaseDate().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_BaseDate().getName() + ", \n" +
      narrativesTable.getField_DateCreated().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_DateCreated().getName() + ", \n" +
      researchersTable.getField_ResearcherName().getFullFieldName(dbOwner)  + " AS " + getField_Researcher_Name().getName() + ", \n" +
      historyNarrativesTable.getField_Order().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_Order().getName() + ", \n" +
      narrativesTable.getField_PK().getFullFieldName(dbOwner)  + " AS " + getField_Narrative_PK().getName() + ", \n" +
      historiesTable.getField_Title().getFullFieldName(dbOwner)  + " AS " + getField_History_Name().getName() + "\n" +
    "FROM " +
      historyNarratives + "\n" +
      "INNER JOIN " + narratives + " ON " +
         historyNarrativesTable.getField_NarrativeFK().getFullFieldName(dbOwner)  + " =  " + narrativesTable.getField_PK().getFullFieldName(dbOwner)  + "\n" +
       "INNER JOIN " + histories + " ON " +
         historyNarrativesTable.getField_HistoryFK().getFullFieldName(dbOwner)  + " =  " + historiesTable.getField_PK().getFullFieldName(dbOwner)  + "\n" +
      "INNER JOIN " + researchers + " ON " +
         historiesTable.getField_ResearcherFK().getFullFieldName(dbOwner)  + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner)  + "\n" +
      "ORDER BY " + historyNarrativesTable.getField_HistoryFK().getFullFieldName(dbOwner) + ", " + historyNarrativesTable.getField_Order().getFullFieldName(dbOwner);
  }
  

}
