
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMJournalEntriesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMJournalEntriesAndResearchersView extends ABCMdbView {
  
  public ABCMJournalEntriesAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_JournalEntry_PK();
  public abstract ABCMdbField getField_JournalEntry_DateMade();
  public abstract ABCMdbField getField_JournalEntry_Entry();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Researcher_Name();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMJournalEntriesTable journalEntriesTable = DB.getJournalEntriesTable();
    ABCMResearchersTable researchersTable = DB.getResearchersTable();

        
    return
    "SELECT " +
        journalEntriesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_JournalEntry_PK().getName() + ", \n" + 
        journalEntriesTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_JournalEntry_DateMade().getName() + ", \n" +
        journalEntriesTable.getField_Entry().getFullFieldName(dbOwner) + " AS " + getField_JournalEntry_Entry().getName() + ", \n" +
        journalEntriesTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + getField_Researcher_PK().getName() + ", \n" +
        researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + "\n" +
    "FROM " + journalEntriesTable.getFullName(dbOwner) + " \n" +
        "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON\n" + 
        journalEntriesTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner);

  }
  

}
