package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMNarrativeArgumentsTable;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;

public abstract class ABCMNarrativeArgumentsView extends ABCMdbView {

  public ABCMNarrativeArgumentsView(String viewName, AbstractABCMDBGateway db){
    super(viewName, db);
  }
  
  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_CommandFK();
  public abstract ABCMdbField getField_ArgNo();
  public abstract ABCMdbField getField_Command();
  public abstract ABCMdbField getField_ArgName();
  
  public String getSQL(){
    ABCMNarrativeCommandsTable  narrativeCommands  = DB.getNarrativeCommandsTable();
    ABCMNarrativeArgumentsTable narrativeArguments = DB.getNarrativeArgumentsTable();
    String dbOwner                                 = DB.getOwner();
    
    return "SELECT " + narrativeCommands.getField_Command().getFullFieldName(dbOwner) + " AS " + getField_Command().getName() + ", \n" +
                       narrativeArguments.getField_PK().getFullFieldName(dbOwner)     + " AS " + getField_PK().getName()      + ", \n" + 
                       narrativeArguments.getField_NarrativeCommandFK().getFullFieldName(dbOwner) + " AS " + getField_CommandFK().getName() + ", \n" +
                       narrativeArguments.getField_ArgumentNumber().getFullFieldName(dbOwner)     + " AS " + getField_ArgNo().getName() + ", \n" + 
                       narrativeArguments.getField_ArgumentName().getFullFieldName(dbOwner)       + " AS " + getField_ArgName().getName() + " \n" +
           "FROM " +   narrativeArguments.getFullName(dbOwner) + " \n" +
              "INNER JOIN " + narrativeCommands.getFullName(dbOwner) + " ON\n" +
                     narrativeArguments.getField_NarrativeCommandFK().getFullFieldName(dbOwner) + " = " + narrativeCommands.getField_PK().getFullFieldName(dbOwner);        
  }
  
  
}
