
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCommandCategoriesTable;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;

public abstract class ABCMNarrativeCommandsByCategoryView extends ABCMdbView {
  
  public ABCMNarrativeCommandsByCategoryView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CommandCategory_Name();
  public abstract ABCMdbField getField_CommandCategory_Desc();
  public abstract ABCMdbField getField_CommandCategory_Order();
  public abstract ABCMdbField getField_Command();
  public abstract ABCMdbField getField_NumberOfArguments();
  public abstract ABCMdbField getField_Command_Desc();
  public abstract ABCMdbField getField_CommandLineoOnly();
  public abstract ABCMdbField getField_Probe();
  public abstract ABCMdbField getField_Instructions();
  public abstract ABCMdbField getField_NarrativeCommand_PK();
  public abstract ABCMdbField getField_CommandCategory_PK();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMCommandCategoriesTable commandCategoriesTable = DB.getCommandCategoriesTable();
    ABCMNarrativeCommandsTable narrativeCommandsTable = DB.getNarrativeCommandsTable();


    return
      "SELECT  " +
          commandCategoriesTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_CommandCategory_Name().getName() + ", \n" + 
          commandCategoriesTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_CommandCategory_Desc().getName() + ", \n" +
          commandCategoriesTable.getField_Order().getFullFieldName(dbOwner) + " AS " + getField_CommandCategory_Order().getName() + ", \n" +
          narrativeCommandsTable.getField_Command().getFullFieldName(dbOwner) + " AS " + getField_Command().getName() + ", \n" +
          narrativeCommandsTable.getField_NumberOfArgs().getFullFieldName(dbOwner) + " AS " + getField_NumberOfArguments().getName() + ", \n" +
          narrativeCommandsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_Command_Desc().getName() + ", \n" +
          narrativeCommandsTable.getField_CommandLineOnly().getFullFieldName(dbOwner) + " AS " + getField_CommandLineoOnly().getName() + ", \n" +
          narrativeCommandsTable.getField_Probe().getFullFieldName(dbOwner) + " AS " + getField_Probe().getName() + ", \n" +
          narrativeCommandsTable.getField_Instructions().getFullFieldName(dbOwner) + " AS " + getField_Instructions().getName() + ", \n" +
          narrativeCommandsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_NarrativeCommand_PK().getName() + ", \n" +
          commandCategoriesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_CommandCategory_PK().getName() + "\n" +
      "FROM  " + 
          commandCategoriesTable.getFullName(dbOwner) + " \n" +
              "INNER JOIN " + narrativeCommandsTable.getFullName(dbOwner) + " ON\n" + 
                 commandCategoriesTable.getField_PK().getFullFieldName(dbOwner) + " = " + narrativeCommandsTable.getField_CommandCategoryFK().getFullFieldName(dbOwner) + "\n" +
      "ORDER BY " + commandCategoriesTable.getField_Order().getFullFieldName(dbOwner) + ", " +
                    narrativeCommandsTable.getField_Command().getFullFieldName(dbOwner);
  }
  

}
