
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCommandCategoriesTable;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;

public abstract class ABCMNarrativeCommandsView extends ABCMdbView {
  
  public ABCMNarrativeCommandsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_NarrativeCommand_PK();
  public abstract ABCMdbField getField_NarrativeCommand();
  public abstract ABCMdbField getField_NumberOfArguments();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_CommandLineOnly();
  public abstract ABCMdbField getField_Probe();
  public abstract ABCMdbField getField_NarrativeCommand_Instructions();
  public abstract ABCMdbField getField_CommandCategory_PK();
  public abstract ABCMdbField getField_CommandCategory();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    
    ABCMNarrativeCommandsTable narrativeCommandsTable = DB.getNarrativeCommandsTable();
        String narrativeCommands = narrativeCommandsTable.getFullName(dbOwner);
        
    ABCMCommandCategoriesTable commandCategoriesTable = DB.getCommandCategoriesTable();
        String commandCategories = commandCategoriesTable.getFullName(dbOwner);

    // TODO FORMATTING
        
    return
       "SELECT " +
        narrativeCommandsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_NarrativeCommand_PK().getName() + ", \n" +
        narrativeCommandsTable.getField_Command().getFullFieldName(dbOwner) + " AS " + getField_NarrativeCommand().getName() + ", \n" +
        narrativeCommandsTable.getField_NumberOfArgs().getFullFieldName(dbOwner) + " AS " + getField_NumberOfArguments().getName() + ", \n" +
        narrativeCommandsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_Description().getName() + ", \n" +
        narrativeCommandsTable.getField_CommandLineOnly().getFullFieldName(dbOwner) + " AS " + getField_CommandLineOnly().getName() + ", \n" +
        narrativeCommandsTable.getField_Probe().getFullFieldName(dbOwner) + " AS " + getField_Probe().getName() + ", \n" +
        narrativeCommandsTable.getField_Instructions().getFullFieldName(dbOwner) + " AS " + getField_NarrativeCommand_Instructions().getName() + ", \n" +
        narrativeCommandsTable.getField_CommandCategoryFK().getFullFieldName(dbOwner) + " AS " + getField_CommandCategory_PK().getName() + ", \n" +
        commandCategoriesTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_CommandCategory().getName() + "\n" +
     "FROM " + narrativeCommands + " INNER JOIN " + commandCategories + " ON " + 
           narrativeCommandsTable.getField_CommandCategoryFK().getFullFieldName(dbOwner) + " = " + commandCategoriesTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
