
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMNarrativeCommandsTable;
import abcm.db.components.tables.ABCMNarrativeInstructionsTable;

public abstract class ABCMNarrativesAndInstructionsView extends ABCMdbView {
  
  public ABCMNarrativesAndInstructionsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Narrative_PK();
  public abstract ABCMdbField getField_NarrativeInstruction_PK();
  public abstract ABCMdbField getField_Date();
  public abstract ABCMdbField getField_Order();
  public abstract ABCMdbField getField_Command();
  public abstract ABCMdbField getField_Arg1();
  public abstract ABCMdbField getField_Arg2();
  public abstract ABCMdbField getField_Arg3();
  public abstract ABCMdbField getField_Arg4();
  public abstract ABCMdbField getField_Arg5();
  public abstract ABCMdbField getField_Arg6();
  public abstract ABCMdbField getField_Arg7();
  public abstract ABCMdbField getField_Arg8();
  public abstract ABCMdbField getField_Arg9();
  public abstract ABCMdbField getField_Arg10();
  public abstract ABCMdbField getField_Comment();
  public abstract ABCMdbField getField_NumberOfArguments();
  public abstract ABCMdbField getField_Narrative_Name();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMNarrativeInstructionsTable narrativeInstructionsTable = DB.getNarrativeInstructionsTable();
    ABCMNarrativeCommandsTable narrativeCommandsTable = DB.getNarrativeCommandsTable();
        
        
    return
       "SELECT  " + 
           narrativeInstructionsTable.getField_NarrativeFK().getFullFieldName(dbOwner)      + " AS " + getField_Narrative_PK().getName() + ",\n" + 
           narrativeInstructionsTable.getField_PK().getFullFieldName(dbOwner)               + " AS " + getField_NarrativeInstruction_PK().getName() + ",\n" + 
           narrativeInstructionsTable.getField_InstructionDate().getFullFieldName(dbOwner)  + " AS " + getField_Date().getName() + ",\n" + 
           narrativeInstructionsTable.getField_InstructionOrder().getFullFieldName(dbOwner) + " AS " + getField_Order().getName() + ",\n" + 
           narrativeCommandsTable.getField_Command().getFullFieldName(dbOwner)              + " AS " + getField_Command().getName() + ",\n" + 
           narrativeInstructionsTable.getField_Arg1().getFullFieldName(dbOwner)             + " AS " + getField_Arg1().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg2().getFullFieldName(dbOwner)             + " AS " + getField_Arg2().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg3().getFullFieldName(dbOwner)             + " AS " + getField_Arg3().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg4().getFullFieldName(dbOwner)             + " AS " + getField_Arg4().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg5().getFullFieldName(dbOwner)             + " AS " + getField_Arg5().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg6().getFullFieldName(dbOwner)             + " AS " + getField_Arg6().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg7().getFullFieldName(dbOwner)             + " AS " + getField_Arg7().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg8().getFullFieldName(dbOwner)             + " AS " + getField_Arg8().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg9().getFullFieldName(dbOwner)             + " AS " + getField_Arg9().getName() + ",\n" +
           narrativeInstructionsTable.getField_Arg10().getFullFieldName(dbOwner)            + " AS " + getField_Arg10().getName() + ",\n" +
           narrativeInstructionsTable.getField_Comment().getFullFieldName(dbOwner)          + " AS " + getField_Comment().getName() + ",\n" + 
           narrativeCommandsTable.getField_NumberOfArgs().getFullFieldName(dbOwner)         + " AS " + getField_NumberOfArguments().getName() + "\n" +
           " FROM " +  narrativeInstructionsTable.getFullName(dbOwner) + " " +
              "INNER JOIN " +  narrativeCommandsTable.getFullName(dbOwner) + " ON \n" +
                  narrativeInstructionsTable.getField_NarrativeCommandFK().getFullFieldName(dbOwner) + " = " + narrativeCommandsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
           " ORDER BY " + narrativeInstructionsTable.getField_InstructionDate().getFullFieldName(dbOwner) + ", " + narrativeInstructionsTable.getField_InstructionOrder().getFullFieldName(dbOwner); 

  }
  

}
