
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMHistoryNarrativesTable;
import abcm.db.components.tables.ABCMNarrativesTable;

public abstract class ABCMNarrativesInHistoriesView extends ABCMdbView {
  
  public ABCMNarrativesInHistoriesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Narrative_PK();
  public abstract ABCMdbField getField_CountOfTimesUsed();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMNarrativesTable narrativesTable = DB.getNarrativesTable();
    ABCMHistoryNarrativesTable historyNarrativesTable = DB.getHistoryNarrativesTable();
        
    return
    "SELECT " +
        narrativesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + this.getField_Narrative_PK().getName() + ",\n" + 
        "COUNT(" + historyNarrativesTable.getField_NarrativeFK().getFullFieldName(dbOwner) + ")" + " AS " + this.getField_CountOfTimesUsed().getName() + "\n" + 
    "FROM " + narrativesTable.getFullName(dbOwner) + "\n" +
        "LEFT OUTER JOIN " + historyNarrativesTable.getFullName(dbOwner) + " ON\n" + 
            narrativesTable.getField_PK().getFullFieldName(dbOwner) + " = " + historyNarrativesTable.getField_NarrativeFK().getFullFieldName(dbOwner) + " GROUP BY " + narrativesTable.getField_PK().getFullFieldName(dbOwner);
    }
  

}
