
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMParametersTable;

public abstract class ABCMParameterSetsAndAllParametersView extends ABCMdbView {
  
  public ABCMParameterSetsAndAllParametersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }
  

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_ParameterSet_Name();
  public abstract ABCMdbField getField_Parameter_PK();
  public abstract ABCMdbField getField_Parameter_DefaultValue();
  public abstract ABCMdbField getField_Parameter_Name();
  public abstract ABCMdbField getField_Parameter_Description();
  public abstract ABCMdbField getField_Parameter_Units();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
        String parameterSets = parameterSetsTable.getFullName(dbOwner);
        
        String PARAM_SET_PK   = parameterSetsTable.getField_PK().getFullFieldName(dbOwner);
        String PARAM_SET_NAME = parameterSetsTable.getField_Name().getFullFieldName(dbOwner); 
        
    ABCMParametersTable parametersTable = DB.getParametersTable();
        String parameters = parametersTable.getFullName(dbOwner);
        
        String PARAM_PK    = parametersTable.getField_PK().getFullFieldName(dbOwner);
        String DEFAULT     = parametersTable.getField_DefaultValue().getFullFieldName(dbOwner);
        String PARAM_NAME  = parametersTable.getField_Name().getFullFieldName(dbOwner);
        String PARAM_DESC  = parametersTable.getField_Description().getFullFieldName(dbOwner);
        String PARAM_UNITS = parametersTable.getField_Units().getFullFieldName(dbOwner);
    
    return
      "SELECT " +
          PARAM_SET_PK   + " AS " + this.getField_ParameterSet_PK().getName() + ", \n" + 
          PARAM_SET_NAME + " AS " + this.getField_ParameterSet_Name().getName() + ", \n" + 
          PARAM_PK       + " AS " + this.getField_Parameter_PK().getName() + ", \n" + 
          DEFAULT        + " AS " + this.getField_Parameter_DefaultValue().getName() + ", \n" + 
          PARAM_NAME     + " AS " + this.getField_Parameter_Name().getName() + ", \n" + 
          PARAM_DESC     + " AS " + this.getField_Parameter_Description().getName() + ", \n" + 
          PARAM_UNITS    + " AS " + this.getField_Parameter_Units().getName() + "\n" +
       "FROM " + parameterSets + " CROSS JOIN " + parameters + " " +
       "ORDER BY " + PARAM_SET_PK;
  }
  

}
