
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMParameterSetsAndResearchersStep1View extends ABCMdbView {
  
  public ABCMParameterSetsAndResearchersStep1View(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_ParameterSet_Name();
  public abstract ABCMdbField getField_ParameterSet_DateCreated();
  public abstract ABCMdbField getField_Automatic();
  public abstract ABCMdbField getField_ParameterSet_Description();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_ParameterSet_TruthValue();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
        String parameterSets = parameterSetsTable.getFullName(dbOwner);

        String PARAM_SET_PK            = parameterSetsTable.getField_PK().getFullFieldName(dbOwner);
        String PARAM_SET_NAME          = parameterSetsTable.getField_Name().getFullFieldName(dbOwner);
        String PARAM_SET_DATE          = parameterSetsTable.getField_DateCreated().getFullFieldName(dbOwner);
        String PARAM_SET_IS_AUTO       = parameterSetsTable.getField_IsAutomatic().getFullFieldName(dbOwner);
        String PARAM_SET_DESC          = parameterSetsTable.getField_Description().getFullFieldName(dbOwner);
        String PARAM_SET_RESEARCHER_FK = parameterSetsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        
    ABCMCanBeEdited_ParameterSetsView canBeEdited_ParameterSetsView = DB.getCanBeEdited_ParameterSetsView();
        String canBeEdited_ParameterSets = canBeEdited_ParameterSetsView.getFullName(dbOwner);

        String PARAM_SET_CBE_FK = canBeEdited_ParameterSetsView.getField_ParameterSet_PK().getFullFieldName(dbOwner);        
        
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);

        String RESEARCHER_PK   = researchersTable.getField_PK().getFullFieldName(dbOwner);
        String RESEARCHER_NAME = researchersTable.getField_ResearcherName().getFullFieldName(dbOwner);
        
    ABCMParameterSetsAndTruthValuesView parameterSetsAndTruthValuesView = DB.getParameterSetsAndTruthValuesView();
        String parameterSetsAndTruthValues = parameterSetsAndTruthValuesView.getFullName(dbOwner);

        String TRUTH_VALUE_PARAM_SET_FK = parameterSetsAndTruthValuesView.getField_ParameterSet_PK().getFullFieldName(dbOwner); 
        String PARAM_SET_TRUTH_VALUE    = parameterSetsAndTruthValuesView.getField_TruthValue().getFullFieldName(dbOwner);

    return
       "SELECT " +
           PARAM_SET_PK            + " AS " + getField_ParameterSet_PK().getName()          + ", \n" + 
           PARAM_SET_NAME          + " AS " + getField_ParameterSet_Name().getName()        + ", \n" + 
           PARAM_SET_DATE          + " AS " + getField_ParameterSet_DateCreated().getName() + ", \n" + 
           PARAM_SET_IS_AUTO       + " AS " + getField_Automatic().getName()                + ", \n" + 
           PARAM_SET_DESC          + " AS " + getField_ParameterSet_Description().getName() + ", \n" +
           PARAM_SET_RESEARCHER_FK + " AS " + getField_Researcher_PK().getName()            + ", \n" +
           RESEARCHER_NAME         + " AS " + getField_Researcher_Name().getName()          + ", \n" +
           PARAM_SET_CBE_FK        + " AS " + getField_CanBeEdited().getName()              + ", \n" + 
           PARAM_SET_TRUTH_VALUE   + " AS " + getField_ParameterSet_TruthValue().getName()  + "\n" +
       "FROM " + parameterSets + "\n" +  
           "INNER JOIN " + researchers + " ON " +"\n" + 
                PARAM_SET_RESEARCHER_FK + " = " + RESEARCHER_PK + "\n" +  
           "LEFT OUTER JOIN " + parameterSetsAndTruthValues + " ON " +"\n" + 
                PARAM_SET_PK + " = " + TRUTH_VALUE_PARAM_SET_FK + "\n" +   
           "LEFT OUTER JOIN " +canBeEdited_ParameterSets + " ON " +"\n" + 
                PARAM_SET_PK + " = " + PARAM_SET_CBE_FK;
  }
  

}
