
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMTruthValuesTable;

public abstract class ABCMParameterSetsAndResearchersView extends ABCMdbView {
  
  public ABCMParameterSetsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_ParameterSet_Description();
  public abstract ABCMdbField getField_Automatic();
  public abstract ABCMdbField getField_ParameterSet_DateCreated();
  public abstract ABCMdbField getField_ParameterSet_Name();
  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_ParameterSet_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMParameterSetsAndResearchersStep1View parameterSetsAndResearchersStep1View = DB.getParameterSetsAndResearchersStep1View();
        String parameterSetsAndResearchersStep1 = parameterSetsAndResearchersStep1View.getFullName(dbOwner);

        String CAN_BE_EDITED         = parameterSetsAndResearchersStep1View.getField_CanBeEdited().getFullFieldName(dbOwner);
        String RESEARCHER_NAME       = parameterSetsAndResearchersStep1View.getField_Researcher_Name().getFullFieldName(dbOwner);
        String RESEARCHER_FK         = parameterSetsAndResearchersStep1View.getField_Researcher_PK().getFullFieldName(dbOwner);
        String PARAM_SET_DESC        = parameterSetsAndResearchersStep1View.getField_ParameterSet_Description().getFullFieldName(dbOwner);
        String PARAM_SET_IS_AUTO     = parameterSetsAndResearchersStep1View.getField_Automatic().getFullFieldName(dbOwner);
        String PARAM_SET_DATE        = parameterSetsAndResearchersStep1View.getField_ParameterSet_DateCreated().getFullFieldName(dbOwner);
        String PARAM_SET_NAME        = parameterSetsAndResearchersStep1View.getField_ParameterSet_Name().getFullFieldName(dbOwner);
        String PARAM_SET_PK          = parameterSetsAndResearchersStep1View.getField_ParameterSet_PK().getFullFieldName(dbOwner);
        String PARAM_SET_TRUTH_VALUE = parameterSetsAndResearchersStep1View.getField_ParameterSet_TruthValue().getFullFieldName(dbOwner);
    
    ABCMTruthValuesTable truthValuesTable = DB.getTruthValuesTable();
        String TRUTH_VALUE    = truthValuesTable.getField_TruthValue().getFullFieldName(dbOwner);
        String TRUTH_VALUE_PK = truthValuesTable.getField_PK().getFullFieldName(dbOwner);
        
    return
      "SELECT " +
         CAN_BE_EDITED      + " AS " + getField_CanBeEdited().getName()                  + ", \n" + 
         RESEARCHER_NAME    + " AS " + getField_Researcher_Name().getName()              + ", \n" +
         RESEARCHER_FK      + " AS " + getField_Researcher_PK().getName()                + ", \n" + 
         PARAM_SET_DESC     + " AS " + getField_ParameterSet_Description().getName()     + ", \n" + 
         PARAM_SET_IS_AUTO  + " AS " + getField_Automatic().getName()                    + ", \n" + 
         PARAM_SET_DATE     + " AS " + getField_ParameterSet_DateCreated().getName()     + ", \n" + 
         PARAM_SET_NAME     + " AS " + getField_ParameterSet_Name().getName()            + ", \n" + 
         PARAM_SET_PK       + " AS " + getField_ParameterSet_PK().getName()              + ", \n" +
         TRUTH_VALUE        + " AS " + getField_ParameterSet_TruthValue().getName()      + "\n" + 
           "FROM   "  + parameterSetsAndResearchersStep1 + " " +
              "LEFT OUTER JOIN " + truthValuesTable.getFullName(dbOwner) + " ON " +"\n" + 
                  PARAM_SET_TRUTH_VALUE + " = " + TRUTH_VALUE_PK;
  }
  
  
}
