
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsAndValuesTable;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.managers.TruthValueManager;

public abstract class ABCMParameterSetsAndTruthValuesView extends ABCMdbView {
  
  public ABCMParameterSetsAndTruthValuesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_TruthValue();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
        String parameterSets = parameterSetsTable.getFullName(dbOwner);
        
        String PARAM_SET_PK = parameterSetsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMParameterSetsAndValuesTable parameterSetsAndValuesTable = DB.getParameterSetsAndValuesTable();
        String parameterSetsAndValues = parameterSetsAndValuesTable.getFullName(dbOwner);
        
        String PARAM_SET_FK = parameterSetsAndValuesTable.getField_ParameterSet_FK().getFullFieldName(dbOwner);
        String TRUTH_VALUE  = parameterSetsAndValuesTable.getField_TruthValue().getFullFieldName(dbOwner);
    
    return
       "SELECT " +
          PARAM_SET_PK               + " AS " + getField_ParameterSet_PK().getName() + ", \n" + 
          DB.getSQLSyntaxEngine().getNullFunction() + "(MAX(" + TRUTH_VALUE + ")," + TruthValueManager.CERTAIN + ")" + " AS " + getField_TruthValue().getName()      + "\n" +
       "FROM " + parameterSetsAndValues + "\n" +
          "RIGHT OUTER JOIN " + parameterSets + " ON " +
          PARAM_SET_FK + " = " + PARAM_SET_PK + "\n" +
       "GROUP BY " + PARAM_SET_PK;
  }
  

}
