
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsAndValuesTable;

public abstract class ABCMParameterSetsAndValuesView extends ABCMdbView {
  
  public ABCMParameterSetsAndValuesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_ParameterSet_Name();
  public abstract ABCMdbField getField_Parameter_PK();
  public abstract ABCMdbField getField_Value();
  public abstract ABCMdbField getField_Parameter_DefaultValue();
  public abstract ABCMdbField getField_Parameter_Name();
  public abstract ABCMdbField getField_Parameter_Description();
  public abstract ABCMdbField getField_Parameter_Units();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMParameterSetsAndAllParametersView parameterSetsAndAllParametersView = DB.getParameterSetsAndAllParametersView();
        String parameterSetsAndAllParameters = parameterSetsAndAllParametersView.getFullName(dbOwner);
        
        String PARAM_SET_PK   = parameterSetsAndAllParametersView.getField_ParameterSet_PK().getFullFieldName(dbOwner);
        String PARAM_SET_NAME = parameterSetsAndAllParametersView.getField_ParameterSet_Name().getFullFieldName(dbOwner);
        String PARAMETER_FK   = parameterSetsAndAllParametersView.getField_Parameter_PK().getFullFieldName(dbOwner);
        String DEFAULT_VALUE  = parameterSetsAndAllParametersView.getField_Parameter_DefaultValue().getFullFieldName(dbOwner);
        String PARAM_NAME     = parameterSetsAndAllParametersView.getField_Parameter_Name().getFullFieldName(dbOwner);
        String PARAM_DESC     = parameterSetsAndAllParametersView.getField_Parameter_Description().getFullFieldName(dbOwner);
        String PARAM_UNITS    = parameterSetsAndAllParametersView.getField_Parameter_Units().getFullFieldName(dbOwner);
        
    ABCMParameterSetsAndValuesTable parameterSetsAndValuesTable = DB.getParameterSetsAndValuesTable();
        String parameterSetsAndValues = parameterSetsAndValuesTable.getFullName(dbOwner);
        
        String PARAM_SET_FK = parameterSetsAndValuesTable.getField_ParameterSet_FK().getFullFieldName(dbOwner);
        String PARAM_FK     = parameterSetsAndValuesTable.getField_Parameter_FK().getFullFieldName(dbOwner);
        String PARAM_VALUE  = parameterSetsAndValuesTable.getField_Value().getFullFieldName(dbOwner);
        
    return
      "SELECT " +
          PARAM_SET_PK   + " AS " + getField_ParameterSet_PK().getName()        + ", \n" + 
          PARAM_SET_NAME + " AS " + getField_ParameterSet_Name().getName()      + ", \n" + 
          PARAMETER_FK   + " AS " + getField_Parameter_PK().getName()           + ", \n" + 
          PARAM_VALUE    + " AS " + getField_Value().getName()                  + ", \n" + 
          DEFAULT_VALUE  + " AS " + getField_Parameter_DefaultValue().getName() + ", \n" + 
          PARAM_NAME     + " AS " + getField_Parameter_Name().getName()         + ", \n" + 
          PARAM_DESC     + " AS " + getField_Parameter_Description().getName()  + ", \n" + 
          PARAM_UNITS    + " AS " + getField_Parameter_Units().getName()        + "\n" + 
      "FROM " + 
         parameterSetsAndValues + " RIGHT OUTER JOIN " +"\n" + 
              parameterSetsAndAllParameters + " ON " +"\n" + 
          PARAM_SET_FK + " = " + PARAM_SET_PK + " AND " +
          PARAM_FK + " = " + PARAMETER_FK;
  }
  

}
