
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;

public abstract class ABCMParameterSetsInSimulationRunsView extends ABCMdbView {
  
  public ABCMParameterSetsInSimulationRunsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_CountOfTimesRun();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
        String parameterSets = parameterSetsTable.getFullName(dbOwner);

        String PARAM_SET_PK = parameterSetsTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
        String simulationRuns = simulationRunsTable.getFullName(dbOwner);
         
        String SIM_RUN_PK   = simulationRunsTable.getField_PK().getFullFieldName(dbOwner);
        String PARAM_SET_FK = simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner);
        
    return
       "SELECT " +
           PARAM_SET_PK + " AS " + getField_ParameterSet_PK().getName()               + ", \n" + 
           "COUNT(" + SIM_RUN_PK + ")" + " AS " + getField_CountOfTimesRun().getName() + "\n" +
       "FROM   " + parameterSets + "\n" +
          "LEFT OUTER JOIN " + simulationRuns + " ON " +"\n" + 
               PARAM_SET_PK + " = " + PARAM_SET_FK + " " +
       "GROUP BY " + PARAM_SET_PK;
  }
  

}
