
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterCategoriesTable;
import abcm.db.components.tables.ABCMParametersTable;

public abstract class ABCMParametersAndCategoriesView extends ABCMdbView {
  
  public ABCMParametersAndCategoriesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ParameterCategory_Name();
  public abstract ABCMdbField getField_Parameter_Name();
  public abstract ABCMdbField getField_ParameterCategory_PK();
  public abstract ABCMdbField getField_Order();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMParameterCategoriesTable parameterCategoriesTable = DB.getParameterCategoriesTable();
        String parameterCategories = parameterCategoriesTable.getFullName(dbOwner);
        
        String CATEGORY_NAME = parameterCategoriesTable.getField_Name().getFullFieldName(dbOwner);
        String CATEGORY_PK   = parameterCategoriesTable.getField_PK().getFullFieldName(dbOwner);
    
    
    ABCMParametersTable          parametersTable          = DB.getParametersTable();
        String parameters = parametersTable.getFullName(dbOwner);
        
        String PARAM_NAME  = parametersTable.getField_Name().getFullFieldName(dbOwner);
        String PARAM_ORDER = parametersTable.getField_Order().getFullFieldName(dbOwner);
        String CATEGORY_FK = parametersTable.getField_ParameterCategoryFK().getFullFieldName(dbOwner);
    
    return
       "SELECT " +
           CATEGORY_NAME         + " AS " + getField_ParameterCategory_Name().getName() + ", \n" +  
           PARAM_NAME            + " AS " + getField_Parameter_Name().getName()         + ", \n" + 
           CATEGORY_PK           + " AS " + getField_ParameterCategory_PK().getName()   + ", \n" + 
           PARAM_ORDER           + " AS " + getField_Order().getName()                  + " \n" + 
       "FROM " +
           parameters + " INNER JOIN " + parameterCategories + " ON " +  
                      CATEGORY_FK + " = " + CATEGORY_PK + " \n" + 
      "ORDER BY " + CATEGORY_PK + ", " + PARAM_ORDER + "";
  }
  

}
