
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMProbeSetsAndResearchersView extends ABCMdbView {
  
  public ABCMProbeSetsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ProbeSet_PK();
  public abstract ABCMdbField getField_ProbeSet_Name();
  public abstract ABCMdbField getField_ProbeSet_DateCreated();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_ProbeSet_Desc();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CanBeEdited();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMProbeSetsTable probeSetsTable = DB.getProbeSetsTable();
        String probeSets = probeSetsTable.getFullName(dbOwner);

        String PROBE_SET_PK            = probeSetsTable.getField_PK().getFullFieldName(dbOwner);
        String PROBE_SET_NAME          = probeSetsTable.getField_Name().getFullFieldName(dbOwner);
        String PROBE_SET_DATE          = probeSetsTable.getField_DateCreated().getFullFieldName(dbOwner);
        String PROBE_SET_RESEARCHER_FK = probeSetsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        String PROBE_SET_DESC          = probeSetsTable.getField_Description().getFullFieldName(dbOwner);
        
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);

        String RESEARCHER_PK   = researchersTable.getField_PK().getFullFieldName(dbOwner);
        String RESEARCHER_NAME = researchersTable.getField_ResearcherName().getFullFieldName(dbOwner);

    ABCMCanBeEdited_ProbeSetsView canBeEdited_ProbeSetsView = DB.getCanBeEdited_ProbeSetsView();
        String canBeEdited_ProbeSets = canBeEdited_ProbeSetsView.getFullName(dbOwner);

        String CBE_PROBE_SET_PK = canBeEdited_ProbeSetsView.getField_ProbeSet_PK().getFullFieldName(dbOwner);
        
    return
    "SELECT " +
          PROBE_SET_PK              + " AS " + getField_ProbeSet_PK().getName()          + ", \n" + 
          PROBE_SET_NAME            + " AS " + getField_ProbeSet_Name().getName()        + ", \n" +
          PROBE_SET_DATE            + " AS " + getField_ProbeSet_DateCreated().getName() + ", \n" +
          PROBE_SET_RESEARCHER_FK   + " AS " + getField_Researcher_PK().getName()        + ", \n" +
          PROBE_SET_DESC            + " AS " + getField_ProbeSet_Desc().getName()        + ", \n" +
          RESEARCHER_NAME           + " AS " + getField_Researcher_Name().getName()      + ", \n" +
          CBE_PROBE_SET_PK          + " AS " + getField_CanBeEdited().getName()          + "\n" +
    "FROM " + probeSets + " " +
        "INNER JOIN " + researchers + " ON " +"\n" + 
            PROBE_SET_RESEARCHER_FK + " = " + RESEARCHER_PK + " " +
        "LEFT OUTER JOIN " + canBeEdited_ProbeSets + " ON " +"\n" + 
            PROBE_SET_PK + " = " + CBE_PROBE_SET_PK;
  }

  
}
