
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;

public abstract class ABCMProbeSetsInSimulationRunsView extends ABCMdbView {
  
  public ABCMProbeSetsInSimulationRunsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_ProbeSet_PK();
  public abstract ABCMdbField getField_TimesRun();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMProbeSetsTable probeSetsTable = DB.getProbeSetsTable();
        String PROBE_SET_PK = probeSetsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
        String simulationRuns = simulationRunsTable.getFullName(dbOwner);
        String SIM_RUN_FK = simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner);
        String SIM_RUN_PK = simulationRunsTable.getField_PK().getFullFieldName(dbOwner);

    
    return
      "SELECT " +
         PROBE_SET_PK                + " AS " + getField_ProbeSet_PK().getName() + ", \n" + 
         "COUNT(" + SIM_RUN_PK + ")" + " AS " + getField_TimesRun().getName()    + "\n" + 
      "FROM " + probeSetsTable.getFullName(dbOwner) + " \n" +
          "LEFT OUTER JOIN " + simulationRuns + " ON " +"\n" + 
         PROBE_SET_PK + " = " + SIM_RUN_FK + " \n" +
      "GROUP BY " + PROBE_SET_PK;
  }
  

}
