
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMProbesAndResearchersView extends ABCMdbView {
  
  public ABCMProbesAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_Probe_PK();
  public abstract ABCMdbField getField_Probe_Name();
  public abstract ABCMdbField getField_Probe_Desc();
  public abstract ABCMdbField getField_Probe_DateCreated();
  public abstract ABCMdbField getField_DataSeries_Name();
  public abstract ABCMdbField getField_DataSeries_Domain();
  public abstract ABCMdbField getField_Probe_IsNumeric();
  public abstract ABCMdbField getField_Probe_IsMonthly();
  public abstract ABCMdbField getField_Probe_BaseDate();
  public abstract ABCMdbField getField_Probe_Frequency();
  public abstract ABCMdbField getField_Probe_Retrieve();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_Probe_Offset();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);

        String RESEARCHER_PK   = researchersTable.getField_PK().getFullFieldName(dbOwner);
        String RESEARCHER_NAME = researchersTable.getField_ResearcherName().getFullFieldName(dbOwner);
    
    ABCMProbesTable probesTable = DB.getProbesTable();
        String probes = probesTable.getFullName(dbOwner);

        String PROBE_PK            = probesTable.getField_PK().getFullFieldName(dbOwner);
        String PROBE_NAME          = probesTable.getField_Name().getFullFieldName(dbOwner);
        String PROBE_DESC          = probesTable.getField_Description().getFullFieldName(dbOwner);
        String PROBE_DATE          = probesTable.getField_DateCreated().getFullFieldName(dbOwner);
        String PROBE_DATA_SERIES   = probesTable.getField_DataSeriesName().getFullFieldName(dbOwner);
        String PROBE_DATA_DOMAIN   = probesTable.getField_DataSeriesDomain().getFullFieldName(dbOwner);
        String PROBE_IS_NUMERIC    = probesTable.getField_IsNumeric().getFullFieldName(dbOwner);
        String PROBE_IS_MONTHLY    = probesTable.getField_IsMonthly().getFullFieldName(dbOwner);
        String PROBE_BASE_DATE     = probesTable.getField_BaseDate().getFullFieldName(dbOwner);
        String PROBE_FREQ          = probesTable.getField_Frequency().getFullFieldName(dbOwner);
        String PROBE_RETRIEVE      = probesTable.getField_Retrieve().getFullFieldName(dbOwner);
        String PROBE_OFFSET        = probesTable.getField_Offset().getFullFieldName(dbOwner);
        String PROBE_RESEARCHER_FK = probesTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        
    ABCMCanBeEdited_ProbesView canBeEdited_ProbesView = DB.getCanBeEdited_ProbesView();
        String canBeEdited_Probes = canBeEdited_ProbesView.getFullName(dbOwner);

        String CBE_PROBE_FK = canBeEdited_ProbesView.getField_Probe_PK().getFullFieldName(dbOwner);
    
    return
       "SELECT " + 
           RESEARCHER_NAME      + " AS " + getField_Researcher_Name().getName()    + ", \n" + 
           PROBE_PK             + " AS " + getField_Probe_PK().getName()           + ", \n" + 
           PROBE_NAME           + " AS " + getField_Probe_Name().getName()         + ", \n" +      
           PROBE_DESC           + " AS " + getField_Probe_Desc().getName()         + ", \n" + 
           PROBE_DATE           + " AS " + getField_Probe_DateCreated().getName()  + ", \n" +
           PROBE_DATA_SERIES    + " AS " + getField_DataSeries_Name().getName()    + ", \n" +
           PROBE_DATA_DOMAIN    + " AS " + getField_DataSeries_Domain().getName()  + ", \n" +
           PROBE_IS_NUMERIC     + " AS " + getField_Probe_IsNumeric().getName()    + ", \n" +
           PROBE_IS_MONTHLY     + " AS " + getField_Probe_IsMonthly().getName()    + ", \n" +
           PROBE_BASE_DATE      + " AS " + getField_Probe_BaseDate().getName()     + ", \n" +
           PROBE_FREQ           + " AS " + getField_Probe_Frequency().getName()    + ", \n" +
           PROBE_RETRIEVE       + " AS " + getField_Probe_Retrieve().getName()     + ", \n" +
           CBE_PROBE_FK         + " AS " + getField_CanBeEdited().getName()        + ", \n" + 
           PROBE_OFFSET         + " AS " + getField_Probe_Offset().getName()       + "\n" +
       "FROM   " + probes + " " +
          "INNER JOIN " + researchers + " ON " +"\n" + 
               PROBE_RESEARCHER_FK + " = " + RESEARCHER_PK + " \n" +
          "LEFT OUTER JOIN " + canBeEdited_Probes + " ON " +"\n" + 
               PROBE_PK + " = " + CBE_PROBE_FK;
  }
  
  
}
