
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProbeSetProbesTable;
import abcm.db.components.tables.ABCMProbesTable;

public abstract class ABCMProbesInProbeSetsView extends ABCMdbView {
  
  public ABCMProbesInProbeSetsView(String viewName, AbstractABCMDBGateway db){
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_Probe_PK();
  public abstract ABCMdbField getField_CountOfProbeSets();
  
  public String getSQL(){
    ABCMProbesTable           probesTable           = DB.getProbesTable();
    ABCMProbeSetProbesTable   probeSetProbesTable   = DB.getProbeSetProbesTable();
    String                    dbOwner               = DB.getOwner();
  
    // TODO Make standard format
    
    return
       "SELECT " + 
           probesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Probe_PK().getName() + ", " +
           "COUNT(" + probeSetProbesTable.getField_ProbeFK().getFullFieldName(dbOwner) + ") AS " + getField_CountOfProbeSets().getName() + " \n" +
       "FROM " + probesTable.getFullName(dbOwner) + " LEFT OUTER JOIN " + probeSetProbesTable.getFullName(dbOwner) + "" +
              " ON " + probesTable.getField_PK().getFullFieldName(dbOwner) + " = " + probeSetProbesTable.getField_ProbeFK().getFullFieldName(dbOwner) + " \n" +
       "GROUP BY " + probesTable.getField_PK().getFullFieldName(dbOwner);    
  }

}
