
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMProjectResearchersTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMProjectResearchersView extends ABCMdbView {
  
  public ABCMProjectResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Researcher_FK();
  public abstract ABCMdbField getField_Researcher_LastNameFirstName();
  public abstract ABCMdbField getField_ProjectResearcher_UserName();

  public String getSQL(){
    ABCMResearchersTable        researchersTable             = DB.getResearchersTable(); 
    ABCMProjectResearchersTable projectResearchersTable      = DB.getProjectResearchersTable();
    String                      dbOwner                      = DB.getOwner();
    
    return 
      "SELECT " + 
               researchersTable.getField_PK().getFullFieldName(dbOwner)                + " AS " + getField_Researcher_FK().getName() + ", " +
               researchersTable.getField_LastNameFirstName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_LastNameFirstName().getName() + ",\n" + 
               projectResearchersTable.getField_Username().getFullFieldName(dbOwner)   + " AS " + getField_ProjectResearcher_UserName().getName() + " \n" + 
      "FROM " + 
               researchersTable.getFullName(dbOwner) + " INNER JOIN " + "\n" + 
               projectResearchersTable.getFullName(dbOwner) + " ON " + "\n" + 
               researchersTable.getField_PK().getFullFieldName(dbOwner) + " = " + projectResearchersTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " \n" + 
      "ORDER BY " + researchersTable.getField_LastNameFirstName().getFullFieldName(dbOwner);
    
  }
  
}
