
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMReferencesAndAuthorsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMReferenceAuthorsView extends ABCMdbView {
  
  public ABCMReferenceAuthorsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Reference_PK();
  public abstract ABCMdbField getField_AuthorOrder();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Researcher_LastNameFirstName();
  

  public String getSQL(){
    
    // TODO Make standard format
    
    ABCMReferencesAndAuthorsTable referencesAndAuthorsTable = DB.getReferencesAndAuthorsTable();
    ABCMResearchersTable researchersTable                   = DB.getResearchersTable();
    
    
    return
      "SELECT " +
          referencesAndAuthorsTable.getField_PK().getFullFieldName(DB.getOwner())          + " AS " + getField_PK().getName()                           + ", \n" +
          referencesAndAuthorsTable.getField_ReferenceFK().getFullFieldName(DB.getOwner()) + " AS " + getField_Reference_PK().getName()                 + ", \n" + 
          referencesAndAuthorsTable.getField_AuthorOrder().getFullFieldName(DB.getOwner()) + " AS " + getField_AuthorOrder().getName()                  + ", \n" + 
          referencesAndAuthorsTable.getField_ResearcherFK().getFullFieldName(DB.getOwner())+ " AS " + getField_Researcher_PK().getName()                + ", \n" + 
          researchersTable.getField_LastNameFirstName().getFullFieldName(DB.getOwner())    + " AS " + getField_Researcher_LastNameFirstName().getName() + "\n" + 
      "FROM " + referencesAndAuthorsTable.getFullName(DB.getOwner()) + "\n" +
          "INNER JOIN " + researchersTable.getFullName(DB.getOwner()) + " ON\n" + 
          referencesAndAuthorsTable.getField_ResearcherFK().getFullFieldName(DB.getOwner()) + " = " + researchersTable.getField_PK().getFullFieldName(DB.getOwner());

  }
  
  
}
