
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCommentsTable;
import abcm.db.components.tables.ABCMReferenceCommentsTable;
import abcm.db.components.tables.ABCMReferencesTable;

public abstract class ABCMReferencesAndCommentsView extends ABCMdbView {
  
  public ABCMReferencesAndCommentsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Comment_PK();
  public abstract ABCMdbField getField_Comment_Entry_Date();
  public abstract ABCMdbField getField_Reference_Title();
  public abstract ABCMdbField getField_Reference_Date();
  public abstract ABCMdbField getField_Reference_PK();
  public abstract ABCMdbField getField_Pages();
  public abstract ABCMdbField getField_Comment();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMReferencesTable referencesTable = DB.getReferencesTable();
        String references = referencesTable.getFullName(dbOwner);

    ABCMReferenceCommentsTable referenceCommentsTable = DB.getReferenceCommentsTable();
        String referenceComments = referenceCommentsTable.getFullName(dbOwner);

    ABCMCommentsTable commentsTable = DB.getCommentsTable();
        String comments = commentsTable.getFullName(dbOwner);
    
    return
      "SELECT " +      
          referenceCommentsTable.getField_PK().getFullFieldName(dbOwner)        + " AS " + getField_PK().getName()                 + ",\n" +   
          referenceCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + " AS " + getField_Comment_PK().getName()         + ",\n" +
          referencesTable.getField_Title().getFullFieldName(dbOwner)            + " AS " + getField_Reference_Title().getName()    + ",\n" +
          referencesTable.getField_ReferenceDate().getFullFieldName(dbOwner)    + " AS " + getField_Reference_Date().getName()     + ",\n" +
          referencesTable.getField_PK().getFullFieldName(dbOwner)               + " AS " + getField_Reference_PK().getName()       + ",\n" +
          referenceCommentsTable.getField_Pages().getFullFieldName(dbOwner)     + " AS " + getField_Pages().getName()              + ",\n" +
          commentsTable.getField_DateCreated().getFullFieldName(dbOwner)        + " AS " + getField_Comment_Entry_Date().getName() + ",\n" +
          commentsTable.getField_Comment().getFullFieldName(dbOwner)            + " AS " + getField_Comment().getName()            + "\n" +
      "FROM " + referenceComments + " \n" +
          "INNER JOIN " + references + " ON " +
             referenceCommentsTable.getField_ReferenceFK().getFullFieldName(dbOwner) + " = " + referencesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
          "INNER JOIN " + comments + " ON " + 
             referenceCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + " = " + commentsTable.getField_PK().getFullFieldName(dbOwner); 
    
  }
  
  
}
