
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMReferenceWorkTypesTable;
import abcm.db.components.tables.ABCMReferencesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMReferencesTypesAndAddedByView extends ABCMdbView {
  
  public ABCMReferencesTypesAndAddedByView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Reference_PK();
  public abstract ABCMdbField getField_Reference_Title();
  public abstract ABCMdbField getField_Reference_Date();
  public abstract ABCMdbField getField_Reference_Summary();
  public abstract ABCMdbField getField_Reference_Abstract();
  public abstract ABCMdbField getField_Reference_Location();
  public abstract ABCMdbField getField_ReferenceType();
  public abstract ABCMdbField getField_Researcher_Name();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    ABCMReferencesTable referencesTable = DB.getReferencesTable();
    ABCMReferenceWorkTypesTable referenceWorkTypesTable = DB.getReferenceWorkTypesTable();
    
    return
    "SELECT " +
        referencesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Reference_PK().getName() + ", \n" + 
        referencesTable.getField_Title().getFullFieldName(dbOwner) + " AS " + getField_Reference_Title().getName() + ", \n" +
        referencesTable.getField_ReferenceDate().getFullFieldName(dbOwner) + " AS " + getField_Reference_Date().getName() + ", \n" +
        referencesTable.getField_Summary().getFullFieldName(dbOwner) + " AS " + getField_Reference_Summary().getName() + ", \n" +
        referencesTable.getField_Abstract().getFullFieldName(dbOwner) + " AS " + getField_Reference_Abstract().getName() + ", \n" +
        referencesTable.getField_Location().getFullFieldName(dbOwner) + " AS " + getField_Reference_Location().getName() + ", \n" +
        referenceWorkTypesTable.getField_Type().getFullFieldName(dbOwner) + " AS " + getField_ReferenceType().getName() + ", \n" +
        researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + "\n" +
    "FROM  " + referencesTable.getFullName(dbOwner) + "\n" +
       "LEFT OUTER JOIN " + researchersTable.getFullName(dbOwner) + " ON " +"\n" + 
           referencesTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
       "LEFT OUTER JOIN " + referenceWorkTypesTable.getFullName(dbOwner) + " ON " +"\n" + 
           referencesTable.getField_ReferenceTypeFK().getFullFieldName(dbOwner) + " = " + referenceWorkTypesTable.getField_PK().getFullFieldName(dbOwner);
  }
  

}
