
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearcherSessionsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMResearchersAndSessionsView extends ABCMdbView {
    
  public ABCMResearchersAndSessionsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_LoginRecord_PK();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_SessionBegin();

  public String getSQL(){
    String                      dbOwner                 = DB.getOwner();
    
    ABCMResearcherSessionsTable researcherSessionsTable = DB.getResearcherSessionsTable();
       String researcherSessions = researcherSessionsTable.getFullName(dbOwner);
       
       String PK             = researcherSessionsTable.getField_PK().getFullFieldName(dbOwner);
       String BEGIN          = researcherSessionsTable.getField_SessionBeginTime().getFullFieldName(dbOwner);
       String RESEARCHER_FK  = researcherSessionsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
       
    ABCMResearchersTable        researchersTable        = DB.getResearchersTable();
       String researchers    = researchersTable.getFullName(dbOwner);
    
       String NAME           = researchersTable.getField_ResearcherName().getFullFieldName(dbOwner);
       String RESEARCHER_PK  = researchersTable.getField_PK().getFullFieldName(dbOwner);
    
    return
       "SELECT " +
          PK    + " AS " + getField_LoginRecord_PK().getName() + ", \n" + 
          NAME  + " AS " + getField_Researcher_Name().getName() + ", \n" + 
          BEGIN + " AS " + getField_SessionBegin().getName() + " \n" + 
       "FROM " + 
          researchers + " INNER JOIN " + researcherSessions + " ON " +"\n" + 
             RESEARCHER_PK + " = " + RESEARCHER_FK + " \n" + 
       "ORDER BY " + BEGIN + " DESC ";
  }
  
  
}
