
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataTable;

public abstract class ABCMSimulationAnalysesAndDataView extends ABCMdbView {
  
  public ABCMSimulationAnalysesAndDataView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_SimulationDataSeries_Date();
  public abstract ABCMdbField getField_SimulationRun_PK();
  public abstract ABCMdbField getField_SimulationDataSeries_Name();
  public abstract ABCMdbField getField_SimulationDataSeries_PK();
  public abstract ABCMdbField getField_Value();
  
  public String getSQL(){
    ABCMSimulationAnalysesDatesView simulationAnalysesDatesView = DB.getSimulationAnalysesDatesView();
    ABCMSimulationDataSeriesTable   simulationDataSeriesTable   = DB.getSimulationDataSeriesTable();
    ABCMSimulationDataTable         simulationDataTable         = DB.getSimulationDataTable();
    ABCMAnalysisDataSeriesTable     analysisDataSeriesTable     = DB.getAnalysisDataSeriesTable();
    String dbOwner = DB.getOwner();
    
    return
      "SELECT " +  
            simulationAnalysesDatesView.getField_Analysis_PK().getFullFieldName(dbOwner)               + " AS " + getField_Analysis_PK().getName()                    + ", \n" + 
            simulationAnalysesDatesView.getField_SimulationDataSeries_Date().getFullFieldName(dbOwner) + " AS " + getField_SimulationDataSeries_Date().getName()      + ", \n" + 
            simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner)             + " AS " + getField_SimulationRun_PK().getName()          + ", \n" + 
            simulationDataSeriesTable.getField_Name().getFullFieldName(dbOwner)                        + " AS " + getField_SimulationDataSeries_Name().getName() + ", \n" + 
            simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner)                          + " AS " + getField_SimulationDataSeries_PK().getName()   + ", \n" + 
            simulationDataTable.getField_NumericValue().getFullFieldName(dbOwner)                      + " AS " + getField_Value().getName()                     + " \n" +
      "FROM " + simulationAnalysesDatesView.getFullName(dbOwner) + " INNER JOIN " +
            analysisDataSeriesTable.getFullName(dbOwner) + " ON " + 
                    simulationAnalysesDatesView.getField_Analysis_PK().getFullFieldName(dbOwner) + " =  " + analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + 
                                            " INNER JOIN " +
            simulationDataSeriesTable.getFullName(dbOwner) + " ON " + 
                    analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " = " + simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + 
                                            " LEFT OUTER JOIN " +
            simulationDataTable.getFullName(dbOwner) + " ON " + 
                    simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + " = " + simulationDataTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " AND " + 
                    simulationAnalysesDatesView.getField_SimulationDataSeries_Date().getFullFieldName(dbOwner) + " =  " + simulationDataTable.getField_SimulationDate().getFullFieldName(dbOwner) + " \n" + 
      "ORDER BY " + simulationAnalysesDatesView.getField_SimulationDataSeries_Date().getFullFieldName(dbOwner) + ", " + 
                    simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) +
    "";
  }
  

}
