
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataTable;

public abstract class ABCMSimulationAnalysesDatesView extends ABCMdbView {

  public ABCMSimulationAnalysesDatesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_SimulationDataSeries_Date();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMAnalysesTable analysesTable                         = DB.getAnalysesTable();
        String analyses = analysesTable.getFullName(dbOwner);
        
        String ANALYSIS_PK = analysesTable.getField_PK().getFullFieldName(dbOwner);
        
    ABCMSimulationDataTable simulationDataTable             = DB.getSimulationDataTable();
        String simulationData = simulationDataTable.getFullName(dbOwner);
        
        String SIM_DATE           = simulationDataTable.getField_SimulationDate().getFullFieldName(dbOwner);
        String SIM_DATA_SERIES_FK = simulationDataTable.getField_DataSeriesFK().getFullFieldName(dbOwner);
    
    ABCMAnalysisDataSeriesTable  analysisDataSeriesTable    = DB.getAnalysisDataSeriesTable();
        String analysisDataSeries = analysisDataSeriesTable.getFullName(dbOwner);
        
        String ANALYSIS_FK    = analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner);
        String DATA_SERIES_FK = analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner); 
    
    ABCMSimulationDataSeriesTable simulationDataSeriesTable = DB.getSimulationDataSeriesTable();
        String simulationDataSeries = simulationDataSeriesTable.getFullName(dbOwner);
        
        String DATA_SERIES_PK = simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner);
    
    
    return
      "SELECT DISTINCT " +
           ANALYSIS_PK  + " AS " + getField_Analysis_PK().getName() + ", \n" + 
           SIM_DATE     + " AS " + getField_SimulationDataSeries_Date().getName()             + " \n" +  
      "FROM   " + 
           analyses + " INNER JOIN " + analysisDataSeries + " ON " +"\n" + 
                ANALYSIS_PK + " = " + ANALYSIS_FK + " INNER JOIN " +"\n" + 
                        simulationDataSeries + " ON " +"\n" + 
                        DATA_SERIES_FK + " = " + DATA_SERIES_PK + " INNER JOIN " +"\n" + 
                        simulationData + " ON " +"\n" + 
                    DATA_SERIES_PK + " = " + SIM_DATA_SERIES_FK + "\n" +
      " ORDER BY " + SIM_DATE;
  }
  
}
