
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;

public abstract class ABCMSimulationAnalysesSeriesView extends ABCMdbView {

  public ABCMSimulationAnalysesSeriesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_Analysis_PK();
  public abstract ABCMdbField getField_SimulationRun_PK();
  public abstract ABCMdbField getField_SimulationDataSeries_Name();
  
  public String getSQL(){
    String                        dbOwner                       = DB.getOwner();
    
    ABCMAnalysesTable             analysesTable                 = DB.getAnalysesTable();
        String analyses = analysesTable.getFullName(dbOwner);
        
        String ANALYSIS_PK = analysesTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMAnalysisDataSeriesTable   analysisDataSeriesTable       = DB.getAnalysisDataSeriesTable();
        String analysisDataSeries = analysisDataSeriesTable.getFullName(dbOwner);
        
        String ANALYSIS_FK    = analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner);
        String DATA_SERIES_FK = analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner);
    
    ABCMSimulationDataSeriesTable simulationDataSeriesTable     = DB.getSimulationDataSeriesTable();
        String simulationDataSeries = simulationDataSeriesTable.getFullName(dbOwner);
        
        String DATA_SERIES_PK = simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner); 
        String SIM_RUN_FK     = simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner);
        String SERIES_NAME    = simulationDataSeriesTable.getField_Name().getFullFieldName(dbOwner);
        
    
    return "SELECT DISTINCT " +
              ANALYSIS_PK    + " AS " + getField_Analysis_PK().getName()               + " ,\n" +
              SIM_RUN_FK     + " AS " + getField_SimulationRun_PK().getName()          + " ,\n" +
              SERIES_NAME    + " AS " + getField_SimulationDataSeries_Name().getName() + "\n" +
            "FROM " +
              analyses + " INNER JOIN " +
                  analysisDataSeries + " ON " + ANALYSIS_PK + " = " + ANALYSIS_FK + " INNER JOIN " +
                  simulationDataSeries + " ON " + DATA_SERIES_FK + " = " + DATA_SERIES_PK;  }

}
