
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
import abcm.db.components.tables.ABCMTruthValuesTable;

public abstract class ABCMSimulationConfigurationsAndResearchersView extends ABCMdbView {
  
  public ABCMSimulationConfigurationsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_Name();
  public abstract ABCMdbField getField_SimulationConfiguration_Desc();
  public abstract ABCMdbField getField_SimulationConfiguration_DateCreated();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationConfigurationsTable simulationConfigurationsTable = DB.getSimulationConfigurationsTable();
        String simulationConfigurations = simulationConfigurationsTable.getFullName(dbOwner);

    ABCMResearchersTable researchersTable = DB.getResearchersTable();

    ABCMCanBeEdited_SimulationConfigurationsView canBeEdited_SimulationConfigurationsView = DB.getCanBeEdited_SimulationConfigurationsView();
        String canBeEdited_SimulationConfigurations = canBeEdited_SimulationConfigurationsView.getFullName(dbOwner);

    ABCMTruthValuesTable truthValuesTable = DB.getTruthValuesTable();

    ABCMSimulationConfigurationsAndTruthValuesView simulationConfigurationsAndTruthValuesView = DB.getSimulationConfigurationsAndTruthValuesView();
        
    return
        "SELECT " +
           simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner)  + " AS " + getField_SimulationConfiguration_PK().getName() + ", \n" + 
           simulationConfigurationsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_Name().getName() + ", \n" + 
           simulationConfigurationsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_Desc().getName() + ", \n" +
           simulationConfigurationsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_DateCreated().getName() + ", \n" +
           researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" +
           canBeEdited_SimulationConfigurationsView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner) + " AS " + getField_CanBeEdited().getName() + ", \n" +
           truthValuesTable.getField_TruthValue().getFullFieldName(dbOwner) + " AS txtTruthValue " +"\n" + 
        "FROM " + truthValuesTable.getFullName(dbOwner) + " \n" +
            "INNER JOIN " + simulationConfigurationsAndTruthValuesView.getName() + " ON " +"\n" + 
                truthValuesTable.getField_PK().getFullFieldName(dbOwner) + " = " + simulationConfigurationsAndTruthValuesView.getField_TruthValue().getFullFieldName(dbOwner) + " \n" +
            "RIGHT OUTER JOIN " +simulationConfigurations + " \n" +
            "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON\n" + 
               simulationConfigurationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + " ON \n" + 
               simulationConfigurationsAndTruthValuesView.getField_PK().getFullFieldName(dbOwner) + " = " + simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner)+ "\n" +
            "LEFT OUTER JOIN " + canBeEdited_SimulationConfigurations + " ON \n" + 
                simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + canBeEdited_SimulationConfigurationsView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner) + " \n" +
        "ORDER BY " + simulationConfigurationsTable.getField_Name().getFullFieldName(dbOwner);
  }
  
}
