package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class ABCMSimulationConfigurationsAndTruthValuesView extends ABCMdbView {

  public ABCMSimulationConfigurationsAndTruthValuesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }
  
  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_SimConfigName();
  public abstract ABCMdbField getField_Desc();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_TruthValue();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationConfigurationsTable simConfigsTable = DB.getSimulationConfigurationsTable();
      String simConfigs = simConfigsTable.getFullName(dbOwner);
    
      String SIMCONFIG_PK              = simConfigsTable.getField_PK().getFullFieldName(dbOwner);
      String SIMCONFIG_NAME            = simConfigsTable.getField_Name().getFullFieldName(dbOwner);
      String SIMCONFIG_DESC            = simConfigsTable.getField_Description().getFullFieldName(dbOwner);
      String SIMCONFIG_DATECREATED     = simConfigsTable.getField_DateCreated().getFullFieldName(dbOwner);
      String SIMCONFIG_RESEARCHERFK    = simConfigsTable.getField_ResearcherFK().getFullFieldName(dbOwner);

    String DEFAULT_TRUTH_VALUE = "0";
      
    String sql = "";
    sql += "SELECT " + SIMCONFIG_PK               + " AS " + getField_PK().getName()            + ", " + "\n" +
                       SIMCONFIG_NAME             + " AS " + getField_SimConfigName().getName() + ", " + "\n" +
                       SIMCONFIG_DESC             + " AS " + getField_Desc().getName()          + ", " + "\n" +
                       SIMCONFIG_DATECREATED      + " AS " + getField_DateCreated().getName()   + ", " + "\n" +
                       SIMCONFIG_RESEARCHERFK     + " AS " + getField_ResearcherFK().getName()  + ", " + "\n" +
                       DEFAULT_TRUTH_VALUE        + " AS " + getField_TruthValue().getName()    + "\n" +
           "FROM  " + simConfigs;
    return sql;
  }

  
}
