
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMSimulationDetailsView extends ABCMdbView {
  
  public ABCMSimulationDetailsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_Simulation_Title();
  public abstract ABCMdbField getField_Simulation_DateCreated();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CodeModel_Title();
  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_DataModel_Title();
  public abstract ABCMdbField getField_Simulation_Desc();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_TruthValue_PK();
  public abstract ABCMdbField getField_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationsWithTruthValuesView simulationsWithTruthValuesView = DB.getSimulationsWithTruthValuesView();
        String simulationsWithTruthValues = simulationsWithTruthValuesView.getFullName(dbOwner);

    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);

    ABCMCodeModelsTable codeModelsTable = DB.getCodeModelsTable();
        String codeModels = codeModelsTable.getFullName(dbOwner);
        
    ABCMDataModelsTable dataModelsTable = DB.getDataModelsTable();
        String dataModels = dataModelsTable.getFullName(dbOwner);

    ABCMCanBeEdited_SimulationsView canBeEdited_SimulationsView = DB.getCanBeEdited_SimulationsView();
        String canBeEdited_Simulations = canBeEdited_SimulationsView.getFullName(dbOwner);

// TODO FORMATTING
        
        
    return
       "SELECT " + DB.getSQLSyntaxEngine().getOptimizerHint() + " " + 
          simulationsWithTruthValuesView.getField_Simulation_PK().getFullFieldName(dbOwner) + " AS " + getField_Simulation_PK().getName()  + ",\n" + 
          simulationsWithTruthValuesView.getField_Simulation_Title().getFullFieldName(dbOwner) + " AS " + getField_Simulation_Title().getName() + ",\n" + 
          simulationsWithTruthValuesView.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_Simulation_DateCreated().getName() + ",\n" + 
          researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ",\n" + 
          codeModelsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_CodeModel_PK().getName()+ ",\n" + 
          codeModelsTable.getField_Title().getFullFieldName(dbOwner) + " AS " + getField_CodeModel_Title().getName()+ ",\n" + 
          simulationsWithTruthValuesView.getField_DataModel_PK().getFullFieldName(dbOwner) + " AS " + getField_DataModel_PK().getName() + ",\n" + 
          dataModelsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_DataModel_Title().getName() + ",\n" + 
          dataModelsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_Simulation_Desc().getName() + ",\n" + 
          canBeEdited_SimulationsView.getField_Simulation_PK().getFullFieldName(dbOwner) + " AS " + getField_CanBeEdited().getName() + ",\n" + 
          simulationsWithTruthValuesView.getField_TruthValue_PK().getFullFieldName(dbOwner) + " AS " + getField_TruthValue_PK().getName()+ ",\n" + 
          simulationsWithTruthValuesView.getField_TruthValue().getFullFieldName(dbOwner) + " AS " + getField_TruthValue().getName()+ "\n" + 
       "FROM   " +
          "((("  + simulationsWithTruthValues + " \n" +
          "INNER JOIN " + researchers + " ON\n" + 
               simulationsWithTruthValuesView.getField_Researcher_PK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + ")\n" +
          "INNER JOIN " + codeModels + " ON\n" + 
               simulationsWithTruthValuesView.getField_CodeModel_PK().getFullFieldName(dbOwner) + " = " + codeModelsTable.getField_PK().getFullFieldName(dbOwner) + ")\n" +
          "INNER JOIN " + dataModels + " ON\n" + 
               simulationsWithTruthValuesView.getField_DataModel_PK().getFullFieldName(dbOwner) + " = " + dataModelsTable.getField_PK().getFullFieldName(dbOwner) + ")\n" +
          "LEFT OUTER JOIN " + canBeEdited_Simulations + " ON\n" + 
               simulationsWithTruthValuesView.getField_Simulation_PK().getFullFieldName(dbOwner) + " = " + canBeEdited_SimulationsView.getField_Simulation_PK().getFullFieldName(dbOwner);
  }
  
  
  
  
}
