
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMParameterSetsTable;
import abcm.db.components.tables.ABCMProbeSetsTable;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMRunModesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMSimulationRunsAndResearchersSTEP0View extends ABCMdbView {

  public ABCMSimulationRunsAndResearchersSTEP0View(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationRun_PK();
  public abstract ABCMdbField getField_SimulationRun_DateTimeBegun();
  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_Simulation_Title();
  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_ParameterSet_Name();
  public abstract ABCMdbField getField_ProbeSet_PK();
  public abstract ABCMdbField getField_ProbeSet_Name();
  public abstract ABCMdbField getField_SimulationRunMode_PK();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_SimulationRun_Notes();
  public abstract ABCMdbField getField_SimulationRun_RandomNumberSeed();
  public abstract ABCMdbField getField_SimulationRun_ReRun_FK();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_SimulationRunMode_Type();
  public abstract ABCMdbField getField_SimulationTruthValue();
  public abstract ABCMdbField getField_ParameterSetTruthValue();
  
  public String getSQL(){
    
    String dbOwner = DB.getOwner();
    
    ABCMSimulationRunsTable               simulationRunsTable              = DB.getSimulationRunsTable();
    ABCMSimulationsTable                  simulationsTable                 = DB.getSimulationsTable();
    ABCMParameterSetsTable                parameterSetsTable               = DB.getParameterSetsTable();
    ABCMProbeSetsTable                    probeSetsTable                   = DB.getProbeSetsTable();
    ABCMResearchersTable                  researchersTable                 = DB.getResearchersTable();
    ABCMRunModesTable                     runModesTable                    = DB.getRunModesTable();
    ABCMParameterSetsAndTruthValuesView   parameterSetsAndTruthValuesView  = DB.getParameterSetsAndTruthValuesView();
    ABCMSimulationsWithTruthValuesView    simulationsWithTruthValuesView   = DB.getSimulationsWithTruthValuesView();

    /*
     *           simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_PK().getName() + ", \n" + 
          simulationRunsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_DateTimeBegun().getName() + ", \n" +
          simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " AS " + getField_Simulation_PK().getName() + ", \n" + 
          simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner) + " AS " + getField_ParameterSet_PK().getName() + ", \n" +
          simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner) + " AS " + getField_ProbeSet_PK().getName() + ", \n" +
          simulationRunsTable.getField_RunModeFK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRunMode_PK().getName() + ", \n" +
          simulationRunsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + getField_Researcher_PK().getName() + ", \n" +
          simulationRunsTable.getField_Notes().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_Notes().getName() + ", \n" +
          simulationRunsTable.getField_RandomNumberSeed().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_RandomNumberSeed().getName() + ", \n" +
          simulationRunsTable.getField_RerunID().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_ReRun_FK().getName() + ", \n" +
          parameterSetsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_ParameterSet_Name().getName() + ", \n" +
          probeSetsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_ProbeSet_Name().getName() + ", \n" +
          researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" +
          runModesTable.getField_RunMode().getFullFieldName(dbOwner) + " AS " + getField_SimulationRunMode_Type().getName() + ", \n" +

     */
    
    
    return 
      "SELECT " +
          simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_PK().getName() + ", \n" +
          simulationRunsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_DateTimeBegun().getName() + ", \n" +
          simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " AS " + getField_Simulation_PK().getName() + ", \n" +  
          simulationsTable.getField_Title().getFullFieldName(dbOwner) + " AS " + getField_Simulation_Title().getName() + ", \n" +
          simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner) + " AS " + getField_ParameterSet_PK().getName() + ", \n" +
          parameterSetsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_ParameterSet_Name().getName() + ", \n" +
          simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner) + " AS " + getField_ProbeSet_PK().getName() + ", \n" + 
          probeSetsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_ProbeSet_Name().getName() + ", \n" + 
          simulationRunsTable.getField_RunModeFK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRunMode_PK().getName() + ", \n" + 
          simulationRunsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + getField_Researcher_PK().getName() + ", \n" + 
          simulationRunsTable.getField_Notes().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_Notes().getName() + ", \n" + 
          simulationRunsTable.getField_RandomNumberSeed().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_RandomNumberSeed().getName() + ", \n" + 
          simulationRunsTable.getField_RerunID().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_ReRun_FK().getName() + ", \n" + 
          researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" + 
          runModesTable.getField_RunMode().getFullFieldName(dbOwner) + " AS " + getField_SimulationRunMode_Type().getName() + ", \n" + 
          simulationsWithTruthValuesView.getField_TruthValue_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationTruthValue().getName() + ", \n" + 
          parameterSetsAndTruthValuesView.getField_TruthValue().getFullFieldName(dbOwner) + " AS " +  getField_ParameterSetTruthValue().getName() + "\n" + 
      "FROM " +
          simulationRunsTable.getFullName(dbOwner) + "\n" +
          "JOIN " + simulationsTable.getFullName(dbOwner) + " ON " + 
            "(" + simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " = " + simulationsTable.getField_PK().getFullFieldName(dbOwner) + ")" + "\n" +
          "JOIN " + parameterSetsTable.getFullName(dbOwner) + " ON " + 
            "(" + simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner)+ " = " + parameterSetsTable.getField_PK().getFullFieldName(dbOwner)+ ")" + "\n" +
          "JOIN " + probeSetsTable.getFullName(dbOwner)+ " ON " + 
            "(" + simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner) + " = " + probeSetsTable.getField_PK().getFullFieldName(dbOwner) + ")" + "\n" +
          "JOIN " + researchersTable.getFullName(dbOwner) + " ON " + 
            "(" + simulationRunsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + ")" + "\n" +
          "JOIN " + runModesTable.getFullName(dbOwner)+ " ON " +
            "(" +simulationRunsTable.getField_RunModeFK().getFullFieldName(dbOwner) + " = " + runModesTable.getField_PK().getFullFieldName(dbOwner) + ")" + "\n" +
          "JOIN " + simulationsWithTruthValuesView.getFullName(dbOwner) + " ON " + 
            "(" + simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner)+ " = " + simulationsWithTruthValuesView.getField_Simulation_PK().getFullFieldName(dbOwner) + ")" + "\n" +
          "JOIN " + parameterSetsAndTruthValuesView.getFullName(dbOwner) + " ON " +
            "(" + simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner) + " = " + parameterSetsAndTruthValuesView.getField_ParameterSet_PK().getFullFieldName(dbOwner) + ")" + ";";

  }
  
}
