
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class ABCMSimulationRunsAndResearchersSTEP1View extends ABCMdbView {
  
  public ABCMSimulationRunsAndResearchersSTEP1View(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationRun_PK();
  public abstract ABCMdbField getField_SimulationRun_DateTimeBegun();
  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_Simulation_Title();
  public abstract ABCMdbField getField_ParameterSet_PK();
  public abstract ABCMdbField getField_ParameterSet_Name();
  public abstract ABCMdbField getField_ProbeSet_PK();
  public abstract ABCMdbField getField_ProbeSet_Name();
  public abstract ABCMdbField getField_SimulationRunMode_PK();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_SimulationRun_Notes();
  public abstract ABCMdbField getField_SimulationRun_RandomNumberSeed();
  public abstract ABCMdbField getField_SimulationRun_ReRun_FK();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_SimulationRunMode_Type();
  public abstract ABCMdbField getField_CombinedTruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationRunsAndResearchersSTEP0View s1 = DB.getSimulationRunsAndResearchersSTEP0View();
    
    return
      "SELECT " + 
        s1.getField_SimulationRun_PK().getFullFieldName(dbOwner) + "  AS " + getField_SimulationRun_PK().getName() + "," + "\n" +
        s1.getField_SimulationRun_DateTimeBegun().getFullFieldName(dbOwner)+ "  AS " + this.getField_SimulationRun_DateTimeBegun().getName() + "," + "\n" +
        s1.getField_Simulation_PK().getFullFieldName(dbOwner)+ "  AS " + this.getField_Simulation_PK().getName() + "," + "\n" +
        s1.getField_Simulation_Title().getFullFieldName(dbOwner)+ "  AS " + this.getField_Simulation_Title().getName() + "," + "\n" +
        s1.getField_ParameterSet_PK().getFullFieldName(dbOwner)+ "  AS " + this.getField_ParameterSet_PK().getName() + "," + "\n" +
        s1.getField_ParameterSet_Name().getFullFieldName(dbOwner)+ "  AS " + this.getField_ParameterSet_Name().getName() + "," + "\n" +
        s1.getField_ProbeSet_PK().getFullFieldName(dbOwner)+ "  AS " + this.getField_ProbeSet_PK().getName() + "," + "\n" +
        s1.getField_ProbeSet_Name().getFullFieldName(dbOwner)+ "  AS " + this.getField_ProbeSet_Name().getName() + "," + "\n" +
        s1.getField_SimulationRunMode_PK().getFullFieldName(dbOwner)+ "  AS " + this.getField_SimulationRunMode_PK().getName() + "," + "\n" +
        s1.getField_Researcher_PK().getFullFieldName(dbOwner)+ "  AS " + this.getField_Researcher_PK().getName() + "," + "\n" +
        s1.getField_SimulationRun_Notes().getFullFieldName(dbOwner)+ "  AS " + this.getField_SimulationRun_Notes().getName() + "," + "\n" +
        s1.getField_SimulationRun_RandomNumberSeed().getFullFieldName(dbOwner)+ "  AS " + this.getField_SimulationRun_RandomNumberSeed().getName() + "," + "\n" +
        s1.getField_SimulationRun_ReRun_FK().getFullFieldName(dbOwner)+ "  AS " + this.getField_SimulationRun_ReRun_FK().getName() + "," + "\n" +
        s1.getField_Researcher_Name().getFullFieldName(dbOwner)+ "  AS " + this.getField_Researcher_Name().getName() + "," + "\n" +
        s1.getField_SimulationRunMode_Type().getFullFieldName(dbOwner)+ "  AS " + this.getField_SimulationRunMode_Type().getName() + "," + "\n" +
        "IF" +
          "(" + s1.getField_SimulationTruthValue().getFullFieldName(dbOwner) + ">" + s1.getField_ParameterSetTruthValue().getFullFieldName(dbOwner) + "," +
            s1.getField_SimulationTruthValue().getFullFieldName(dbOwner) + "," +
            s1.getField_ParameterSetTruthValue().getFullFieldName(dbOwner) +")" + " AS " + getField_CombinedTruthValue().getName() + "\n" +
     "FROM " + "\n" +
       s1.getFullName(dbOwner) + ";";
    
//    
//    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
//    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
//    ABCMParameterSetsTable parameterSetsTable = DB.getParameterSetsTable();
//    ABCMProbeSetsTable probeSetsTable = DB.getProbeSetsTable();
//    ABCMResearchersTable researchersTable = DB.getResearchersTable();
//    ABCMRunModesTable runModesTable = DB.getRunModesTable();
//    ABCMParameterSetsAndTruthValuesView parameterSetsAndTruthValuesView = DB.getParameterSetsAndTruthValuesView();
//    ABCMSimulationDetailsView simulationDetailsView = DB.getSimulationDetailsView();
//
//    return
//      "SELECT " + DB.getSQLSyntaxEngine().getOptimizerHint() + " " + 
//          simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_PK().getName() + ", \n" + 
//          simulationRunsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_DateTimeBegun().getName() + ", \n" +
//          simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " AS " + getField_Simulation_PK().getName() + ", \n" + 
//          simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner) + " AS " + getField_ParameterSet_PK().getName() + ", \n" +
//          simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner) + " AS " + getField_ProbeSet_PK().getName() + ", \n" +
//          simulationRunsTable.getField_RunModeFK().getFullFieldName(dbOwner) + " AS " + getField_SimulationRunMode_PK().getName() + ", \n" +
//          simulationRunsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + getField_Researcher_PK().getName() + ", \n" +
//          simulationRunsTable.getField_Notes().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_Notes().getName() + ", \n" +
//          simulationRunsTable.getField_RandomNumberSeed().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_RandomNumberSeed().getName() + ", \n" +
//          simulationRunsTable.getField_RerunID().getFullFieldName(dbOwner) + " AS " + getField_SimulationRun_ReRun_FK().getName() + ", \n" +
//          parameterSetsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_ParameterSet_Name().getName() + ", \n" +
//          probeSetsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_ProbeSet_Name().getName() + ", \n" +
//          researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" +
//          runModesTable.getField_RunMode().getFullFieldName(dbOwner) + " AS " + getField_SimulationRunMode_Type().getName() + ", \n" +
//          simulationDetailsView.getField_Simulation_Title().getFullFieldName(dbOwner) + " AS " + getField_Simulation_Title().getName() + ", \n" +
////          "CASE WHEN [" + parameterSetsAndTruthValuesView.getField_TruthValue().getName()+ "] > " +
////          "[" + simulationDetailsView.getField_TruthValue_PK().getName() + "] " +
////     "THEN [" + parameterSetsAndTruthValuesView.getField_TruthValue().getName() + "] " +
////     "ELSE [" + simulationDetailsView.getField_TruthValue_PK().getName() + "] " +
////     "END " + " AS " + getField_CombinedTruthValue().getName() + "\n" +
//          "CASE WHEN " + DB.getSQLSyntaxEngine().getDottedName(parameterSetsAndTruthValuesView.getField_TruthValue().getFullFieldName(dbOwner))+ " > " +
//                    DB.getSQLSyntaxEngine().getDottedName(simulationDetailsView.getField_TruthValue_PK().getFullFieldName(dbOwner)) + " " +
//               "THEN " + DB.getSQLSyntaxEngine().getDottedName(parameterSetsAndTruthValuesView.getField_TruthValue().getFullFieldName(dbOwner)) + " " +
//               "ELSE " + DB.getSQLSyntaxEngine().getDottedName(simulationDetailsView.getField_TruthValue_PK().getFullFieldName(dbOwner)) + " " +
//               "END " + " AS " + getField_CombinedTruthValue().getName() + "\n" +
//      "FROM  ((" + simulationRunsTable.getFullName(dbOwner) + "\n" +
//           "INNER JOIN " + parameterSetsTable.getFullName(dbOwner) + " ON " +"\n" + 
//              simulationRunsTable.getField_ParameterSetFK().getFullFieldName(dbOwner) + " = " + parameterSetsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
//           "INNER JOIN " + probeSetsTable.getFullName(dbOwner) + " ON " +"\n" + 
//              simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner) + " = " + probeSetsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
//           "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON " +"\n" + 
//              simulationRunsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
////           "INNER JOIN " + simulationsTable.getFullName(dbOwner) + " ON " +"\n" + 
////              simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " = " + simulationsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
//           "INNER JOIN " + runModesTable.getFullName(dbOwner) + " ON " +"\n" + 
//              simulationRunsTable.getField_RunModeFK().getFullFieldName(dbOwner) + " = " + runModesTable.getField_PK().getFullFieldName(dbOwner) + ")\n" +
//           "INNER JOIN " + simulationDetailsView.getName() + " ON\n" + 
//              simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " = " + simulationDetailsView.getField_Simulation_PK().getFullFieldName(dbOwner) + ")\n" +
//           "INNER JOIN " + parameterSetsAndTruthValuesView.getName() + " ON\n" + 
//              simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " = " + parameterSetsAndTruthValuesView.getField_ParameterSet_PK().getFullFieldName(dbOwner) + "\n" +"";
////           "ORDER BY " + simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " DESC ";
   
  }
  
  
}
