
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMSimulationsAndResearchersView extends ABCMdbView {
  
  public ABCMSimulationsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_Simulation_Title();
  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_Simulation_DateCreated();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Researcher_Name();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
        String researchers = researchersTable.getFullName(dbOwner);

    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);

        
    return
       "SELECT " +
          simulationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + this.getField_Simulation_PK().getName()+ ",\n" + 
          simulationsTable.getField_Title().getFullFieldName(dbOwner) + " AS " + this.getField_Simulation_Title().getName()+ ",\n" + 
          simulationsTable.getField_CodeModelFK().getFullFieldName(dbOwner) + " AS " + this.getField_CodeModel_PK().getName()+ ",\n" + 
          simulationsTable.getField_DataModelFK().getFullFieldName(dbOwner) + " AS " + this.getField_DataModel_PK().getName()+ ",\n" + 
          simulationsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + this.getField_Simulation_DateCreated().getName()+ ",\n" + 
          simulationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + this.getField_Researcher_PK().getName()+ ",\n" + 
          researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + this.getField_Researcher_Name().getName() + "\n" + 
       "FROM   " + simulations + " \n" +
          "INNER JOIN " + researchers + " ON " +"\n" + 
              simulationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
