
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;

public abstract class ABCMSimulationsInSimulationRunsView extends ABCMdbView {
  
  public ABCMSimulationsInSimulationRunsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationRun_PK();
  public abstract ABCMdbField getField_CountOfTimesRun();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);
        String SIM_PK = simulationsTable.getField_PK().getFullFieldName(dbOwner);
    
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
        String SIM_RUN_FK = simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner);

    
    return
       "SELECT " +
            SIM_PK                     + " AS " + getField_SimulationRun_PK().getName() + ",\n" +  
           "COUNT(" + SIM_RUN_FK + ")" + " AS " + getField_CountOfTimesRun().getName() + "\n" + 
           "FROM   " + simulationRunsTable.getFullName(dbOwner) + " \n" +
              "RIGHT OUTER JOIN " + simulations + " ON " +"\n" + 
                    SIM_RUN_FK + " = " + SIM_PK + "\n" +
           "GROUP BY " + SIM_PK;
  }
  
}
