
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationsTable;
import abcm.db.components.tables.ABCMTruthValuesTable;

public abstract class ABCMSimulationsWithTruthValuesView extends ABCMdbView {
  
  public ABCMSimulationsWithTruthValuesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Simulation_PK();
  public abstract ABCMdbField getField_Simulation_Title();
  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_DataModel_PK();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Simulation_Desc();
  public abstract ABCMdbField getField_TruthValue_PK();
  public abstract ABCMdbField getField_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
        String simulations = simulationsTable.getFullName(dbOwner);

        String SIM_PK            = simulationsTable.getField_PK().getFullFieldName(dbOwner);
        String SIM_TITLE         = simulationsTable.getField_Title().getFullFieldName(dbOwner);
        String SIM_CODE_MODEL_FK = simulationsTable.getField_CodeModelFK().getFullFieldName(dbOwner);
        String SIM_DATA_MODEL_FK = simulationsTable.getField_DataModelFK().getFullFieldName(dbOwner);
        String SIM_DATE_CREATED  = simulationsTable.getField_DateCreated().getFullFieldName(dbOwner);
        String SIM_RESEARCHER_FK = simulationsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
        String SIM_DESC          = simulationsTable.getField_Description().getFullFieldName(dbOwner);
        
    ABCMDataModelsWithNamesOfElementsView dataModelsWithNamesOfElementsView = DB.getDataModelsWithNamesOfElementsView();
        String dataModelsWithNamesOfElements = dataModelsWithNamesOfElementsView.getFullName(dbOwner);

        String TRUTH_VALUE_FK = dataModelsWithNamesOfElementsView.getField_TruthValue_PK().getFullFieldName(dbOwner);
        String DATA_MODEL_FK  = dataModelsWithNamesOfElementsView.getField_DataModel_PK().getFullFieldName(dbOwner);
        
    ABCMTruthValuesTable truthValuesTable = DB.getTruthValuesTable();
        String truthValues = truthValuesTable.getFullName(dbOwner);
        
        String TRUTH_VALUE_PK  = truthValuesTable.getField_PK().getFullFieldName(dbOwner);
        String TRUTH_VALUE_TXT = truthValuesTable.getField_TruthValue().getFullFieldName(dbOwner);

        
    return
     "SELECT " +
        SIM_PK             + " AS " + getField_Simulation_PK().getName()     + ",\n" +
        SIM_TITLE          + " AS " + getField_Simulation_Title().getName()  + ",\n" +
        SIM_CODE_MODEL_FK  + " AS " + getField_CodeModel_PK().getName()      + ",\n" +
        SIM_DATA_MODEL_FK  + " AS " + getField_DataModel_PK().getName()      + ",\n" +
        SIM_DATE_CREATED   + " AS " + getField_DateCreated().getName()       + ",\n" +
        SIM_RESEARCHER_FK  + " AS " + getField_Researcher_PK().getName()     + ",\n" +
        SIM_DESC           + " AS " + getField_Simulation_Desc().getName()   + ",\n" +
        TRUTH_VALUE_FK     + " AS " + getField_TruthValue_PK().getName()     + ",\n" + 
        TRUTH_VALUE_TXT    + " AS " + this.getField_TruthValue().getName()   + "\n" + 
     "FROM   " + simulations + "\n" +
        "INNER JOIN " + dataModelsWithNamesOfElements + " ON " +"\n" + 
              SIM_DATA_MODEL_FK + " = " + DATA_MODEL_FK + " \n" +
        "LEFT OUTER JOIN " + truthValues + " ON\n" + 
              TRUTH_VALUE_FK + " = " + TRUTH_VALUE_PK;
  }
  
}
