
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSummariesTable;

public abstract class ABCMSummariesAndResearchersView extends ABCMdbView {
  
  public ABCMSummariesAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_Summary_Title();
  public abstract ABCMdbField getField_Summary_Desc();
  public abstract ABCMdbField getField_Summary_Summary();
  public abstract ABCMdbField getField_Summary_Conclusion();
  public abstract ABCMdbField getField_Summary_DateCreated();
  public abstract ABCMdbField getField_Researcher_LastNameFirstName();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMSummariesTable summariesTable = DB.getSummariesTable();
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    
    return
    "SELECT " +
       summariesTable.getField_PK().getFullFieldName(dbOwner)                   + " AS " + getField_Summary_PK().getName() + ", \n" + 
       summariesTable.getField_Title().getFullFieldName(dbOwner)                + " AS " + getField_Summary_Title().getName() + ", \n" +
       summariesTable.getField_Description().getFullFieldName(dbOwner)          + " AS " + getField_Summary_Desc().getName() + ", \n" +
       summariesTable.getField_Summary().getFullFieldName(dbOwner)              + " AS " + getField_Summary_Summary().getName() + ", \n" +
       summariesTable.getField_Conclusion().getFullFieldName(dbOwner)           + " AS " + getField_Summary_Conclusion().getName() + ", \n" +
       summariesTable.getField_DateCreated().getFullFieldName(dbOwner)          + " AS " + getField_Summary_DateCreated().getName() + ", \n" +
       researchersTable.getField_LastNameFirstName().getFullFieldName(dbOwner)  + " AS " + getField_Researcher_LastNameFirstName().getName() + "\n" +
    "FROM   " + summariesTable.getFullName(dbOwner) + " \n" +
        "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON\n" + 
            summariesTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
