
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMSummaryCodeModelsAndDetailsView extends ABCMdbView {
  
  public ABCMSummaryCodeModelsAndDetailsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_CodeModel_PK();
  public abstract ABCMdbField getField_CodeModel_Title();
  public abstract ABCMdbField getField_CodeModel_DateCreated();
  public abstract ABCMdbField getField_CodeModel_Desc();
  public abstract ABCMdbField getField_Researcher_Name();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMCodeModelsTable           codeModelsTable           = DB.getCodeModelsTable();
    ABCMSummaryCodeModelsView     summaryCodeModelsView     = DB.getSummaryCodeModelsView();
    ABCMResearchersTable          researchersTable          = DB.getResearchersTable();
    
    return
     "SELECT " + summaryCodeModelsView.getField_Summary_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName()            + ", " + "\n" +
                 codeModelsTable.getField_PK().getFullFieldName(dbOwner)               + " AS " + getField_CodeModel_PK().getName()          + ", " + "\n" +
                 codeModelsTable.getField_Title().getFullFieldName(dbOwner)            + " AS " + getField_CodeModel_Title().getName()       + ", " + "\n" +
                 codeModelsTable.getField_DateCreated().getFullFieldName(dbOwner)      + " AS " + getField_CodeModel_DateCreated().getName() + ", " + "\n" +
                 codeModelsTable.getField_Description().getFullFieldName(dbOwner)      + " AS " + getField_CodeModel_Desc().getName()        + ", " + "\n" + 
                 researchersTable.getField_ResearcherName().getFullFieldName(dbOwner)  + " AS " + getField_Researcher_Name().getName()       + "\n" +
           "FROM "  + summaryCodeModelsView.getName() + 
               " INNER JOIN " + codeModelsTable.getFullName(dbOwner)  + " ON " + "\n" + 
                        summaryCodeModelsView.getField_CodeModel_PK().getFullFieldName(dbOwner) + " = " + codeModelsTable.getField_PK().getFullFieldName(dbOwner) + 
               " INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON " + "\n" + 
                        codeModelsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
