
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMCodeModelsTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;

public abstract class ABCMSummaryCodeModelsView extends ABCMdbView {
  
  public ABCMSummaryCodeModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_CodeModel_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummariesTable            summariesTable            = DB.getSummariesTable();
    ABCMCodeModelsTable           codeModelsTable           = DB.getCodeModelsTable();
    ABCMSummaryAnalysesTable      summaryAnalysesTable      = DB.getSummaryAnalysesTable();
    ABCMAnalysesTable             analysesTable             = DB.getAnalysesTable();
    ABCMAnalysisDataSeriesTable   analysisDataSeriesTable   = DB.getAnalysisDataSeriesTable();
    ABCMSimulationDataSeriesTable simulationDataSeriesTable = DB.getSimulationDataSeriesTable();
    ABCMSimulationRunsTable       simulationRunsTable       = DB.getSimulationRunsTable();
    ABCMSimulationsTable          simulationsTable          = DB.getSimulationsTable();
    
    return
      "SELECT DISTINCT " + summariesTable.getField_PK().getFullFieldName(dbOwner)  + " AS " + getField_Summary_PK().getName()   + ",\n" +
                           codeModelsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_CodeModel_PK().getName() + "\n" + 
           "FROM   " + summariesTable.getFullName(dbOwner) + 
                     " INNER JOIN " + summaryAnalysesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        summariesTable.getField_PK().getFullFieldName(dbOwner) + " = " + summaryAnalysesTable.getField_SummaryFK().getFullFieldName(dbOwner) + 
                     " INNER JOIN " + analysesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        summaryAnalysesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " = " + analysesTable.getField_PK().getFullFieldName(dbOwner) + 
                     " INNER JOIN " + analysisDataSeriesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + 
                     " INNER JOIN " + simulationDataSeriesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " = " + simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + 
                     " INNER JOIN " + simulationRunsTable.getFullName(dbOwner) + " ON " +"\n" + 
                        simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) + " = " + simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + 
                     " INNER JOIN " + simulationsTable.getFullName(dbOwner) + " ON " +"\n" + 
                        simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " = " + simulationsTable.getField_PK().getFullFieldName(dbOwner) + 
                     " INNER JOIN " + codeModelsTable.getFullName(dbOwner) + " ON " +"\n" + 
                        simulationsTable.getField_CodeModelFK().getFullFieldName(dbOwner) + " = " + codeModelsTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
