
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class ABCMSummaryConfigurationsAndDetailsView extends ABCMdbView {
  
  public ABCMSummaryConfigurationsAndDetailsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_name();
  public abstract ABCMdbField getField_SimulationConfiguration_Desc();
  public abstract ABCMdbField getField_SimulationConfiguration_DateCreated();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMSummaryConfigurationsView summaryConfigurationsView = DB.getSummaryConfigurationsView();
    ABCMSimulationConfigurationsTable simulationConfigurationsTable = DB.getSimulationConfigurationsTable();
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    ABCMSimulationConfigurationsAndResearchersView simulationConfigurationsAndResearchersView = DB.getSimulationConfigurationsAndResearchersView();

    String simulationConfigurations = simulationConfigurationsTable.getFullName(dbOwner);
     
    return
        "SELECT " +
            summaryConfigurationsView.getField_Summary_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ", \n" + 
            simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_PK().getName() + ", \n" +
            simulationConfigurationsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_name().getName() + ", \n" +
            simulationConfigurationsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_Desc().getName() + ", \n" +
            simulationConfigurationsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfiguration_DateCreated().getName() + ", \n" +
            simulationConfigurationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + getField_Researcher_PK().getName() + ", \n" +
            researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" +
            simulationConfigurationsAndResearchersView.getField_TruthValue().getFullFieldName(dbOwner) + " AS " + getField_TruthValue().getName() + "\n" +
       "FROM "  + summaryConfigurationsView.getName() + "\n" +
          "INNER JOIN " + simulationConfigurations + " ON \n" + 
               summaryConfigurationsView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner) + " = " + simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
          "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON \n" + 
               simulationConfigurationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
          "INNER JOIN " + simulationConfigurationsAndResearchersView.getName() + " ON \n" + 
              simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + simulationConfigurationsAndResearchersView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner);
  }
  
  
}
