
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;

public abstract class ABCMSummaryDataModelsView extends ABCMdbView {
  
  public ABCMSummaryDataModelsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_DataModel_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummariesTable summariesTable = DB.getSummariesTable();
    ABCMSummaryAnalysesTable summaryAnalysesTable = DB.getSummaryAnalysesTable();
    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
    ABCMAnalysisDataSeriesTable analysisDataSeriesTable = DB.getAnalysisDataSeriesTable();
    ABCMSimulationDataSeriesTable simulationDataSeriesTable = DB.getSimulationDataSeriesTable();
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
    ABCMDataModelsTable dataModelsTable = DB.getDataModelsTable();
    ABCMAnalysesTable analysesTable = DB.getAnalysesTable();

    return
    "SELECT DISTINCT " +
         summariesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + this.getField_Summary_PK().getName() + ",\n" +  
         simulationsTable.getField_DataModelFK().getFullFieldName(dbOwner) + " AS " + this.getField_DataModel_PK().getName() + "\n" +
    "FROM   " + summariesTable.getFullName(dbOwner) + " \n" +
        "INNER JOIN " + summaryAnalysesTable.getFullName(dbOwner) + " ON\n" + 
             summariesTable.getField_PK().getFullFieldName(dbOwner) + " = " + summaryAnalysesTable.getField_SummaryFK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + analysesTable.getFullName(dbOwner) + " ON\n" + 
             summaryAnalysesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " = " + analysesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + analysisDataSeriesTable.getFullName(dbOwner) + " ON\n" + 
             analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + simulationDataSeriesTable.getFullName(dbOwner) + " ON\n" + 
             analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " = " + simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
        "INNER JOIN " + simulationRunsTable.getFullName(dbOwner) + " ON\n" + 
             simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) + " = " + simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + simulationsTable.getFullName(dbOwner) + " ON\n" + 
             simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " = " + simulationsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + dataModelsTable.getFullName(dbOwner) + " ON\n" + 
             simulationsTable.getField_DataModelFK().getFullFieldName(dbOwner) + " = " + dataModelsTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
