
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMHistoriesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMSummaryHistoriesAndDetailsView extends ABCMdbView {
  
  public ABCMSummaryHistoriesAndDetailsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_History_PK();
  public abstract ABCMdbField getField_History_Title();
  public abstract ABCMdbField getField_History_Desc();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummaryHistoriesView summaryHistoriesView = DB.getSummaryHistoriesView();
    ABCMHistoriesTable historiesTable = DB.getHistoriesTable();
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    ABCMHistoriesAndResearchersView historiesAndResearchersView = DB.getHistoriesAndResearchersView();

    String summaryHistories = summaryHistoriesView.getFullName(dbOwner);
    
    return
     "SELECT " +
         summaryHistoriesView.getField_Summary_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ", \n" + 
         historiesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_History_PK().getName() + ", \n" +
         historiesTable.getField_Title().getFullFieldName(dbOwner) + " AS " + getField_History_Title().getName() + ", \n" +
         historiesTable.getField_Description().getFullFieldName(dbOwner)  + " AS " + getField_History_Desc().getName() + ", \n" +
         researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" +
         historiesAndResearchersView.getField_TruthValue_Value().getFullFieldName(dbOwner) + " AS " + getField_TruthValue().getName() + "\n" +
     "FROM   "  + summaryHistories + " \n" +
        "INNER JOIN " + historiesTable.getFullName(dbOwner) + " ON\n" + 
             summaryHistoriesView.getField_History_PK().getFullFieldName(dbOwner) + " = " + historiesTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
        "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON\n" + 
             historiesTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
        "INNER JOIN " + historiesAndResearchersView.getFullName(dbOwner) + " ON\n" + 
             historiesTable.getField_PK().getFullFieldName(dbOwner) + " = " + historiesAndResearchersView.getField_History_PK().getFullFieldName(dbOwner);
  }
  
  
}
