
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMNarrativesTable;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class ABCMSummaryNarrativesAndDetailsView extends ABCMdbView {
  
  public ABCMSummaryNarrativesAndDetailsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_Narrative_Name();
  public abstract ABCMdbField getField_Narrative_Description();
  public abstract ABCMdbField getField_Narrative_BaseDate();
  public abstract ABCMdbField getField_Narrative_DateCreated();
  public abstract ABCMdbField getField_Narrative_IsSeasonal();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_Narrative_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummaryNarrativesView summaryNarrativesView = DB.getSummaryNarrativesView();
    ABCMNarrativesTable narrativesTable = DB.getNarrativesTable();
    ABCMResearchersTable researchersTable = DB.getResearchersTable();

    return
       "SELECT " + 
          summaryNarrativesView.getField_Summary_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ", \n" + 
          narrativesTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_Narrative_Name().getName() + ", \n" +
          narrativesTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_Narrative_Description().getName() + ", \n" +
          narrativesTable.getField_BaseDate().getFullFieldName(dbOwner) + " AS " + getField_Narrative_BaseDate().getName() + ", \n" +
          narrativesTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_Narrative_DateCreated().getName() + ", \n" +
          narrativesTable.getField_Seasonal().getFullFieldName(dbOwner) + " AS " + getField_Narrative_IsSeasonal().getName() + ", \n" +
          researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", \n" +
          narrativesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Narrative_PK().getName() + "\n" +
      "FROM   "  + summaryNarrativesView.getName() + " \n" +
          "INNER JOIN " + narrativesTable.getFullName(dbOwner) + " ON \n" + 
              summaryNarrativesView.getField_Narrative_PK().getFullFieldName(dbOwner) + " = " + narrativesTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
          "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON \n" + 
              narrativesTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner);    
  }
  
  
}
