
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;

public abstract class ABCMSummaryProbeSetsView extends ABCMdbView {
  
  public ABCMSummaryProbeSetsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_ProbeSet_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummariesTable summariesTable = DB.getSummariesTable();
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
    ABCMSummaryAnalysesTable summaryAnalysesTable = DB.getSummaryAnalysesTable();
    ABCMAnalysesTable analysesTable = DB.getAnalysesTable();
    ABCMAnalysisDataSeriesTable analysisDataSeriesTable = DB.getAnalysisDataSeriesTable();
    ABCMSimulationDataSeriesTable simulationDataSeriesTable = DB.getSimulationDataSeriesTable();
    
    return
    "SELECT DISTINCT " +
       summariesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ",\n" + 
       simulationRunsTable.getField_ProbeSetFK().getFullFieldName(dbOwner) + " AS " + this.getField_ProbeSet_PK().getName() + "\n" +  
    "FROM   " + summariesTable.getFullName(dbOwner) + " \n" +
        "INNER JOIN " + summaryAnalysesTable.getFullName(dbOwner) + " ON \n" + 
             summariesTable.getField_PK().getFullFieldName(dbOwner) + " = " + summaryAnalysesTable.getField_SummaryFK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + analysesTable.getFullName(dbOwner) + " ON \n" + 
             summaryAnalysesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " = " + analysesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + analysisDataSeriesTable.getFullName(dbOwner) + " ON \n" + 
             analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + simulationDataSeriesTable.getFullName(dbOwner) + " ON \n" + 
             analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " = " + simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "INNER JOIN " + simulationRunsTable.getFullName(dbOwner) + " ON \n" + 
             simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) + " = " + simulationRunsTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
