
package abcm.db.components.views;

import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;

public abstract class ABCMSummaryRunsView extends ABCMdbView {
  
  public ABCMSummaryRunsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_SimulationRun_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummaryAnalysesTable summaryAnalysesTable = DB.getSummaryAnalysesTable();
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
    ABCMAnalysesTable analysesTable = DB.getAnalysesTable();
    ABCMAnalysisDataSeriesTable analysisDataSeriesTable = DB.getAnalysisDataSeriesTable();
    ABCMSimulationDataSeriesTable simulationDataSeriesTable = DB.getSimulationDataSeriesTable();

        
    return
    "SELECT DISTINCT " +
        summaryAnalysesTable.getField_SummaryFK().getFullFieldName(dbOwner) + " AS intSummaryID, " +"\n" + 
        simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " AS intSimulationRunID " +"\n" + 
    "FROM  " + analysesTable.getFullName(dbOwner) + "\n" +
        "INNER JOIN " + analysisDataSeriesTable.getFullName(dbOwner) + " ON\n" + 
              analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + "\n" +
        "INNER JOIN " + summaryAnalysesTable.getFullName(dbOwner) + " ON\n" + 
              analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + summaryAnalysesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + "\n" +
        "INNER JOIN " + simulationDataSeriesTable.getFullName(dbOwner) + " ON\n" + 
              analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " = " + simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
         "INNER JOIN " + simulationRunsTable.getFullName(dbOwner) + " ON\n" + 
              simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) + " = " + simulationRunsTable.getField_PK().getFullFieldName(dbOwner);

    
  }
  
  
}
