package abcm.graphics;

/**
 * Classes that implement this interface can accept an X3DAssist object and
 * add the representation of themselves to it.
 * 
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public interface X3DRepresentable {

  /**
   * Add this class's x3d representation to the specified X3DAssist object.
   * @param x3d the object to which the representation is to be added
   */
  public void addToX3D(X3DAssist x3d);
  
}
