package abcm.sim;

/**
 * Selectable objecst can be marked as either selected or not. This can be of use
 * in specifying operations that should be performed on subsets of the collections
 * of these objects.
 * 
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public interface Selectable {

  /**
   * Marks this object as selected.
   */
  public void select();
  
  /**
   * Marks this object as unselected
   */
  public void unSelect();  

  /**
   * Returns true if this object is marked 'selected', false otherwise
   * @return status as 'selected'
   */
  public boolean isSelected();
  
}
