package abcm.space;

import abcm.math.Point;

/**
 * Basic interface identifying components that have a 3-D elevation
 *
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public interface HasElevation {

  /**
   * Gets the elevation (z) found at the x,y coordinates of the
   * point given
   * @param P the point to be tested
   * @return the Z value at the specified x,y point
   */
  public double getZ(Point P);
  
}
