package flowag.basic;

import abcm.cloning.ABCMCloneStore;
import abcm.cloning.ABCMDeepCloneable;

/**
 * A basic implementation of a Chemical.
 * 
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public class BasicChemical extends AbstractChemical {

  /**
   * Constructor providing basic instance information
   * @param newName
   * @param newConcentration
   */
  public BasicChemical(String newName, double newConcentration) {
    super(newName, newConcentration);
  }

  /**
   * @see abcm.cloning.ABCMDeepCloneable#getDeepClone(abcm.cloning.ABCMCloneStore)
   */
  public ABCMDeepCloneable getDeepClone(ABCMCloneStore cloneStore){
    return new BasicChemical(this.getName(), this.getConcentration());
  }
  
}
