package flowag.basic;

/**
 * Any object that can receive rainfall should implement this interface.
 * 
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public interface RainRecipient{
  
  /**
   * Deposits the given amount of water, with the characteristics of
   * rainsource, onto the recipient.
   * @param MM the amount of water
   * @param rainSource template of water to be deposited (i.e. with
   * a specific chemical composition)
   */
  public void rain(double MM, Water rainSource);
  
}