package wm.db;

import wm.db.defaults.tables.WMDefaultChemicalsTable;
import wm.db.defaults.tables.WMDefaultPlantCommentsTable;
import wm.db.defaults.tables.WMDefaultPlantConfigurationChemicalEffectsTable;
import wm.db.defaults.tables.WMDefaultPlantConfigurationCommentsTable;
import wm.db.defaults.tables.WMDefaultPlantConfigurationStagesTable;
import wm.db.defaults.tables.WMDefaultPlantConfigurationsTable;
import wm.db.defaults.tables.WMDefaultPlantsTable;
import wm.db.defaults.tables.WMDefaultSimulationConfigurationPlantConfigurationsTable;
import wm.db.defaults.views.WMDefaultCanBeEdited_PlantConfigurationsView;
import wm.db.defaults.views.WMDefaultCanBeEdited_PlantsView;
import wm.db.defaults.views.WMDefaultCommentsCount_PlantConfigurationsView;
import wm.db.defaults.views.WMDefaultCommentsCount_PlantsView;
import wm.db.defaults.views.WMDefaultPlantConfigsAndResearchersView;
import wm.db.defaults.views.WMDefaultPlantConfigurationInfoView1;
import wm.db.defaults.views.WMDefaultPlantConfigurationInfoView2;
import wm.db.defaults.views.WMDefaultPlantConfigurationsInSimulationConfigurationsView;
import wm.db.defaults.views.WMDefaultPlantsAndCommentsView;
import wm.db.defaults.views.WMDefaultPlantsAndReferencesToThemView;
import wm.db.defaults.views.WMDefaultPlantsAndResearchersView;
import wm.db.defaults.views.WMDefaultPlantsCountingConfigurationsView;
import wm.db.defaults.views.WMDefaultPlantsInCommentsView;
import wm.db.defaults.views.WMDefaultSimConfigPlantStagesView;
import wm.db.defaults.views.WMDefaultSimulationConfigsWithPlantConfigTruthValueView;
import wm.db.defaults.views.WMDefaultSimulationConfigurationPlantConfigurationsView;
import wm.db.defaults.views.WMDefaultSimulationConfigurationsAndTruthValuesView;
import wm.db.defaults.views.WMDefaultSummaryPlantConfigurationsAndDetailsView;
import wm.db.defaults.views.WMDefaultSummaryPlantConfigurationsView;
import wm.db.tables.WMChemicalsTable;
import wm.db.tables.WMPlantCommentsTable;
import wm.db.tables.WMPlantConfigurationChemicalEffectsTable;
import wm.db.tables.WMPlantConfigurationCommentsTable;
import wm.db.tables.WMPlantConfigurationStagesTable;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import wm.db.views.WMCanBeEdited_PlantConfigurationsView;
import wm.db.views.WMCanBeEdited_PlantsView;
import wm.db.views.WMCommentsCount_PlantConfigurationsView;
import wm.db.views.WMCommentsCount_PlantsView;
import wm.db.views.WMPlantConfigsAndResearchersView;
import wm.db.views.WMPlantConfigurationInfoView1;
import wm.db.views.WMPlantConfigurationInfoView2;
import wm.db.views.WMPlantConfigurationsInSimulationConfigurationsView;
import wm.db.views.WMPlantsAndCommentsView;
import wm.db.views.WMPlantsAndReferencesToThemView;
import wm.db.views.WMPlantsAndResearchersView;
import wm.db.views.WMPlantsCountingConfigurationsView;
import wm.db.views.WMPlantsInCommentsView;
import wm.db.views.WMSimConfigPlantStagesView;
import wm.db.views.WMSimulationConfigsWithPlantConfigTruthValueView;
import wm.db.views.WMSimulationConfigurationPlantConfigurationsView;
import wm.db.views.WMSummaryPlantConfigurationsAndDetailsView;
import wm.db.views.WMSummaryPlantConfigurationsView;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.AbstractDBDataInitializer;
import abcm.db.syntaxengines.AbstractSQLSyntaxEngine;

/**
 * WMDBGateway is an extension of the ABCMDBGateway object that is tailored for use in the
 * WatMan simulation. It contains references to tables specific to the WM context, and
 * provides a WM-specific data initializer. 
 * 
 *  @author John T. Murphy<br/>
 *  Global Institute of Sustainability,<br/>
 *  Arizona State University<br/>
 *  For license and disclaimers, see the Overview.
 */
public abstract class WMDBGateway extends AbstractABCMDBGateway{

  /** Constant that identifies the DB object 'Plant'               */ public static final int PLANT               =  2;
  /** Constant that identifies the DB object 'Plant Configuration' */ public static final int PLANT_CONFIGURATION = 14;
  
  /* Tables */
  /** Chemicals table                     */ protected WMChemicalsTable                                  chemicalsTable;
  /** Plants table                        */ protected WMPlantsTable                                     plantsTable;
  /** Plant Configurations Table          */ protected WMPlantConfigurationsTable                        plantConfigurationsTable;
  /** Plant Configuration Stages Table    */ protected WMPlantConfigurationStagesTable                   plantConfigurationStagesTable;
  /** Simulation Configurations Plant 
     Configurations Table                 */ protected WMSimulationConfigurationPlantConfigurationsTable simulationConfigurationPlantConfigurationsTable;
  /** PlantConfigurationChemicalEffects
     Table                                */ protected WMPlantConfigurationChemicalEffectsTable          plantConfigurationChemicalEffectsTable;
  /** Plant Configuration Comments Table  */ protected WMPlantConfigurationCommentsTable                 plantConfigurationCommentsTable;
  /** Plant Comments Table                */ protected WMPlantCommentsTable                              plantCommentsTable;

  /* Views */
  /** Plant Configurations View           */ protected WMCommentsCount_PlantConfigurationsView              commentsCount_PlantConfigurationsView;
  /** Plants Counting Configurations View */ protected WMPlantsCountingConfigurationsView                   plantsCountingConfigurationsView;
  /** Plants in Comments View             */ protected WMPlantsInCommentsView                               plantsInCommentsView;
  /** Plant Configurations in Simulation
     Configurations View                  */ protected WMPlantConfigurationsInSimulationConfigurationsView  plantConfigurationsInSimulationConfigurationsView;
  /** Plant Configurations and Researchers
     View                                 */ protected WMPlantConfigsAndResearchersView                     plantConfigsAndResearchersView;
  /** Plants and Comments View            */ protected WMPlantsAndCommentsView                              plantsAndCommentsView;
  /** Plants and References to Them View  */ protected WMPlantsAndReferencesToThemView                      plantsAndReferencesToThemView;
  /** Plants and Researchers View         */ protected WMPlantsAndResearchersView                           plantsAndResearchersView;
  /** Can Be Edited Plant Configurations
     View                                 */ protected WMCanBeEdited_PlantConfigurationsView                canBeEdited_PlantConfigurationsView;
  /** Can Be Edited Plants View           */ protected WMCanBeEdited_PlantsView                             canBeEdited_PlantsView;
  /** Summary Plant Configurations View   */ protected WMSummaryPlantConfigurationsView                     summaryPlantConfigurationsView;
  /** Summary Plant Configurations and
     Details View                         */ protected WMSummaryPlantConfigurationsAndDetailsView           summaryPlantConfigurationsAndDetailsView;
  /** Sim Config Plant Stages View        */ protected WMSimConfigPlantStagesView                           simConfigPlantStagesView;
  /** Simulation Configs With Plant 
     Plant Config Truth Value View        */ protected WMSimulationConfigsWithPlantConfigTruthValueView     simulationConfigsWithPlantConfigTruthValueView;
  /** Simulation Configuration Plant 
     Configurations View                  */ protected WMSimulationConfigurationPlantConfigurationsView     simulationConfigurationPlantConfigurationsView;  
  /** Comments Count Plants View          */ protected WMCommentsCount_PlantsView                           commentsCount_PlantsView;
  
  /** PlantConfig Info View 1             */ protected WMPlantConfigurationInfoView1                        plantConfigurationInfoView1;
  /** PlantConfig Info View 2             */ protected WMPlantConfigurationInfoView2                        plantConfigurationInfoView2;
  
  /**
   * Constructor 
   */
  public WMDBGateway(AbstractSQLSyntaxEngine syntaxEngine){
    super(syntaxEngine);
    
    /* Tables */
    setChemicalsTable(                                  new WMDefaultChemicalsTable(researchersTable)                                      );
    setPlantsTable(                                     new WMDefaultPlantsTable(researchersTable)                                         );
    setPlantConfigurationsTable(                        new WMDefaultPlantConfigurationsTable(researchersTable, plantsTable, 
                                                             truthValuesTable)                                                             );
    setPlantConfigurationStagesTable(                   new WMDefaultPlantConfigurationStagesTable(plantConfigurationsTable)               );
    setPlantConfigurationChemicalEffectsTable(          new WMDefaultPlantConfigurationChemicalEffectsTable(plantConfigurationsTable)      ); 
    setPlantConfigurationCommentsTable(                 new WMDefaultPlantConfigurationCommentsTable(plantConfigurationsTable, 
                                                            commentsTable)                                                                 );
    setSimulationConfigurationPlantConfigurationsTable( new WMDefaultSimulationConfigurationPlantConfigurationsTable(
                                                             simulationConfigurationsTable, plantConfigurationsTable)                      );
    setPlantCommentsTable(                              new WMDefaultPlantCommentsTable(plantsTable, commentsTable)                        );
   
    /* Views */
    
    // This view overrides the stub view specified by the ABCM gateway.
    setSimulationConfigurationsAndTruthValuesView(           new WMDefaultSimulationConfigurationsAndTruthValuesView(this)                 );
  
    // However, this view also needs this one:
    setSimulationConfigsWithPlantConfigTruthValueView(       new WMDefaultSimulationConfigsWithPlantConfigTruthValueView(this)             );
    moveViewBefore(getSimulationConfigsWithPlantConfigTruthValueView(), 
                   getSimulationConfigurationsAndTruthValuesView());

    // Other views required
    setPlantsCountingConfigurationsView(                     new WMDefaultPlantsCountingConfigurationsView(this)                           );
    setPlantsInCommentsView(                                 new WMDefaultPlantsInCommentsView(this)                                       );
    setPlantConfigurationsInSimulationConfigurationsView(    new WMDefaultPlantConfigurationsInSimulationConfigurationsView(this)          );
    setCommentsCount_PlantConfigurationsView(                new WMDefaultCommentsCount_PlantConfigurationsView(this)                      );
    setCanBeEdited_PlantConfigurationsView(                  new WMDefaultCanBeEdited_PlantConfigurationsView(this)                        );
    setPlantConfigsAndResearchersView(                       new WMDefaultPlantConfigsAndResearchersView(this)                             );
    setPlantsAndCommentsView(                                new WMDefaultPlantsAndCommentsView(this)                                      );
    setPlantsAndReferencesToThemView(                        new WMDefaultPlantsAndReferencesToThemView(this)                              );
    setCanBeEdited_PlantsView(                               new WMDefaultCanBeEdited_PlantsView(this)                                     );
    setPlantsAndResearchersView(                             new WMDefaultPlantsAndResearchersView(this)                                   );
    setSummaryPlantConfigurationsView(                       new WMDefaultSummaryPlantConfigurationsView(this)                             );
    setSummaryPlantConfigurationsAndDetailsView(             new WMDefaultSummaryPlantConfigurationsAndDetailsView(this)                   );
    setSimConfigPlantStagesView(                             new WMDefaultSimConfigPlantStagesView(this)                                   );
    setSimulationConfigsWithPlantConfigTruthValueView(       new WMDefaultSimulationConfigsWithPlantConfigTruthValueView(this)             );
    setSimulationConfigurationPlantConfigurationsView(       new WMDefaultSimulationConfigurationPlantConfigurationsView(this)             );
    setCommentsCount_PlantsView(                             new WMDefaultCommentsCount_PlantsView(this)                                   );
    setPlantConfigurationInfoView1(                          new WMDefaultPlantConfigurationInfoView1(this)                                );
    setPlantConfigurationInfoView2(                          new WMDefaultPlantConfigurationInfoView2(this)                                );
  }

  /* Setters */
  // Tables
  public void setChemicalsTable(WMChemicalsTable table){
    substituteTable(chemicalsTable, table);
    chemicalsTable= table;
  }
  
  public void setPlantsTable(WMPlantsTable table){
    substituteTable(plantsTable, table);
    plantsTable= table;
  }

  public void setPlantConfigurationsTable(WMPlantConfigurationsTable table){
    substituteTable(plantConfigurationsTable, table);
    plantConfigurationsTable= table;
  }

  public void setPlantConfigurationStagesTable(WMPlantConfigurationStagesTable table){
    substituteTable(plantConfigurationStagesTable, table);
    plantConfigurationStagesTable= table;
  }

  public void setPlantConfigurationChemicalEffectsTable(WMPlantConfigurationChemicalEffectsTable table){
    substituteTable(plantConfigurationChemicalEffectsTable, table);
    plantConfigurationChemicalEffectsTable= table;
  }
  
  public void setSimulationConfigurationPlantConfigurationsTable(WMSimulationConfigurationPlantConfigurationsTable table){
    substituteTable(simulationConfigurationPlantConfigurationsTable, table);
    simulationConfigurationPlantConfigurationsTable= table;
  }

  public void setPlantCommentsTable(WMPlantCommentsTable table){
    substituteTable(plantCommentsTable, table);
    plantCommentsTable= table;
  }

  public void setPlantConfigurationCommentsTable(WMPlantConfigurationCommentsTable table){
    substituteTable(plantConfigurationCommentsTable, table);
    plantConfigurationCommentsTable= table;
  }
  

  // Views  
  public void setPlantsCountingConfigurationsView(WMPlantsCountingConfigurationsView view){
    substituteView(plantsCountingConfigurationsView, view);
    plantsCountingConfigurationsView = view;
  }

  public void setPlantsInCommentsView(WMPlantsInCommentsView view){
    substituteView(plantsInCommentsView, view);
    plantsInCommentsView = view;
  }
  
  public void setPlantConfigurationsInSimulationConfigurationsView(WMPlantConfigurationsInSimulationConfigurationsView view){
    substituteView(plantConfigurationsInSimulationConfigurationsView, view);
    plantConfigurationsInSimulationConfigurationsView = view;
  }
  
  public void setPlantConfigsAndResearchersView(WMPlantConfigsAndResearchersView view){
    substituteView(plantConfigsAndResearchersView, view);
    plantConfigsAndResearchersView = view;
  }

  public void setPlantsAndCommentsView(WMPlantsAndCommentsView view){
    substituteView(plantsAndCommentsView, view);
    plantsAndCommentsView = view;
  }

  public void setPlantsAndReferencesToThemView(WMPlantsAndReferencesToThemView view){
    substituteView(plantsAndReferencesToThemView, view);
    plantsAndReferencesToThemView = view;
  }
  
  public void setPlantsAndResearchersView(WMPlantsAndResearchersView view){
    substituteView(plantsAndResearchersView, view);
    plantsAndResearchersView = view;
  }
  
  public void setCanBeEdited_PlantConfigurationsView(WMCanBeEdited_PlantConfigurationsView view){
    substituteView(canBeEdited_PlantConfigurationsView, view);
    canBeEdited_PlantConfigurationsView = view;
  }

  public void setCanBeEdited_PlantsView(WMCanBeEdited_PlantsView view){
    substituteView(canBeEdited_PlantsView, view);
    canBeEdited_PlantsView = view;
  }
  
  public void setSummaryPlantConfigurationsView(WMSummaryPlantConfigurationsView view){
    substituteView(summaryPlantConfigurationsView, view);
    summaryPlantConfigurationsView = view;
  }

  public void setSummaryPlantConfigurationsAndDetailsView(WMSummaryPlantConfigurationsAndDetailsView view){
    substituteView(summaryPlantConfigurationsAndDetailsView, view);
    summaryPlantConfigurationsAndDetailsView = view;
  }

  public void setCommentsCount_PlantConfigurationsView(WMCommentsCount_PlantConfigurationsView view){
    substituteView(commentsCount_PlantConfigurationsView, view);
    commentsCount_PlantConfigurationsView = view;
  }

  public void setSimConfigPlantStagesView(WMSimConfigPlantStagesView view){
    substituteView(simConfigPlantStagesView, view);
    simConfigPlantStagesView = view;
  }
  
  public void setSimulationConfigsWithPlantConfigTruthValueView(WMSimulationConfigsWithPlantConfigTruthValueView view){
    substituteView(simulationConfigsWithPlantConfigTruthValueView, view);
    simulationConfigsWithPlantConfigTruthValueView = view;
  }

  public void setSimulationConfigurationPlantConfigurationsView(WMSimulationConfigurationPlantConfigurationsView view){
    substituteView(simulationConfigurationPlantConfigurationsView, view);
    simulationConfigurationPlantConfigurationsView = view;
  }

  public void setCommentsCount_PlantsView(WMCommentsCount_PlantsView view){
    substituteView(commentsCount_PlantsView, view);
    commentsCount_PlantsView = view;
  }
  
  public void setPlantConfigurationInfoView1(WMPlantConfigurationInfoView1 view){
	  substituteView(plantConfigurationInfoView1, view);
	  plantConfigurationInfoView1 = view;
  }

  public void setPlantConfigurationInfoView2(WMPlantConfigurationInfoView2 view){
	  substituteView(plantConfigurationInfoView2, view);
	  plantConfigurationInfoView2 = view;
  }

  

  /* Getters */
  // Tables
  public WMPlantsTable getPlantsTable(){                                                                         return plantsTable;                                     }
  public WMPlantConfigurationsTable getPlantConfigurationsTable(){                                               return plantConfigurationsTable;                        }
  public WMPlantConfigurationStagesTable getPlantConfigurationStagesTable(){                                     return plantConfigurationStagesTable;                   }
  public WMPlantConfigurationChemicalEffectsTable getPlantConfigurationChemicalEffectsTable(){                   return plantConfigurationChemicalEffectsTable;          }
  public WMSimulationConfigurationPlantConfigurationsTable getSimulationConfigurationPlantConfigurationsTable(){ return simulationConfigurationPlantConfigurationsTable; }
  public WMPlantCommentsTable getPlantCommentsTable(){                                                           return plantCommentsTable;                              }
  public WMPlantConfigurationCommentsTable getPlantConfigurationCommentsTable(){                                 return plantConfigurationCommentsTable;                 }
  public WMChemicalsTable getChemicalsTable(){                                                                   return chemicalsTable;                                  }
  
  // Views
  public WMPlantsCountingConfigurationsView                   getPlantsCountingConfigurationsView(){                   return plantsCountingConfigurationsView;                  }
  public WMPlantsInCommentsView                               getPlantsInCommentsView(){                               return plantsInCommentsView;                              }
  public WMPlantConfigurationsInSimulationConfigurationsView  getPlantConfigurationsInSimulationConfigurationsView(){  return plantConfigurationsInSimulationConfigurationsView; }
  public WMPlantConfigsAndResearchersView                     getPlantConfigsAndResearchersView(){                     return plantConfigsAndResearchersView;                    }
  public WMPlantsAndCommentsView                              getPlantsAndCommentsView(){                              return plantsAndCommentsView;                             }
  public WMPlantsAndReferencesToThemView                      getPlantsAndReferencesToThemView(){                      return plantsAndReferencesToThemView;                     }
  public WMPlantsAndResearchersView                           getPlantsAndResearchersView(){                           return plantsAndResearchersView;                          }
  public WMCanBeEdited_PlantConfigurationsView                getCanBeEdited_PlantConfigurationsView(){                return canBeEdited_PlantConfigurationsView;               }
  public WMCanBeEdited_PlantsView                             getCanBeEdited_PlantsView(){                             return canBeEdited_PlantsView;                            }
  public WMSummaryPlantConfigurationsView                     getSummaryPlantConfigurationsView(){                     return summaryPlantConfigurationsView;                    }
  public WMSummaryPlantConfigurationsAndDetailsView           getSummaryPlantConfigurationsAndDetailsView(){           return summaryPlantConfigurationsAndDetailsView;          }
  public WMCommentsCount_PlantConfigurationsView              getCommentsCount_PlantConfigurationsView(){              return commentsCount_PlantConfigurationsView;             }
  public WMSimConfigPlantStagesView                           getSimConfigPlantStagesView(){                           return simConfigPlantStagesView;                          }
  public WMSimulationConfigsWithPlantConfigTruthValueView     getSimulationConfigsWithPlantConfigTruthValueView(){     return simulationConfigsWithPlantConfigTruthValueView;    }  
  public WMSimulationConfigurationPlantConfigurationsView     getSimulationConfigurationPlantConfigurationsView(){     return simulationConfigurationPlantConfigurationsView;    }
  public WMCommentsCount_PlantsView                           getCommentsCount_PlantsView(){                           return commentsCount_PlantsView;                          }
  public WMPlantConfigurationInfoView1                        getPlantConfigurationInfoView1(){                        return plantConfigurationInfoView1;                       }
  public WMPlantConfigurationInfoView2                        getPlantConfigurationInfoView2(){                        return plantConfigurationInfoView2;                       }
  
  // Data initializer
  /** 
   * @see abcm.db.AbstractABCMDBGateway#getDataInitializer() 
   */
  public AbstractDBDataInitializer getDataInitializer(){
    return new WMDBDataInitializer(this);
  }
  
}
