 
package wm.db.defaults.tables;  
 
import wm.db.tables.WMChemicalsTable;
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class WMDefaultChemicalsTable extends WMChemicalsTable {

  protected ABCMdbField PK, NAME, COMMENTS, FK_RESEARCHER;

  public WMDefaultChemicalsTable(ABCMResearchersTable researchersTable){
    super("tblChemicals");
    PK            = createAndAddField("intChemicalID",     INT,                true);
    NAME          = createAndAddField("vcharChemicalName", false, VCHAR20          );
    COMMENTS      = createAndAddField("txtComments",       false, TEXT             );
    FK_RESEARCHER = createAndAddField("intResearcherID",   false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupChems", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Name(){         return NAME;           }
  public ABCMdbField getField_Comments(){     return COMMENTS;       }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
 
}
 
