 
package wm.db.defaults.tables;  
 
import wm.db.tables.WMPlantCommentsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMCommentsTable;
 
public class WMDefaultPlantCommentsTable extends WMPlantCommentsTable {

  protected ABCMdbField PK, FK_PLANT, FK_COMMENT;

  public WMDefaultPlantCommentsTable(WMPlantsTable plantsTable,
      ABCMCommentsTable commentsTable){
    super("tblPlantComments");
    PK         = createAndAddField("intPlantCommentID", INT,        true);
    FK_PLANT   = createAndAddField("intPlantID",        false, INT,
        plantsTable.getName(), plantsTable.getField_PK().getName());
    FK_COMMENT = createAndAddField("intCommentID",      false, INT,
        commentsTable.getName(), commentsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupPlantComments", new String[]{ getField_PlantFK().getName(), getField_CommentFK().getName() }));

  }

  public ABCMdbField getField_PK(){        return PK;          }
  public ABCMdbField getField_PlantFK(){   return FK_PLANT;    }
  public ABCMdbField getField_CommentFK(){ return FK_COMMENT;  }
 
}
 
