package wm.db.defaults.tables;

import wm.db.tables.WMPlantConfigurationChemicalEffectsTable;
import wm.db.tables.WMPlantConfigurationsTable;
import abcm.db.components.ABCMdbField;

public class WMDefaultPlantConfigurationChemicalEffectsTable extends WMPlantConfigurationChemicalEffectsTable{

  protected ABCMdbField PK, FK_PLANT_CONFIGURATION, CHEMICAL, NEED, CONSUME;

  public WMDefaultPlantConfigurationChemicalEffectsTable(WMPlantConfigurationsTable plantConfigurationsTable){
    super("tblPlantConfigurationChemicalEffects");
    PK                     = createAndAddField("intPlantConfigChemEffID",   INT,             true  );
    FK_PLANT_CONFIGURATION = createAndAddField("intPlantConfigurationID",   false, INT,
        plantConfigurationsTable.getName(), plantConfigurationsTable.getField_PK().getName()         );
    CHEMICAL               = createAndAddField("txtChemical",               false, VCHAR50     );
    NEED                   = createAndAddField("dblNeedOrResist",           false, FLOAT8            );
    CONSUME                = createAndAddField("dblConsumeOrEmit",          false, FLOAT8            );
    
    addIndex(new ABCMdbIndex("NoDupStageChems", new String[]{ getField_PlantConfigurationFK().getName(), getField_ChemicalName().getName() }));

  }

  
  public ABCMdbField getField_PK(){                      return PK;                     }
  public ABCMdbField getField_PlantConfigurationFK(){    return FK_PLANT_CONFIGURATION; }
  public ABCMdbField getField_ChemicalName(){            return CHEMICAL;               }
  public ABCMdbField getField_NeedOrResist(){            return NEED;                   }
  public ABCMdbField getField_ConsumeOrEmit(){           return CONSUME;                }

  
}
