 
package wm.db.defaults.tables;  
 
import wm.db.tables.WMPlantConfigurationStagesTable;
import wm.db.tables.WMPlantConfigurationsTable;
import abcm.db.components.ABCMdbField;
 
public class WMDefaultPlantConfigurationStagesTable extends WMPlantConfigurationStagesTable {

  protected ABCMdbField PK, FK_PLANT_CONFIGURATION, ORDER, DURATION, 
      CROP_FACTOR, DROUGHT_SENSITIVITY, LABOR_REQUIRED;

  public WMDefaultPlantConfigurationStagesTable(WMPlantConfigurationsTable plantConfigurationsTable){
    super("tblPlantConfigurationStages");
    PK                     = createAndAddField("intPlantConfigStageID",   INT,             true);
    FK_PLANT_CONFIGURATION = createAndAddField("intPlantConfigurationID", false, INT,
        plantConfigurationsTable.getName(), plantConfigurationsTable.getField_PK().getName());
    ORDER                  = createAndAddField("intOrder",                false, INT           );
    DURATION               = createAndAddField("intDuration",             false, INT           );
    CROP_FACTOR            = createAndAddField("dblCropFactor",           false, FLOAT8          );
    DROUGHT_SENSITIVITY    = createAndAddField("dblDroughtSensitivity",   false, FLOAT8          );
    LABOR_REQUIRED         = createAndAddField("dblLaborRequired",        false, FLOAT8          );

    addIndex(new ABCMdbIndex("NoDupStageOrders", new String[]{ getField_PlantConfigurationFK().getName(), getField_Order().getName() }));

  }

  public ABCMdbField getField_PK(){                   return PK;                      }
  public ABCMdbField getField_PlantConfigurationFK(){ return FK_PLANT_CONFIGURATION;  }
  public ABCMdbField getField_Order(){                return ORDER;                   }
  public ABCMdbField getField_Duration(){             return DURATION;                }
  public ABCMdbField getField_CropFactor(){           return CROP_FACTOR;             }
  public ABCMdbField getField_DroughtSensitivity(){   return DROUGHT_SENSITIVITY;     }
  public ABCMdbField getField_Labor(){                return LABOR_REQUIRED;          }

}
 
