 
package wm.db.defaults.tables;  
 
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMTruthValuesTable;
 
public class WMDefaultPlantConfigurationsTable extends WMPlantConfigurationsTable {

  protected ABCMdbField PK, NAME, DESC, CREATED, FK_RESEARCHER, FK_PLANT, FK_TRUTH_VALUE;

  public WMDefaultPlantConfigurationsTable(ABCMResearchersTable researchersTable,
      WMPlantsTable plantsTable, ABCMTruthValuesTable truthValuesTable){
    super("tblPlantConfigurations");
    PK             = createAndAddField("intPlantConfigurationID", INT,                 true);
    NAME           = createAndAddField("vcharPlantConfigName",    false, VCHAR100      );
    DESC           = createAndAddField("txtDescription",          false, TEXT                );
    CREATED        = createAndAddField("dteDateCreated",          false, DATETIME          );
    FK_RESEARCHER  = createAndAddField("intResearcherID",         false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());
    FK_PLANT       = createAndAddField("intPlantID",              false, INT,
        plantsTable.getName(), plantsTable.getField_PK().getName());
    FK_TRUTH_VALUE = createAndAddField("intTruthValue",           false, INT,
        truthValuesTable.getName(), truthValuesTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupPlantConfigurationNames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;              }
  public ABCMdbField getField_Name(){         return NAME;            }
  public ABCMdbField getField_Description(){  return DESC;            }
  public ABCMdbField getField_DateCreated(){  return CREATED;         }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;   }
  public ABCMdbField getField_PlantFK(){      return FK_PLANT;        }
  public ABCMdbField getField_TruthValueFK(){ return FK_TRUTH_VALUE;  }
 
}
 
