 
package wm.db.defaults.tables;  
 
import wm.db.tables.WMPlantsTable;
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMResearchersTable;
 
public class WMDefaultPlantsTable extends WMPlantsTable {

  protected ABCMdbField PK, NAME, FK_RESEARCHER;

  public WMDefaultPlantsTable(ABCMResearchersTable researchersTable){
    super("tblPlants");
    PK            = createAndAddField("intPlantID",      INT,                true);
    NAME          = createAndAddField("vcharPlantName",  false, VCHAR50      );
    FK_RESEARCHER = createAndAddField("intResearcherID", false, INT,
        researchersTable.getName(), researchersTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupPlantnames", new String[]{ getField_Name().getName() }));

  }

  public ABCMdbField getField_PK(){           return PK;             }
  public ABCMdbField getField_Name(){         return NAME;           }
  public ABCMdbField getField_ResearcherFK(){ return FK_RESEARCHER;  }
 
}
 
