 
package wm.db.defaults.tables;  
 
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.components.ABCMdbField;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
 
public class WMDefaultSimulationConfigurationPlantConfigurationsTable extends WMSimulationConfigurationPlantConfigurationsTable {

  protected ABCMdbField PK, FK_SIMULATION_CONFIGURATION, FK_PLANT_CONFIGURATION;

  public WMDefaultSimulationConfigurationPlantConfigurationsTable(ABCMSimulationConfigurationsTable simulationConfigurationsTable,
      WMPlantConfigurationsTable plantConfigurationsTable){
    super("tblSimulationConfigurationPlantConfigurations");
    PK                          = createAndAddField("intSimConfigPlantConfigID",    INT,        true);
    FK_SIMULATION_CONFIGURATION = createAndAddField("intSimulationConfigurationID", false, INT,
        simulationConfigurationsTable.getName(), simulationConfigurationsTable.getField_PK().getName());
    FK_PLANT_CONFIGURATION      = createAndAddField("intPlantConfigurationID",      false, INT,
        plantConfigurationsTable.getName(), plantConfigurationsTable.getField_PK().getName());

    addIndex(new ABCMdbIndex("NoDupSimConfigPlantConfigs", 
        new String[]{ getField_SimulationConfigurationFK().getName(), 
                      getField_PlantConfigurationFK().getName() }));

  }

  public ABCMdbField getField_PK(){                        return PK;                           }
  public ABCMdbField getField_SimulationConfigurationFK(){ return FK_SIMULATION_CONFIGURATION;  }
  public ABCMdbField getField_PlantConfigurationFK(){      return FK_PLANT_CONFIGURATION;       }
 
}
 
