package wm.db.defaults.views;

import wm.db.WMDBGateway;
import wm.db.views.WMSimulationConfigsWithPlantConfigTruthValueView;
import abcm.db.components.defaults.views.ABCMDefaultSimulationConfigurationsAndTruthValuesView;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public class WMDefaultSimulationConfigurationsAndTruthValuesView extends
    ABCMDefaultSimulationConfigurationsAndTruthValuesView {

  
  public WMDefaultSimulationConfigurationsAndTruthValuesView(WMDBGateway db){
    super(db);
  }
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationConfigurationsTable simConfigsTable = DB.getSimulationConfigurationsTable();
      String simConfigs = simConfigsTable.getFullName(dbOwner);
    
      String SIMCONFIG_PK              = simConfigsTable.getField_PK().getFullFieldName(dbOwner);
      String SIMCONFIG_NAME            = simConfigsTable.getField_Name().getFullFieldName(dbOwner);
      String SIMCONFIG_DESC            = simConfigsTable.getField_Description().getFullFieldName(dbOwner);
      String SIMCONFIG_DATECREATED     = simConfigsTable.getField_DateCreated().getFullFieldName(dbOwner);
      String SIMCONFIG_RESEARCHERFK    = simConfigsTable.getField_ResearcherFK().getFullFieldName(dbOwner);

    WMSimulationConfigsWithPlantConfigTruthValueView simConfigsWTVView = ((WMDBGateway)DB).getSimulationConfigsWithPlantConfigTruthValueView();
      String simConfigsWTV = simConfigsWTVView.getFullName(dbOwner);
    
      String SIMCONFIG_WTV_PK          = simConfigsWTVView.getField_SimulationConfiguration_PK().getFullFieldName(dbOwner);
      String SIMCONFIG_TRUTH_VALUE     = simConfigsWTVView.getField_TruthValue().getFullFieldName(dbOwner);
      
    return
           "SELECT " + SIMCONFIG_PK               + " AS " + getField_PK().getName()            + ", " + "\n" +
                       SIMCONFIG_NAME             + " AS " + getField_SimConfigName().getName() + ", " + "\n" +
                       SIMCONFIG_DESC             + " AS " + getField_Desc().getName()          + ", " + "\n" +
                       SIMCONFIG_DATECREATED      + " AS " + getField_DateCreated().getName()   + ", " + "\n" +
                       SIMCONFIG_RESEARCHERFK     + " AS " + getField_ResearcherFK().getName()  + ", " + "\n" +
                       SIMCONFIG_TRUTH_VALUE      + " AS " + getField_TruthValue().getName()    + "\n" +
           "FROM  " + simConfigs + " INNER JOIN " + simConfigsWTV + " ON " + SIMCONFIG_PK + " = " + SIMCONFIG_WTV_PK;    
  }
  
}
