package wm.db.tables;

import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;

public abstract class WMPlantConfigurationChemicalEffectsTable extends ABCMdbTable{

  public WMPlantConfigurationChemicalEffectsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_PlantConfigurationFK();
  public abstract ABCMdbField getField_ChemicalName();
  public abstract ABCMdbField getField_NeedOrResist();
  public abstract ABCMdbField getField_ConsumeOrEmit();

  
  public ABCMdbDatum getDatum(String plantConfigFK, String chemicalName, String needOrResistance, String consumeOrEmit){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_PlantConfigurationFK(), plantConfigFK);
    datum.addValue(getField_ChemicalName(), chemicalName);
    datum.addValue(getField_NeedOrResist(), needOrResistance);
    datum.addValue(getField_ConsumeOrEmit(), consumeOrEmit);
    return datum;
  }

  public ABCMdbDatum getDatum(long plantConfigFK, String chemicalName, double needOrResistance, double consumeOrEmit){
    return getDatum("" + plantConfigFK, chemicalName, "" + needOrResistance, "" + consumeOrEmit);
  }
  
}
