 
package wm.db.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class WMPlantConfigurationStagesTable extends ABCMdbTable{
 
  public WMPlantConfigurationStagesTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_PlantConfigurationFK();
  public abstract ABCMdbField getField_Order();
  public abstract ABCMdbField getField_Duration();
  public abstract ABCMdbField getField_CropFactor();
  public abstract ABCMdbField getField_DroughtSensitivity();
  public abstract ABCMdbField getField_Labor();

  public ABCMdbDatum getDatum(String plantConfigFK, String order, String duration, String cropFactor, String droughtSensitivity, String labor){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_PlantConfigurationFK(), plantConfigFK);
    datum.addValue(getField_Order(), order);
    datum.addValue(getField_Duration(), duration);
    datum.addValue(getField_CropFactor(), cropFactor);
    datum.addValue(getField_DroughtSensitivity(), droughtSensitivity);
    datum.addValue(getField_Labor(), labor);
    return datum;
  }
  
  public ABCMdbDatum getDatum(long plantConfigPK, int order, int duration, double cropFactor, double droughtSensitivity, double labor){
    return getDatum("" + plantConfigPK, "" + order, "" + duration, "" + cropFactor, "" + droughtSensitivity, "" + labor);
  }
  
}
 
