 
package wm.db.tables;  
 
import abcm.db.components.ABCMdbDatum;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbTable;
 
public abstract class WMPlantConfigurationsTable extends ABCMdbTable{
 
  public WMPlantConfigurationsTable(String tableName){ super(tableName); }

  public abstract ABCMdbField getField_PK();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_Description();
  public abstract ABCMdbField getField_DateCreated();
  public abstract ABCMdbField getField_ResearcherFK();
  public abstract ABCMdbField getField_PlantFK();
  public abstract ABCMdbField getField_TruthValueFK();

  public ABCMdbDatum getDatum(String name, String description, String dateCreated, String researcherFK, String plantFK, String truthValueFK){
    ABCMdbDatum datum = new ABCMdbDatum(this);
    datum.addValue(getField_Name(), name);
    datum.addValue(getField_Description(), description);
    datum.addValue(getField_DateCreated(), dateCreated);
    datum.addValue(getField_ResearcherFK(), researcherFK);
    datum.addValue(getField_PlantFK(), plantFK);
    datum.addValue(getField_TruthValueFK(), truthValueFK);
    return datum;
  }
  
  public ABCMdbDatum getDatum(String name, String description, String dateCreated, long researcherFK, long plantFK, long truthValueFK){
    return getDatum(name, description, dateCreated, "" + researcherFK, "" + plantFK, "" + truthValueFK);
  }
  
}
 
