
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMCanBeEdited_PlantConfigurationsView extends ABCMdbView {
  
  public WMCanBeEdited_PlantConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_PlantConfiguration_PK();
  public abstract ABCMdbField getField_CountOfSimulationConfigurations();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
    
    WMPlantConfigurationsInSimulationConfigurationsView plantConfigsInSimConfigsView = ((WMDBGateway)DB).getPlantConfigurationsInSimulationConfigurationsView();
    
    WMCommentsCount_PlantConfigurationsView commentsCount_PlantConfigurationsView = ((WMDBGateway)DB).getCommentsCount_PlantConfigurationsView();
    
    return
      "SELECT " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_PK().getName() + ", " +"\n" + 
                  plantConfigsInSimConfigsView.getField_CountOfSimulationConfigurations().getFullFieldName(dbOwner) + " AS " + getField_CountOfSimulationConfigurations().getName() + ", " +"\n" + 
                  commentsCount_PlantConfigurationsView.getField_CountOfComments().getFullFieldName(dbOwner) + " AS " + getField_CountOfComments().getName() + "\n" + 
        "FROM   " + plantConfigurationsTable.getFullName(dbOwner) + " " +
            "LEFT OUTER JOIN " + commentsCount_PlantConfigurationsView.getFullName(dbOwner) + " ON " +"\n" + 
                         plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + commentsCount_PlantConfigurationsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner) + " " +
            "LEFT OUTER JOIN " + plantConfigsInSimConfigsView.getFullName(dbOwner) + " ON " +"\n" + 
                         plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantConfigsInSimConfigsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner) + " \n" +
       "WHERE (" + plantConfigsInSimConfigsView.getField_CountOfSimulationConfigurations().getFullFieldName(dbOwner) + " = 0) \n" +
             "AND (" + commentsCount_PlantConfigurationsView.getField_CountOfComments().getFullFieldName(dbOwner) + " = 0)";
  }


}
