
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMCanBeEdited_PlantsView extends ABCMdbView {
  
  public WMCanBeEdited_PlantsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Plant_PK();
  public abstract ABCMdbField getField_Plant_Name();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_CountOfConfigurations();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    WMPlantsCountingConfigurationsView plantsCountingConfigurationsView = ((WMDBGateway)DB).getPlantsCountingConfigurationsView();
    
    WMPlantsInCommentsView plantsInCommentsView = ((WMDBGateway)DB).getPlantsInCommentsView();
    
    return
      "SELECT " +plantsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Plant_PK().getName() + ", " +"\n" + 
                 plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS  " + getField_Plant_Name().getName() + ", " +"\n" + 
                 plantsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS  " + getField_Researcher_PK().getName() + ", " +"\n" + 
                 plantsCountingConfigurationsView.getField_CountOfConfigurations().getFullFieldName(dbOwner) + " AS  " + getField_CountOfConfigurations().getName() + ", " +"\n" + 
                 plantsInCommentsView.getField_CountOfComments().getFullFieldName(dbOwner) + " AS  " + getField_CountOfComments().getName() + " " +"\n" + 
           "FROM   " + plantsTable.getFullName(dbOwner) + " \n" +
              "LEFT OUTER JOIN " + plantsInCommentsView.getName() + " ON " +"\n" + 
                    plantsTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantsInCommentsView.getField_Plant_PK().getFullFieldName(dbOwner) + " \n" +
              "LEFT OUTER JOIN " + plantsCountingConfigurationsView.getName() + " ON " +"\n" + 
                    plantsTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantsCountingConfigurationsView.getField_Plant_PK().getFullFieldName(dbOwner) + "\n" +
              " WHERE (" + plantsCountingConfigurationsView.getField_CountOfConfigurations().getFullFieldName(dbOwner) + " = 0) \n" +
                 "AND (" + plantsInCommentsView.getField_CountOfComments().getFullFieldName(dbOwner) + " = 0)";  }
  
  
}
