
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationCommentsTable;
import wm.db.tables.WMPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMCommentsCount_PlantConfigurationsView extends ABCMdbView {
  
  public WMCommentsCount_PlantConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);    
  }

  public abstract ABCMdbField getField_PlantConfiguration_PK();
  public abstract ABCMdbField getField_CountOfComments();
  
  public String getSQL(){
    
    String dbOwner = DB.getOwner();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
    
    WMPlantConfigurationCommentsTable plantConfigurationCommentsTable = ((WMDBGateway)DB).getPlantConfigurationCommentsTable(); 
    
    return
      "SELECT " +plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_PK().getName() + ", " +"\n" +
              "COUNT(" + plantConfigurationCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + ") AS CountOfComments " +"\n" + 
       "FROM  " + plantConfigurationCommentsTable.getFullName(dbOwner) + " " +
           "RIGHT OUTER JOIN " +"\n" + plantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" + 
               plantConfigurationCommentsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " = " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " " +
       "GROUP BY " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner);
  }
  

}
