
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantCommentsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMCommentsCount_PlantsView extends ABCMdbView {
  
  public WMCommentsCount_PlantsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Plant_PK();
  public abstract ABCMdbField getField_CountOfComments();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    WMPlantCommentsTable plantCommentsTable = ((WMDBGateway)DB).getPlantCommentsTable();
    
    return
       "SELECT " +plantsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Plant_PK().getName() + ", " +"\n" + 
               "COUNT(" + plantCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + ")" + " AS " + getField_CountOfComments().getName() + "\n" + 
           "FROM   " + plantsTable.getFullName(dbOwner) + "\n" +
              "LEFT OUTER JOIN " + plantCommentsTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantsTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantCommentsTable.getField_PlantFK().getFullFieldName(dbOwner) + "\n" +
           "GROUP BY " + plantsTable.getField_PK().getFullFieldName(dbOwner);
    }
  
}
