
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMTruthValuesTable;

public abstract class WMPlantConfigsAndResearchersView extends ABCMdbView {
  
  public WMPlantConfigsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_PlantConfiguration_PK();
  public abstract ABCMdbField getField_PlantConfiguration_Name();
  public abstract ABCMdbField getField_PlantConfiguration_Description();
  public abstract ABCMdbField getField_PlantConfiguration_DateCreated();
  public abstract ABCMdbField getField_Plant_PK();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_Plant_Name();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_PlantConfiguration_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
    
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    WMCanBeEdited_PlantConfigurationsView canBeEdited_PlantConfigurationsView = ((WMDBGateway)DB).getCanBeEdited_PlantConfigurationsView();
    
    ABCMTruthValuesTable truthValuesTable = DB.getTruthValuesTable();
    
    return
      "SELECT " +plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_PK().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_Name().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_Description().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_DateCreated().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner) + " AS " + getField_Plant_PK().getName() + ", " +"\n" + 
                   researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", " +"\n" + 
                   plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_Plant_Name().getName() + ", " +"\n" + 
                   canBeEdited_PlantConfigurationsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner) + " AS " + getField_CanBeEdited().getName() + ", " +"\n" + 
                   truthValuesTable.getField_TruthValue().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_TruthValue().getName() + " " +"\n" + 
           "FROM   " + plantConfigurationsTable.getFullName(dbOwner) + " \n" +
              "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantConfigurationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + plantsTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner) + " = " + plantsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + truthValuesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantConfigurationsTable.getField_TruthValueFK().getFullFieldName(dbOwner) + " = " + truthValuesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "LEFT OUTER JOIN " + canBeEdited_PlantConfigurationsView.getName() + " ON " +"\n" + 
                        plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + canBeEdited_PlantConfigurationsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner);
  }
  
}
