package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMPlantConfigurationInfoView1 extends ABCMdbView {

  public WMPlantConfigurationInfoView1(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }
  
  public abstract ABCMdbField getField_VarietyName();
  public abstract ABCMdbField getField_Name();
  public abstract ABCMdbField getField_ConfigurationPK();
  
  public String getSQL(){
	  String dbOwner = DB.getOwner();
	  WMSimulationConfigurationPlantConfigurationsTable simConfigPlantConfigsTable = ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
	  String simConfigPlantConfigsTableName = simConfigPlantConfigsTable.getFullName(dbOwner);
	  String plantConfigFKField = simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner);
	  String configFKField = simConfigPlantConfigsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner);

	  WMPlantConfigurationsTable plantConfigsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
	  
	  String plantConfigsTableName = plantConfigsTable.getFullName(dbOwner);
	  String configNameField = plantConfigsTable.getField_Name().getFullFieldName(dbOwner);
	  String plantConfigPKField = plantConfigsTable.getField_PK().getFullFieldName(dbOwner);
	  String plantFKField = plantConfigsTable.getField_PlantFK().getFullFieldName(dbOwner);

	  WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
	  String plantsTableName = plantsTable.getFullName(dbOwner);
	  String plantPKField = plantsTable.getField_PK().getFullFieldName(dbOwner);
	  String plantNameField = plantsTable.getField_Name().getFullFieldName(dbOwner);


	  return
	       "SELECT " + configNameField       + " AS " + getField_Name().getName()            + ", " +
	                   plantNameField        + " AS " + getField_VarietyName().getName()     + ", " +
	                   configFKField         + " AS " + getField_ConfigurationPK().getName() + " " + 
	        "FROM "   + simConfigPlantConfigsTableName + " " + 
	        "INNER JOIN " + plantConfigsTableName + " " +
	          "ON " + plantConfigFKField + " = " + plantConfigPKField + " " +
	        "INNER JOIN " + plantsTableName + " " +
	          "ON " + plantFKField + " = " + plantPKField;
  }
	

}
