package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationStagesTable;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMPlantConfigurationInfoView2 extends ABCMdbView {

  public WMPlantConfigurationInfoView2(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_VarietyName();
  public abstract ABCMdbField getField_Order();
  public abstract ABCMdbField getField_Duration();
  public abstract ABCMdbField getField_CropFactor();
  public abstract ABCMdbField getField_DroughtSensitivity();
  public abstract ABCMdbField getField_LaborRequired();
  public abstract ABCMdbField getField_SimulationConfigurationPK();
  
  public String getSQL() {
	  String dbOwner = DB.getOwner();
	  
	  
	  WMPlantConfigurationStagesTable plantConfigStagesTable = ((WMDBGateway)DB).getPlantConfigurationStagesTable();
	  String plantConfigStagesTableName = plantConfigStagesTable.getFullName(dbOwner);
	  String plantConfigurationFK       = plantConfigStagesTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner);
	  String order                      = plantConfigStagesTable.getField_Order().getFullFieldName(dbOwner);
	  String duration                   = plantConfigStagesTable.getField_Duration().getFullFieldName(dbOwner);
	  String cropFactor                 = plantConfigStagesTable.getField_CropFactor().getFullFieldName(dbOwner);
	  String droughtSensitivity         = plantConfigStagesTable.getField_DroughtSensitivity().getFullFieldName(dbOwner);
	  String laborRequired              = plantConfigStagesTable.getField_Labor().getFullFieldName(dbOwner);
	  


	  WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
	  String plantConfigurationsTableName = plantConfigurationsTable.getFullName(dbOwner);
	  String plantConfigurationPK = plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner);
//	  String plantFK = plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner);
	  String varietyName = plantConfigurationsTable.getField_Name().getFullFieldName(dbOwner);

	  WMSimulationConfigurationPlantConfigurationsTable simConfigPlantConfigsTable = ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
	  String simConfigPlantConfigsTableName = simConfigPlantConfigsTable.getFullName(dbOwner);
	  String plantConfigFKii = simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner);
	  String configurationPK = simConfigPlantConfigsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner); 

	  return
	        "SELECT " + varietyName          + " AS " + getField_VarietyName().getName() + ", " +
	                     order               + " AS " + getField_Order().getName() +  ", " +
	                     duration            + " AS " + getField_Duration().getName() +  ", " +
	                     cropFactor          + " AS " + getField_CropFactor().getName() +  ", " +
	                     droughtSensitivity  + " AS " + getField_DroughtSensitivity().getName() +  ", " +
	                     laborRequired       + " AS " + getField_LaborRequired().getName() +  ", " +
	                     configurationPK     + " AS " + getField_SimulationConfigurationPK().getName() +  " " +
	        "FROM " + plantConfigStagesTableName + " " +
	        "INNER JOIN " + plantConfigurationsTableName + " " +
	          "ON " + plantConfigurationFK + " = " + plantConfigurationPK + " " +
	        "INNER JOIN " + simConfigPlantConfigsTableName + " " +
	          "ON " + plantConfigFKii + " = " + plantConfigurationPK;

  }

}
