
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMPlantConfigurationsInSimulationConfigurationsView extends ABCMdbView {
  
  public WMPlantConfigurationsInSimulationConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_PlantConfiguration_PK();
  public abstract ABCMdbField getField_CountOfSimulationConfigurations();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();    
    
    WMSimulationConfigurationPlantConfigurationsTable simConfigPlantConfigsTable = ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
    
    return
     "SELECT " +plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_PK().getName() + ", " +"\n" + 
            "COUNT(" + simConfigPlantConfigsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner) + ")" + " AS " + getField_CountOfSimulationConfigurations().getName()  + "\n" + 
           "FROM   " + plantConfigurationsTable.getFullName(dbOwner) + " " +
              "LEFT OUTER JOIN " + simConfigPlantConfigsTable.getFullName(dbOwner) + " ON " +"\n" + 
                    plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " GROUP BY " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner);
  }
  

}
