
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantCommentsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMPlantsAndCommentsView extends ABCMdbView {
  
  public WMPlantsAndCommentsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Comment_PK();
  public abstract ABCMdbField getField_Plant_Name();
  public abstract ABCMdbField getField_Plant_PK();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantCommentsTable plantCommentsTable = ((WMDBGateway)DB).getPlantCommentsTable();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    return
      "SELECT " +plantCommentsTable.getField_CommentFK().getFullFieldName(dbOwner) + " AS " + getField_Comment_PK().getName() + ", " +"\n" + 
             plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_Plant_Name().getName() + ", " +"\n" + 
             plantsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
        "FROM " + plantCommentsTable.getFullName(dbOwner) + " \n" +
        "INNER JOIN " + plantsTable.getFullName(dbOwner) + " ON " +"\n" + 
           plantCommentsTable.getField_PlantFK().getFullFieldName(dbOwner) + " = " + plantsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
         "ORDER BY " + plantCommentsTable.getField_CommentFK().getFullFieldName(dbOwner);
  }
  

}
