
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class WMPlantsAndResearchersView extends ABCMdbView {
  
  public WMPlantsAndResearchersView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Plant_PK();
  public abstract ABCMdbField getField_Plant_Nm();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CanBeEdited();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    
    WMCanBeEdited_PlantsView canBeEdited_PlantsView = ((WMDBGateway)DB).getCanBeEdited_PlantsView();
    
    return
      "SELECT " + plantsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Plant_PK().getName() + ", " +"\n" + 
                   plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_Plant_Nm().getName() + ", " +"\n" + 
                   researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", " +"\n" + 
                   canBeEdited_PlantsView.getField_Plant_PK().getFullFieldName(dbOwner) + " AS " + getField_CanBeEdited().getName() + " " +"\n" + 
           "FROM   " + plantsTable.getFullName(dbOwner) + " \n" +
               "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
               "LEFT OUTER JOIN " + canBeEdited_PlantsView.getName() + " ON " +"\n" + 
                    plantsTable.getField_PK().getFullFieldName(dbOwner) + " = " + canBeEdited_PlantsView.getField_Plant_PK().getFullFieldName(dbOwner);
  }
  

}
