
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;

public abstract class WMPlantsCountingConfigurationsView extends ABCMdbView {
  
  public WMPlantsCountingConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Plant_PK();
  public abstract ABCMdbField getField_CountOfConfigurations();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
    
    return
       "SELECT " +plantsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Plant_PK().getName() + ", " +"\n" + 
               "COUNT(" + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + ") " + " AS " + getField_CountOfConfigurations().getName() + "\n" + 
           "FROM " + plantsTable.getFullName(dbOwner) + " LEFT OUTER JOIN " +"\n" + 
                        plantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" + 
                    plantsTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner) + " \n" +
           "GROUP BY " + plantsTable.getField_PK().getFullFieldName(dbOwner);
  }
  
  
}
