
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationStagesTable;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;

public abstract class WMSimConfigPlantStagesView extends ABCMdbView {
  
  public WMSimConfigPlantStagesView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_Name();
  public abstract ABCMdbField getField_PlantConfiguration_ID();
  public abstract ABCMdbField getField_PlantConfiguration_Name();
  public abstract ABCMdbField getField_PlantStage_Order();
  public abstract ABCMdbField getField_PlantStage_Duration();
  public abstract ABCMdbField getField_PlantStage_CropFactor();
  public abstract ABCMdbField getField_PlantStage_DroughtSensitivity();
  public abstract ABCMdbField getField_Plant_Name();
  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSimulationConfigurationsTable simulationConfigurations    = DB.getSimulationConfigurationsTable();
    WMPlantsTable plantsTable                                     = ((WMDBGateway)DB).getPlantsTable();
    WMPlantConfigurationsTable plantConfigurationsTable           = ((WMDBGateway)DB).getPlantConfigurationsTable();
    WMPlantConfigurationStagesTable plantConfigurationStagesTable = ((WMDBGateway)DB).getPlantConfigurationStagesTable();
    WMSimulationConfigurationPlantConfigurationsTable simulationConfigurationPlantConfigurationsTable = 
        ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
    
    return
      "SELECT " +simulationConfigurations.getField_PK().getFullFieldName(dbOwner)    + " AS " + this.getField_SimulationConfiguration_PK().getName() + ", " +"\n" + 
                   simulationConfigurations.getField_Name().getFullFieldName(dbOwner)                    + " AS " + this.getField_SimulationConfiguration_Name().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner)                      + " AS " + this.getField_PlantConfiguration_ID().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Name().getFullFieldName(dbOwner)                    + " AS " + this.getField_PlantConfiguration_Name().getName() + ", " +"\n" + 
                   plantConfigurationStagesTable.getField_Order().getFullFieldName(dbOwner)              + " AS " + this.getField_PlantStage_Order().getName() + ", " +"\n" + 
                   plantConfigurationStagesTable.getField_Duration().getFullFieldName(dbOwner)           + " AS " + this.getField_PlantStage_Duration().getName() + ", " +"\n" + 
                   plantConfigurationStagesTable.getField_CropFactor().getFullFieldName(dbOwner)         + " AS " + this.getField_PlantStage_CropFactor().getName() + ", " +"\n" + 
                   plantConfigurationStagesTable.getField_DroughtSensitivity().getFullFieldName(dbOwner) + " AS " + this.getField_PlantStage_DroughtSensitivity().getName() + ", " +"\n" + 
                   plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + this.getField_Plant_Name().getName() + "\n " +
               "FROM " + simulationConfigurations.getFullName(dbOwner) + " INNER JOIN " +"\n" + 
                        simulationConfigurationPlantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" + 
                            simulationConfigurations.getField_PK().getFullFieldName(dbOwner) + " = " + 
                            simulationConfigurationPlantConfigurationsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner) + " INNER JOIN " +"\n" + 
                            plantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" +
                            simulationConfigurationPlantConfigurationsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " = " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " INNER JOIN " +"\n" +
                            plantConfigurationStagesTable.getFullName(dbOwner)+ " ON " +"\n" +
                            plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantConfigurationStagesTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " INNER JOIN " +"\n" +
                            plantsTable.getFullName(dbOwner) + " ON " +"\n" +
                            plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner) + " = " + plantsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
                            "";
//             "ORDER BY " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + ", " + plantConfigurationStagesTable.getField_Order().getFullFieldName(dbOwner);  

                        
                        
                        ////           "FROM   " + simulationConfigurations.getFullName(dbOwner) + " INNER JOIN " +"\n" + 
////                        simulationConfigurationPlantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" + 
////                         simulationConfigurations.getField_PK().getFullFieldName(dbOwner) + " = " + simulationConfigurationPlantConfigurationsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner) + " INNER JOIN " +"\n" + 
////                        plantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" + 
////                     jtmurphy.tblSimulationConfigurationPlantConfigurations.intPlantConfigurationID = jtmurphy.tblPlantConfigurations.intPlantConfigurationID INNER JOIN " +"\n" + 
////                    jtmurphy.tblPlantConfigurationStages ON " +"\n" + 
////                     jtmurphy.tblPlantConfigurations.intPlantConfigurationID = jtmurphy.tblPlantConfigurationStages.intPlantConfigurationID INNER JOIN " +"\n" + 
////                    jtmurphy.tblPlants ON " +"\n" + 
////                    jtmurphy.tblPlantConfigurations.intPlantID = jtmurphy.tblPlants.intPlantID ORDER BY " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + ", " + plantConfigurationStagesTable.getField_Order().getFullFieldName(dbOwner) + " ");
//

  }

  public String getSelectSQL(String dbOwner, String clause){
    return getSQL() + " " + clause;
  }

}
