
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
import abcm.db.managers.TruthValueManager;

public abstract class WMSimulationConfigsWithPlantConfigTruthValueView extends ABCMdbView {
  
  public WMSimulationConfigsWithPlantConfigTruthValueView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_TruthValue();

  public String getSQL(){
    String dbOwner = DB.getOwner();

    ABCMSimulationConfigurationsTable simConfigsTable = DB.getSimulationConfigurationsTable();
        String simConfigs = simConfigsTable.getFullName(dbOwner);
    
        String SIM_CONFIG_PK = simConfigsTable.getField_PK().getFullFieldName(dbOwner);
    
    WMSimulationConfigurationPlantConfigurationsTable simConfigPlantConfigsTable = ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
        String simConfigPlantConfigs = simConfigPlantConfigsTable.getFullName(dbOwner);
        
        String SIM_CONFIG_FK   = simConfigPlantConfigsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner);
        String PLANT_CONFIG_FK = simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner);
    
    WMPlantConfigurationsTable plantConfigsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
        String plantConfigs = plantConfigsTable.getFullName(dbOwner);
        
        String PLANT_CONFIG_PK = plantConfigsTable.getField_PK().getFullFieldName(dbOwner);
        String TRUTH_VALUE     = plantConfigsTable.getField_TruthValueFK().getFullFieldName(dbOwner);
    
    
    return
    "SELECT " +
        SIM_CONFIG_PK                         + " AS " + getField_SimulationConfiguration_PK().getName() + ", \n" + 
        DB.getSQLSyntaxEngine().getNullFunction() + "(MAX(" + TRUTH_VALUE + ")," + TruthValueManager.CERTAIN + ")" + " AS " + getField_TruthValue().getName()                 + "\n" + 
    "FROM " +
        plantConfigs + " INNER JOIN " + simConfigPlantConfigs  + " ON \n" + 
            PLANT_CONFIG_PK + " = " + PLANT_CONFIG_FK + " RIGHT OUTER JOIN " + simConfigs + " ON \n" + 
            SIM_CONFIG_FK + " = " + SIM_CONFIG_PK + "\n" +          
    "GROUP BY " + SIM_CONFIG_PK + ", " + SIM_CONFIG_FK;
  }
  
}
