
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;
import abcm.db.components.tables.ABCMTruthValuesTable;

public abstract class WMSimulationConfigurationPlantConfigurationsView extends ABCMdbView {
  
  public WMSimulationConfigurationPlantConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_SimulationConfigurationPlantConfiguration_PK();
  public abstract ABCMdbField getField_SimulationConfiguration_PK();
  public abstract ABCMdbField getField_PlantConfiguration_PK();
  public abstract ABCMdbField getField_PlantConfiguration_Name();
  public abstract ABCMdbField getField_PlantConfiguration_Description();
  public abstract ABCMdbField getField_PlantConfiguration_DateCreated();
  public abstract ABCMdbField getField_Researcher_PK();
  public abstract ABCMdbField getField_Plant_Name();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_CanBeEdited();
  public abstract ABCMdbField getField_TruthValue();

  
  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMSimulationConfigurationPlantConfigurationsTable simConfigPlantConfigsTable = ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();
    
    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    ABCMResearchersTable researchersTable = DB.getResearchersTable();
    
    WMCanBeEdited_PlantConfigurationsView canBeEdited_PlantConfigurationsView = ((WMDBGateway)DB).getCanBeEdited_PlantConfigurationsView();
    
    ABCMTruthValuesTable truthValuesTable = DB.getTruthValuesTable();
    
    return
      "SELECT " +simConfigPlantConfigsTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_SimulationConfigurationPlantConfiguration_PK().getName() + ", " +"\n" +
                simConfigPlantConfigsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner)+ " AS " + getField_SimulationConfiguration_PK().getName() + ", " +"\n" +
                simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_PK().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_Name().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_Description().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_DateCreated().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " AS " + getField_Researcher_PK().getName() + ", " +"\n" +
                   plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_Plant_Name().getName() + ", " +"\n" + 
                   researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", " +"\n" + 
                   canBeEdited_PlantConfigurationsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner) + " AS " + getField_CanBeEdited().getName() + ", " +"\n" + 
                   truthValuesTable.getField_TruthValue().getFullFieldName(dbOwner) + " AS " + getField_TruthValue().getName() + "\n" + 
           "FROM " + simConfigPlantConfigsTable.getFullName(dbOwner) + "\n" +
              " INNER JOIN " +plantConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" +
                   simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " = " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
              " INNER JOIN " +plantsTable.getFullName(dbOwner) + " ON " +"\n" +
                   plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner) + " = " + plantsTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
              " INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              " LEFT OUTER JOIN " + truthValuesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantConfigurationsTable.getField_TruthValueFK().getFullFieldName(dbOwner) + " = " + truthValuesTable.getField_PK().getFullFieldName(dbOwner) + "\n" +
              " LEFT OUTER JOIN " +canBeEdited_PlantConfigurationsView.getName() + " ON " +"\n" + 
                     plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + canBeEdited_PlantConfigurationsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner);
  }
  

}
