
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMPlantConfigurationsTable;
import wm.db.tables.WMPlantsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMResearchersTable;

public abstract class WMSummaryPlantConfigurationsAndDetailsView extends ABCMdbView {
  
  public WMSummaryPlantConfigurationsAndDetailsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_PlantConfiguration_PK();
  public abstract ABCMdbField getField_PlantConfiguration_Name();
  public abstract ABCMdbField getField_PlantConfiguration_Description();
  public abstract ABCMdbField getField_PlantConfiguration_DateCreated();
  public abstract ABCMdbField getField_Researcher_Name();
  public abstract ABCMdbField getField_Plant_Name();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    WMSummaryPlantConfigurationsView summaryPlantConfigurationsView = ((WMDBGateway)DB).getSummaryPlantConfigurationsView();
    
    WMPlantConfigurationsTable plantConfigurationsTable = ((WMDBGateway)DB).getPlantConfigurationsTable();

    ABCMResearchersTable researchersTable = DB.getResearchersTable();

    WMPlantsTable plantsTable = ((WMDBGateway)DB).getPlantsTable();
    
    return
      "SELECT " +  summaryPlantConfigurationsView.getField_Summary_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner)+ " AS " + getField_PlantConfiguration_PK().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_Name().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_Description().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_Description().getName() + ", " +"\n" + 
                   plantConfigurationsTable.getField_DateCreated().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_DateCreated().getName() + ", " +"\n" + 
                   researchersTable.getField_ResearcherName().getFullFieldName(dbOwner) + " AS " + getField_Researcher_Name().getName() + ", " +"\n" + 
                   plantsTable.getField_Name().getFullFieldName(dbOwner) + " AS " + getField_Plant_Name().getName() + "\n" + 
           "FROM   "  + summaryPlantConfigurationsView.getName() + " INNER JOIN " +"\n" + 
                    plantConfigurationsTable.getName() + " ON " +"\n" + 
                         summaryPlantConfigurationsView.getField_PlantConfiguration_PK().getFullFieldName(dbOwner) + " = " + plantConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
                  "INNER JOIN " + researchersTable.getFullName(dbOwner) + " ON " +"\n" + 
                        plantConfigurationsTable.getField_ResearcherFK().getFullFieldName(dbOwner) + " = " + researchersTable.getField_PK().getFullFieldName(dbOwner)+ " INNER JOIN " +"\n" + 
                    plantsTable.getFullName(dbOwner) + " ON " +"\n" + 
                    plantConfigurationsTable.getField_PlantFK().getFullFieldName(dbOwner) + " = " + plantsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
                "AND " + researchersTable.getField_PK().getFullFieldName(dbOwner) + " = " + plantsTable.getField_ResearcherFK().getFullFieldName(dbOwner);
  }
  
  
}
