
package wm.db.views;

import wm.db.WMDBGateway;
import wm.db.tables.WMSimulationConfigurationPlantConfigurationsTable;
import abcm.db.AbstractABCMDBGateway;
import abcm.db.components.ABCMdbField;
import abcm.db.components.ABCMdbView;
import abcm.db.components.tables.ABCMAnalysesTable;
import abcm.db.components.tables.ABCMAnalysisDataSeriesTable;
import abcm.db.components.tables.ABCMDataModelsTable;
import abcm.db.components.tables.ABCMSimulationConfigurationsTable;
import abcm.db.components.tables.ABCMSimulationDataSeriesTable;
import abcm.db.components.tables.ABCMSimulationRunsTable;
import abcm.db.components.tables.ABCMSimulationsTable;
import abcm.db.components.tables.ABCMSummariesTable;
import abcm.db.components.tables.ABCMSummaryAnalysesTable;

public abstract class WMSummaryPlantConfigurationsView extends ABCMdbView {
  
  public WMSummaryPlantConfigurationsView(String viewName, AbstractABCMDBGateway db){ 
    super(viewName, db);
  }

  public abstract ABCMdbField getField_Summary_PK();
  public abstract ABCMdbField getField_PlantConfiguration_PK();

  public String getSQL(){
    String dbOwner = DB.getOwner();
    
    ABCMSummariesTable summariesTable = DB.getSummariesTable();
    
    WMSimulationConfigurationPlantConfigurationsTable simConfigPlantConfigsTable = ((WMDBGateway)DB).getSimulationConfigurationPlantConfigurationsTable();
    
    ABCMSimulationDataSeriesTable simulationDataSeriesTable = DB.getSimulationDataSeriesTable();
    
    ABCMAnalysisDataSeriesTable analysisDataSeriesTable = DB.getAnalysisDataSeriesTable();
    
    ABCMSimulationRunsTable simulationRunsTable = DB.getSimulationRunsTable();
    
    ABCMSimulationsTable simulationsTable = DB.getSimulationsTable();
    
    ABCMDataModelsTable dataModelsTable = DB.getDataModelsTable();
    
    ABCMSimulationConfigurationsTable simulationConfigurationsTable = DB.getSimulationConfigurationsTable();

    ABCMAnalysesTable analysesTable = DB.getAnalysesTable();
    
    ABCMSummaryAnalysesTable summaryAnalysesTable = DB.getSummaryAnalysesTable();
    
    return
       "SELECT DISTINCT " + summariesTable.getField_PK().getFullFieldName(dbOwner) + " AS " + getField_Summary_PK().getName() + ", " +"\n" + 
                simConfigPlantConfigsTable.getField_PlantConfigurationFK().getFullFieldName(dbOwner) + " AS " + getField_PlantConfiguration_PK().getName() + "\n" + 
           "FROM   " + simulationDataSeriesTable.getFullName(dbOwner) + " \n" +
              "INNER JOIN " + analysisDataSeriesTable.getFullName(dbOwner) + " ON " +"\n" + 
                 simulationDataSeriesTable.getField_PK().getFullFieldName(dbOwner) + " = " + analysisDataSeriesTable.getField_DataSeriesFK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + simulationRunsTable.getFullName(dbOwner) + " ON " +"\n" + 
                 simulationDataSeriesTable.getField_SimulationRunFK().getFullFieldName(dbOwner) + " = " + simulationRunsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + simulationsTable.getFullName(dbOwner) + " ON " +"\n" + 
                 simulationRunsTable.getField_SimulationFK().getFullFieldName(dbOwner) + " = " + simulationsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + dataModelsTable.getFullName(dbOwner) + " ON " +"\n" + 
                 simulationsTable.getField_DataModelFK().getFullFieldName(dbOwner) + " = " + dataModelsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + simulationConfigurationsTable.getFullName(dbOwner) + " ON " +"\n" + 
                 dataModelsTable.getField_ConfigurationFK().getFullFieldName(dbOwner) + " = " + simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " +simConfigPlantConfigsTable.getFullName(dbOwner) + " ON " +"\n" +
                 simulationConfigurationsTable.getField_PK().getFullFieldName(dbOwner) + " = " + simConfigPlantConfigsTable.getField_SimulationConfigurationFK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN " + analysesTable.getFullName(dbOwner) + " ON " +"\n" + 
                 analysisDataSeriesTable.getField_AnalysisFK().getFullFieldName(dbOwner) + " = " + analysesTable.getField_PK().getFullFieldName(dbOwner) + " \n" +
              "INNER JOIN (" + summariesTable.getFullName(dbOwner) + " \n" +
                  "INNER JOIN " + summaryAnalysesTable.getFullName(dbOwner) + " ON " +"\n" + 
                        summariesTable.getField_PK().getFullFieldName(dbOwner) + " = " + summaryAnalysesTable.getField_SummaryFK().getFullFieldName(dbOwner) + ") ON " +"\n" + 
                         analysesTable.getField_PK().getFullFieldName(dbOwner) + " = " + summaryAnalysesTable.getField_AnalysisFK().getFullFieldName(dbOwner);
  }
  
  
}
